/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/product/common/product","vs/editor/common/config/editorOptions","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=me[Y[g]];return e};define(me[54],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(me[55],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(n){const I=[];for(let d in n)g.call(n,d)&&I.push(n[d]);return I}e.values=L;function k(n,I){for(let d in n)if(g.call(n,d)&&I({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=k;function D(n,I){const d=Object.create(null);for(const m of n){const u=I(m);let p=d[u];p||(p=d[u]=[]),p.push(m)}return d}e.groupBy=D;function A(n){const I=Object.create(null);return n&&n.forEach((d,m)=>{I[m]=d}),I}e.fromMap=A;function C(n,I){const d=[],m=[];for(let u of n)I.has(u)||d.push(u);for(let u of I)n.has(u)||m.push(u);return{removed:d,added:m}}e.diffSets=C;function y(n,I){const d=[],m=[];for(let[u,p]of n)I.has(u)||d.push(p);for(let[u,p]of I)n.has(u)||m.push(p);return{removed:d,added:m}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(I,d){let m=this.map.get(I);m||(m=new Set,this.map.set(I,m)),m.add(d)}delete(I,d){const m=this.map.get(I);!m||(m.delete(d),m.size===0&&this.map.delete(I))}forEach(I,d){const m=this.map.get(I);!m||m.forEach(d)}}e.SetMap=P}),define(me[56],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(A){return(C,y,P)=>{let n=null,I=null;if(typeof P.value=="function"?(n="value",I=P.value):typeof P.get=="function"&&(n="get",I=P.get),!I)throw new Error("not supported");P[n]=A(I,y)}}e.createDecorator=g;function L(A,C,y){let P=null,n=null;if(typeof y.value=="function"?(P="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",n=y.get),!n)throw new Error("not supported");const I=`$memoize$${C}`;y[P]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[I]}}e.memoize=L;function k(A,C,y){return g((P,n)=>{const I=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...m){this[d]||(this[d]=y?y():void 0),clearTimeout(this[I]),C&&(this[d]=C(this[d],...m),m=[this[d]]),this[I]=setTimeout(()=>{P.apply(this,m),this[d]=y?y():void 0},A)}})}e.debounce=k;function D(A,C,y){return g((P,n)=>{const I=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...p){if(this[d]||(this[d]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),C&&(this[d]=C(this[d],...p)),this[u])return;const _=this[m]+A;_<=Date.now()?(this[m]=Date.now(),P.apply(this,[this[d]]),this[d]=y?y():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),P.apply(this,[this[d]]),this[d]=y?y():void 0},_-Date.now()))}})}e.throttle=D}),define(me[16],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function k(v){y(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=k;function D(v){y(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=D;function A(v){if(v instanceof Error){let{name:t,message:r}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:s}}return v}e.transformErrorForSerialization=A;const C="Canceled";function y(v){return v instanceof Error&&v.name===C&&v.message===C}e.isPromiseCanceledError=y;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function n(){const v=new Error(C);return v.name=v.message,v}e.canceled=n;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function d(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=d;function m(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function p(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=p;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class T extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=T;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function a(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function l(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(me[20],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,X=0){return W[W.length-(1+X)]}e.tail=L;function k(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=k;function D(W,X,Z=(fe,_e)=>fe===_e){if(W===X)return!0;if(!W||!X||W.length!==X.length)return!1;for(let fe=0,_e=W.length;fe<_e;fe++)if(!Z(W[fe],X[fe]))return!1;return!0}e.equals=D;function A(W,X,Z){let fe=0,_e=W.length-1;for(;fe<=_e;){const De=(fe+_e)/2|0,Le=Z(W[De],X);if(Le<0)fe=De+1;else if(Le>0)_e=De-1;else return De}return-(fe+1)}e.binarySearch=A;function C(W,X){let Z=0,fe=W.length;if(fe===0)return 0;for(;Z<fe;){const _e=Math.floor((Z+fe)/2);X(W[_e])?fe=_e:Z=_e+1}return Z}e.findFirstInSorted=C;function y(W,X,Z){if(W=W|0,W>=X.length)throw new TypeError("invalid index");let fe=X[Math.floor(X.length*Math.random())],_e=[],De=[],Le=[];for(let qe of X){const xe=Z(qe,fe);xe<0?_e.push(qe):xe>0?De.push(qe):Le.push(qe)}return W<_e.length?y(W,_e,Z):W<_e.length+Le.length?Le[0]:y(W-(_e.length+Le.length),De,Z)}e.quickSelect=y;function P(W,X){const Z=[];let fe;for(const _e of W.slice(0).sort(X))!fe||X(fe[0],_e)!==0?(fe=[_e],Z.push(fe)):fe.push(_e);return Z}e.groupBy=P;function n(W,X,Z){const fe=[];function _e(qe,xe,Ke){if(xe===0&&Ke.length===0)return;const H=fe[fe.length-1];H&&H.start+H.deleteCount===qe?(H.deleteCount+=xe,H.toInsert.push(...Ke)):fe.push({start:qe,deleteCount:xe,toInsert:Ke})}let De=0,Le=0;for(;;){if(De===W.length){_e(De,0,X.slice(Le));break}if(Le===X.length){_e(De,W.length-De,[]);break}const qe=W[De],xe=X[Le],Ke=Z(qe,xe);Ke===0?(De+=1,Le+=1):Ke<0?(_e(De,1,[]),De+=1):Ke>0&&(_e(De,0,[xe]),Le+=1)}return fe}e.sortedDiff=n;function I(W,X,Z){const fe=n(W,X,Z),_e=[],De=[];for(const Le of fe)_e.push(...W.slice(Le.start,Le.start+Le.deleteCount)),De.push(...Le.toInsert);return{removed:_e,added:De}}e.delta=I;function d(W,X,Z){if(Z===0)return[];const fe=W.slice(0,Z).sort(X);return u(W,X,fe,Z,W.length),fe}e.top=d;function m(W,X,Z,fe,_e){return Z===0?Promise.resolve([]):new Promise((De,Le)=>{(async()=>{const qe=W.length,xe=W.slice(0,Z).sort(X);for(let Ke=Z,H=Math.min(Z+fe,qe);Ke<qe;Ke=H,H=Math.min(H+fe,qe)){if(Ke>Z&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();u(W,X,xe,Ke,H)}return xe})().then(De,Le)})}e.topAsync=m;function u(W,X,Z,fe,_e){for(const De=Z.length;fe<_e;fe++){const Le=W[fe];if(X(Le,Z[De-1])<0){Z.pop();const qe=C(Z,xe=>X(Le,xe)<0);Z.splice(qe,0,Le)}}}function p(W){return W.filter(X=>!!X)}e.coalesce=p;function _(W){let X=0;for(let Z=0;Z<W.length;Z++)W[Z]&&(W[X]=W[Z],X+=1);W.length=X}e.coalesceInPlace=_;function T(W,X,Z){W.splice(Z,0,W.splice(X,1)[0])}e.move=T;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function a(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=a;function l(W,X){if(!X)return W.filter((fe,_e)=>W.indexOf(fe)===_e);const Z=Object.create(null);return W.filter(fe=>{const _e=X(fe);return Z[_e]?!1:(Z[_e]=!0,!0)})}e.distinct=l;function v(W){const X=new Set;return W.filter(Z=>X.has(Z)?!1:(X.add(Z),!0))}e.distinctES6=v;function t(W){const X=Object.create(null);return Z=>{const fe=W(Z);return X[fe]?!1:(X[fe]=!0,!0)}}e.uniqueFilter=t;function r(W,X){for(let Z=W.length-1;Z>=0;Z--){const fe=W[Z];if(X(fe))return Z}return-1}e.lastIndex=r;function s(W,X){return W.length>0?W[0]:X}e.firstOrDefault=s;function i(W,X,Z=(fe,_e)=>fe===_e){let fe=0;for(let _e=0,De=Math.min(W.length,X.length);_e<De&&Z(W[_e],X[_e]);_e++)fe++;return fe}e.commonPrefixLength=i;function c(W){return[].concat(...W)}e.flatten=c;function f(W,X){let Z=typeof X=="number"?W:0;typeof X=="number"?Z=W:(Z=0,X=W);const fe=[];if(Z<=X)for(let _e=Z;_e<X;_e++)fe.push(_e);else for(let _e=Z;_e>X;_e--)fe.push(_e);return fe}e.range=f;function h(W,X,Z){return W.reduce((fe,_e)=>(fe[X(_e)]=Z?Z(_e):_e,fe),Object.create(null))}e.index=h;function b(W,X){return W.push(X),()=>S(W,X)}e.insert=b;function S(W,X){const Z=W.indexOf(X);if(Z>-1)return W.splice(Z,1),X}e.remove=S;function o(W,X,Z){const fe=W.slice(0,X),_e=W.slice(X);return fe.concat(Z,_e)}e.arrayInsert=o;function w(W,X){let Z;if(typeof X=="number"){let fe=X;Z=()=>{const _e=Math.sin(fe++)*179426549;return _e-Math.floor(_e)}}else Z=Math.random;for(let fe=W.length-1;fe>0;fe-=1){const _e=Math.floor(Z()*(fe+1)),De=W[fe];W[fe]=W[_e],W[_e]=De}}e.shuffle=w;function R(W,X){const Z=W.indexOf(X);Z>-1&&(W.splice(Z,1),W.unshift(X))}e.pushToStart=R;function O(W,X){const Z=W.indexOf(X);Z>-1&&(W.splice(Z,1),W.push(X))}e.pushToEnd=O;function $(W,X){return Array.isArray(W)?W.map(X):X(W)}e.mapArrayOrNot=$;function K(W){return Array.isArray(W)?W:[W]}e.asArray=K;function G(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=G;function N(W,X){for(const Z of W){const fe=X(Z);if(fe!==void 0)return fe}}e.mapFind=N;function x(W,X,Z){const fe=V(W,X),_e=W.length,De=Z.length;W.length=_e+De;for(let Le=_e-1;Le>=fe;Le--)W[Le+De]=W[Le];for(let Le=0;Le<De;Le++)W[Le+fe]=Z[Le]}e.insertInto=x;function F(W,X,Z,fe){const _e=V(W,X),De=W.splice(_e,Z);return x(W,_e,fe),De}e.splice=F;function V(W,X){return X<0?Math.max(X+W.length,0):Math.min(X,W.length)}function M(W,X){let Z=Number.MAX_SAFE_INTEGER,fe=0;return W.forEach((_e,De)=>{const Le=X(_e);Le<Z&&(Z=Le,fe=De)}),fe}e.minIndex=M;function U(W,X){let Z=Number.MIN_SAFE_INTEGER,fe=0;return W.forEach((_e,De)=>{const Le=X(_e);Le>Z&&(Z=Le,fe=De)}),fe}e.maxIndex=U;class q{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Z=this.firstIdx;for(;Z<this.items.length&&X(this.items[Z]);)Z++;const fe=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,fe}takeFromEndWhile(X){let Z=this.lastIdx;for(;Z>=0&&X(this.items[Z]);)Z--;const fe=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,fe}}e.ArrayQueue=q}),define(me[74],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const k=this;let D=!1,A;return function(){return D||(D=!0,A=L.apply(k,arguments)),A}}e.once=g}),define(me[75],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(me[76],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function k(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=k;const D=Object.freeze([]);function A(){return D}L.empty=A;function*C(v){yield v}L.single=C;function y(v){return v||D}L.from=y;function P(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=P;function n(v){return v[Symbol.iterator]().next().value}L.first=n;function I(v,t){for(const r of v)if(t(r))return!0;return!1}L.some=I;function d(v,t){for(const r of v)if(t(r))return r}L.find=d;function*m(v,t){for(const r of v)t(r)&&(yield r)}L.filter=m;function*u(v,t){let r=0;for(const s of v)yield t(s,r++)}L.map=u;function*p(...v){for(const t of v)for(const r of t)yield r}L.concat=p;function*_(v){for(const t of v)for(const r of t)yield r}L.concatNested=_;function T(v,t,r){let s=r;for(const i of v)s=t(s,i);return s}L.reduce=T;function*E(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}L.slice=E;function a(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const s=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=s.next();if(c.done)return[r,L.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=a;function l(v,t,r=(s,i)=>s===i){const s=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=s.next(),f=i.next();if(c.done!==f.done)return!1;if(c.done)return!0;if(!r(c.value,f.value))return!1}}L.equals=l})(g=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let s=0,i=t.length,c="",f=0,h=16,b=0;function S(G){let N=0,x=0;for(;N<G;){const F=t.charCodeAt(s);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;s++,N++}return N<G&&(x=-1),x}function o(G){s=G,c="",f=0,h=16,b=0}function w(){const G=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&P(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&P(t.charCodeAt(s)))for(s++;s<t.length&&P(t.charCodeAt(s));)s++;else return b=3,t.substring(G,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&P(t.charCodeAt(s))){for(s++;s<t.length&&P(t.charCodeAt(s));)s++;N=s}else b=3;return t.substring(G,N)}function R(){let G="",N=s;for(;;){if(s>=i){G+=t.substring(N,s),b=2;break}const x=t.charCodeAt(s);if(x===34){G+=t.substring(N,s),s++;break}if(x===92){if(G+=t.substring(N,s),s++,s>=i){b=2;break}switch(t.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const V=S(4);V>=0?G+=String.fromCharCode(V):b=4;break;default:b=5}N=s;continue}if(x>=0&&x<=31)if(y(x)){G+=t.substring(N,s),b=2;break}else b=6;s++}return G}function O(){if(c="",b=0,f=s,s>=i)return f=i,h=17;let G=t.charCodeAt(s);if(C(G)){do s++,c+=String.fromCharCode(G),G=t.charCodeAt(s);while(C(G));return h=15}if(y(G))return s++,c+=String.fromCharCode(G),G===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),h=14;switch(G){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,c=R(),h=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!y(t.charCodeAt(s));)s++;return c=t.substring(N,s),h=12}if(t.charCodeAt(s+1)===42){s+=2;const x=i-1;let F=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,F=!0;break}s++}return F||(s++,b=1),c=t.substring(N,s),h=13}return c+=String.fromCharCode(G),s++,h=16;case 45:if(c+=String.fromCharCode(G),s++,s===i||!P(t.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=w(),h=11;default:for(;s<i&&$(G);)s++,G=t.charCodeAt(s);if(f!==s){switch(c=t.substring(f,s),c){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return c+=String.fromCharCode(G),s++,h=16}}function $(G){if(C(G)||y(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let G;do G=O();while(G>=12&&G<=15);return G}return{setPosition:o,getPosition:()=>s,scan:r?K:O,getToken:()=>h,getTokenValue:()=>c,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>b}}e.createScanner=A;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,r){const s=[],i=new Object;let c;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function b(S,o,w,R){f.value=S,f.offset=o,f.length=w,f.type=R,f.colonOffset=void 0,c=f}try{a(t,{onObjectBegin:(S,o)=>{if(r<=S)throw i;c=void 0,h=r>S,s.push("")},onObjectProperty:(S,o,w)=>{if(r<o||(b(S,o,w,"property"),s[s.length-1]=S,r<=o+w))throw i},onObjectEnd:(S,o)=>{if(r<=S)throw i;c=void 0,s.pop()},onArrayBegin:(S,o)=>{if(r<=S)throw i;c=void 0,s.push(0)},onArrayEnd:(S,o)=>{if(r<=S)throw i;c=void 0,s.pop()},onLiteralValue:(S,o,w)=>{if(r<o||(b(S,o,w,v(S)),r<=o+w))throw i},onSeparator:(S,o,w)=>{if(r<=o)throw i;if(S===":"&&c&&c.type==="property")c.colonOffset=o,h=!1,c=void 0;else if(S===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(h=!0,s[s.length-1]=""),c=void 0}}})}catch(S){if(S!==i)throw S}return{path:s,previousNode:c,isAtPropertyKey:h,matches:S=>{let o=0;for(let w=0;o<S.length&&w<s.length;w++)if(S[o]===s[w]||S[o]==="*")o++;else if(S[o]!=="**")return!1;return o===S.length}}}e.getLocation=I;function d(t,r=[],s=D.DEFAULT){let i=null,c=[];const f=[];function h(S){Array.isArray(c)?c.push(S):i!==null&&(c[i]=S)}return a(t,{onObjectBegin:()=>{const S={};h(S),f.push(c),c=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{const S=[];h(S),f.push(c),c=S,i=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:h,onError:(S,o,w)=>{r.push({error:S,offset:o,length:w})}},s),c[0]}e.parse=d;function m(t,r=[],s=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function f(S){return i.children.push(S),S}a(t,{onObjectBegin:S=>{i=f({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,o,w)=>{i=f({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:o,length:w,parent:i})},onObjectEnd:(S,o)=>{i.length=S+o-i.offset,i=i.parent,c(S+o)},onArrayBegin:(S,o)=>{i=f({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,o)=>{i.length=S+o-i.offset,i=i.parent,c(S+o)},onLiteralValue:(S,o,w)=>{f({type:v(S),offset:o,length:w,parent:i,value:S}),c(o+w)},onSeparator:(S,o,w)=>{i.type==="property"&&(S===":"?i.colonOffset=o:S===","&&c(o))},onError:(S,o,w)=>{r.push({error:S,offset:o,length:w})}},s);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=m;function u(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===i){s=f.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=u;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=p;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=_(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function T(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=T;function E(t,r,s=!1){if(T(t,r,s)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const f=E(i[c],r,s);if(f)return f}return t}}e.findNodeAtOffset=E;function a(t,r,s=D.DEFAULT){const i=A(t,!1);function c(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(Z){return Z?fe=>Z(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=c(r.onObjectBegin),b=f(r.onObjectProperty),S=c(r.onObjectEnd),o=c(r.onArrayBegin),w=c(r.onArrayEnd),R=f(r.onLiteralValue),O=f(r.onSeparator),$=c(r.onComment),K=f(r.onError),G=s&&s.disallowComments,N=s&&s.allowTrailingComma;function x(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:G||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(Z){case 12:case 13:G?F(10):$();break;case 16:F(1);break;case 15:case 14:break;default:return Z}}}function F(Z,fe=[],_e=[]){if(K(Z),fe.length+_e.length>0){let De=i.getToken();for(;De!==17;){if(fe.indexOf(De)!==-1){x();break}else if(_e.indexOf(De)!==-1)break;De=x()}}}function V(Z){const fe=i.getTokenValue();return Z?R(fe):b(fe),x(),!0}function M(){switch(i.getToken()){case 11:let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(F(2),Z=0)}catch(fe){F(2)}R(Z);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return x(),!0}function U(){return i.getToken()!==10?(F(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(O(":"),x(),X()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function q(){h(),x();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||F(4,[],[]),O(","),x(),i.getToken()===2&&N)break}else Z&&F(6,[],[]);U()||F(4,[],[2,5]),Z=!0}return S(),i.getToken()!==2?F(7,[2],[]):x(),!0}function W(){o(),x();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||F(4,[],[]),O(","),x(),i.getToken()===4&&N)break}else Z&&F(6,[],[]);X()||F(4,[],[4,5]),Z=!0}return w(),i.getToken()!==4?F(8,[4],[]):x(),!0}function X(){switch(i.getToken()){case 3:return W();case 1:return q();case 10:return V(!0);default:return M()}}return x(),i.getToken()===17?s.allowEmptyContent?!0:(F(4,[],[]),!1):X()?(i.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=a;function l(t,r){let s=A(t),i=[],c,f=0,h;do switch(h=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:f!==h&&i.push(t.substring(f,h)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(c!==17);return i.join("")}e.stripComments=l;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(me[138],ge([0,1,57]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,P,n){let I,d,m,u,p;if(P){for(u=P.offset,p=u+P.length,m=u;m>0&&!C(y,m-1);)m--;let f=p;for(;f<y.length&&!C(y,f);)f++;d=y.substring(m,f),I=D(d,n)}else d=y,I=0,m=0,u=0,p=y.length;const _=A(n,y);let T=!1,E=0,a;n.insertSpaces?a=k(" ",n.tabSize||4):a="	";const l=(0,g.createScanner)(d,!1);let v=!1;function t(){return _+k(a,I+E)}function r(){let f=l.scan();for(T=!1;f===15||f===14;)T=T||f===14,f=l.scan();return v=f===16||l.getTokenError()!==0,f}const s=[];function i(f,h,b){!v&&h<p&&b>u&&y.substring(h,b)!==f&&s.push({offset:h,length:b-h,content:f})}let c=r();if(c!==17){const f=l.getTokenOffset()+m,h=k(a,I);i(h,m,f)}for(;c!==17;){let f=l.getTokenOffset()+l.getTokenLength()+m,h=r(),b="";for(;!T&&(h===12||h===13);){const o=l.getTokenOffset()+m;i(" ",f,o),f=l.getTokenOffset()+l.getTokenLength()+m,b=h===12?t():"",h=r()}if(h===2)c!==1&&(E--,b=t());else if(h===4)c!==3&&(E--,b=t());else{switch(c){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:T?b=t():b=" ";break;case 6:b=" ";break;case 10:if(h===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?b=" ":h!==5&&h!==17&&(v=!0);break;case 16:v=!0;break}T&&(h===12||h===13)&&(b=t())}const S=l.getTokenOffset()+m;i(b,f,S),c=h}return s}e.format=L;function k(y,P){let n="";for(let I=0;I<P;I++)n+=y;return n}function D(y,P){let n=0,I=0;const d=P.tabSize||4;for(;n<y.length;){const m=y.charAt(n);if(m===" ")I++;else if(m==="	")I+=d;else break;n++}return Math.floor(I/d)}function A(y,P){for(let n=0;n<P.length;n++){const I=P.charAt(n);if(I==="\r")return n+1<P.length&&P.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=A;function C(y,P){return`\r
`.indexOf(y.charAt(P))!==-1}e.isEOL=C}),define(me[139],ge([0,1,57,138]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,n,I){return D(P,n,void 0,I)}e.removeProperty=k;function D(P,n,I,d,m){const u=n.slice(),p=[],_=(0,g.parseTree)(P,p);let T,E;for(;u.length>0&&(E=u.pop(),T=(0,g.findNodeAtLocation)(_,u),T===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(T)if(T.type==="object"&&typeof E=="string"&&Array.isArray(T.children)){const a=(0,g.findNodeAtLocation)(T,[E]);if(a!==void 0)if(I===void 0){if(!a.parent)throw new Error("Malformed AST");const l=T.children.indexOf(a.parent);let v,t=a.parent.offset+a.parent.length;if(l>0){const r=T.children[l-1];v=r.offset+r.length}else v=T.offset+1,T.children.length>1&&(t=T.children[1].offset);return A(P,{offset:v,length:t-v,content:""},d)}else return A(P,{offset:a.offset,length:a.length,content:JSON.stringify(I)},d);else{if(I===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,v=m?m(T.children.map(r=>r.children[0].value)):T.children.length;let t;if(v>0){const r=T.children[v-1];t={offset:r.offset+r.length,length:0,content:","+l}}else T.children.length===0?t={offset:T.offset+1,length:0,content:l}:t={offset:T.offset+1,length:0,content:l+","};return A(P,t,d)}}else if(T.type==="array"&&typeof E=="number"&&Array.isArray(T.children))if(I!==void 0){const a=`${JSON.stringify(I)}`;let l;if(T.children.length===0||E===0)l={offset:T.offset+1,length:0,content:T.children.length===0?a:a+","};else{const v=E===-1||E>T.children.length?T.children.length:E,t=T.children[v-1];l={offset:t.offset+t.length,length:0,content:","+a}}return A(P,l,d)}else{const a=E,l=T.children[a];let v;if(T.children.length===1)v={offset:T.offset+1,length:T.length-2,content:""};else if(T.children.length-1===a){const t=T.children[a-1],r=t.offset+t.length,s=T.offset+T.length;v={offset:r,length:s-2-r,content:""}}else v={offset:l.offset,length:T.children[a+1].offset-l.offset,content:""};return A(P,v,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${T.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},d)}}e.setProperty=D;function A(P,n,I){let d=C(P,n),m=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,L.isEOL)(d,m-1);)m--;for(;u<d.length&&!(0,L.isEOL)(d,u);)u++}const p=(0,L.format)(d,{offset:m,length:u-m},I);for(let T=p.length-1;T>=0;T--){const E=p[T];d=C(d,E),m=Math.min(m,E.offset),u=Math.max(u,E.offset+E.length),u+=E.content.length-E.length}const _=P.length-(d.length-u)-m;return[{offset:m,length:_,content:d.substring(m,u)}]}e.withFormatting=A;function C(P,n){return P.substring(0,n.offset)+n.content+P.substring(n.offset+n.length)}e.applyEdit=C;function y(P,n){let I=n.slice(0).sort((m,u)=>{const p=m.offset-u.offset;return p===0?m.length-u.length:p}),d=P.length;for(let m=I.length-1;m>=0;m--){let u=I[m];if(u.offset+u.length<=d)P=C(P,u);else throw new Error("Overlapping edit");d=u.offset}return P}e.applyEdits=y}),define(me[140],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(me[6],ge([0,1,74,76]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let D=null;function A(s){D=s}if(e.setDisposableTracker=A,k){const s="__is_disposable_tracked__";A(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function C(s){return D?.trackDisposable(s),s}function y(s){D?.markAsDisposed(s)}function P(s,i){D?.setParent(s,i)}function n(s,i){if(!!D)for(const c of s)D.setParent(c,i)}function I(s){return D?.markAsSingleton(s),s}e.markAsSingleton=I;class d extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=d;function m(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=m;function u(s){if(L.Iterable.is(s)){let i=[];for(const c of s)if(c)try{c.dispose()}catch(f){i.push(f)}if(i.length===1)throw i[0];if(i.length>1)throw new d(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=u;function p(...s){const i=_(()=>u(s));return n(s,i),i}e.combinedDisposable=p;function _(s){const i=C({dispose:(0,g.once)(()=>{y(i),s()})});return i}e.toDisposable=_;class T{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return P(i,this),this._isDisposed?T.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=T,T.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new T,C(this),P(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&P(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&P(i,null),i}}e.MutableDisposable=a;class l{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class v{constructor(){this.references=new Map}acquire(i,...c){let f=this.references.get(i);f||(f={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,f));const{object:h}=f,b=(0,g.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(i,f.object),this.references.delete(i))});return f.counter++,{object:h,dispose:b}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const f=this.referenceCollection.acquire(i,...c);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(h){throw f.dispose(),h}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(me[95],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(D){this.element=D,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let D=this._first;for(;D!==g.Undefined;){const A=D.next;D.prev=g.Undefined,D.next=g.Undefined,D=A}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,A){const C=new g(D);if(this._first===g.Undefined)this._first=C,this._last=C;else if(A){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(C))}}shift(){if(this._first!==g.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==g.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==g.Undefined&&D.next!==g.Undefined){const A=D.prev;A.next=D.next,D.next.prev=A}else D.prev===g.Undefined&&D.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):D.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):D.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==g.Undefined;)yield D.element,D=D.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,Se){for(var Ce=0;Ce<Se.length;Ce++){var ne=Se[Ce];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Re,ne.key,ne)}}function e(Re,Se,Ce){return Se&&Y(Re.prototype,Se),Ce&&Y(Re,Ce),Re}function g(Re,Se){if(!!Re){if(typeof Re=="string")return L(Re,Se);var Ce=Object.prototype.toString.call(Re).slice(8,-1);if(Ce==="Object"&&Re.constructor&&(Ce=Re.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Re);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return L(Re,Se)}}function L(Re,Se){(Se==null||Se>Re.length)&&(Se=Re.length);for(var Ce=0,ne=new Array(Se);Ce<Se;Ce++)ne[Ce]=Re[Ce];return ne}function k(Re,Se){var Ce=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Ce)return(Ce=Ce.call(Re)).next.bind(Ce);if(Array.isArray(Re)||(Ce=g(Re))||Se&&Re&&typeof Re.length=="number"){Ce&&(Re=Ce);var ne=0;return function(){return ne>=Re.length?{done:!0}:{done:!1,value:Re[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var D={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Re){D.exports.defaults=Re}D.exports={defaults:A(),getDefaults:A,changeDefaults:C};var y=/[&<>"']/,P=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(Se){return d[Se]};function u(Re,Se){if(Se){if(y.test(Re))return Re.replace(P,m)}else if(n.test(Re))return Re.replace(I,m);return Re}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Re){return Re.replace(p,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var T=/(^|[^\[])\^/g;function E(Re,Se){Re=Re.source||Re,Se=Se||"";var Ce={replace:function(de,be){return be=be.source||be,be=be.replace(T,"$1"),Re=Re.replace(de,be),Ce},getRegex:function(){return new RegExp(Re,Se)}};return Ce}var a=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,Se,Ce){if(Re){var ne;try{ne=decodeURIComponent(_(Ce)).replace(a,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Se&&!l.test(Ce)&&(Ce=c(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(de){return null}return Ce}var t={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Re,Se){t[" "+Re]||(r.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=S(Re,"/",!0)),Re=t[" "+Re];var Ce=Re.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Re.replace(s,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Re.replace(i,"$1")+Se:Re+Se}var f={exec:function(){}};function h(Re){for(var Se=1,Ce,ne;Se<arguments.length;Se++){Ce=arguments[Se];for(ne in Ce)Object.prototype.hasOwnProperty.call(Ce,ne)&&(Re[ne]=Ce[ne])}return Re}function b(Re,Se){var Ce=Re.replace(/\|/g,function(be,we,Me){for(var Ve=!1,We=we;--We>=0&&Me[We]==="\\";)Ve=!Ve;return Ve?"|":" |"}),ne=Ce.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>Se)ne.splice(Se);else for(;ne.length<Se;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function S(Re,Se,Ce){var ne=Re.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Re.charAt(ne-de-1);if(be===Se&&!Ce)de++;else if(be!==Se&&Ce)de++;else break}return Re.substr(0,ne-de)}function o(Re,Se){if(Re.indexOf(Se[1])===-1)return-1;for(var Ce=Re.length,ne=0,de=0;de<Ce;de++)if(Re[de]==="\\")de++;else if(Re[de]===Se[0])ne++;else if(Re[de]===Se[1]&&(ne--,ne<0))return de;return-1}function w(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Re),Se>>=1,Re+=Re;return Ce+Re}var O={escape:u,unescape:_,edit:E,cleanUrl:v,resolveUrl:c,noopTest:f,merge:h,splitCells:b,rtrim:S,findClosingBracket:o,checkSanitizeDeprecation:w,repeatString:R},$=D.exports.defaults,K=O.rtrim,G=O.splitCells,N=O.escape,x=O.findClosingBracket;function F(Re,Se,Ce,ne){var de=Se.href,be=Se.title?N(Se.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");return Re[0].charAt(0)!=="!"?(ne.state.inLink=!0,{type:"link",raw:Ce,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])}):{type:"image",raw:Ce,href:de,title:be,text:N(we)}}function V(Re,Se){var Ce=Re.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var ne=Ce[1];return Se.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var M=function(){function Re(Ce){this.options=Ce||$}var Se=Re.prototype;return Se.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Se.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:K(be,`
`)}}},Se.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=V(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},Se.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=K(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Me={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Me.text,Me.tokens),Me}},Se.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},Se.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Se.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Me,Ve,We,Je,nt,oe,Ee,ue,j=de[1].trim(),Ae=j.length>1,Ie={type:"list",raw:"",ordered:Ae,start:Ae?+j.slice(0,-1):"",loose:!1,items:[]};j=Ae?"\\d{1,9}\\"+j.slice(-1):"\\"+j,this.options.pedantic&&(j=Ae?j:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+j+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ye.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(Ve=2,ue=Ee[0].trimLeft()):(Ve=de[2].search(/[^ ]/),Ve=de[1].length+(Ve>4?1:Ve),ue=Ee[0].slice(Ve-de[1].length)),Je=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Ie.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,Ve-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(We=1;We<Ee.length;We++){if(oe=Ee[We],this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(oe)){be=de[1]+Ee.slice(0,We).join(`
`)+`
`;break}if(!Je){oe.trim()||(Je=!0),oe.search(/[^ ]/)>=Ve?ue+=`
`+oe.slice(Ve):ue+=`
`+oe;continue}if(oe.search(/[^ ]/)>=Ve||!oe.trim()){ue+=`
`+oe.slice(Ve);continue}else{be=de[1]+Ee.slice(0,We).join(`
`)+`
`;break}}Ie.loose||(nt?Ie.loose=!0:/\n *\n *$/.test(be)&&(nt=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ue),we&&(Me=we[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:be,task:!!we,checked:Me,loose:!1,text:ue}),Ie.raw+=be,ne=ne.slice(be.length)}Ie.items[Ie.items.length-1].raw=be.trimRight(),Ie.items[Ie.items.length-1].text=ue.trimRight(),Ie.raw=Ie.raw.trimRight();var ot=Ie.items.length;for(We=0;We<ot;We++)this.lexer.state.top=!1,Ie.items[We].tokens=this.lexer.blockTokens(Ie.items[We].text,[]),Ie.items[We].tokens.some(function(_t){return _t.type==="space"})&&(Ie.loose=!0,Ie.items[We].loose=!0);return Ie}},Se.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):N(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Se.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},Se.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:G(de[1]).map(function(nt){return{text:nt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Me,Ve,We,Je;for(Me=0;Me<we;Me++)/^ *-+: *$/.test(be.align[Me])?be.align[Me]="right":/^ *:-+: *$/.test(be.align[Me])?be.align[Me]="center":/^ *:-+ *$/.test(be.align[Me])?be.align[Me]="left":be.align[Me]=null;for(we=be.rows.length,Me=0;Me<we;Me++)be.rows[Me]=G(be.rows[Me],be.header.length).map(function(nt){return{text:nt}});for(we=be.header.length,Ve=0;Ve<we;Ve++)be.header[Ve].tokens=[],this.lexer.inlineTokens(be.header[Ve].text,be.header[Ve].tokens);for(we=be.rows.length,Ve=0;Ve<we;Ve++)for(Je=be.rows[Ve],We=0;We<Je.length;We++)Je[We].tokens=[],this.lexer.inlineTokens(Je[We].text,Je[We].tokens);return be}}},Se.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Se.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Se.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Se.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:N(de[1])}},Se.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):N(de[0]):de[0]}},Se.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=K(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Me=x(de[2],"()");if(Me>-1){var Ve=de[0].indexOf("!")===0?5:4,We=Ve+de[1].length+Me;de[2]=de[2].substring(0,Me),de[0]=de[0].substring(0,We).trim(),de[3]=""}}var Je=de[2],nt="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Je);oe&&(Je=oe[1],nt=oe[3])}else nt=de[3]?de[3].slice(1,-1):"";return Je=Je.trim(),/^</.test(Je)&&(this.options.pedantic&&!/>$/.test(be)?Je=Je.slice(1):Je=Je.slice(1,-1)),F(de,{href:Je&&Je.replace(this.rules.inline._escapes,"$1"),title:nt&&nt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Se.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Me=be[0].charAt(0);return{type:"text",raw:Me,text:Me}}return F(be,we,be[0],this.lexer)}},Se.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=we[1]||we[2]||"";if(!Me||Me&&(be===""||this.rules.inline.punctuation.exec(be))){var Ve=we[0].length-1,We,Je,nt=Ve,oe=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+Ve);(we=Ee.exec(de))!=null;)if(We=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!We){if(Je=We.length,we[3]||we[4]){nt+=Je;continue}else if((we[5]||we[6])&&Ve%3&&!((Ve+Je)%3)){oe+=Je;continue}if(nt-=Je,!(nt>0)){if(Je=Math.min(Je,Je+nt+oe),Math.min(Ve,Je)%2){var ue=ne.slice(1,Ve+we.index+Je);return{type:"em",raw:ne.slice(0,Ve+we.index+Je+1),text:ue,tokens:this.lexer.inlineTokens(ue,[])}}var j=ne.slice(2,Ve+we.index+Je-1);return{type:"strong",raw:ne.slice(0,Ve+we.index+Je+1),text:j,tokens:this.lexer.inlineTokens(j,[])}}}}}},Se.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Me=/^ /.test(be)&&/ $/.test(be);return we&&Me&&(be=be.substring(1,be.length-1)),be=N(be,!0),{type:"codespan",raw:de[0],text:be}}},Se.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},Se.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Se.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Me;return be[2]==="@"?(we=N(this.options.mangle?de(be[1]):be[1]),Me="mailto:"+we):(we=N(be[1]),Me=we),{type:"link",raw:be[0],text:we,href:Me,tokens:[{type:"text",raw:we,text:we}]}}},Se.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Me;if(be[2]==="@")we=N(this.options.mangle?de(be[0]):be[0]),Me="mailto:"+we;else{var Ve;do Ve=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ve!==be[0]);we=N(be[0]),be[1]==="www."?Me="http://"+we:Me=we}return{type:"link",raw:be[0],text:we,href:Me,tokens:[{type:"text",raw:we,text:we}]}}},Se.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):N(be[0]):be[0]:we=N(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),U=O.noopTest,q=O.edit,W=O.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=q(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=q(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=q(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=q(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=q(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=q(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=W({},X),X.gfm=W({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=q(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=W({},X.normal,{html:q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:q(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Z.punctuation=q(Z.punctuation).replace(/punctuation/g,Z._punctuation).getRegex(),Z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Z.escapedEmSt=/\\\*|\\_/g,Z._comment=q(X._comment).replace("(?:-->|$)","-->").getRegex(),Z.emStrong.lDelim=q(Z.emStrong.lDelim).replace(/punct/g,Z._punctuation).getRegex(),Z.emStrong.rDelimAst=q(Z.emStrong.rDelimAst,"g").replace(/punct/g,Z._punctuation).getRegex(),Z.emStrong.rDelimUnd=q(Z.emStrong.rDelimUnd,"g").replace(/punct/g,Z._punctuation).getRegex(),Z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Z.autolink=q(Z.autolink).replace("scheme",Z._scheme).replace("email",Z._email).getRegex(),Z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Z.tag=q(Z.tag).replace("comment",Z._comment).replace("attribute",Z._attribute).getRegex(),Z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Z.link=q(Z.link).replace("label",Z._label).replace("href",Z._href).replace("title",Z._title).getRegex(),Z.reflink=q(Z.reflink).replace("label",Z._label).getRegex(),Z.reflinkSearch=q(Z.reflinkSearch,"g").replace("reflink",Z.reflink).replace("nolink",Z.nolink).getRegex(),Z.normal=W({},Z),Z.pedantic=W({},Z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:q(/^!?\[(label)\]\((.*?)\)/).replace("label",Z._label).getRegex(),reflink:q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Z._label).getRegex()}),Z.gfm=W({},Z.normal,{escape:q(Z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Z.gfm.url=q(Z.gfm.url,"i").replace("email",Z.gfm._extended_email).getRegex(),Z.breaks=W({},Z.gfm,{br:q(Z.br).replace("{2,}","*").getRegex(),text:q(Z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:X,inline:Z},_e=M,De=D.exports.defaults,Le=fe.block,qe=fe.inline,xe=O.repeatString;function Ke(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Re){var Se="",Ce,ne,de=Re.length;for(Ce=0;Ce<de;Ce++)ne=Re.charCodeAt(Ce),Math.random()>.5&&(ne="x"+ne.toString(16)),Se+="&#"+ne+";";return Se}var ee=function(){function Re(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||De,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Le.normal,inline:qe.normal};this.options.pedantic?(ne.block=Le.pedantic,ne.inline=qe.pedantic):this.options.gfm&&(ne.block=Le.gfm,this.options.breaks?ne.inline=qe.breaks:ne.inline=qe.gfm),this.tokenizer.rules=ne}Re.lex=function(ne,de){var be=new Re(de);return be.lex(ne)},Re.lexInline=function(ne,de){var be=new Re(de);return be.inlineTokens(ne)};var Se=Re.prototype;return Se.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Se.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Me,Ve,We;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(nt){return(we=nt.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Me=de[de.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Me=de[de.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ve=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var nt=Infinity,oe=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ue){Ee=ue.call({lexer:this},oe),typeof Ee=="number"&&Ee>=0&&(nt=Math.min(nt,Ee))}),nt<Infinity&&nt>=0&&(Ve=ne.substring(0,nt+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ve))){Me=de[de.length-1],We&&Me.type==="paragraph"?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(we),We=Ve.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Me=de[de.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(we);continue}if(ne){var Je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Je);break}else throw new Error(Je)}}return this.state.top=!0,de},Se.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},Se.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Me,Ve,We=ne,Je,nt,oe;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Je=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)Ee.includes(Je[0].slice(Je[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,Je.index)+"["+xe("a",Je[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Je=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,Je.index)+"["+xe("a",Je[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Je=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,Je.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(nt||(oe=""),nt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(j){return(we=j.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Me=de[de.length-1],Me&&we.type==="text"&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Me=de[de.length-1],Me&&we.type==="text"&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,We,oe)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,H)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,H))){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ve=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var j=Infinity,Ae=ne.slice(1),Ie=void 0;be.options.extensions.startInline.forEach(function(Ye){Ie=Ye.call({lexer:this},Ae),typeof Ie=="number"&&Ie>=0&&(j=Math.min(j,Ie))}),j<Infinity&&j>=0&&(Ve=ne.substring(0,j+1))}(),we=this.tokenizer.inlineText(Ve,Ke)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(oe=we.raw.slice(-1)),nt=!0,Me=de[de.length-1],Me&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):de.push(we);continue}if(ne){var ue="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:Le,inline:qe}}}]),Re}(),re=D.exports.defaults,le=O.cleanUrl,J=O.escape,ae=function(){function Re(Ce){this.options=Ce||re}var Se=Re.prototype;return Se.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(ne,we);Me!=null&&Me!==ne&&(be=!0,ne=Me)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+J(we,!0)+'">'+(be?ne:J(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:J(ne,!0))+`</code></pre>
`},Se.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Se.html=function(ne){return ne},Se.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ne,de,be){var we=de?"ol":"ul",Me=de&&be!==1?' start="'+be+'"':"";return"<"+we+Me+`>
`+ne+"</"+we+`>
`},Se.listitem=function(ne){return"<li>"+ne+`</li>
`},Se.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ne){return"<p>"+ne+`</p>
`},Se.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},Se.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Se.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},Se.strong=function(ne){return"<strong>"+ne+"</strong>"},Se.em=function(ne){return"<em>"+ne+"</em>"},Se.codespan=function(ne){return"<code>"+ne+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ne){return"<del>"+ne+"</del>"},Se.link=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+J(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},Se.image=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},Se.text=function(ne){return ne},Re}(),ve=function(){function Re(){}var Se=Re.prototype;return Se.strong=function(ne){return ne},Se.em=function(ne){return ne},Se.codespan=function(ne){return ne},Se.del=function(ne){return ne},Se.html=function(ne){return ne},Se.text=function(ne){return ne},Se.link=function(ne,de,be){return""+be},Se.image=function(ne,de,be){return""+be},Se.br=function(){return""},Re}(),Fe=function(){function Re(){this.seen={}}var Se=Re.prototype;return Se.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},Se.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Re}(),je=ae,Qe=ve,et=Fe,ke=D.exports.defaults,ct=O.unescape,Q=function(){function Re(Ce){this.options=Ce||ke,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Qe,this.slugger=new et}Re.parse=function(ne,de){var be=new Re(de);return be.parse(ne)},Re.parseInline=function(ne,de){var be=new Re(de);return be.parseInline(ne)};var Se=Re.prototype;return Se.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Me,Ve,We,Je,nt,oe,Ee,ue,j,Ae,Ie,Ye,Xe,ot,_t,vt,gt,mt,ht=ne.length;for(we=0;we<ht;we++){if(j=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(mt=this.options.extensions.renderers[j.type].call({parser:this},j),mt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(j.type))){be+=mt||"";continue}switch(j.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(j.tokens),j.depth,ct(this.parseInline(j.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(j.text,j.lang,j.escaped);continue}case"table":{for(Ee="",oe="",We=j.header.length,Me=0;Me<We;Me++)oe+=this.renderer.tablecell(this.parseInline(j.header[Me].tokens),{header:!0,align:j.align[Me]});for(Ee+=this.renderer.tablerow(oe),ue="",We=j.rows.length,Me=0;Me<We;Me++){for(nt=j.rows[Me],oe="",Je=nt.length,Ve=0;Ve<Je;Ve++)oe+=this.renderer.tablecell(this.parseInline(nt[Ve].tokens),{header:!1,align:j.align[Ve]});ue+=this.renderer.tablerow(oe)}be+=this.renderer.table(Ee,ue);continue}case"blockquote":{ue=this.parse(j.tokens),be+=this.renderer.blockquote(ue);continue}case"list":{for(Ae=j.ordered,Ie=j.start,Ye=j.loose,We=j.items.length,ue="",Me=0;Me<We;Me++)ot=j.items[Me],_t=ot.checked,vt=ot.task,Xe="",ot.task&&(gt=this.renderer.checkbox(_t),Ye?ot.tokens.length>0&&ot.tokens[0].type==="paragraph"?(ot.tokens[0].text=gt+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=gt+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:gt}):Xe+=gt),Xe+=this.parse(ot.tokens,Ye),ue+=this.renderer.listitem(Xe,vt,_t);be+=this.renderer.list(ue,Ae,Ie);continue}case"html":{be+=this.renderer.html(j.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(j.tokens));continue}case"text":{for(ue=j.tokens?this.parseInline(j.tokens):j.text;we+1<ht&&ne[we+1].type==="text";)j=ne[++we],ue+=`
`+(j.tokens?this.parseInline(j.tokens):j.text);be+=de?this.renderer.paragraph(ue):ue;continue}default:{var yt='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(yt);return}else throw new Error(yt)}}}return be},Se.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Me,Ve,We=ne.length;for(we=0;we<We;we++){if(Me=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(Ve=this.options.extensions.renderers[Me.type].call({parser:this},Me),Ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){be+=Ve||"";continue}switch(Me.type){case"escape":{be+=de.text(Me.text);break}case"html":{be+=de.html(Me.text);break}case"link":{be+=de.link(Me.href,Me.title,this.parseInline(Me.tokens,de));break}case"image":{be+=de.image(Me.href,Me.title,Me.text);break}case"strong":{be+=de.strong(this.parseInline(Me.tokens,de));break}case"em":{be+=de.em(this.parseInline(Me.tokens,de));break}case"codespan":{be+=de.codespan(Me.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Me.tokens,de));break}case"text":{be+=de.text(Me.text);break}default:{var Je='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return be},Re}(),te=ee,pe=Q,He=M,tt=ae,st=ve,lt=Fe,wt=O.merge,Ct=O.checkSanitizeDeprecation,ce=O.escape,Pe=D.exports.getDefaults,Ne=D.exports.changeDefaults,Ge=D.exports.defaults;function $e(Re,Se,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=wt({},$e.defaults,Se||{}),Ct(Se),Ce){var ne=Se.highlight,de;try{de=te.lex(Re,Se)}catch(Ve){return Ce(Ve)}var be=function(We){var Je;if(!We)try{Se.walkTokens&&$e.walkTokens(de,Se.walkTokens),Je=pe.parse(de,Se)}catch(nt){We=nt}return Se.highlight=ne,We?Ce(We):Ce(null,Je)};if(!ne||ne.length<3||(delete Se.highlight,!de.length))return be();var we=0;$e.walkTokens(de,function(Ve){Ve.type==="code"&&(we++,setTimeout(function(){ne(Ve.text,Ve.lang,function(We,Je){if(We)return be(We);Je!=null&&Je!==Ve.text&&(Ve.text=Je,Ve.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Me=te.lex(Re,Se);return Se.walkTokens&&$e.walkTokens(Me,Se.walkTokens),pe.parse(Me,Se)}catch(Ve){if(Ve.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ce(Ve.message+"",!0)+"</pre>";throw Ve}}$e.options=$e.setOptions=function(Re){return wt($e.defaults,Re),Ne($e.defaults),$e},$e.getDefaults=Pe,$e.defaults=Ge,$e.use=function(){for(var Re=this,Se=arguments.length,Ce=new Array(Se),ne=0;ne<Se;ne++)Ce[ne]=arguments[ne];var de=wt.apply(void 0,[{}].concat(Ce)),be=$e.defaults.extensions||{renderers:{},childTokens:{}},we;Ce.forEach(function(Me){if(Me.extensions&&(we=!0,Me.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Je=be.renderers?be.renderers[We.name]:null;Je?be.renderers[We.name]=function(){for(var nt=arguments.length,oe=new Array(nt),Ee=0;Ee<nt;Ee++)oe[Ee]=arguments[Ee];var ue=We.renderer.apply(this,oe);return ue===!1&&(ue=Je.apply(this,oe)),ue}:be.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[We.level]?be[We.level].unshift(We.tokenizer):be[We.level]=[We.tokenizer],We.start&&(We.level==="block"?be.startBlock?be.startBlock.push(We.start):be.startBlock=[We.start]:We.level==="inline"&&(be.startInline?be.startInline.push(We.start):be.startInline=[We.start]))}We.childTokens&&(be.childTokens[We.name]=We.childTokens)})),Me.renderer&&function(){var We=$e.defaults.renderer||new tt,Je=function(Ee){var ue=We[Ee];We[Ee]=function(){for(var j=arguments.length,Ae=new Array(j),Ie=0;Ie<j;Ie++)Ae[Ie]=arguments[Ie];var Ye=Me.renderer[Ee].apply(We,Ae);return Ye===!1&&(Ye=ue.apply(We,Ae)),Ye}};for(var nt in Me.renderer)Je(nt);de.renderer=We}(),Me.tokenizer&&function(){var We=$e.defaults.tokenizer||new He,Je=function(Ee){var ue=We[Ee];We[Ee]=function(){for(var j=arguments.length,Ae=new Array(j),Ie=0;Ie<j;Ie++)Ae[Ie]=arguments[Ie];var Ye=Me.tokenizer[Ee].apply(We,Ae);return Ye===!1&&(Ye=ue.apply(We,Ae)),Ye}};for(var nt in Me.tokenizer)Je(nt);de.tokenizer=We}(),Me.walkTokens){var Ve=$e.defaults.walkTokens;de.walkTokens=function(We){Me.walkTokens.call(Re,We),Ve&&Ve(We)}}we&&(de.extensions=be),$e.setOptions(de)})},$e.walkTokens=function(Re,Se){for(var Ce=function(){var we=de.value;switch(Se(we),we.type){case"table":{for(var Me=k(we.header),Ve;!(Ve=Me()).done;){var We=Ve.value;$e.walkTokens(We.tokens,Se)}for(var Je=k(we.rows),nt;!(nt=Je()).done;)for(var oe=nt.value,Ee=k(oe),ue;!(ue=Ee()).done;){var j=ue.value;$e.walkTokens(j.tokens,Se)}break}case"list":{$e.walkTokens(we.items,Se);break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[we.type]?$e.defaults.extensions.childTokens[we.type].forEach(function(Ae){$e.walkTokens(we[Ae],Se)}):we.tokens&&$e.walkTokens(we.tokens,Se)}},ne=k(Re),de;!(de=ne()).done;)Ce()},$e.parseInline=function(Re,Se){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Se=wt({},$e.defaults,Se||{}),Ct(Se);try{var Ce=te.lexInline(Re,Se);return Se.walkTokens&&$e.walkTokens(Ce,Se.walkTokens),pe.parseInline(Ce,Se)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ce(ne.message+"",!0)+"</pre>";throw ne}},$e.Parser=pe,$e.parser=pe.parse,$e.Renderer=tt,$e.TextRenderer=st,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=He,$e.Slugger=lt,$e.parse=$e;var at=$e;return at}),define(me[77],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(A,C,y){return Math.min(Math.max(A,C),y)}e.clamp=g;function L(A,C){return(C+A%C)%C}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class D{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=D}),function(){function Y(k){const D=[];typeof k=="number"&&D.push("code/timeOrigin",k);function A(y){D.push(y,Date.now())}function C(){const y=[];for(let P=0;P<D.length;P+=2)y.push({name:D[P],startTime:D[P+1]});return y}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))D.push({name:A.name,startTime:Math.round(k+A.startTime)});return D}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(me[11],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,k=!1,D=!1,A=!1,C=!1,y=!1,P=!1,n,I=g,d,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const p=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=p&&u?.sandboxed,typeof navigator=="object"&&!p)m=navigator.userAgent,L=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,P=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=m.indexOf("Linux")>=0,y=!0,n=navigator.language,I=n;else if(typeof u=="object"){L=u.platform==="win32",k=u.platform==="darwin",D=u.platform==="linux",A=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=g,I=g;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),c=i.availableLanguages["*"];n=i.locale,I=c||g,d=i._translationsConfigFile}catch(i){}C=!0}else console.error("Unable to resolve platform.");var _;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function T(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=T;let E=0;k?E=1:L?E=3:D&&(E=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=D,e.isLinuxSnap=A,e.isNative=C,e.isWeb=y,e.isIOS=P,e.platform=E,e.userAgent=m,e.language=I;var a;(function(s){function i(){return e.language}s.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function f(){return e.language==="en"}s.isDefault=f})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let b=0,S=c.length;b<S;b++){const o=c[b];if(o.id===h.data.vscodeSetImmediateId){c.splice(b,1),o.callback();return}}});let f=0;return h=>{const b=++f;c.push({id:b,callback:h}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var l;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||P?2:L?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(me[38],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(D){return(0,g.setImmediate)(D)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(me[8],ge([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,D=90,A=122,C=46,y=47,P=92,n=58,I=63;class d extends Error{constructor(l,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const s=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${s} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(a,l){if(typeof a!="string")throw new d(l,"string",a)}function u(a){return a===y||a===P}function p(a){return a===y}function _(a){return a>=L&&a<=D||a>=k&&a<=A}function T(a,l,v,t){let r="",s=0,i=-1,c=0,f=0;for(let h=0;h<=a.length;++h){if(h<a.length)f=a.charCodeAt(h);else{if(t(f))break;f=y}if(t(f)){if(!(i===h-1||c===1))if(c===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const b=r.lastIndexOf(v);b===-1?(r="",s=0):(r=r.slice(0,b),s=r.length-1-r.lastIndexOf(v)),i=h,c=0;continue}else if(r.length!==0){r="",s=0,i=h,c=0;continue}}l&&(r+=r.length>0?`${v}..`:"..",s=2)}else r.length>0?r+=`${v}${a.slice(i+1,h)}`:r=a.slice(i+1,h),s=h-i-1;i=h,c=0}else f===C&&c!==-1?++c:c=-1}return r}function E(a,l){if(l===null||typeof l!="object")throw new d("pathObject","Object",l);const v=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${t}`:`${v}${a}${t}`:t}e.win32={resolve(...a){let l="",v="",t=!1;for(let r=a.length-1;r>=-1;r--){let s;if(r>=0){if(s=a[r],m(s,"path"),s.length===0)continue}else l.length===0?s=g.cwd():(s=g.env[`=${l}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${l}\\`));const i=s.length;let c=0,f="",h=!1;const b=s.charCodeAt(0);if(i===1)u(b)&&(c=1,h=!0);else if(u(b))if(h=!0,u(s.charCodeAt(1))){let S=2,o=S;for(;S<i&&!u(s.charCodeAt(S));)S++;if(S<i&&S!==o){const w=s.slice(o,S);for(o=S;S<i&&u(s.charCodeAt(S));)S++;if(S<i&&S!==o){for(o=S;S<i&&!u(s.charCodeAt(S));)S++;(S===i||S!==o)&&(f=`\\\\${w}\\${s.slice(o,S)}`,c=S)}}}else c=1;else _(b)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),c=2,i>2&&u(s.charCodeAt(2))&&(h=!0,c=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(v=`${s.slice(c)}\\${v}`,t=h,h&&l.length>0)break}return v=T(v,!t,"\\",u),t?`${l}\\${v}`:`${l}${v}`||"."},normalize(a){m(a,"path");const l=a.length;if(l===0)return".";let v=0,t,r=!1;const s=a.charCodeAt(0);if(l===1)return p(s)?"\\":a;if(u(s))if(r=!0,u(a.charCodeAt(1))){let c=2,f=c;for(;c<l&&!u(a.charCodeAt(c));)c++;if(c<l&&c!==f){const h=a.slice(f,c);for(f=c;c<l&&u(a.charCodeAt(c));)c++;if(c<l&&c!==f){for(f=c;c<l&&!u(a.charCodeAt(c));)c++;if(c===l)return`\\\\${h}\\${a.slice(f)}\\`;c!==f&&(t=`\\\\${h}\\${a.slice(f,c)}`,v=c)}}}else v=1;else _(s)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),v=2,l>2&&u(a.charCodeAt(2))&&(r=!0,v=3));let i=v<l?T(a.slice(v),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(a.charCodeAt(l-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){m(a,"path");const l=a.length;if(l===0)return!1;const v=a.charCodeAt(0);return u(v)||l>2&&_(v)&&a.charCodeAt(1)===n&&u(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let l,v;for(let s=0;s<a.length;++s){const i=a[s];m(i,"path"),i.length>0&&(l===void 0?l=v=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++r;const s=v.length;s>1&&u(v.charCodeAt(1))&&(++r,s>2&&(u(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&u(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(a,l){if(m(a,"from"),m(l,"to"),a===l)return"";const v=e.win32.resolve(a),t=e.win32.resolve(l);if(v===t||(a=v.toLowerCase(),l=t.toLowerCase(),a===l))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===P;)r++;let s=a.length;for(;s-1>r&&a.charCodeAt(s-1)===P;)s--;const i=s-r;let c=0;for(;c<l.length&&l.charCodeAt(c)===P;)c++;let f=l.length;for(;f-1>c&&l.charCodeAt(f-1)===P;)f--;const h=f-c,b=i<h?i:h;let S=-1,o=0;for(;o<b;o++){const R=a.charCodeAt(r+o);if(R!==l.charCodeAt(c+o))break;R===P&&(S=o)}if(o!==b){if(S===-1)return t}else{if(h>b){if(l.charCodeAt(c+o)===P)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}i>b&&(a.charCodeAt(r+o)===P?S=o:o===2&&(S=3)),S===-1&&(S=0)}let w="";for(o=r+S+1;o<=s;++o)(o===s||a.charCodeAt(o)===P)&&(w+=w.length===0?"..":"\\..");return c+=S,w.length>0?`${w}${t.slice(c,f)}`:(t.charCodeAt(c)===P&&++c,t.slice(c,f))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const l=e.win32.resolve(a);if(l.length<=2)return a;if(l.charCodeAt(0)===P){if(l.charCodeAt(1)===P){const v=l.charCodeAt(2);if(v!==I&&v!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(_(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===P)return`\\\\?\\${l}`;return a},dirname(a){m(a,"path");const l=a.length;if(l===0)return".";let v=-1,t=0;const r=a.charCodeAt(0);if(l===1)return u(r)?a:".";if(u(r)){if(v=t=1,u(a.charCodeAt(1))){let c=2,f=c;for(;c<l&&!u(a.charCodeAt(c));)c++;if(c<l&&c!==f){for(f=c;c<l&&u(a.charCodeAt(c));)c++;if(c<l&&c!==f){for(f=c;c<l&&!u(a.charCodeAt(c));)c++;if(c===l)return a;c!==f&&(v=t=c+1)}}}}else _(r)&&a.charCodeAt(1)===n&&(v=l>2&&u(a.charCodeAt(2))?3:2,t=v);let s=-1,i=!0;for(let c=l-1;c>=t;--c)if(u(a.charCodeAt(c))){if(!i){s=c;break}}else i=!1;if(s===-1){if(v===-1)return".";s=v}return a.slice(0,s)},basename(a,l){l!==void 0&&m(l,"ext"),m(a,"path");let v=0,t=-1,r=!0,s;if(a.length>=2&&_(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(v=2),l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let i=l.length-1,c=-1;for(s=a.length-1;s>=v;--s){const f=a.charCodeAt(s);if(u(f)){if(!r){v=s+1;break}}else c===-1&&(r=!1,c=s+1),i>=0&&(f===l.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=v;--s)if(u(a.charCodeAt(s))){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){m(a,"path");let l=0,v=-1,t=0,r=-1,s=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&_(a.charCodeAt(0))&&(l=t=2);for(let c=a.length-1;c>=l;--c){const f=a.charCodeAt(c);if(u(f)){if(!s){t=c+1;break}continue}r===-1&&(s=!1,r=c+1),f===C?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":a.slice(v,r)},format:E.bind(null,"\\"),parse(a){m(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const v=a.length;let t=0,r=a.charCodeAt(0);if(v===1)return u(r)?(l.root=l.dir=a,l):(l.base=l.name=a,l);if(u(r)){if(t=1,u(a.charCodeAt(1))){let S=2,o=S;for(;S<v&&!u(a.charCodeAt(S));)S++;if(S<v&&S!==o){for(o=S;S<v&&u(a.charCodeAt(S));)S++;if(S<v&&S!==o){for(o=S;S<v&&!u(a.charCodeAt(S));)S++;S===v?t=S:S!==o&&(t=S+1)}}}}else if(_(r)&&a.charCodeAt(1)===n){if(v<=2)return l.root=l.dir=a,l;if(t=2,u(a.charCodeAt(2))){if(v===3)return l.root=l.dir=a,l;t=3}}t>0&&(l.root=a.slice(0,t));let s=-1,i=t,c=-1,f=!0,h=a.length-1,b=0;for(;h>=t;--h){if(r=a.charCodeAt(h),u(r)){if(!f){i=h+1;break}continue}c===-1&&(f=!1,c=h+1),r===C?s===-1?s=h:b!==1&&(b=1):s!==-1&&(b=-1)}return c!==-1&&(s===-1||b===0||b===1&&s===c-1&&s===i+1?l.base=l.name=a.slice(i,c):(l.name=a.slice(i,s),l.base=a.slice(i,c),l.ext=a.slice(s,c))),i>0&&i!==t?l.dir=a.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let l="",v=!1;for(let t=a.length-1;t>=-1&&!v;t--){const r=t>=0?a[t]:g.cwd();m(r,"path"),r.length!==0&&(l=`${r}/${l}`,v=r.charCodeAt(0)===y)}return l=T(l,!v,"/",p),v?`/${l}`:l.length>0?l:"."},normalize(a){if(m(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===y,v=a.charCodeAt(a.length-1)===y;return a=T(a,!l,"/",p),a.length===0?l?"/":v?"./":".":(v&&(a+="/"),l?`/${a}`:a)},isAbsolute(a){return m(a,"path"),a.length>0&&a.charCodeAt(0)===y},join(...a){if(a.length===0)return".";let l;for(let v=0;v<a.length;++v){const t=a[v];m(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(a,l){if(m(a,"from"),m(l,"to"),a===l||(a=e.posix.resolve(a),l=e.posix.resolve(l),a===l))return"";const v=1,t=a.length,r=t-v,s=1,i=l.length-s,c=r<i?r:i;let f=-1,h=0;for(;h<c;h++){const S=a.charCodeAt(v+h);if(S!==l.charCodeAt(s+h))break;S===y&&(f=h)}if(h===c)if(i>c){if(l.charCodeAt(s+h)===y)return l.slice(s+h+1);if(h===0)return l.slice(s+h)}else r>c&&(a.charCodeAt(v+h)===y?f=h:h===0&&(f=0));let b="";for(h=v+f+1;h<=t;++h)(h===t||a.charCodeAt(h)===y)&&(b+=b.length===0?"..":"/..");return`${b}${l.slice(s+f)}`},toNamespacedPath(a){return a},dirname(a){if(m(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===y;let v=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===y){if(!t){v=r;break}}else t=!1;return v===-1?l?"/":".":l&&v===1?"//":a.slice(0,v)},basename(a,l){l!==void 0&&m(l,"ext"),m(a,"path");let v=0,t=-1,r=!0,s;if(l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let i=l.length-1,c=-1;for(s=a.length-1;s>=0;--s){const f=a.charCodeAt(s);if(f===y){if(!r){v=s+1;break}}else c===-1&&(r=!1,c=s+1),i>=0&&(f===l.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===y){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){m(a,"path");let l=-1,v=0,t=-1,r=!0,s=0;for(let i=a.length-1;i>=0;--i){const c=a.charCodeAt(i);if(c===y){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),c===C?l===-1?l=i:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||t===-1||s===0||s===1&&l===t-1&&l===v+1?"":a.slice(l,t)},format:E.bind(null,"/"),parse(a){m(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const v=a.charCodeAt(0)===y;let t;v?(l.root="/",t=1):t=0;let r=-1,s=0,i=-1,c=!0,f=a.length-1,h=0;for(;f>=t;--f){const b=a.charCodeAt(f);if(b===y){if(!c){s=f+1;break}continue}i===-1&&(c=!1,i=f+1),b===C?r===-1?r=f:h!==1&&(h=1):r!==-1&&(h=-1)}if(i!==-1){const b=s===0&&v?1:s;r===-1||h===0||h===1&&r===i-1&&r===s+1?l.base=l.name=a.slice(b,i):(l.name=a.slice(b,r),l.base=a.slice(b,i),l.ext=a.slice(r,i))}return s>0?l.dir=a.slice(0,s-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[141],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(D,...A){const C=A.reduce((n,I)=>(n[I]=!0,n),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(n=>!C[n]).forEach(n=>{for(let I=0;I<y.length;I++)if(n.search(y[I])!==-1){delete D[n];break}})}e.sanitizeProcessEnvironment=k}),define(me[46],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(me[3],ge([0,1,16,74,6,95,46]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(a){a.None=()=>k.Disposable.None;function l(G){return(N,x=null,F)=>{let V=!1,M;return M=G(U=>{if(!V)return M?M.dispose():V=!0,N.call(x,U)},null,F),V&&M.dispose(),M}}a.once=l;function v(G,N){return f((x,F=null,V)=>G(M=>x.call(F,N(M)),null,V))}a.map=v;function t(G,N){return f((x,F=null,V)=>G(M=>{N(M),x.call(F,M)},null,V))}a.forEach=t;function r(G,N){return f((x,F=null,V)=>G(M=>N(M)&&x.call(F,M),null,V))}a.filter=r;function s(G){return G}a.signal=s;function i(...G){return(N,x=null,F)=>(0,k.combinedDisposable)(...G.map(V=>V(M=>N.call(x,M),null,F)))}a.any=i;function c(G,N,x){let F=x;return v(G,V=>(F=N(F,V),F))}a.reduce=c;function f(G){let N;const x=new d({onFirstListenerAdd(){N=G(x.fire,x)},onLastListenerRemove(){N.dispose()}});return x.event}function h(G,N,x=100,F=!1,V){let M,U,q,W=0;const X=new d({leakWarningThreshold:V,onFirstListenerAdd(){M=G(Z=>{W++,U=N(U,Z),F&&!q&&(X.fire(U),U=void 0),clearTimeout(q),q=setTimeout(()=>{const fe=U;U=void 0,q=void 0,(!F||W>1)&&X.fire(fe),W=0},x)})},onLastListenerRemove(){M.dispose()}});return X.event}a.debounce=h;function b(G,N=(x,F)=>x===F){let x=!0,F;return r(G,V=>{const M=x||!N(V,F);return x=!1,F=V,M})}a.latch=b;function S(G,N){return[a.filter(G,N),a.filter(G,x=>!N(x))]}a.split=S;function o(G,N=!1,x=[]){let F=x.slice(),V=G(q=>{F?F.push(q):U.fire(q)});const M=()=>{F&&F.forEach(q=>U.fire(q)),F=null},U=new d({onFirstListenerAdd(){V||(V=G(q=>U.fire(q)))},onFirstListenerDidAdd(){F&&(N?setTimeout(M):M())},onLastListenerRemove(){V&&V.dispose(),V=null}});return U.event}a.buffer=o;class w{constructor(N){this.event=N}map(N){return new w(v(this.event,N))}forEach(N){return new w(t(this.event,N))}filter(N){return new w(r(this.event,N))}reduce(N,x){return new w(c(this.event,N,x))}latch(){return new w(b(this.event))}debounce(N,x=100,F=!1,V){return new w(h(this.event,N,x,F,V))}on(N,x,F){return this.event(N,x,F)}once(N,x,F){return l(this.event)(N,x,F)}}function R(G){return new w(G)}a.chain=R;function O(G,N,x=F=>F){const F=(...q)=>U.fire(x(...q)),V=()=>G.on(N,F),M=()=>G.removeListener(N,F),U=new d({onFirstListenerAdd:V,onLastListenerRemove:M});return U.event}a.fromNodeEventEmitter=O;function $(G,N,x=F=>F){const F=(...q)=>U.fire(x(...q)),V=()=>G.addEventListener(N,F),M=()=>G.removeEventListener(N,F),U=new d({onFirstListenerAdd:V,onLastListenerRemove:M});return U.event}a.fromDOMEventEmitter=$;function K(G){return new Promise(N=>l(G)(N))}a.toPromise=K})(C=e.Event||(e.Event={}));class y{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${y._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let P=-1;function n(a){const l=P;return P=a,{dispose(){P=l}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(l,v=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let v=P;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||l<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let s,i=0;for(const[c,f]of this._stacks)(!s||i<f)&&(s=c,i=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(l,v,t)=>{this._listeners||(this._listeners=new D.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(v?[l,v]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,k.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class m extends d{async fireAsync(l,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],c={...s,waitUntil:f=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof r=="function"?r:r[0])),i.push(f)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(f){(0,g.onUnexpectedError)(f);continue}Object.freeze(i),await Promise.allSettled(i).then(f=>{for(const h of f)h.status==="rejected"&&(0,g.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=m;class u extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class p extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=p;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const v={event:l,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(v=>this.emitter.fire(v))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class T{constructor(){this.buffers=[]}wrapEvent(l){return(v,t,r)=>l(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,s)):v.call(t,s)},void 0,r)}bufferEvents(l){const v=[];this.buffers.push(v);const t=l();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=T;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=k.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,y){const P=setTimeout(C.bind(y),0);return{dispose(){clearTimeout(P)}}});var k;(function(C){function y(P){return P===C.None||P===C.Cancelled||P instanceof D?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=y,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(me[47],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const d=this._icons.get(I.id);d?I.description?d.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function D(n,I){return new C(n,I)}e.registerCodicon=D;function A(n){return n?n.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=A;class C{constructor(I,d,m){this.id=I,this.definition=d,this.description=m,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function y(n,I){const d=["codicon","codicon-"+n];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=y;var P;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(p){if(p instanceof C)return["codicon","codicon-"+p.id];const _=I.exec(p.id);if(!_)return d(C.error);let[,T,E]=_;const a=["codicon","codicon-"+T];return E&&a.push("codicon-modifier-"+E.substr(1)),a}n.asClassNameArray=d;function m(p){return d(p).join(" ")}n.asClassName=m;function u(p){return"."+d(p).join(".")}n.asCSSSelector=u})(P=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=k;function D(a){const l=a;return l?k(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(a,l){return new C(a,l)}e.newWriteableStream=A;class C{constructor(l,v){this.reducer=l,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(v=>v(l))}emitError(l){this.listeners.error.length===0?(0,g.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(v=>v(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,v){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(l,v){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,l){const v=[];let t;for(;(t=a.read())!==null;)v.push(t);return l(v)}e.consumeReadable=y;function P(a,l,v){const t=[];let r;for(;(r=a.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=P;function n(a,l){return new Promise((v,t)=>{const r=[];I(a,{onData:s=>{l&&r.push(s)},onError:s=>{l?t(s):v(void 0)},onEnd:()=>{v(l?l(r):void 0)}})})}e.consumeStream=n;function I(a,l){a.on("error",v=>l.onError(v)),a.on("end",()=>l.onEnd()),a.on("data",v=>l.onData(v))}e.listenStream=I;function d(a,l){return new Promise((v,t)=>{const r=new L.DisposableStore,s=[],i=h=>{if(s.push(h),s.length>l)return r.dispose(),a.pause(),v({stream:a,buffer:s,ended:!1})},c=h=>t(h),f=()=>v({stream:a,buffer:s,ended:!0});r.add((0,L.toDisposable)(()=>a.removeListener("error",c))),a.on("error",c),r.add((0,L.toDisposable)(()=>a.removeListener("end",f))),a.on("end",f),r.add((0,L.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=d;function m(a,l){const v=A(l);return v.end(a),v}e.toStream=m;function u(){const a=A(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=u;function p(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.toReadable=p;function _(a,l,v){const t=A(v);return I(a,{onData:r=>t.write(l.data(r)),onError:r=>t.error(l.error?l.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function T(a,l,v){let t=!1;return{read:()=>{const r=l.read();return t?r:(t=!0,r!==null?v([a,r]):a)}}}e.prefixedReadable=T;function E(a,l,v){let t=!1;const r=A(v);return I(l,{onData:s=>t?r.write(s):(t=!0,r.write(v([a,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(a)),r.end()}}),r}e.prefixedStream=E}),define(me[22],ge([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,D;class A{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new A(Buffer.allocUnsafe(i)):new A(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new A(i)}static fromString(i,c){return!(c?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(i)):(k||(k=new TextEncoder),new A(k.encode(i)))}static concat(i,c){if(typeof c=="undefined"){c=0;for(let b=0,S=i.length;b<S;b++)c+=i[b].byteLength}const f=A.alloc(c);let h=0;for(let b=0,S=i.length;b<S;b++){const o=i[b];f.set(o,h),h+=o.byteLength}return f}toString(){return L?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(i,c){return new A(this.buffer.subarray(i,c))}set(i,c){i instanceof A?this.buffer.set(i.buffer,c):this.buffer.set(i,c)}readUInt32BE(i){return P(this.buffer,i)}writeUInt32BE(i,c){n(this.buffer,i,c)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,c){d(this.buffer,i,c)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,c){u(this.buffer,i,c)}}e.VSBuffer=A;function C(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0}e.readUInt16LE=C;function y(s,i,c){s[c+0]=i&255,i=i>>>8,s[c+1]=i&255}e.writeUInt16LE=y;function P(s,i){return s[i]*2**24+s[i+1]*2**16+s[i+2]*2**8+s[i+3]}e.readUInt32BE=P;function n(s,i,c){s[c+3]=i,i=i>>>8,s[c+2]=i,i=i>>>8,s[c+1]=i,i=i>>>8,s[c]=i}e.writeUInt32BE=n;function I(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0|s[i+2]<<16>>>0|s[i+3]<<24>>>0}e.readUInt32LE=I;function d(s,i,c){s[c+0]=i&255,i=i>>>8,s[c+1]=i&255,i=i>>>8,s[c+2]=i&255,i=i>>>8,s[c+3]=i&255}e.writeUInt32LE=d;function m(s,i){return s[i]}e.readUInt8=m;function u(s,i,c){s[c]=i}e.writeUInt8=u;function p(s){return g.consumeReadable(s,i=>A.concat(i))}e.readableToBuffer=p;function _(s){return g.toReadable(s)}e.bufferToReadable=_;function T(s){return g.consumeStream(s,i=>A.concat(i))}e.streamToBuffer=T;async function E(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await T(s.stream)])}e.bufferedStreamToBuffer=E;function a(s){return g.toStream(s,i=>A.concat(i))}e.bufferToStream=a;function l(s){return g.transform(s,{data:i=>typeof i=="string"?A.fromString(i):A.wrap(i)},i=>A.concat(i))}e.streamToBufferReadableStream=l;function v(s){return g.newWriteableStream(i=>A.concat(i),s)}e.newWriteableBufferStream=v;function t(s,i){return g.prefixedReadable(s,i,c=>A.concat(c))}e.prefixedBufferReadable=t;function r(s,i){return g.prefixedStream(s,i,c=>A.concat(c))}e.prefixedBufferStream=r}),define(me[9],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function k(ce,...Pe){return Pe.length===0?ce:ce.replace(L,function(Ne,Ge){const $e=parseInt(Ge,10);return isNaN($e)||$e<0||$e>=Pe.length?Ne:Pe[$e]})}e.format=k;const D=/{([^}]+)}/g;function A(ce,Pe){return ce.replace(D,(Ne,Ge)=>Pe[Ge]??Ne)}e.format2=A;function C(ce){return ce.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.escape=C;function y(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(ce,Pe){let Ne=0;const Ge=Pe.charCodeAt(0);for(let $e=ce.length-1;$e>=0;$e--)ce.charCodeAt($e)===Ge&&Ne++;return Ne}e.count=P;function n(ce,Pe,Ne="\u2026"){return ce.length<=Pe?ce:`${ce.substr(0,Pe)}${Ne}`}e.truncate=n;function I(ce,Pe=" "){const Ne=d(ce,Pe);return m(Ne,Pe)}e.trim=I;function d(ce,Pe){if(!ce||!Pe)return ce;const Ne=Pe.length;if(Ne===0||ce.length===0)return ce;let Ge=0;for(;ce.indexOf(Pe,Ge)===Ge;)Ge=Ge+Ne;return ce.substring(Ge)}e.ltrim=d;function m(ce,Pe){if(!ce||!Pe)return ce;const Ne=Pe.length,Ge=ce.length;if(Ne===0||Ge===0)return ce;let $e=Ge,at=-1;for(;at=ce.lastIndexOf(Pe,$e-1),!(at===-1||at+Ne!==$e);){if(at===0)return"";$e=at}return ce.substring(0,$e)}e.rtrim=m;function u(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function p(ce){return ce.replace(/\*/g,"")}e.stripWildcards=p;function _(ce,Pe,Ne={}){if(!ce)throw new Error("Cannot create regex from empty string");Pe||(ce=y(ce)),Ne.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Ge="";return Ne.global&&(Ge+="g"),Ne.matchCase||(Ge+="i"),Ne.multiline&&(Ge+="m"),Ne.unicode&&(Ge+="u"),new RegExp(ce,Ge)}e.createRegExp=_;function T(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=T;function E(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function a(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=a;function l(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=l;function v(ce){for(let Pe=0,Ne=ce.length;Pe<Ne;Pe++){const Ge=ce.charCodeAt(Pe);if(Ge!==32&&Ge!==9)return Pe}return-1}e.firstNonWhitespaceIndex=v;function t(ce,Pe=0,Ne=ce.length){for(let Ge=Pe;Ge<Ne;Ge++){const $e=ce.charCodeAt(Ge);if($e!==32&&$e!==9)return ce.substring(Pe,Ge)}return ce.substring(Pe,Ne)}e.getLeadingWhitespace=t;function r(ce,Pe=ce.length-1){for(let Ne=Pe;Ne>=0;Ne--){const Ge=ce.charCodeAt(Ne);if(Ge!==32&&Ge!==9)return Ne}return-1}e.lastNonWhitespaceIndex=r;function s(ce,Pe){return ce<Pe?-1:ce>Pe?1:0}e.compare=s;function i(ce,Pe,Ne=0,Ge=ce.length,$e=0,at=Pe.length){for(;Ne<Ge&&$e<at;Ne++,$e++){let Ce=ce.charCodeAt(Ne),ne=Pe.charCodeAt($e);if(Ce<ne)return-1;if(Ce>ne)return 1}const Re=Ge-Ne,Se=at-$e;return Re<Se?-1:Re>Se?1:0}e.compareSubstring=i;function c(ce,Pe){return f(ce,Pe,0,ce.length,0,Pe.length)}e.compareIgnoreCase=c;function f(ce,Pe,Ne=0,Ge=ce.length,$e=0,at=Pe.length){for(;Ne<Ge&&$e<at;Ne++,$e++){let Ce=ce.charCodeAt(Ne),ne=Pe.charCodeAt($e);if(Ce===ne)continue;const de=Ce-ne;if(!(de===32&&b(ne))&&!(de===-32&&b(Ce)))return h(Ce)&&h(ne)?de:i(ce.toLowerCase(),Pe.toLowerCase(),Ne,Ge,$e,at)}const Re=Ge-Ne,Se=at-$e;return Re<Se?-1:Re>Se?1:0}e.compareSubstringIgnoreCase=f;function h(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=h;function b(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=b;function S(ce){return h(ce)||b(ce)}function o(ce,Pe){return ce.length===Pe.length&&w(ce,Pe)}e.equalsIgnoreCase=o;function w(ce,Pe,Ne=ce.length){for(let Ge=0;Ge<Ne;Ge++){const $e=ce.charCodeAt(Ge),at=Pe.charCodeAt(Ge);if($e!==at){if(S($e)&&S(at)){const Re=Math.abs($e-at);if(Re!==0&&Re!==32)return!1}else if(String.fromCharCode($e).toLowerCase()!==String.fromCharCode(at).toLowerCase())return!1}}return!0}function R(ce,Pe){const Ne=Pe.length;return Pe.length>ce.length?!1:w(ce,Pe,Ne)}e.startsWithIgnoreCase=R;function O(ce,Pe){let Ne,Ge=Math.min(ce.length,Pe.length);for(Ne=0;Ne<Ge;Ne++)if(ce.charCodeAt(Ne)!==Pe.charCodeAt(Ne))return Ne;return Ge}e.commonPrefixLength=O;function $(ce,Pe){let Ne,Ge=Math.min(ce.length,Pe.length);const $e=ce.length-1,at=Pe.length-1;for(Ne=0;Ne<Ge;Ne++)if(ce.charCodeAt($e-Ne)!==Pe.charCodeAt(at-Ne))return Ne;return Ge}e.commonSuffixLength=$;function K(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=K;function G(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=G;function N(ce,Pe){return(ce-55296<<10)+(Pe-56320)+65536}e.computeCodePoint=N;function x(ce,Pe,Ne){const Ge=ce.charCodeAt(Ne);if(K(Ge)&&Ne+1<Pe){const $e=ce.charCodeAt(Ne+1);if(G($e))return N(Ge,$e)}return Ge}e.getNextCodePoint=x;function F(ce,Pe){const Ne=ce.charCodeAt(Pe-1);if(G(Ne)&&Pe>1){const Ge=ce.charCodeAt(Pe-2);if(K(Ge))return N(Ge,Ne)}return Ne}function V(ce,Pe){const Ne=pe.getInstance(),Ge=Pe,$e=ce.length,at=x(ce,$e,Pe);Pe+=at>=65536?2:1;let Re=Ne.getGraphemeBreakType(at);for(;Pe<$e;){const Se=x(ce,$e,Pe),Ce=Ne.getGraphemeBreakType(Se);if(Q(Re,Ce))break;Pe+=Se>=65536?2:1,Re=Ce}return Pe-Ge}e.nextCharLength=V;function M(ce,Pe){const Ne=pe.getInstance(),Ge=Pe,$e=F(ce,Pe);Pe-=$e>=65536?2:1;let at=Ne.getGraphemeBreakType($e);for(;Pe>0;){const Re=F(ce,Pe),Se=Ne.getGraphemeBreakType(Re);if(Q(Se,at))break;Pe-=Re>=65536?2:1,at=Se}return Ge-Pe}e.prevCharLength=M;function U(ce,Pe){const Ne=pe.getInstance(),Ge=ce.length,$e=Pe,at=x(ce,Ge,Pe),Re=Ne.getGraphemeBreakType(at);Pe+=at>=65536?2:1;let Se=Re;for(;Pe<Ge;){const ne=x(ce,Ge,Pe),de=Ne.getGraphemeBreakType(ne);if(Q(Se,de))break;Pe+=ne>=65536?2:1,Se=de}const Ce=Pe;for(Pe=$e,Se=Re;Pe>0;){const ne=F(ce,Pe),de=Ne.getGraphemeBreakType(ne);if(Q(de,Se))break;Pe-=ne>=65536?2:1,Se=de}return[Pe,Ce]}function q(ce,Pe){return Pe>0&&G(ce.charCodeAt(Pe))?U(ce,Pe-1):U(ce,Pe)}e.getCharContainingOffset=q;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(ce){return W.test(ce)}e.containsRTL=X;const Z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function fe(ce){return Z.test(ce)}e.containsEmoji=fe;const _e=/^[\t\n\r\x20-\x7E]*$/;function De(ce){return _e.test(ce)}e.isBasicASCII=De,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=Le;function qe(ce){for(let Pe=0,Ne=ce.length;Pe<Ne;Pe++)if(xe(ce.charCodeAt(Pe)))return!0;return!1}e.containsFullWidthCharacter=qe;function xe(ce){return ce=+ce,ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=xe;function Ke(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=Ke;function H(ce,Pe){if(ce.length<Pe)return ce;const Ne=/\b/g;let Ge=0;for(;Ne.test(ce)&&!(ce.length-Ne.lastIndex<Pe);)Ge=Ne.lastIndex,Ne.lastIndex+=1;return ce.substring(Ge).replace(/^\s/,"")}e.lcut=H;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function J(ce){return ce&&(ce=ce.replace(ee,""),ce=ce.replace(re,""),ce=ce.replace(le,"")),ce}e.removeAnsiEscapeCodes=J,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ae;function ve(ce){return ae(ce)?ce.substr(1):ce}e.stripUTF8BOM=ve;function Fe(ce,Pe){if(!ce||!Pe||ce.length<Pe.length)return!1;const Ne=Pe.length,Ge=ce.toLowerCase();let $e=0,at=-1;for(;$e<Ne;){const Re=Ge.indexOf(Pe[$e],at+1);if(Re<0)return!1;at=Re,$e++}return!0}e.fuzzyContains=Fe;function je(ce,Pe=!1){return ce?(Pe&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=je;function Qe(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Qe;function et(ce,Pe=1){if(Pe===0)return"";let Ne=-1;do Ne=ce.indexOf(`
`,Ne+1),Pe--;while(Pe>0&&Ne>=0);return Ne===-1?ce:(ce[Ne-1]==="\r"&&Ne--,ce.substr(0,Ne))}e.getNLines=et;function ke(ce){const Pe=90-65+1;return ce=ce%(2*Pe),ce<Pe?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Pe)}e.singleLetterHash=ke;function ct(ce){return pe.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=ct;function Q(ce,Pe){return ce===0?Pe!==5&&Pe!==7:ce===2&&Pe===3?!1:ce===4||ce===2||ce===3||Pe===4||Pe===2||Pe===3?!0:!(ce===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(ce===11||ce===9)&&(Pe===9||Pe===10)||(ce===12||ce===10)&&Pe===10||Pe===5||Pe===13||Pe===7||ce===1||ce===13&&Pe===14||ce===6&&Pe===6)}e.breakBetweenGraphemeBreakType=Q;var te;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=He()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Ne=this._data,Ge=Ne.length/3;let $e=1;for(;$e<=Ge;)if(Pe<Ne[3*$e])$e=2*$e;else if(Pe>Ne[3*$e+1])$e=2*$e+1;else return Ne[3*$e+2];return 0}}pe._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(ce,Pe){if(ce===0)return 0;const Ne=st(ce,Pe);if(Ne!==void 0)return Ne;const Ge=F(Pe,ce);return ce-=lt(Ge),ce}e.getLeftDeleteOffset=tt;function st(ce,Pe){let Ne=F(Pe,ce);for(ce-=lt(Ne);wt(Ne)||Ne===65039||Ne===8419;){if(ce===0)return;Ne=F(Pe,ce),ce-=lt(Ne)}if(!!Ke(Ne)){if(ce>=0){const Ge=F(Pe,ce);Ge===8205&&(ce-=lt(Ge))}return ce}}function lt(ce){return ce>=65536?2:1}function wt(ce){return 127995<=ce&&ce<=127999}var Ct;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(Ct||(Ct={}))}),define(me[58],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(T){return k(T,0)}e.hash=L;function k(T,E){switch(typeof T){case"object":return T===null?D(349,E):Array.isArray(T)?y(T,E):P(T,E);case"string":return C(T,E);case"boolean":return A(T,E);case"number":return D(T,E);case"undefined":return D(937,E);default:return D(617,E)}}e.doHash=k;function D(T,E){return(E<<5)-E+T|0}function A(T,E){return D(T?433:863,E)}function C(T,E){E=D(149417,E);for(let a=0,l=T.length;a<l;a++)E=D(T.charCodeAt(a),E);return E}e.stringHash=C;function y(T,E){return E=D(104579,E),T.reduce((a,l)=>k(l,a),E)}function P(T,E){return E=D(181387,E),Object.keys(T).sort().reduce((a,l)=>(a=C(l,a),k(T[l],a)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=n;var I;(function(T){T[T.BLOCK_SIZE=64]="BLOCK_SIZE",T[T.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(T,E,a=32){const l=a-E,v=~((1<<l)-1);return(T<<E|(v&T)>>>l)>>>0}function m(T,E=0,a=T.byteLength,l=0){for(let v=0;v<a;v++)T[E+v]=l}function u(T,E,a="0"){for(;T.length<E;)T=a+T;return T}function p(T,E=32){return T instanceof ArrayBuffer?Array.from(new Uint8Array(T)).map(a=>a.toString(16).padStart(2,"0")).join(""):u((T>>>0).toString(16),E/4)}e.toHexString=p;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const l=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=E.charCodeAt(0),s=0);;){let i=r;if(g.isHighSurrogate(r))if(s+1<a){const c=E.charCodeAt(s+1);g.isLowSurrogate(c)?(s++,i=g.computeCodePoint(r,c)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(v=this._push(l,v,i),s++,s<a)r=E.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,a,l){return l<128?E[a++]=l:l<2048?(E[a++]=192|(l&1984)>>>6,E[a++]=128|(l&63)>>>0):l<65536?(E[a++]=224|(l&61440)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0):(E[a++]=240|(l&1835008)>>>18,E[a++]=128|(l&258048)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,a=this._buffDV;for(let h=0;h<64;h+=4)E.setUint32(h,a.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)E.setUint32(h,d(E.getUint32(h-12,!1)^E.getUint32(h-32,!1)^E.getUint32(h-56,!1)^E.getUint32(h-64,!1),1),!1);let l=this._h0,v=this._h1,t=this._h2,r=this._h3,s=this._h4,i,c,f;for(let h=0;h<80;h++)h<20?(i=v&t|~v&r,c=1518500249):h<40?(i=v^t^r,c=1859775393):h<60?(i=v&t|v&r|t&r,c=2400959708):(i=v^t^r,c=3395469782),f=d(l,5)+i+s+c+E.getUint32(h*4,!1)&4294967295,s=r,r=t,t=d(v,30),v=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const D="error",A="warning",C="warn",y="info",P="ignore";function n(d){return d?g.equalsIgnoreCase(D,d)?k.Error:g.equalsIgnoreCase(A,d)||g.equalsIgnoreCase(C,d)?k.Warning:g.equalsIgnoreCase(y,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=n;function I(d){switch(d){case k.Error:return D;case k.Warning:return A;case k.Info:return y;default:return P}}k.toString=I}(L||(L={})),e.default=L}),define(me[14],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(h){return Array.isArray(h)}e.isArray=g;function L(h){return typeof h=="string"}e.isString=L;function k(h){return Array.isArray(h)&&h.every(b=>L(b))}e.isStringArray=k;function D(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=D;function A(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=A;function C(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=C;function y(h){return h===!0||h===!1}e.isBoolean=y;function P(h){return typeof h=="undefined"}e.isUndefined=P;function n(h){return!I(h)}e.isDefined=n;function I(h){return P(h)||h===null}e.isUndefinedOrNull=I;function d(h,b){if(!h)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=d;function m(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=m;function u(...h){const b=[];for(let S=0;S<h.length;S++){const o=h[S];if(I(o))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);b.push(o)}return b}e.assertAllDefined=u;const p=Object.prototype.hasOwnProperty;function _(h){if(!D(h))return!1;for(let b in h)if(p.call(h,b))return!1;return!0}e.isEmptyObject=_;function T(h){return typeof h=="function"}e.isFunction=T;function E(...h){return h.length>0&&h.every(T)}e.areFunctions=E;function a(h,b){const S=Math.min(h.length,b.length);for(let o=0;o<S;o++)l(h[o],b[o])}e.validateConstraints=a;function l(h,b){if(L(b)){if(typeof h!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(T(b)){try{if(h instanceof b)return}catch{}if(!I(h)&&h.constructor===b||b.length===1&&b.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function v(h){let b=[],S=Object.getPrototypeOf(h);for(;Object.prototype!==S;)b=b.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return b}e.getAllPropertyNames=v;function t(h){const b=[];for(const S of v(h))typeof h[S]=="function"&&b.push(S);return b}e.getAllMethodNames=t;function r(h,b){const S=w=>function(){const R=Array.prototype.slice.call(arguments,0);return b(w,R)};let o={};for(const w of h)o[w]=S(w);return o}e.createProxyObject=r;function s(h){return h===null?void 0:h}e.withNullAsUndefined=s;function i(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=i;function c(h){return class{constructor(){return new Proxy({},{get(b,S){if(b[S])return b[S];throw new Error(`Not Implemented: ${h}->${String(S)}`)}})}}}e.NotImplementedProxy=c;function f(h,b="Unreachable"){throw new Error(b)}e.assertNever=f}),define(me[29],ge([0,1,8,11,9,14]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function C(s){return s.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=C;function y(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function P(s,i=g.posix.sep){if(!s)return"";const c=s.length,f=s.charCodeAt(0);if(A(f)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let b=3;const S=b;for(;b<c&&!A(s.charCodeAt(b));b++);if(S!==b&&!A(s.charCodeAt(b+1))){for(b+=1;b<c;b++)if(A(s.charCodeAt(b)))return s.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(T(f)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(A(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=P;function n(s){if(!L.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let c=2;const f=c;for(;c<s.length&&(i=s.charCodeAt(c),i!==92);c++);return!(f===c||(i=s.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(s,i=L.isWindows){const c=i?I:d;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||i&&m.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=u;function p(s,i,c){const f=s===i;return!c||f?f:!s||!i?!1:(0,k.equalsIgnoreCase)(s,i)}e.isEqual=p;function _(s,i,c,f=g.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let b=i.length;return i.charAt(i.length-1)===f&&b--,s.charAt(b)===f}return i.charAt(i.length-1)!==f&&(i+=f),s.indexOf(i)===0}e.isEqualOrParent=_;function T(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=T;function E(s,i){return L.isWindows&&s.endsWith(":")&&(s+=g.sep),(0,g.isAbsolute)(s)||(s=(0,g.join)(i,s)),s=(0,g.normalize)(s),L.isWindows?(s=(0,k.rtrim)(s,g.sep),s.endsWith(":")&&(s+=g.sep)):(s=(0,k.rtrim)(s,g.sep),s||(s=g.sep)),s}e.sanitizeFilePath=E;function a(s){const i=(0,g.normalize)(s);return L.isWindows?s.length>3?!1:l(i)&&(s.length===2||i.charCodeAt(2)===92):i===g.posix.sep}e.isRootOrDriveLetter=a;function l(s){return L.isWindows?T(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function v(s){return l(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,c){return i.length>s.length?-1:s===i?0:(c&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let c,f,h;if(i.forEach(b=>{const S=Number(b);(0,D.isNumber)(S)?f===void 0?f=S:h===void 0&&(h=S):c=c?[c,b].join(":"):b}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:f!==void 0?f:void 0,column:h!==void 0?h:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[23],ge([0,1,14]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const _=Array.isArray(p)?[]:{};return Object.keys(p).forEach(T=>{p[T]&&typeof p[T]=="object"?_[T]=L(p[T]):_[T]=p[T]}),_}e.deepClone=L;function k(p){if(!p||typeof p!="object")return p;const _=[p];for(;_.length>0;){const T=_.shift();Object.freeze(T);for(const E in T)if(D.call(T,E)){const a=T[E];typeof a=="object"&&!Object.isFrozen(a)&&_.push(a)}}return p}e.deepFreeze=k;const D=Object.prototype.hasOwnProperty;function A(p,_){return C(p,_,new Set)}e.cloneAndChange=A;function C(p,_,T){if((0,g.isUndefinedOrNull)(p))return p;const E=_(p);if(typeof E!="undefined")return E;if((0,g.isArray)(p)){const a=[];for(const l of p)a.push(C(l,_,T));return a}if((0,g.isObject)(p)){if(T.has(p))throw new Error("Cannot clone recursive data-structure");T.add(p);const a={};for(let l in p)D.call(p,l)&&(a[l]=C(p[l],_,T));return T.delete(p),a}return p}function y(p,_,T=!0){return(0,g.isObject)(p)?((0,g.isObject)(_)&&Object.keys(_).forEach(E=>{E in p?T&&((0,g.isObject)(p[E])&&(0,g.isObject)(_[E])?y(p[E],_[E],T):p[E]=_[E]):p[E]=_[E]}),p):_}e.mixin=y;function P(p,_){if(p===_)return!0;if(p==null||_===null||_===void 0||typeof p!=typeof _||typeof p!="object"||Array.isArray(p)!==Array.isArray(_))return!1;let T,E;if(Array.isArray(p)){if(p.length!==_.length)return!1;for(T=0;T<p.length;T++)if(!P(p[T],_[T]))return!1}else{const a=[];for(E in p)a.push(E);a.sort();const l=[];for(E in _)l.push(E);if(l.sort(),!P(a,l))return!1;for(T=0;T<a.length;T++)if(!P(p[a[T]],_[a[T]]))return!1}return!0}e.equals=P;function n(p){const _=new Set;return JSON.stringify(p,(T,E)=>{if((0,g.isObject)(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=n;function I(p,_,T){const E=_(p);return typeof E=="undefined"?T:E}e.getOrDefault=I;function d(p,_){const T=Object.create(null);return!p||!_||Object.keys(_).forEach(a=>{const l=p[a],v=_[a];P(l,v)||(T[a]=v)}),T}e.distinct=d;function m(p,_){const T=_.toLowerCase(),E=Object.keys(p).find(a=>a.toLowerCase()===T);return E?p[E]:p[_]}e.getCaseInsensitive=m;function u(p,_){const T=Object.create(null);for(const E of Object.keys(p))_(E,p[E])&&(T[E]=p[E]);return T}e.filter=u}),define(me[97],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(D){return D<0?0:D>255?255:D|0}e.toUint8=L;function k(D){return D<0?0:D>4294967295?4294967295:D|0}e.toUint32=k}),define(me[2],ge([0,1,8,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,D=/^\//,A=/^\/\//;function C(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!k.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!D.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,i){return!s&&!i?"file":s}function P(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,c,f,h,b,S=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,S),this.authority=c||n,this.path=P(this.scheme,f||n),this.query=h||n,this.fragment=b||n,C(this,S))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:f,path:h,query:b,fragment:S}=i;return c===void 0?c=this.scheme:c===null&&(c=n),f===void 0?f=this.authority:f===null&&(f=n),h===void 0?h=this.path:h===null&&(h=n),b===void 0?b=this.query:b===null&&(b=n),S===void 0?S=this.fragment:S===null&&(S=n),c===this.scheme&&f===this.authority&&h===this.path&&b===this.query&&S===this.fragment?this:new p(c,f,h,b,S)}static parse(i,c=!1){const f=d.exec(i);return f?new p(f[2]||n,r(f[4]||n),r(f[5]||n),r(f[7]||n),r(f[9]||n),c):new p(n,n,n,n,n)}static file(i){let c=n;if(L.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const f=i.indexOf(I,2);f===-1?(c=i.substring(2),i=I):(c=i.substring(2,f),i=i.substring(f)||I)}return new p("file",c,i,n,n)}static from(i){const c=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return C(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return L.isWindows&&i.scheme==="file"?f=m.file(g.win32.join(a(i,!0),...c)).path:f=g.posix.join(i.path,...c),i.with({path:f})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const c=new p(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=m;const u=L.isWindows?1:void 0;class p extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function T(s,i){let c,f=-1;for(let h=0;h<s.length;h++){const b=s.charCodeAt(h);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)f!==-1&&(c+=encodeURIComponent(s.substring(f,h)),f=-1),c!==void 0&&(c+=s.charAt(h));else{c===void 0&&(c=s.substr(0,h));const S=_[b];S!==void 0?(f!==-1&&(c+=encodeURIComponent(s.substring(f,h)),f=-1),c+=S):f===-1&&(f=h)}}return f!==-1&&(c+=encodeURIComponent(s.substring(f))),c!==void 0?c:s}function E(s){let i;for(let c=0;c<s.length;c++){const f=s.charCodeAt(c);f===35||f===63?(i===void 0&&(i=s.substr(0,c)),i+=_[f]):i!==void 0&&(i+=s[c])}return i!==void 0?i:s}function a(s,i){let c;return s.authority&&s.path.length>1&&s.scheme==="file"?c=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?c=s.path.substr(1):c=s.path[1].toLowerCase()+s.path.substr(2):c=s.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=a;function l(s,i){const c=i?E:T;let f="",{scheme:h,authority:b,path:S,query:o,fragment:w}=s;if(h&&(f+=h,f+=":"),(b||h==="file")&&(f+=I,f+=I),b){let R=b.indexOf("@");if(R!==-1){const O=b.substr(0,R);b=b.substr(R+1),R=O.indexOf(":"),R===-1?f+=c(O,!1):(f+=c(O.substr(0,R),!1),f+=":",f+=c(O.substr(R+1),!1)),f+="@"}b=b.toLowerCase(),R=b.indexOf(":"),R===-1?f+=c(b,!1):(f+=c(b.substr(0,R),!1),f+=b.substr(R))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const R=S.charCodeAt(1);R>=65&&R<=90&&(S=`/${String.fromCharCode(R+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const R=S.charCodeAt(0);R>=65&&R<=90&&(S=`${String.fromCharCode(R+32)}:${S.substr(2)}`)}f+=c(S,!0)}return o&&(f+="?",f+=c(o,!1)),w&&(f+="#",f+=i?w:T(w,!1)),f}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>v(i)):s}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[24],ge([0,1,9,2]),function(Y,e,g,L){"use strict";var k,D,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=C;function y(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function P(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class d{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,g.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,g.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,g.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,g.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class p{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new u(r))}static forPaths(){return new _(new d)}static forStrings(){return new _(new n)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let c;for(this._root||(this._root=new p,this._root.segment=i.value()),c=this._root;;){const h=i.cmp(c.segment);if(h>0)c.left||(c.left=new p,c.left.segment=i.value()),c=c.left;else if(h<0)c.right||(c.right=new p,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new p,c.mid.segment=i.value()),c=c.mid;else break}const f=c.value;return c.value=s,c.key=r,f}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),c=[];let f=this._root;for(;f;){const h=i.cmp(f.segment);if(h>0)c.push([1,f]),f=f.left;else if(h<0)c.push([-1,f]),f=f.right;else if(i.hasNext())i.next(),c.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;c.length>0&&f.isEmpty();){let[b,S]=c.pop();switch(b){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}f=S}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,c;for(;i;){const f=s.cmp(i.segment);if(f>0)i=i.left;else if(f<0)i=i.right;else if(s.hasNext())s.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=_;class T{constructor(r,s){this[k]="ResourceMap",r instanceof T?(this.map=new Map(r.map),this.toKey=s??T.defaultToKey):(this.map=new Map,this.toKey=r??T.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,c]of this.map)r(c,L.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=T,T.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class a{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let c=this._map.get(r);if(c)c.value=s,i!==0&&this.touch(c,i);else{switch(c={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let c=this._head;for(;c;){if(s?r.bind(s)(c.value,c.key,this):r(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:i.key,done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return c}values(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:i.value,done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return c}entries(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:[i.key,i.value],done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,c=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=a;class l extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class v{constructor(r){A.set(this,void 0),rt(this,A,r,"f")}get size(){return Be(this,A,"f").size}forEach(r,s){Be(this,A,"f").forEach(r,s)}get(r){return Be(this,A,"f").get(r)}has(r){return Be(this,A,"f").has(r)}entries(){return Be(this,A,"f").entries()}keys(){return Be(this,A,"f").keys()}values(){return Be(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Be(this,A,"f").entries()}}e.ReadonlyMapView=v}),define(me[98],ge([0,1,24,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...J){return function(ae,ve){for(let Fe=0,je=J.length;Fe<je;Fe++){const Qe=J[Fe](ae,ve);if(Qe)return Qe}return null}}e.or=k,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(J,ae,ve){if(!ve||ve.length<ae.length)return null;let Fe;return J?Fe=L.startsWithIgnoreCase(ve,ae):Fe=ve.indexOf(ae)===0,Fe?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(J,ae){const ve=ae.toLowerCase().indexOf(J.toLowerCase());return ve===-1?null:[{start:ve,end:ve+J.length}]}e.matchesContiguousSubString=A;function C(J,ae){return y(J.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=C;function y(J,ae,ve,Fe){if(ve===J.length)return[];if(Fe===ae.length)return null;if(J[ve]===ae[Fe]){let je=null;return(je=y(J,ae,ve+1,Fe+1))?T({start:Fe,end:Fe+1},je):null}return y(J,ae,ve,Fe+1)}function P(J){return 97<=J&&J<=122}function n(J){return 65<=J&&J<=90}e.isUpper=n;function I(J){return 48<=J&&J<=57}function d(J){return J===32||J===9||J===10||J===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>m.add(J.charCodeAt(0)));function u(J){return d(J)||m.has(J)}function p(J,ae){return J===ae||u(J)&&u(ae)}function _(J){return P(J)||n(J)||I(J)}function T(J,ae){return ae.length===0?ae=[J]:J.end===ae[0].start?ae[0].start=J.start:ae.unshift(J),ae}function E(J,ae){for(let ve=ae;ve<J.length;ve++){const Fe=J.charCodeAt(ve);if(n(Fe)||I(Fe)||ve>0&&!_(J.charCodeAt(ve-1)))return ve}return J.length}function a(J,ae,ve,Fe){if(ve===J.length)return[];if(Fe===ae.length)return null;if(J[ve]!==ae[Fe].toLowerCase())return null;{let je=null,Qe=Fe+1;for(je=a(J,ae,ve+1,Fe+1);!je&&(Qe=E(ae,Qe))<ae.length;)je=a(J,ae,ve+1,Qe),Qe++;return je===null?null:T({start:Fe,end:Fe+1},je)}}function l(J){let ae=0,ve=0,Fe=0,je=0,Qe=0;for(let te=0;te<J.length;te++)Qe=J.charCodeAt(te),n(Qe)&&ae++,P(Qe)&&ve++,_(Qe)&&Fe++,I(Qe)&&je++;const et=ae/J.length,ke=ve/J.length,ct=Fe/J.length,Q=je/J.length;return{upperPercent:et,lowerPercent:ke,alphaPercent:ct,numericPercent:Q}}function v(J){const{upperPercent:ae,lowerPercent:ve}=J;return ve===0&&ae>.6}function t(J){const{upperPercent:ae,lowerPercent:ve,alphaPercent:Fe,numericPercent:je}=J;return ve>.2&&ae<.8&&Fe>.6&&je<.2}function r(J){let ae=0,ve=0,Fe=0,je=0;for(let Qe=0;Qe<J.length;Qe++)Fe=J.charCodeAt(Qe),n(Fe)&&ae++,P(Fe)&&ve++,d(Fe)&&je++;return(ae===0||ve===0)&&je===0?J.length<=30:ae<=5}function s(J,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(J)||ae.length>60)return null;const ve=l(ae);if(!t(ve)){if(!v(ve))return null;ae=ae.toLowerCase()}let Fe=null,je=0;for(J=J.toLowerCase();je<ae.length&&(Fe=a(J,ae,0,je))===null;)je=E(ae,je+1);return Fe}e.matchesCamelCase=s;function i(J,ae,ve=!1){if(!ae||ae.length===0)return null;let Fe=null,je=0;for(J=J.toLowerCase(),ae=ae.toLowerCase();je<ae.length&&(Fe=c(J,ae,0,je,ve))===null;)je=f(ae,je+1);return Fe}e.matchesWords=i;function c(J,ae,ve,Fe,je){if(ve===J.length)return[];if(Fe===ae.length)return null;if(p(J.charCodeAt(ve),ae.charCodeAt(Fe))){let Qe=null,et=Fe+1;if(Qe=c(J,ae,ve+1,Fe+1,je),!je)for(;!Qe&&(et=f(ae,et))<ae.length;)Qe=c(J,ae,ve+1,et,je),et++;return Qe===null?null:T({start:Fe,end:Fe+1},Qe)}else return null}function f(J,ae){for(let ve=ae;ve<J.length;ve++)if(u(J.charCodeAt(ve))||ve>0&&u(J.charCodeAt(ve-1)))return ve;return J.length}const h=k(e.matchesPrefix,s,A),b=k(e.matchesPrefix,s,C),S=new g.LRUCache(1e4);function o(J,ae,ve=!1){if(typeof J!="string"||typeof ae!="string")return null;let Fe=S.get(J);Fe||(Fe=new RegExp(L.convertSimple2RegExpPattern(J),"i"),S.set(J,Fe));const je=Fe.exec(ae);return je?[{start:je.index,end:je.index+je[0].length}]:ve?b(J,ae):h(J,ae)}e.matchesFuzzy=o;function w(J,ae){const ve=qe(J,J.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return ve?O(ve):null}e.matchesFuzzy2=w;function R(J,ae,ve,Fe,je,Qe){const et=Math.min(13,J.length);for(;ve<et;ve++){const ke=qe(J,ae,ve,Fe,je,Qe,!1);if(ke)return ke}return[0,Qe]}e.anyScore=R;function O(J){if(typeof J=="undefined")return[];const ae=[],ve=J[1];for(let Fe=J.length-1;Fe>1;Fe--){const je=J[Fe]+ve,Qe=ae[ae.length-1];Qe&&Qe.end===je?Qe.end=je+1:ae.push({start:je,end:je+1})}return ae}e.createMatches=O;const $=128;function K(){const J=[],ae=[];for(let ve=0;ve<=$;ve++)ae[ve]=0;for(let ve=0;ve<=$;ve++)J.push(ae.slice(0));return J}function G(J){const ae=[];for(let ve=0;ve<=J;ve++)ae[ve]=0;return ae}const N=G(2*$),x=G(2*$),F=K(),V=K(),M=K(),U=!1;function q(J,ae,ve,Fe,je){function Qe(ke,ct,Q=" "){for(;ke.length<ct;)ke=Q+ke;return ke}let et=` |   |${Fe.split("").map(ke=>Qe(ke,3)).join("|")}
`;for(let ke=0;ke<=ve;ke++)ke===0?et+=" |":et+=`${ae[ke-1]}|`,et+=J[ke].slice(0,je+1).map(ct=>Qe(ct.toString(),3)).join("|")+`
`;return et}function W(J,ae,ve,Fe){J=J.substr(ae),ve=ve.substr(Fe),console.log(q(V,J,J.length,ve,ve.length)),console.log(q(M,J,J.length,ve,ve.length)),console.log(q(F,J,J.length,ve,ve.length))}function X(J,ae){if(ae<0||ae>=J.length)return!1;const ve=J.codePointAt(ae);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function Z(J,ae){if(ae<0||ae>=J.length)return!1;switch(J.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function fe(J,ae,ve){return ae[J]!==ve[J]}function _e(J,ae,ve,Fe,je,Qe,et=!1){for(;ae<ve&&je<Qe;)J[ae]===Fe[je]&&(et&&(N[ae]=je),ae+=1),je+=1;return ae===ve}e.isPatternInWord=_e;var De;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(De||(De={}));var Le;(function(J){J.Default=[-100,0];function ae(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}J.isDefault=ae})(Le=e.FuzzyScore||(e.FuzzyScore={}));function qe(J,ae,ve,Fe,je,Qe,et){const ke=J.length>$?$:J.length,ct=Fe.length>$?$:Fe.length;if(ve>=ke||Qe>=ct||ke-ve>ct-Qe||!_e(ae,ve,ke,je,Qe,ct,!0))return;xe(ke,ct,ve,Qe,ae,je);let Q=1,te=1,pe=ve,He=Qe;const tt=[!1];for(Q=1,pe=ve;pe<ke;Q++,pe++){const ce=N[pe],Pe=x[pe],Ne=pe+1<ke?x[pe+1]:ct;for(te=ce-Qe+1,He=ce;He<Ne;te++,He++){let Ge=Number.MIN_SAFE_INTEGER,$e=!1;He<=Pe&&(Ge=Ke(J,ae,pe,ve,Fe,je,He,ct,Qe,F[Q-1][te-1]===0,tt));let at=0;Ge!==Number.MAX_SAFE_INTEGER&&($e=!0,at=Ge+V[Q-1][te-1]);const Re=He>ce,Se=Re?V[Q][te-1]+(F[Q][te-1]>0?-5:0):0,Ce=He>ce+1&&F[Q][te-1]>0,ne=Ce?V[Q][te-2]+(F[Q][te-2]>0?-5:0):0;if(Ce&&(!Re||ne>=Se)&&(!$e||ne>=at))V[Q][te]=ne,M[Q][te]=3,F[Q][te]=0;else if(Re&&(!$e||Se>=at))V[Q][te]=Se,M[Q][te]=2,F[Q][te]=0;else if($e)V[Q][te]=at,M[Q][te]=1,F[Q][te]=F[Q-1][te-1]+1;else throw new Error("not possible")}}if(U&&W(J,ve,Fe,Qe),!tt[0]&&!et)return;Q--,te--;const st=[V[Q][te],Qe];let lt=0,wt=0;for(;Q>=1;){let ce=te;do{const Pe=M[Q][ce];if(Pe===3)ce=ce-2;else if(Pe===2)ce=ce-1;else break}while(ce>=1);lt>1&&ae[ve+Q-1]===je[Qe+te-1]&&!fe(ce+Qe-1,Fe,je)&&lt+1>F[Q][ce]&&(ce=te),ce===te?lt++:lt=1,wt||(wt=ce),Q--,te=ce-1,st.push(te)}ct===ke&&(st[0]+=2);const Ct=wt-ke;return st[0]-=Ct,st}e.fuzzyScore=qe;function xe(J,ae,ve,Fe,je,Qe){let et=J-1,ke=ae-1;for(;et>=ve&&ke>=Fe;)je[et]===Qe[ke]&&(x[et]=ke,et--),ke--}function Ke(J,ae,ve,Fe,je,Qe,et,ke,ct,Q,te){if(ae[ve]!==Qe[et])return Number.MIN_SAFE_INTEGER;let pe=1,He=!1;return et===ve-Fe?pe=J[ve]===je[et]?7:5:fe(et,je,Qe)&&(et===0||!fe(et-1,je,Qe))?(pe=J[ve]===je[et]?7:5,He=!0):X(Qe,et)&&(et===0||!X(Qe,et-1))?pe=5:(X(Qe,et-1)||Z(Qe,et-1))&&(pe=5,He=!0),pe>1&&ve===Fe&&(te[0]=!0),He||(He=fe(et,je,Qe)||X(Qe,et-1)||Z(Qe,et-1)),ve===Fe?et>ct&&(pe-=He?3:5):Q?pe+=He?2:0:pe+=He?0:1,et+1===ke&&(pe-=He?3:5),pe}function H(J,ae,ve,Fe,je,Qe,et){return re(J,ae,ve,Fe,je,Qe,!0,et)}e.fuzzyScoreGracefulAggressive=H;function ee(J,ae,ve,Fe,je,Qe,et){return re(J,ae,ve,Fe,je,Qe,!1,et)}e.fuzzyScoreGraceful=ee;function re(J,ae,ve,Fe,je,Qe,et,ke){let ct=qe(J,ae,ve,Fe,je,Qe,ke);if(ct&&!et)return ct;if(J.length>=3){const Q=Math.min(7,J.length-1);for(let te=ve+1;te<Q;te++){const pe=le(J,te);if(pe){const He=qe(pe,pe.toLowerCase(),ve,Fe,je,Qe,ke);He&&(He[0]-=3,(!ct||He[0]>ct[0])&&(ct=He))}}}return ct}function le(J,ae){if(ae+1>=J.length)return;const ve=J[ae],Fe=J[ae+1];if(ve!==Fe)return J.slice(0,ae)+Fe+ve+J.slice(ae+2)}}),define(me[142],ge([0,1,47,98,9]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${D.source}`,"g");function C(p){return p.replace(A,(_,T)=>T?_:`\\${_}`)}e.escapeIcons=C;const y=new RegExp(`\\\\${D.source}`,"g");function P(p){return p.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=P;const n=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function I(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(n,(_,T,E,a)=>E?_:T||a||"")}e.stripIcons=I;function d(p){const _=p.indexOf(e.iconStartMarker);return _===-1?{text:p}:m(p,_)}e.parseLabelWithIcons=d;function m(p,_){const T=[];let E="";function a(f){if(f){E+=f;for(const h of f)T.push(t)}}let l=-1,v="",t=0,r,s,i=_;const c=p.length;for(a(p.substr(0,_));i<c;)r=p[i],s=p[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(l=i,a(v),v=e.iconStartMarker,i++):r===")"&&l!==-1?(t+=i-l+1,l=-1,v=""):l!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(a(v),l=-1,v=""):a(r),i++;return a(v),{text:E,iconOffsets:T}}function u(p,_,T=!1){const{text:E,iconOffsets:a}=_;if(!a||a.length===0)return(0,L.matchesFuzzy)(p,E,T);const l=(0,k.ltrim)(E," "),v=E.length-l.length,t=(0,L.matchesFuzzy)(p,l,T);if(t)for(const r of t){const s=a[r.start+v]+v;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=u}),define(me[99],ge([0,1,16,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(m="",u=!1){if(this.value=m,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(m,u=0){return this.value+=P(this.supportThemeIcons?(0,L.escapeIcons)(m):m).replace(/([ \t]+)/g,(p,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,u){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=D;function A(d){return C(d)?!d.value:Array.isArray(d)?d.every(A):!0}e.isEmptyMarkdownString=A;function C(d){return d instanceof D?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function y(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=y;function P(d){return d.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function n(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(d){const m=[],u=d.split("|").map(_=>_.trim());d=u[0];const p=u[1];if(p){const _=/height=(\d+)/.exec(p),T=/width=(\d+)/.exec(p),E=_?_[1]:"",a=T?T[1]:"",l=isFinite(parseInt(a)),v=isFinite(parseInt(E));l&&m.push(`width="${a}"`),v&&m.push(`height="${E}"`)}return{href:d,dimensions:m}}e.parseHrefAndDimensions=I}),define(me[59],ge([0,1,22,9,2]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(n){return JSON.stringify(n,y)}e.stringify=D;function A(n){let I=JSON.parse(n);return I=P(I),I}e.parse=A;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function y(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function P(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=P(n[d],I+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=P(n[d],I+1))}return n}e.revive=P}),define(me[10],ge([0,1,11,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,n){this._hosts[y]=P,this._ports[y]=n}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let n=this._hosts[P];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[P],d=this._connectionTokens[P];let m=`path=${encodeURIComponent(y.path)}`;return typeof d=="string"&&(m+=`&tkn=${encodeURIComponent(d)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new D;class A{asBrowserUri(y,P){const n=this.toUri(y,P);return n.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===k.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,P){const n=this.toUri(y,P);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,P){return L.URI.isUri(y)?y:L.URI.parse(P.toUrl(y))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(me[78],ge([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function k(P){return y(P,"NFC",L)}e.normalizeNFC=k;const D=new g.LRUCache(1e4);function A(P){return y(P,"NFD",D)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function y(P,n,I){if(!P)return P;const d=I.get(P);if(d)return d;let m;return C.test(P)?m=P.normalize(n):m=P,I.set(P,m),m}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(n){return A(n).replace(P,"")}}()}),define(me[25],ge([0,1,29,10,8,11,9,2]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,C.uriToFsPath)(m,!0)}e.originalFSPath=y;class P{constructor(u){this._ignorePathCasing=u}compare(u,p,_=!1){return u===p?0:(0,A.compare)(this.getComparisonKey(u,_),this.getComparisonKey(p,_))}isEqual(u,p,_=!1){return u===p?!0:!u||!p?!1:this.getComparisonKey(u,_)===this.getComparisonKey(p,_)}getComparisonKey(u,p=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,p,_=!1){if(u.scheme===p.scheme){if(u.scheme===L.Schemas.file)return g.isEqualOrParent(y(u),y(p),this._ignorePathCasing(u))&&u.query===p.query&&(_||u.fragment===p.fragment);if((0,e.isEqualAuthority)(u.authority,p.authority))return g.isEqualOrParent(u.path,p.path,this._ignorePathCasing(u),"/")&&u.query===p.query&&(_||u.fragment===p.fragment)}return!1}joinPath(u,...p){return C.URI.joinPath(u,...p)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return k.posix.basename(u.path)}extname(u){const p=k.posix.extname(u.path),_=p.indexOf("?");return _!==-1?p.substr(0,_):p}dirname(u){if(u.path.length===0)return u;let p;return u.scheme===L.Schemas.file?p=C.URI.file(k.dirname(y(u))).path:(p=k.posix.dirname(u.path),u.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),p="/")),u.with({path:p})}normalizePath(u){if(!u.path.length)return u;let p;return u.scheme===L.Schemas.file?p=C.URI.file(k.normalize(y(u))).path:p=k.posix.normalize(u.path),u.with({path:p})}relativePath(u,p){if(u.scheme!==p.scheme||!(0,e.isEqualAuthority)(u.authority,p.authority))return;if(u.scheme===L.Schemas.file){const E=k.relative(y(u),y(p));return D.isWindows?g.toSlashes(E):E}let _=u.path||"/",T=p.path||"/";if(this._ignorePathCasing(u)){let E=0;for(const a=Math.min(_.length,T.length);E<a&&!(_.charCodeAt(E)!==T.charCodeAt(E)&&_.charAt(E).toLowerCase()!==T.charAt(E).toLowerCase());E++);_=T.substr(0,E)+_.substr(E)}return k.posix.relative(_,T)}resolvePath(u,p){if(u.scheme===L.Schemas.file){const _=C.URI.file(k.resolve(y(u),p));return u.with({authority:_.authority,path:_.path})}return p=g.toPosixPath(p),u.with({path:k.posix.resolve(u.path,p)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,p){return u===p||(0,A.equalsIgnoreCase)(u,p)}hasTrailingPathSeparator(u,p=k.sep){if(u.scheme===L.Schemas.file){const _=y(u);return _.length>g.getRoot(_).length&&_[_.length-1]===p}else{const _=u.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,p=k.sep){return(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,p=k.sep){let _=!1;if(u.scheme===L.Schemas.file){const T=y(u);_=T!==void 0&&T.length===g.getRoot(T).length&&T[T.length-1]===p}else{p="/";const T=u.path;_=T.length===1&&T.charCodeAt(T.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path+"/"}):u}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(m=>m.scheme===L.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new P(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,u){const p=[];for(let _=0;_<m.length;_++){const T=u(m[_]);m.some((E,a)=>a===_?!1:(0,e.isEqualOrParent)(T,u(E)))||p.push(m[_])}return p}e.distinctParents=n;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(p){const _=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[l,v]=a.split(":");l&&v&&_.set(l,v)});const E=p.path.substring(0,p.path.indexOf(";"));return E&&_.set(m.META_DATA_MIME,E),_}m.parseMetaData=u})(I=e.DataUri||(e.DataUri={}));function d(m,u,p){if(u){let _=m.path;return _&&_[0]!==k.posix.sep&&(_=k.posix.sep+_),m.with({scheme:p,authority:u,path:_})}return m.with({scheme:p})}e.toLocalResource=d}),define(me[17],ge([0,1,21,16,3,6,25]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(x){return!!x&&typeof x.then=="function"}e.isThenable=C;function y(x){const F=new g.CancellationTokenSource,V=x(F.token),M=new Promise((U,q)=>{const W=F.token.onCancellationRequested(()=>{W.dispose(),F.dispose(),q((0,L.canceled)())});Promise.resolve(V).then(X=>{W.dispose(),F.dispose(),U(X)},X=>{W.dispose(),F.dispose(),q(X)})});return new class{cancel(){F.cancel()}then(U,q){return M.then(U,q)}catch(U){return this.then(void 0,U)}finally(U){return M.finally(U)}}}e.createCancelablePromise=y;function P(x,F,V){return Promise.race([x,new Promise(M=>F.onCancellationRequested(()=>M(V)))])}e.raceCancellation=P;async function n(x){let F=-1;const V=x.map((U,q)=>U.then(W=>(F=q,W))),M=await Promise.race(V);return x.forEach((U,q)=>{q!==F&&U.cancel()}),M}e.raceCancellablePromises=n;function I(x,F,V){let M;const U=setTimeout(()=>{M?.(void 0),V?.()},F);return Promise.race([x.finally(()=>clearTimeout(U)),new Promise(q=>M=q)])}e.raceTimeout=I;function d(x){return new Promise((F,V)=>{const M=x();C(M)?M.then(F,V):F(M)})}e.asPromise=d;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(V,V).then(M)})}return new Promise((V,M)=>{this.queuedPromise.then(V,M)})}return this.activePromise=F(),new Promise((V,M)=>{this.activePromise.then(U=>{this.activePromise=null,V(U)},U=>{this.activePromise=null,M(U)})})}}e.Throttler=m;class u{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=u;class p{constructor(){this.promiseMap=new Map}queue(F,V){const U=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(F)===U&&this.promiseMap.delete(F)});return this.promiseMap.set(F,U),U}}e.SequencerByKey=p;class _{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,V=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,U)=>{this.doResolve=M,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class T{constructor(F){this.delayer=new _(F),this.throttler=new m}trigger(F,V){return this.delayer.trigger(()=>this.throttler.queue(F),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class E{constructor(){this._isOpen=!1,this._promise=new Promise((F,V)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class a extends E{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(x,F){return F?new Promise((V,M)=>{const U=setTimeout(()=>{q.dispose(),V()},x),q=F.onCancellationRequested(()=>{clearTimeout(U),q.dispose(),M((0,L.canceled)())})}):y(V=>l(x,V))}e.timeout=l;function v(x,F=0){const V=setTimeout(x,F);return(0,D.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=v;function t(x){const F=[];let V=0;const M=x.length;function U(){return V<M?x[V++]():null}function q(W){W!=null&&F.push(W);const X=U();return X?X.then(q):Promise.resolve(F)}return Promise.resolve(null).then(q)}e.sequence=t;function r(x,F=M=>!!M,V=null){let M=0;const U=x.length,q=()=>{if(M>=U)return Promise.resolve(V);const W=x[M++];return Promise.resolve(W()).then(Z=>F(Z)?Promise.resolve(Z):q())};return q()}e.first=r;function s(x,F=M=>!!M,V=null){if(x.length===0)return Promise.resolve(V);let M=x.length;const U=()=>{M=-1;for(const q of x)q.cancel?.()};return new Promise((q,W)=>{for(const X of x)X.then(Z=>{--M>=0&&F(Z)?(U(),q(Z)):M===0&&q(V)}).catch(Z=>{--M>=0&&(U(),W(Z))})})}e.firstParallel=s;class i{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((V,M)=>{this.outstandingPromises.push({factory:F,c:V,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const V=F.factory();V.then(F.c,F.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class f{constructor(){this.queues=new Map}queueFor(F,V=A.extUri){const M=V.getComparisonKey(F);let U=this.queues.get(M);return U||(U=new c,k.Event.once(U.onFinished)(()=>{U?.dispose(),this.queues.delete(M)}),this.queues.set(M,U)),U}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=f;class h{constructor(F,V){this._token=-1,typeof F=="function"&&typeof V=="number"&&this.setIfNotSet(F,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},V)}setIfNotSet(F,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},V))}}e.TimeoutTimer=h;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setInterval(()=>{F()},V)}}e.IntervalTimer=b;class S{constructor(F,V){this.timeoutToken=-1,this.runner=F,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class o extends S{constructor(F,V){super(F,V);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class w extends D.Disposable{constructor(F,V,M,U){super();this.maxWorkChunkSize=F,this.maxPendingWork=V,this.throttleDelay=M,this.handler=U,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=w,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const V=setTimeout(()=>F(x));let M=!1;return{dispose(){M||(M=!0,clearTimeout(V))}}}}else e.runWhenIdle=(x,F)=>{const V=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(V))}}}}();class R{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function O(x,F,V){let M;for(let U=0;U<V;U++)try{return await x()}catch(q){M=q,await l(F)}throw M}e.retry=O;class ${hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,V,M){return this._pending={taskId:F,cancel:()=>M?.(),promise:V},V.then(()=>this.donePending(F),()=>this.donePending(F)),V}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let V,M;const U=new Promise((q,W)=>{V=q,M=W});this._next={run:F,promise:U,promiseResolve:V,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=$;class K{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,V)=>{this.completeCallback=F,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(V=>{this.completeCallback(F),this.resolved=!0,V()})}error(F){return new Promise(V=>{this.errorCallback(F),this.rejected=!0,V()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=G;var N;(function(x){async function F(V){let M;const U=await Promise.all(V.map(q=>q.then(W=>W,W=>{M||(M=W)})));if(typeof M!="undefined")throw M;return U}x.settled=F})(N=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,17,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new g.IdleValue(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),D=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(S,o,w=!1){const R=S||"",O=o||"",$=k.value.collator.compare(R,O);return k.value.collatorIsNumeric&&$===0&&R!==O?R<O?-1:1:$}e.compareFileNames=C;function y(S,o){const w=D.value.collator;return S=S||"",o=o||"",v(w,S,o)}e.compareFileNamesDefault=y;function P(S,o){const w=D.value.collator;return S=S||"",o=o||"",i(S,o)||v(w,S,o)}e.compareFileNamesUpper=P;function n(S,o){const w=D.value.collator;return S=S||"",o=o||"",s(S,o)||v(w,S,o)}e.compareFileNamesLower=n;function I(S,o){return S=S||"",o=o||"",S===o?0:S<o?-1:1}e.compareFileNamesUnicode=I;function d(S,o,w=!1){w||(S=S&&S.toLowerCase(),o=o&&o.toLowerCase());const[R,O]=a(S),[$,K]=a(o);return R!==$?R<$?-1:1:O===K?0:O<K?-1:1}e.noIntlCompareFileNames=d;function m(S,o){const[w,R]=a(S),[O,$]=a(o);let K=k.value.collator.compare(R,$);if(K===0){if(k.value.collatorIsNumeric&&R!==$)return R<$?-1:1;if(K=k.value.collator.compare(w,O),k.value.collatorIsNumeric&&K===0&&w!==O)return w<O?-1:1}return K}e.compareFileExtensions=m;function u(S,o){S=S||"",o=o||"";const w=l(S),R=l(o),O=D.value.collator,$=A.value.collator;return v($,w,R)||v(O,S,o)}e.compareFileExtensionsDefault=u;function p(S,o){S=S||"",o=o||"";const w=l(S),R=l(o),O=D.value.collator,$=A.value.collator;return v($,w,R)||i(S,o)||v(O,S,o)}e.compareFileExtensionsUpper=p;function _(S,o){S=S||"",o=o||"";const w=l(S),R=l(o),O=D.value.collator,$=A.value.collator;return v($,w,R)||s(S,o)||v(O,S,o)}e.compareFileExtensionsLower=_;function T(S,o){S=S||"",o=o||"";const w=l(S).toLowerCase(),R=l(o).toLowerCase();return w!==R?w<R?-1:1:S!==o?S<o?-1:1:0}e.compareFileExtensionsUnicode=T;const E=/^(.*?)(\.([^.]*))?$/;function a(S,o=!1){const w=S?E.exec(S):[];let R=[w&&w[1]||"",w&&w[3]||""];return o&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function l(S){const o=S?E.exec(S):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(S,o,w){let R=S.compare(o,w);return R!==0?R:o.length!==w.length?o.length<w.length?-1:1:0}function t(S){const o=S.charAt(0);return o.toLocaleUpperCase()!==o}function r(S){const o=S.charAt(0);return o.toLocaleLowerCase()!==o}function s(S,o){return t(S)&&r(o)?-1:r(S)&&t(o)?1:0}function i(S,o){return r(S)&&t(o)?-1:t(S)&&r(o)?1:0}function c(S,o,w=!1){return w||(S=S&&S.toLowerCase(),o=o&&o.toLowerCase()),S===o?0:S<o?-1:1}function f(S,o,w=!1){const R=S.split(L.sep),O=o.split(L.sep),$=R.length-1,K=O.length-1;let G,N;for(let x=0;;x++){if(G=$===x,N=K===x,G&&N)return C(R[x],O[x],w);if(G)return-1;if(N)return 1;const F=c(R[x],O[x],w);if(F!==0)return F}}e.comparePaths=f;function h(S,o,w){const R=S.toLowerCase(),O=o.toLowerCase(),$=b(S,o,w);if($)return $;const K=R.endsWith(w),G=O.endsWith(w);if(K!==G)return K?-1:1;const N=C(R,O);return N!==0?N:R.localeCompare(O)}e.compareAnything=h;function b(S,o,w){const R=S.toLowerCase(),O=o.toLowerCase(),$=R.startsWith(w),K=O.startsWith(w);if($!==K)return $?-1:1;if($&&K){if(R.length<O.length)return-1;if(R.length>O.length)return 1}return 0}e.compareByPrefix=b}),define(me[101],ge([0,1,100,98,8,11,9]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,y=[C,[]];function P(G,N,x,F){if(!G||!N)return y;const V=G.length,M=N.length;if(V<M)return y;const U=G.toLowerCase();return!F&&!U.includes(x)?y:n(N,x,M,G,U,V)}e.scoreFuzzy=P;function n(G,N,x,F,V,M){const U=[],q=[];for(let fe=0;fe<x;fe++){const _e=fe*M,De=_e-M,Le=fe>0,qe=G[fe],xe=N[fe];for(let Ke=0;Ke<M;Ke++){const H=Ke>0,ee=_e+Ke,re=ee-1,le=De+Ke-1,J=H?U[re]:0,ae=Le&&H?U[le]:0,ve=Le&&H?q[le]:0;let Fe;!ae&&Le?Fe=0:Fe=I(qe,xe,F,V,Ke,ve),Fe&&ae+Fe>=J?(q[ee]=ve+1,U[ee]=ae+Fe):(q[ee]=C,U[ee]=J)}}const W=[];let X=x-1,Z=M-1;for(;X>=0&&Z>=0;){const fe=X*M+Z;q[fe]===C||(W.push(Z),X--),Z--}return[U[x*M-1],W.reverse()]}function I(G,N,x,F,V,M){let U=0;if(!d(N,F[V]))return U;if(U+=1,M>0&&(U+=M*5),G===x[V]&&(U+=1),V===0)U+=8;else{const q=m(x.charCodeAt(V-1));q?U+=q:(0,L.isUpper)(x.charCodeAt(V))&&(U+=2)}return U}function d(G,N){return G===N?!0:G==="/"||G==="\\"?N==="/"||N==="\\":!1}function m(G){switch(G){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function p(G,N,x=0,F=0){const V=N;return V.values&&V.values.length>1?_(G,V.values,x,F):T(G,N,x,F)}e.scoreFuzzy2=p;function _(G,N,x,F){let V=0;const M=[];for(const U of N){const[q,W]=T(G,U,x,F);if(typeof q!="number")return u;V+=q,M.push(...W)}return[V,f(M)]}function T(G,N,x,F){const V=(0,L.fuzzyScore)(N.original,N.originalLowercase,x,G,G.toLowerCase(),F,!0);return V?[V[0],(0,L.createMatches)(V)]:u}const E=Object.freeze({score:0}),a=1<<18,l=1<<17,v=1<<16;function t(G,N,x,F,V){if(!G||!N.normalized)return E;const M=F.getItemLabel(G);if(!M)return E;const U=F.getItemDescription(G);let q;U?q=`${M}${U}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`:q=`${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`;const W=V[q];if(W)return W;const X=r(M,U,F.getItemPath(G),N,x);return V[q]=X,X}e.scoreItemFuzzy=t;function r(G,N,x,F,V){const M=!x||!F.containsPathSeparator;return x&&(D.isLinux?F.pathNormalized===x:(0,A.equalsIgnoreCase)(F.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:G.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:F.values&&F.values.length>1?s(G,N,x,F.values,M,V):i(G,N,x,F,M,V)}function s(G,N,x,F,V,M){let U=0;const q=[],W=[];for(const X of F){const{score:Z,labelMatch:fe,descriptionMatch:_e}=i(G,N,x,X,V,M);if(Z===C)return E;U+=Z,fe&&q.push(...fe),_e&&W.push(..._e)}return{score:U,labelMatch:f(q),descriptionMatch:f(W)}}function i(G,N,x,F,V,M){if(V||!N){const[U,q]=P(G,F.normalized,F.normalizedLowercase,M);if(U){const W=(0,L.matchesPrefix)(F.normalized,G);let X;return W?(X=l,X+=Math.round(F.normalized.length/G.length*100)):X=v,{score:X+U,labelMatch:W||c(q)}}}if(N){let U=N;x&&(U=`${N}${k.sep}`);const q=U.length,W=`${U}${G}`,[X,Z]=P(W,F.normalized,F.normalizedLowercase,M);if(X){const fe=c(Z),_e=[],De=[];return fe.forEach(Le=>{Le.start<q&&Le.end>q?(_e.push({start:0,end:Le.end-q}),De.push({start:Le.start,end:q})):Le.start>=q?_e.push({start:Le.start-q,end:Le.end-q}):De.push(Le)}),{score:X,labelMatch:_e,descriptionMatch:De}}}return E}function c(G){const N=[];if(!G)return N;let x;for(const F of G)x&&x.end===F?x.end+=1:(x={start:F,end:F+1},N.push(x));return N}function f(G){const N=G.sort((V,M)=>V.start-M.start),x=[];let F;for(const V of N)!F||!h(F,V)?(F=V,x.push(V)):(F.start=Math.min(F.start,V.start),F.end=Math.max(F.end,V.end));return x}function h(G,N){return!(G.end<N.start||N.end<G.start)}function b(G,N,x,F,V,M){const U=t(G,x,F,V,M),q=t(N,x,F,V,M),W=U.score,X=q.score;if((W===a||X===a)&&W!==X)return W===a?-1:1;if(W>v||X>v){if(W!==X)return W>X?-1:1;if(W<l&&X<l){const xe=o(U.labelMatch,q.labelMatch);if(xe!==0)return xe}const Le=V.getItemLabel(G)||"",qe=V.getItemLabel(N)||"";if(Le.length!==qe.length)return Le.length-qe.length}if(W!==X)return W>X?-1:1;const Z=Array.isArray(U.labelMatch)&&U.labelMatch.length>0,fe=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(Z&&!fe)return-1;if(fe&&!Z)return 1;const _e=S(G,U,V),De=S(N,q,V);return _e&&De&&_e!==De?De>_e?-1:1:w(G,N,x,V)}e.compareItemsByFuzzyScore=b;function S(G,N,x){let F=-1,V=-1;if(N.descriptionMatch&&N.descriptionMatch.length?F=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(F=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(V=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const M=x.getItemDescription(G);M&&(V+=M.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(V=N.descriptionMatch[N.descriptionMatch.length-1].end);return V-F}function o(G,N){if(!G&&!N||(!G||!G.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!G||!G.length)return 1;const x=G[0].start,V=G[G.length-1].end-x,M=N[0].start,q=N[N.length-1].end-M;return V===q?0:q<V?1:-1}function w(G,N,x,F){const V=F.getItemLabel(G)||"",M=F.getItemLabel(N)||"",U=F.getItemDescription(G),q=F.getItemDescription(N),W=V.length+(U?U.length:0),X=M.length+(q?q.length:0);if(W!==X)return W-X;const Z=F.getItemPath(G),fe=F.getItemPath(N);return Z&&fe&&Z.length!==fe.length?Z.length-fe.length:V!==M?(0,g.compareAnything)(V,M,x.normalized):U&&q&&U!==q?(0,g.compareAnything)(U,q,x.normalized):Z&&fe&&Z!==fe?(0,g.compareAnything)(Z,fe,x.normalized):0}const R=" ";function O(G){typeof G!="string"&&(G="");const N=G.toLowerCase(),{pathNormalized:x,normalized:F,normalizedLowercase:V}=$(G),M=x.indexOf(k.sep)>=0;let U;const q=G.split(R);if(q.length>1)for(const W of q){const{pathNormalized:X,normalized:Z,normalizedLowercase:fe}=$(W);Z&&(U||(U=[]),U.push({original:W,originalLowercase:W.toLowerCase(),pathNormalized:X,normalized:Z,normalizedLowercase:fe}))}return{original:G,originalLowercase:N,pathNormalized:x,normalized:F,normalizedLowercase:V,values:U,containsPathSeparator:M}}e.prepareQuery=O;function $(G){let N;D.isWindows?N=G.replace(/\//g,k.sep):N=G.replace(/\\/g,k.sep);const x=(0,A.stripWildcards)(N).replace(/\s/g,"");return{pathNormalized:N,normalized:x,normalizedLowercase:x.toLowerCase()}}function K(G){return Array.isArray(G)?O(G.map(N=>N.original).join(R)):O(G.original)}e.pieceToQuery=K}),define(me[30],ge([0,1,17,29,24,8,9]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const y="**",P="/",n="[/\\\\]",I="[^/\\\\]",d=/\//g;function m(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function u(U,q){if(!U)return[];const W=[];let X=!1,Z=!1,fe="";for(const _e of U){switch(_e){case q:if(!X&&!Z){W.push(fe),fe="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}fe+=_e}return fe&&W.push(fe),W}e.splitGlobAware=u;function p(U){if(!U)return"";let q="";const W=u(U,P);if(W.every(X=>X===y))q=".*";else{let X=!1;W.forEach((Z,fe)=>{if(Z===y){X||(q+=m(2),X=!0);return}let _e=!1,De="",Le=!1,qe="";for(const xe of Z){if(xe!=="}"&&_e){De+=xe;continue}if(Le&&(xe!=="]"||!qe)){let Ke;xe==="-"?Ke=xe:(xe==="^"||xe==="!")&&!qe?Ke="^":xe===P?Ke="":Ke=A.escapeRegExpCharacters(xe),qe+=Ke;continue}switch(xe){case"{":_e=!0;continue;case"[":Le=!0;continue;case"}":q+=`(?:${u(De,",").map(ee=>p(ee)).join("|")})`,_e=!1,De="";break;case"]":q+="["+qe+"]",Le=!1,qe="";break;case"?":q+=I;continue;case"*":q+=m(1);continue;default:q+=A.escapeRegExpCharacters(xe)}}fe<W.length-1&&(W[fe+1]!==y||fe+2<W.length)&&(q+=n),X=!1})}return q}const _=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(U,q){if(!U)return s;let W;typeof U!="string"?W=U.pattern:W=U,W=W.trim();const X=`${W}_${!!q.trimForExclusions}`;let Z=t.get(X);if(Z)return c(Z,U);let fe;if(_.test(W)){const _e=W.substr(4);Z=function(De,Le){return typeof De=="string"&&De.endsWith(_e)?W:null}}else(fe=T.exec(f(W,q)))?Z=h(fe[1],W):(q.trimForExclusions?a:E).test(W)?Z=b(W,q):(fe=l.exec(f(W,q)))?Z=S(fe[1].substr(1),W,!0):(fe=v.exec(f(W,q)))?Z=S(fe[1],W,!1):Z=o(W);return t.set(X,Z),c(Z,U)}function c(U,q){return typeof q=="string"?U:function(W,X){return L.isEqualOrParent(W,q.base)?U(D.relative(q.base,W),X):null}}function f(U,q){return q.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function h(U,q){const W=`/${U}`,X=`\\${U}`,Z=function(_e,De){return typeof _e!="string"?null:De?De===U?q:null:_e===U||_e.endsWith(W)||_e.endsWith(X)?q:null},fe=[U];return Z.basenames=fe,Z.patterns=[q],Z.allBasenames=fe,Z}function b(U,q){const W=M(U.slice(1,-1).split(",").map(De=>i(De,q)).filter(De=>De!==s),U),X=W.length;if(!X)return s;if(X===1)return W[0];const Z=function(De,Le){for(let qe=0,xe=W.length;qe<xe;qe++)if(W[qe](De,Le))return U;return null},fe=W.find(De=>!!De.allBasenames);fe&&(Z.allBasenames=fe.allBasenames);const _e=W.reduce((De,Le)=>Le.allPaths?De.concat(Le.allPaths):De,[]);return _e.length&&(Z.allPaths=_e),Z}function S(U,q,W){const X=D.sep===D.posix.sep,Z=X?U:U.replace(d,D.sep),fe=D.sep+Z,_e=D.posix.sep+U,De=W?function(Le,qe){return typeof Le=="string"&&(Le===Z||Le.endsWith(fe)||!X&&(Le===U||Le.endsWith(_e)))?q:null}:function(Le,qe){return typeof Le=="string"&&(Le===Z||!X&&Le===U)?q:null};return De.allPaths=[(W?"*/":"./")+U],De}function o(U){try{const q=new RegExp(`^${p(U)}$`);return function(W){return q.lastIndex=0,typeof W=="string"&&q.test(W)?U:null}}catch(q){return s}}function w(U,q,W){return!U||typeof q!="string"?!1:R(U)(q,void 0,W)}e.match=w;function R(U,q={}){if(!U)return r;if(typeof U=="string"||G(U)){const W=i(U,q);if(W===s)return r;const X=function(Z,fe){return!!W(Z,fe)};return W.allBasenames&&(X.allBasenames=W.allBasenames),W.allPaths&&(X.allPaths=W.allPaths),X}return F(U,q)}e.parse=R;function O(U){if(!U)return;let q;return W=>(q||(q=(U()||Promise.resolve([])).then(X=>X?K(X):{})),q.then(X=>!!X[W]))}e.hasSiblingPromiseFn=O;function $(U){if(!U)return;let q;return W=>{if(!q){const X=U();q=X?K(X):{}}return!!q[W]}}e.hasSiblingFn=$;function K(U){const q={};for(const W of U)q[W]=!0;return q}function G(U){const q=U;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=G;function N(U){return U.allBasenames||[]}e.getBasenameTerms=N;function x(U){return U.allPaths||[]}e.getPathTerms=x;function F(U,q){const W=M(Object.getOwnPropertyNames(U).map(De=>V(De,U[De],q)).filter(De=>De!==s)),X=W.length;if(!X)return s;if(!W.some(De=>!!De.requiresSiblings)){if(X===1)return W[0];const De=function(xe,Ke){for(let H=0,ee=W.length;H<ee;H++){const re=W[H](xe,Ke);if(re)return re}return null},Le=W.find(xe=>!!xe.allBasenames);Le&&(De.allBasenames=Le.allBasenames);const qe=W.reduce((xe,Ke)=>Ke.allPaths?xe.concat(Ke.allPaths):xe,[]);return qe.length&&(De.allPaths=qe),De}const Z=function(De,Le,qe){let xe;for(let Ke=0,H=W.length;Ke<H;Ke++){const ee=W[Ke];ee.requiresSiblings&&qe&&(Le||(Le=D.basename(De)),xe||(xe=Le.substr(0,Le.length-D.extname(De).length)));const re=ee(De,Le,xe,qe);if(re)return re}return null},fe=W.find(De=>!!De.allBasenames);fe&&(Z.allBasenames=fe.allBasenames);const _e=W.reduce((De,Le)=>Le.allPaths?De.concat(Le.allPaths):De,[]);return _e.length&&(Z.allPaths=_e),Z}function V(U,q,W){if(q===!1)return s;const X=i(U,W);if(X===s)return s;if(typeof q=="boolean")return X;if(q){const Z=q.when;if(typeof Z=="string"){const fe=(_e,De,Le,qe)=>{if(!qe||!X(_e,De))return null;const xe=Z.replace("$(basename)",Le),Ke=qe(xe);return(0,g.isThenable)(Ke)?Ke.then(H=>H?U:null):Ke?U:null};return fe.requiresSiblings=!0,fe}}return X}function M(U,q){const W=U.filter(De=>!!De.basenames);if(W.length<2)return U;const X=W.reduce((De,Le)=>{const qe=Le.basenames;return qe?De.concat(qe):De},[]);let Z;if(q){Z=[];for(let De=0,Le=X.length;De<Le;De++)Z.push(q)}else Z=W.reduce((De,Le)=>{const qe=Le.patterns;return qe?De.concat(qe):De},[]);const fe=function(De,Le){if(typeof De!="string")return null;if(!Le){let xe;for(xe=De.length;xe>0;xe--){const Ke=De.charCodeAt(xe-1);if(Ke===47||Ke===92)break}Le=De.substr(xe)}const qe=X.indexOf(Le);return qe!==-1?Z[qe]:null};fe.basenames=X,fe.patterns=Z,fe.allBasenames=X;const _e=U.filter(De=>!De.basenames);return _e.push(fe),_e}}),define(me[79],ge([0,1,29,10,8,11,25,9,2]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,c,f){if(typeof i=="string"&&(i=y.URI.file(i)),f){const b=f.getWorkspaceFolder(i);if(b){const S=f.getWorkspace().folders.length>1;let o;if((0,A.isEqual)(b.uri,i)?o="":o=(0,A.relativePath)(b.uri,i),S){const w=b.name?b.name:(0,A.basename)(b.uri);o=o?w+" \u2022 "+o:w}return o}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(i.fsPath))return(0,k.normalize)(I(i.fsPath));let h=(0,k.normalize)(i.fsPath);return!D.isWindows&&c?.userHome&&(h=m(h,c.userHome.fsPath)),h}e.getPathLabel=P;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,A.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,g.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=n;function I(i){return(0,g.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let d=Object.create(null);function m(i,c){if(D.isWindows||!i||!c)return i;let f=d.original===c?d.normalized:void 0;return f||(f=`${(0,C.rtrim)(c,k.posix.sep)}${k.posix.sep}`,d={original:c,normalized:f}),(D.isLinux?i.startsWith(f):(0,C.startsWithIgnoreCase)(i,f))&&(i=`~/${i.substr(f.length)}`),i}e.tildify=m;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const p="\u2026",_="\\\\",T="~";function E(i,c=k.sep){const f=new Array(i.length);let h=!1;for(let b=0;b<i.length;b++){let S=i[b];if(S===""){f[b]=`.${c}`;continue}if(!S){f[b]=S;continue}h=!0;let o="";S.indexOf(_)===0?(o=S.substr(0,S.indexOf(_)+_.length),S=S.substr(S.indexOf(_)+_.length)):S.indexOf(c)===0?(o=S.substr(0,S.indexOf(c)+c.length),S=S.substr(S.indexOf(c)+c.length)):S.indexOf(T)===0&&(o=S.substr(0,S.indexOf(T)+T.length),S=S.substr(S.indexOf(T)+T.length));const w=S.split(c);for(let R=1;h&&R<=w.length;R++)for(let O=w.length-R;h&&O>=0;O--){h=!1;let $=w.slice(O,O+R).join(c);for(let K=0;!h&&K<i.length;K++)if(K!==b&&i[K]&&i[K].indexOf($)>-1){const G=O+R===w.length,N=O>0&&i[K].indexOf(c)>-1?c+$:$,x=i[K].endsWith(N);h=!G||x}if(!h){let K="";(w[0].endsWith(":")||o!=="")&&(O===1&&(O=0,R++,$=w[0]+c+$),O>0&&(K=w[0]+c),K=o+K),O>0&&(K=K+p+c),K=K+$,O+R<w.length&&(K=K+c+p),f[b]=K}}h&&(f[b]=S)}return f}e.shorten=E;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function l(i,c=Object.create(null)){const f=[];let h=!1,b="";for(const S of i)if(S==="$"||h&&S==="{")b&&f.push({value:b,type:a.TEXT}),b="",h=!0;else if(S==="}"&&h){const o=c[b];if(typeof o=="string")o.length&&f.push({value:o,type:a.VARIABLE});else if(o){const w=f[f.length-1];(!w||w.type!==a.SEPARATOR)&&f.push({value:o.label,type:a.SEPARATOR})}b="",h=!1}else b+=S;return b&&!h&&f.push({value:b,type:a.TEXT}),f.filter((S,o)=>{if(S.type===a.SEPARATOR){const w=f[o-1],R=f[o+1];return[w,R].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=l;function v(i,c){return D.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return D.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const c=i.indexOf("/")!==-1?k.posix:k.win32,f=c.basename(i),h=c.dirname(i);return f.length?{name:f,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(me[102],ge([0,1,30,10,8,25,9]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let y=[],P=[],n=[];function I(i,c=!1){const f=d(i);y.push(f),f.userConfigured?n.push(f):P.push(f),c&&!f.userConfigured&&y.forEach(h=>{h.mime===f.mime||h.userConfigured||(f.extension&&h.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&h.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&h.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&h.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=I;function d(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(k.posix.sep)>=0:!1}}function m(i){i?(y=y.filter(c=>!c.userConfigured),n=[]):(y=[],P=[],n=[])}e.clearTextMimes=m;function u(i,c){let f;if(i)switch(i.scheme){case L.Schemas.file:f=i.fsPath;break;case L.Schemas.data:f=D.DataUri.parseMetaData(i).get(D.DataUri.META_DATA_LABEL);break;default:f=i.path}if(!f)return[C.unknown];f=f.toLowerCase();const h=(0,k.basename)(f),b=p(f,h,n);if(b)return[b,C.text];const S=p(f,h,P);if(S)return[S,C.text];if(c){const o=_(c);if(o)return[o,C.text]}return[C.unknown]}e.guessMimeTypes=u;function p(i,c,f){let h=null,b=null,S=null;for(let o=f.length-1;o>=0;o--){const w=f[o];if(c===w.filenameLowercase){h=w;break}if(w.filepattern&&(!b||w.filepattern.length>b.filepattern.length)){const R=w.filepatternOnPath?i:c;(0,g.match)(w.filepatternLowercase,R)&&(b=w)}w.extension&&(!S||w.extension.length>S.extension.length)&&c.endsWith(w.extensionLowercase)&&(S=w)}return h?h.mime:b?b.mime:S?S.mime:null}function _(i){if((0,A.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let c=y.length-1;c>=0;c--){const f=y[c];if(!f.firstline)continue;const h=i.match(f.firstline);if(h&&h.length>0)return f.mime}return null}function T(i){return i?typeof i=="string"?i===C.binary||i===C.text||i===C.unknown:i.length===1&&T(i[0]):!0}e.isUnspecific=T;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(i){const c=(0,k.extname)(i),f=E[c.toLowerCase()];return f!==void 0?f:v(i)}e.getMediaOrTextMime=l;function v(i){const c=(0,k.extname)(i);return a[c.toLowerCase()]}e.getMediaMime=v;function t(i){for(const c in a)if(a[c]===i)return c}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function s(i,c){const f=r.exec(i);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:c?void 0:i}e.normalizeMimeType=s}),define(me[103],ge([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const d=this._uriTransformer.transformIncoming(I);return d===I?I:L(g.URI.from(d))}transformOutgoing(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:L(g.URI.from(d))}transformOutgoingURI(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:g.URI.from(d)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function D(n,I,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const u=D(n[m],I,d+1);u!==null&&(n[m]=u)}}return null}function A(n,I){const d=D(n,I,0);return d===null?n:d}e.transformOutgoingURIs=A;function C(n,I,d,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const p=C(n[u],I,d,m+1);p!==null&&(n[u]=p)}}return null}function y(n,I){const d=C(n,I,!1,0);return d===null?n:d}e.transformIncomingURIs=y;function P(n,I){const d=C(n,I,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=P}),define(me[32],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return g.test(y)}e.isUUID=L;const k=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function C(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,P="";return P+=D[k[y++]],P+=D[k[y++]],P+=D[k[y++]],P+=D[k[y++]],P+="-",P+=D[k[y++]],P+=D[k[y++]],P+="-",P+=D[k[y++]],P+=D[k[y++]],P+="-",P+=D[k[y++]],P+=D[k[y++]],P+="-",P+=D[k[y++]],P+=D[k[y++]],P+=D[k[y++]],P+=D[k[y++]],P+=D[k[y++]],P+=D[k[y++]],P}e.generateUuid=C}),define(me[143],ge([0,1,104]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(D="utf8"){this.stringDecoder=new g.StringDecoder(D),this.remaining=null}write(D){const A=[],C=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(C.length<1)return A;let y=0,P,n=y;for(;n<C.length;)if(P=C.charCodeAt(n),P===13||P===10){if(A.push(C.substring(y,n)),n++,n<C.length){const I=P;P=C.charCodeAt(n),(I===13&&P===10||I===10&&P===13)&&n++}y=n}else n++;return this.remaining=y<C.length?C.substr(y):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,49,80,290,17,29,78,8,11,25,2,32]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function u(N,x=m.UNLINK){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?_(N):p(N)}async function p(N){try{const x=(0,y.join)((0,L.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(N,x)}catch(F){return _(N)}_(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function _(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function T(N){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(N,{recursive:!0})}e.rimrafSync=T;async function E(N,x){return v(await(x?a(N):(0,k.promisify)(g.readdir)(N)))}async function a(N){try{return await(0,k.promisify)(g.readdir)(N,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const x=[],F=await E(N);for(const V of F){let M=!1,U=!1,q=!1;try{const W=await e.Promises.lstat((0,y.join)(N,V));M=W.isFile(),U=W.isDirectory(),q=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}x.push({name:V,isFile:()=>M,isDirectory:()=>U,isSymbolicLink:()=>q})}return x}function l(N){return v(g.readdirSync(N))}e.readdirSync=l;function v(N){return N.map(x=>typeof x=="string"?P.isMacintosh?(0,C.normalizeNFC)(x):x:(x.name=P.isMacintosh?(0,C.normalizeNFC)(x.name):x.name,x))}async function t(N){const x=await E(N),F=[];for(const V of x)await s.existsDirectory((0,y.join)(N,V))&&F.push(V);return F}function r(N,x=1e3){return new Promise(F=>{let V=!1;const M=setInterval(()=>{V||(V=!0,g.access(N,U=>{V=!1,U&&(clearInterval(M),F(void 0))}))},x)})}e.whenDeleted=r;var s;(function(N){async function x(M){let U;try{if(U=await e.Promises.lstat(M),!U.isSymbolicLink())return{stat:U}}catch(q){}try{return{stat:await e.Promises.stat(M),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(P.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw W}throw q}}N.stat=x;async function F(M){try{const{stat:U,symbolicLink:q}=await N.stat(M);return U.isFile()&&q?.dangling!==!0}catch(U){}return!1}N.existsFile=F;async function V(M){try{const{stat:U,symbolicLink:q}=await N.stat(M);return U.isDirectory()&&q?.dangling!==!0}catch(U){}return!1}N.existsDirectory=V})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new D.ResourceQueue;function c(N,x,F){return i.queueFor(I.URI.file(N),n.extUriBiasedIgnorePathCase).queue(()=>{const V=S(F);return new Promise((M,U)=>h(N,x,V,q=>q?U(q):M()))})}let f=!0;function h(N,x,F,V){if(!f)return g.writeFile(N,x,{mode:F.mode,flag:F.flag},V);g.open(N,F.flag,F.mode,(M,U)=>{if(M)return V(M);g.writeFile(U,x,q=>{if(q)return g.close(U,()=>V(q));g.fdatasync(U,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),f=!1),g.close(U,X=>V(X))))})})}function b(N,x,F){const V=S(F);if(!f)return g.writeFileSync(N,x,{mode:V.mode,flag:V.flag});const M=g.openSync(N,V.flag,V.mode);try{g.writeFileSync(M,x);try{g.fdatasyncSync(M)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),f=!1}}finally{g.closeSync(M)}}e.writeFileSync=b;function S(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,x){if(N===x)return;async function F(V){try{const M=await e.Promises.lstat(V);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(V,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(N,x),await F(x)}catch(V){if(N.toLowerCase()!==x.toLowerCase()&&V.code==="EXDEV"||N.endsWith("."))await w(N,x,{preserveSymlinks:!1}),await u(N,m.MOVE),await F(x);else throw V}}async function w(N,x,F){return O(N,x,{root:{source:N,target:x},options:F,handledSourcePaths:new Set})}const R=511;async function O(N,x,F){if(F.handledSourcePaths.has(N))return;F.handledSourcePaths.add(N);const{stat:V,symbolicLink:M}=await s.stat(N);if(M){if(F.options.preserveSymlinks)try{return await G(N,x,F)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(M.dangling)return}return V.isDirectory()?$(N,x,V.mode&R,F):K(N,x,V.mode&R)}async function $(N,x,F,V){await e.Promises.mkdir(x,{recursive:!0,mode:F});const M=await E(N);for(const U of M)await O((0,y.join)(N,U),(0,y.join)(x,U),V)}async function K(N,x,F){await e.Promises.copyFile(N,x),await e.Promises.chmod(x,F)}async function G(N,x,F){let V=await e.Promises.readlink(N);(0,A.isEqualOrParent)(V,F.root.source,!P.isLinux)&&(V=(0,y.join)(F.root.target,V.substr(F.root.source.length+1))),await e.Promises.symlink(V,x)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return o}get copy(){return w}}}),define(me[105],ge([0,1,49,8,9,28]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const I=(0,L.dirname)(n);if(n===I)return n;const d=((0,L.basename)(n)||n).toLowerCase();try{const u=(0,D.readdirSync)(I).filter(p=>p.toLowerCase()===d);if(u.length===1){const p=A(I);if(p)return(0,L.join)(p,u[0])}else if(u.length>1){const p=u.indexOf(d);if(p>=0){const _=A(I);if(_)return(0,L.join)(_,u[p])}}}catch(m){}return null}e.realcaseSync=A;async function C(n){try{return await D.Promises.realpath(n)}catch(I){const d=P(n);return await D.Promises.access(d,g.constants.R_OK),d}}e.realpath=C;function y(n){try{return g.realpathSync(n)}catch(I){const d=P(n);return g.accessSync(d,g.constants.R_OK),d}}e.realpathSync=y;function P(n){return(0,k.rtrim)((0,L.normalize)(n),L.sep)}});var ze=this&&this.__decorate||function(Y,e,g,L){var k=arguments.length,D=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Y,e,g,L);else for(var C=Y.length-1;C>=0;C--)(A=Y[C])&&(D=(k<3?A(D):k>3?A(e,g,D):A(e,g))||D);return k>3&&D&&Object.defineProperty(e,g,D),D};define(me[106],ge([0,1,20,17,22,21,56,16,3,6,59,9,14]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function _(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var T;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(T||(T={}));class E{constructor(U){this.buffer=U,this.pos=0}read(U){const q=this.buffer.slice(this.pos,this.pos+U);return this.pos+=q.byteLength,q}}class a{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var l;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(l||(l={}));function v(M){const U=k.VSBuffer.alloc(4);return U.writeUInt32BE(M,0),U}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const U=k.VSBuffer.alloc(1);return U.writeUInt8(M,0),U}const s={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},i=typeof Buffer!="undefined";function c(M,U){if(typeof U=="undefined")M.write(s.Undefined);else if(typeof U=="string"){const q=k.VSBuffer.fromString(U);M.write(s.String),M.write(v(q.byteLength)),M.write(q)}else if(i&&Buffer.isBuffer(U)){const q=k.VSBuffer.wrap(U);M.write(s.Buffer),M.write(v(q.byteLength)),M.write(q)}else if(U instanceof k.VSBuffer)M.write(s.VSBuffer),M.write(v(U.byteLength)),M.write(U);else if(Array.isArray(U)){M.write(s.Array),M.write(v(U.length));for(const q of U)c(M,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(U));M.write(s.Object),M.write(v(q.byteLength)),M.write(q)}}function f(M){switch(M.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return M.read(t(M)).toString();case l.Buffer:return M.read(t(M)).buffer;case l.VSBuffer:return M.read(t(M));case l.Array:{const q=t(M),W=[];for(let X=0;X<q;X++)W.push(f(M));return W}case l.Object:return JSON.parse(M.read(t(M)).toString())}}class h{constructor(U,q,W=null,X=1e3){this.protocol=U,this.ctx=q,this.logger=W,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(U,q){this.channels.set(U,q),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const q=this.send([U.type]);this.logger&&this.logger.logOutgoing(q,0,1,_(U.type));return}case 201:case 202:case 204:case 203:{const q=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(q,U.id,1,_(U.type),U.data);return}}}send(U,q=void 0){const W=new a;return c(W,U),c(W,q),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(q){return 0}}onRawMessage(U){const q=new E(U),W=f(q),X=f(q),Z=W[0];switch(Z){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${u(Z)}: ${W[2]}.${W[3]}`,X),this.onPromise({type:Z,id:W[1],channelName:W[2],name:W[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${u(Z)}: ${W[2]}.${W[3]}`,X),this.onEventListen({type:Z,id:W[1],channelName:W[2],name:W[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${u(Z)}`),this.disposeActiveRequest({type:Z,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${u(Z)}`),this.disposeActiveRequest({type:Z,id:W[1]})}}onPromise(U){const q=this.channels.get(U.channelName);if(!q){this.collectPendingRequest(U);return}const W=new D.CancellationTokenSource;let X;try{X=q.call(this.ctx,U.name,U.arg,W.token)}catch(_e){X=Promise.reject(_e)}const Z=U.id;X.then(_e=>{this.sendResponse({id:Z,data:_e,type:201}),this.activeRequests.delete(U.id)},_e=>{_e instanceof Error?this.sendResponse({id:Z,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Z,data:_e,type:203}),this.activeRequests.delete(U.id)});const fe=(0,P.toDisposable)(()=>W.cancel());this.activeRequests.set(U.id,fe)}onEventListen(U){const q=this.channels.get(U.channelName);if(!q){this.collectPendingRequest(U);return}const W=U.id,Z=q.listen(this.ctx,U.name,U.arg)(fe=>this.sendResponse({id:W,data:fe,type:204}));this.activeRequests.set(U.id,Z)}disposeActiveRequest(U){const q=this.activeRequests.get(U.id);q&&(q.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let q=this.pendingRequests.get(U.channelName);q||(q=[],this.pendingRequests.set(U.channelName,q));const W=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:U,timeoutTimer:W})}flushPendingRequests(U){const q=this.pendingRequests.get(U);if(q){for(const W of q)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var b;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(U,q=null){this.protocol=U,this.isDisposed=!1,this.state=T.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=q}getChannel(U){const q=this;return{call(W,X,Z){return q.isDisposed?Promise.reject(C.canceled()):q.requestPromise(U,W,X,Z)},listen(W,X){return q.isDisposed?Promise.reject(C.canceled()):q.requestEvent(U,W,X)}}}requestPromise(U,q,W,X=D.CancellationToken.None){const Z=this.lastRequestId++,_e={id:Z,type:100,channelName:U,name:q,arg:W};if(X.isCancellationRequested)return Promise.reject(C.canceled());let De;return new Promise((qe,xe)=>{if(X.isCancellationRequested)return xe(C.canceled());const Ke=()=>{const le=J=>{switch(J.type){case 201:this.handlers.delete(Z),qe(J.data);break;case 202:this.handlers.delete(Z);const ae=new Error(J.data.message);ae.stack=J.data.stack,ae.name=J.data.name,xe(ae);break;case 203:this.handlers.delete(Z),xe(J.data);break}};this.handlers.set(Z,le),this.sendRequest(_e)};let H=null;this.state===T.Idle?Ke():(H=(0,L.createCancelablePromise)(le=>this.whenInitialized()),H.then(()=>{H=null,Ke()}));const ee=()=>{H?(H.cancel(),H=null):this.sendRequest({id:Z,type:101}),xe(C.canceled())},re=X.onCancellationRequested(ee);De=(0,P.combinedDisposable)((0,P.toDisposable)(ee),re),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(U,q,W){const X=this.lastRequestId++,fe={id:X,type:102,channelName:U,name:q,arg:W};let _e=null;const De=new y.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(qe=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(De),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(De),this.sendRequest({id:X,type:103}))}}),Le=qe=>De.fire(qe.data);return this.handlers.set(X,Le),De.event}sendRequest(U){switch(U.type){case 100:case 102:{const q=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(q,U.id,0,`${u(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(q,U.id,0,u(U.type));return}}}send(U,q=void 0){const W=new a;return c(W,U),c(W,q),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(q){return 0}}onBuffer(U){const q=new E(U),W=f(q),X=f(q),Z=W[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,_(Z)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],0,_(Z),X),this.onResponse({type:W[0],id:W[1],data:X})}}onResponse(U){if(U.type===200){this.state=T.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(U.id);q&&q(U)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}ze([A.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class o{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:q,onDidClientDisconnect:W})=>{y.Event.once(q.onMessage)(Z=>{const fe=new E(Z),_e=f(fe),De=new h(q,_e),Le=new S(q);this.channels.forEach((xe,Ke)=>De.registerChannel(Ke,xe));const qe={channelServer:De,channelClient:Le,ctx:_e};this._connections.add(qe),this._onDidAddConnection.fire(qe),W(()=>{De.dispose(),Le.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const U=[];return this._connections.forEach(q=>U.push(q)),U}getChannel(U,q){const W=this;return{call(X,Z,fe){let _e;if((0,d.isFunction)(q)){let Le=(0,g.getRandomElement)(W.connections.filter(q));_e=Le?Promise.resolve(Le):y.Event.toPromise(y.Event.filter(W.onDidAddConnection,q))}else _e=q.routeCall(W,X,Z);const De=_e.then(Le=>Le.channelClient.getChannel(U));return R(De).call(X,Z,fe)},listen(X,Z){if((0,d.isFunction)(q))return W.getMulticastEvent(U,q,X,Z);const fe=q.routeEvent(W,X,Z).then(_e=>_e.channelClient.getChannel(U));return R(fe).listen(X,Z)}}}getMulticastEvent(U,q,W,X){const Z=this;let fe=new P.DisposableStore;const _e=new y.Emitter({onFirstListenerAdd:()=>{fe=new P.DisposableStore;const De=new y.EventMultiplexer,Le=new Map,qe=Ke=>{const ee=Ke.channelClient.getChannel(U).listen(W,X),re=De.add(ee);Le.set(Ke,re)},xe=Ke=>{const H=Le.get(Ke);!H||(H.dispose(),Le.delete(Ke))};Z.connections.filter(q).forEach(qe),y.Event.filter(Z.onDidAddConnection,q)(qe,void 0,fe),Z.onDidRemoveConnection(xe,void 0,fe),De.event(_e.fire,_e,fe),fe.add(De)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(U,q){this.channels.set(U,q),this._connections.forEach(W=>{W.channelServer.registerChannel(U,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class w{constructor(U,q,W=null){const X=new a;c(X,q),U.send(X.buffer),this.channelClient=new S(U,W),this.channelServer=new h(U,q,W)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,q){this.channelServer.registerChannel(U,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function R(M){return{call(U,q,W){return M.then(X=>X.call(U,q,W))},listen(U,q){const W=new y.Relay;return M.then(X=>W.input=X.listen(U,q)),W.event}}}e.getDelayedChannel=R;function O(M){let U=!1;return{call(q,W,X){return U?M.call(q,W,X):(0,L.timeout)(0).then(()=>U=!0).then(()=>M.call(q,W,X))},listen(q,W){if(U)return M.listen(q,W);const X=new y.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>X.input=M.listen(q,W)),X.event}}}e.getNextTickChannel=O;class ${constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const q of U.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await y.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=$;var K;(function(M){function U(X,Z){const fe=X,_e=Z&&Z.disableMarshalling,De=new Map;for(const Le in fe)W(Le)&&De.set(Le,y.Event.buffer(fe[Le],!0));return new class{listen(Le,qe){const xe=De.get(qe);if(xe)return xe;throw new Error(`Event not found: ${qe}`)}call(Le,qe,xe){const Ke=fe[qe];if(typeof Ke=="function"){if(!_e&&Array.isArray(xe))for(let H=0;H<xe.length;H++)xe[H]=(0,n.revive)(xe[H]);return Ke.apply(fe,xe)}throw new Error(`Method not found: ${qe}`)}}}M.fromService=U;function q(X,Z){const fe=Z&&Z.disableMarshalling;return new Proxy({},{get(_e,De){if(typeof De=="string")return Z?.properties?.has(De)?Z.properties.get(De):W(De)?X.listen(De):async function(...Le){let qe;Z&&!(0,d.isUndefinedOrNull)(Z.context)?qe=[Z.context,...Le]:qe=Le;const xe=await X.call(De,qe);return fe?xe:(0,n.revive)(xe)};throw new Error(`Property not found: ${String(De)}`)}})}M.toService=q;function W(X){return X[0]==="o"&&X[1]==="n"&&I.isUpperAsciiLetter(X.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let U=M.toString();if(U!=="[object Object]")return U}return M}function x(M){return Array.isArray(M)?M.map(N):N(M)}function F(M,U,q,W,X,Z,fe){fe=x(fe);const _e=G[X],De=_e[W%_e.length];let Le=[`%c[${M}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(Z)?(Le=Le.concat(fe),Le.push(")")):Le.push(fe),console.log.apply(console,Le)}e.logWithColors=F;class V{constructor(U,q){this._outgoingPrefix=U,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,q,W,X,Z){this._totalOutgoing+=U,F(this._outgoingPrefix,this._totalOutgoing,U,q,W,X,Z)}logIncoming(U,q,W,X,Z){this._totalIncoming+=U,F(this._incomingPrefix,this._totalIncoming,U,q,W,X,Z)}}e.IPCLogger=V}),define(me[107],ge([0,1,22,3,6,11,38,106]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function n(){return P||(P=g.VSBuffer.alloc(0)),P}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,c){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const S=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=i),S}if(this._chunks[0].byteLength>i){const S=this._chunks[0].slice(0,i);return c&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),S}let f=g.VSBuffer.alloc(i),h=0,b=0;for(;i>0;){const S=this._chunks[b];if(S.byteLength>i){const o=S.slice(0,i);f.set(o,h),h+=i,c&&(this._chunks[b]=S.slice(i),this._totalLength-=i),i-=i}else f.set(S,h),h+=S.byteLength,c?(this._chunks.shift(),this._totalLength-=S.byteLength):b++,i-=S.byteLength}return f}}e.ChunkStream=I;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var m;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(i,c,f,h){this.type=i,this.id=c,this.ack=f,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends k.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const f=this._state.messageType,h=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new u(f,h,b,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=g.VSBuffer.alloc(13);c.writeUInt8(i.type,0),c.writeUInt32BE(i.id,1),c.writeUInt32BE(i.ack,5),c.writeUInt32BE(i.data.byteLength,9),this._writeSoon(c,i.data)}_bufferAdd(i,c){const f=this._totalLength===0;return this._data.push(i,c),this._totalLength+=i.byteLength+c.byteLength,f}_bufferTake(){const i=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,c){this._bufferAdd(i,c)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class T extends k.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new u(1,0,0,i))}}e.Protocol=T;class E extends C.IPCClient{constructor(i,c,f=null){super(i,c,f);this.protocol=i}static fromSocket(i,c){return new E(new T(i),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(i){this.data=i,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],c=0,f=this._first;for(;f;)i[c++]=f.data,f=f.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const c=new l(i);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let c=0;c<t._HISTORY_LENGTH;c++)this.lastRuns[c]=i-1e3*c;setInterval(()=>{for(let c=t._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),c=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let h=0;h<t._HISTORY_LENGTH;h++)i-this.lastRuns[h]<=c&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(i,c=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new u(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const c=new u(4,0,0,n());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let c=0,f=i.length;c<f;c++)this._socketWriter.write(i[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new u(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const c=this._outgoingUnackMsg.toArray();for(let f=0,h=c.length;f<h;f++)this._socketWriter.write(c[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new u(1,c,this._incomingAckId,i);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(i){const c=new u(2,0,0,i);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),c=Date.now()-i.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new u(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let y=(0,g.toUint8)(C);this._defaultValue=y,this._asciiMap=L._createAsciiMap(y),this._map=new Map}static _createAsciiMap(C){let y=new Uint8Array(256);for(let P=0;P<256;P++)y[P]=C;return y}set(C,y){let P=(0,g.toUint8)(y);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class D{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=D}),define(me[144],ge([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(C){super(0);for(let y=0,P=C.length;y<P;y++)this.set(C.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function D(A){let C={};return y=>(C.hasOwnProperty(y)||(C[y]=A(y)),C[y])}e.getMapForWordSeparators=D(A=>new k(A))}),define(me[50],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,D){this.lineNumber=k,this.column=D}with(k=this.lineNumber,D=this.column){return k===this.lineNumber&&D===this.column?this:new g(k,D)}delta(k=0,D=0){return this.with(this.lineNumber+k,this.column+D)}equals(k){return g.equals(this,k)}static equals(k,D){return!k&&!D?!0:!!k&&!!D&&k.lineNumber===D.lineNumber&&k.column===D.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,D){return k.lineNumber<D.lineNumber?!0:D.lineNumber<k.lineNumber?!1:k.column<D.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,D){return k.lineNumber<D.lineNumber?!0:D.lineNumber<k.lineNumber?!1:k.column<=D.column}static compare(k,D){let A=k.lineNumber|0,C=D.lineNumber|0;if(A===C){let y=k.column|0,P=D.column|0;return y-P}return A-C}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(me[41],ge([0,1,50]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(D,A,C,y){D>C||D===C&&A>y?(this.startLineNumber=C,this.startColumn=y,this.endLineNumber=D,this.endColumn=A):(this.startLineNumber=D,this.startColumn=A,this.endLineNumber=C,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return L.containsPosition(this,D)}static containsPosition(D,A){return!(A.lineNumber<D.startLineNumber||A.lineNumber>D.endLineNumber||A.lineNumber===D.startLineNumber&&A.column<D.startColumn||A.lineNumber===D.endLineNumber&&A.column>D.endColumn)}containsRange(D){return L.containsRange(this,D)}static containsRange(D,A){return!(A.startLineNumber<D.startLineNumber||A.endLineNumber<D.startLineNumber||A.startLineNumber>D.endLineNumber||A.endLineNumber>D.endLineNumber||A.startLineNumber===D.startLineNumber&&A.startColumn<D.startColumn||A.endLineNumber===D.endLineNumber&&A.endColumn>D.endColumn)}strictContainsRange(D){return L.strictContainsRange(this,D)}static strictContainsRange(D,A){return!(A.startLineNumber<D.startLineNumber||A.endLineNumber<D.startLineNumber||A.startLineNumber>D.endLineNumber||A.endLineNumber>D.endLineNumber||A.startLineNumber===D.startLineNumber&&A.startColumn<=D.startColumn||A.endLineNumber===D.endLineNumber&&A.endColumn>=D.endColumn)}plusRange(D){return L.plusRange(this,D)}static plusRange(D,A){let C,y,P,n;return A.startLineNumber<D.startLineNumber?(C=A.startLineNumber,y=A.startColumn):A.startLineNumber===D.startLineNumber?(C=A.startLineNumber,y=Math.min(A.startColumn,D.startColumn)):(C=D.startLineNumber,y=D.startColumn),A.endLineNumber>D.endLineNumber?(P=A.endLineNumber,n=A.endColumn):A.endLineNumber===D.endLineNumber?(P=A.endLineNumber,n=Math.max(A.endColumn,D.endColumn)):(P=D.endLineNumber,n=D.endColumn),new L(C,y,P,n)}intersectRanges(D){return L.intersectRanges(this,D)}static intersectRanges(D,A){let C=D.startLineNumber,y=D.startColumn,P=D.endLineNumber,n=D.endColumn,I=A.startLineNumber,d=A.startColumn,m=A.endLineNumber,u=A.endColumn;return C<I?(C=I,y=d):C===I&&(y=Math.max(y,d)),P>m?(P=m,n=u):P===m&&(n=Math.min(n,u)),C>P||C===P&&y>n?null:new L(C,y,P,n)}equalsRange(D){return L.equalsRange(this,D)}static equalsRange(D,A){return!!D&&!!A&&D.startLineNumber===A.startLineNumber&&D.startColumn===A.startColumn&&D.endLineNumber===A.endLineNumber&&D.endColumn===A.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(D){return new g.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(D){return new g.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,A){return new L(this.startLineNumber,this.startColumn,D,A)}setStartPosition(D,A){return new L(D,A,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(D){return new L(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,A=D){return new L(D.lineNumber,D.column,A.lineNumber,A.column)}static lift(D){return D?new L(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,A){return!(D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn||A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn)}static areIntersecting(D,A){return!(D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn||A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,A){if(D&&A){const P=D.startLineNumber|0,n=A.startLineNumber|0;if(P===n){const I=D.startColumn|0,d=A.startColumn|0;if(I===d){const m=D.endLineNumber|0,u=A.endLineNumber|0;if(m===u){const p=D.endColumn|0,_=A.endColumn|0;return p-_}return m-u}return I-d}return P-n}return(D?1:0)-(A?1:0)}static compareRangesUsingEnds(D,A){return D.endLineNumber===A.endLineNumber?D.endColumn===A.endColumn?D.startLineNumber===A.startLineNumber?D.startColumn-A.startColumn:D.startLineNumber-A.startLineNumber:D.endColumn-A.endColumn:D.endLineNumber-A.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=L}),define(me[145],ge([0,1,50,41]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class D extends L.Range{constructor(C,y,P,n){super(C,y,P,n);this.selectionStartLineNumber=C,this.selectionStartColumn=y,this.positionLineNumber=P,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return D.selectionsEqual(this,C)}static selectionsEqual(C,y){return C.selectionStartLineNumber===y.selectionStartLineNumber&&C.selectionStartColumn===y.selectionStartColumn&&C.positionLineNumber===y.positionLineNumber&&C.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,y){return this.getDirection()===0?new D(this.startLineNumber,this.startColumn,C,y):new D(C,y,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,y){return this.getDirection()===0?new D(C,y,this.endLineNumber,this.endColumn):new D(this.endLineNumber,this.endColumn,C,y)}static fromPositions(C,y=C){return new D(C.lineNumber,C.column,y.lineNumber,y.column)}static liftSelection(C){return new D(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,y){if(C&&!y||!C&&y)return!1;if(!C&&!y)return!0;if(C.length!==y.length)return!1;for(let P=0,n=C.length;P<n;P++)if(!this.selectionsEqual(C[P],y[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,y,P,n,I){return I===0?new D(C,y,P,n):new D(P,n,C,y)}}e.Selection=D}),define(me[109],ge([0,1,23]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class P{constructor(_,T){this._findMatchBrand=void 0,this.range=_,this.matches=T}}e.FindMatch=P;var n;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(I=e.PositionAffinity||(e.PositionAffinity={}));var d;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d=e.ModelConstants||(e.ModelConstants={}));class m{constructor(_,T,E,a,l,v){this.identifier=_,this.range=T,this.text=E,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=l,this._isTracked=v}}e.ValidAnnotatedEditOperation=m;class u{constructor(_,T,E){this.reverseEdits=_,this.changes=T,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=u}),define(me[146],ge([0,1,9,144,50,41,109]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class y{constructor(a,l,v,t){this.searchString=a,this.isRegex=l,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let l=null;try{l=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let v=!this.isRegex&&!a;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(l,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=y;function P(E){if(!E||E.length===0)return!1;for(let a=0,l=E.length;a<l;a++)if(E.charCodeAt(a)===92){if(a++,a>=l)break;const t=E.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class n{constructor(a,l,v){this.regex=a,this.wordSeparators=l,this.simpleSearch=v}}e.SearchData=n;function I(E,a,l){if(!l)return new A.FindMatch(E,null);let v=[];for(let t=0,r=a.length;t<r;t++)v[t]=a[t];return new A.FindMatch(E,v)}e.createFindMatch=I;class d{constructor(a){let l=[],v=0;for(let t=0,r=a.length;t<r;t++)a.charCodeAt(t)===10&&(l[v++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(a){const l=this._lineFeedsOffsets;let v=0,t=l.length-1;if(t===-1||a<=l[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);l[r]>=a?t=r-1:l[r+1]>=a?(v=r,t=r):v=r+1}return v+1}}class m{static findMatches(a,l,v,t,r){const s=l.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(a,v,new T(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(a,v,s,t,r):[]}static _getMultilineMatchRange(a,l,v,t,r,s){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(r),i=l+r+c):i=l+r;let f;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-c;f=i+s.length+o}else f=i+s.length;const h=a.getPositionAt(i),b=a.getPositionAt(f);return new D.Range(h.lineNumber,h.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(a,l,v,t,r){const s=a.getOffsetAt(l.getStartPosition()),i=a.getValueInRange(l,1),c=a.getEOL()===`\r
`?new d(i):null,f=[];let h=0,b;for(v.reset(0);b=v.next(i);)if(f[h++]=I(this._getMultilineMatchRange(a,s,i,c,b.index,b[0]),b,t),h>=r)return f;return f}static _doFindMatchesLineByLine(a,l,v,t,r){const s=[];let i=0;if(l.startLineNumber===l.endLineNumber){const f=a.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return i=this._findMatchesInLine(v,f,l.startLineNumber,l.startColumn-1,i,s,t,r),s}const c=a.getLineContent(l.startLineNumber).substring(l.startColumn-1);i=this._findMatchesInLine(v,c,l.startLineNumber,l.startColumn-1,i,s,t,r);for(let f=l.startLineNumber+1;f<l.endLineNumber&&i<r;f++)i=this._findMatchesInLine(v,a.getLineContent(f),f,0,i,s,t,r);if(i<r){const f=a.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);i=this._findMatchesInLine(v,f,l.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(a,l,v,t,r,s,i,c){const f=a.wordSeparators;if(!i&&a.simpleSearch){const S=a.simpleSearch,o=S.length,w=l.length;let R=-o;for(;(R=l.indexOf(S,R+o))!==-1;)if((!f||_(f,l,w,R,o))&&(s[r++]=new A.FindMatch(new D.Range(v,R+1+t,v,R+1+o+t),null),r>=c))return r;return r}const h=new T(a.wordSeparators,a.regex);let b;h.reset(0);do if(b=h.next(l),b&&(s[r++]=I(new D.Range(v,b.index+1+t,v,b.index+1+b[0].length+t),b,i),r>=c))return r;while(b);return r}static findNextMatch(a,l,v,t){const r=l.parseSearchRequest();if(!r)return null;const s=new T(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(a,v,s,t):this._doFindNextMatchLineByLine(a,v,s,t)}static _doFindNextMatchMultiline(a,l,v,t){const r=new k.Position(l.lineNumber,1),s=a.getOffsetAt(r),i=a.getLineCount(),c=a.getValueInRange(new D.Range(r.lineNumber,r.column,i,a.getLineMaxColumn(i)),1),f=a.getEOL()===`\r
`?new d(c):null;v.reset(l.column-1);let h=v.next(c);return h?I(this._getMultilineMatchRange(a,s,c,f,h.index,h[0]),h,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(a,new k.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(a,l,v,t){const r=a.getLineCount(),s=l.lineNumber,i=a.getLineContent(s),c=this._findFirstMatchInLine(v,i,s,l.column,t);if(c)return c;for(let f=1;f<=r;f++){const h=(s+f-1)%r,b=a.getLineContent(h+1),S=this._findFirstMatchInLine(v,b,h+1,1,t);if(S)return S}return null}static _findFirstMatchInLine(a,l,v,t,r){a.reset(t-1);const s=a.next(l);return s?I(new D.Range(v,s.index+1,v,s.index+1+s[0].length),s,r):null}static findPreviousMatch(a,l,v,t){const r=l.parseSearchRequest();if(!r)return null;const s=new T(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(a,v,s,t):this._doFindPreviousMatchLineByLine(a,v,s,t)}static _doFindPreviousMatchMultiline(a,l,v,t){const r=this._doFindMatchesMultiline(a,new D.Range(1,1,l.lineNumber,l.column),v,t,10*C);if(r.length>0)return r[r.length-1];const s=a.getLineCount();return l.lineNumber!==s||l.column!==a.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(a,new k.Position(s,a.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(a,l,v,t){const r=a.getLineCount(),s=l.lineNumber,i=a.getLineContent(s).substring(0,l.column-1),c=this._findLastMatchInLine(v,i,s,t);if(c)return c;for(let f=1;f<=r;f++){const h=(r+s-f-1)%r,b=a.getLineContent(h+1),S=this._findLastMatchInLine(v,b,h+1,t);if(S)return S}return null}static _findLastMatchInLine(a,l,v,t){let r=null,s;for(a.reset(0);s=a.next(l);)r=I(new D.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=m;function u(E,a,l,v,t){if(v===0)return!0;const r=a.charCodeAt(v-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v);if(E.get(s)!==0)return!0}return!1}function p(E,a,l,v,t){if(v+t===l)return!0;const r=a.charCodeAt(v+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v+t-1);if(E.get(s)!==0)return!0}return!1}function _(E,a,l,v,t){return u(E,a,l,v,t)&&p(E,a,l,v,t)}e.isValidMatch=_;class T{constructor(a,l){this._wordSeparators=a,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const l=a.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(v=this._searchRegex.exec(a),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(a,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,a,l,t,r))return v}while(v);return null}}e.Searcher=T}),define(me[110],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(C=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)C.indexOf(P)>=0||(y+="\\"+P);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=g();function L(C){let y=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)y=C;else{let P="g";C.ignoreCase&&(P+="i"),C.multiline&&(P+="m"),C.unicode&&(P+="u"),y=new RegExp(C.source,P)}return y.lastIndex=0,y}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function D(C,y,P,n,I=k){if(P.length>I.maxLen){let _=C-I.maxLen/2;return _<0?_=0:n+=_,P=P.substring(_,C+I.maxLen/2),D(C,y,P,n,I)}const d=Date.now(),m=C-1-n;let u=-1,p=null;for(let _=1;!(Date.now()-d>=I.timeBudget);_++){const T=m-I.windowSize*_;y.lastIndex=Math.max(0,T);const E=A(y,P,m,u);if(!E&&p||(p=E,T<=0))break;u=T}if(p){let _={word:p[0],startColumn:n+1+p.index,endColumn:n+1+p.index+p[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=D;function A(C,y,P,n){let I;for(;I=C.exec(y);){const d=I.index||0;if(d<=P&&C.lastIndex>=P)return I;if(n>0&&d>n)return null}return null}}),define(me[147],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let y=0,P=C.notIn.length;y<P;y++)switch(C.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of C)D(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),D(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),D(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),D(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&D(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function D(A,C,y){A.has(C)?A.get(C).push(y):A.set(C,[y])}}),define(me[81],ge([0,1,30,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(D,A,C,y){if(Array.isArray(D)){let P=0;for(const n of D){const I=k(n,A,C,y);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof D=="string")return y?D==="*"?5:D===C?10:0:0;if(D){const{language:P,pattern:n,scheme:I,hasAccessToAllModels:d}=D;if(!y&&!d)return 0;let m=0;if(I)if(I===A.scheme)m=10;else if(I==="*")m=5;else return 0;if(P)if(P===C)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,L.normalize)(n.base)},u===A.fsPath||(0,g.match)(u,A.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(me[148],ge([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(u,p,_){const T=new Uint8Array(u*p);for(let E=0,a=u*p;E<a;E++)T[E]=_;this._data=T,this.rows=u,this.cols=p}get(u,p){return this._data[u*this.cols+p]}set(u,p,_){this._data[u*this.cols+p]=_}}e.Uint8Matrix=k;class D{constructor(u){let p=0,_=0;for(let E=0,a=u.length;E<a;E++){let[l,v,t]=u[E];v>p&&(p=v),l>_&&(_=l),t>_&&(_=t)}p++,_++;let T=new k(_,p,0);for(let E=0,a=u.length;E<a;E++){let[l,v,t]=u[E];T.set(l,v,t)}this._states=T,this._maxCharCode=p}nextState(u,p){return p<0||p>=this._maxCharCode?0:this._states.get(u,p)}}e.StateMachine=D;let A=null;function C(){return A===null&&(A=new D([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let P=null;function n(){if(P===null){P=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<m.length;p++)P.set(m.charCodeAt(p),1);const u=".,;";for(let p=0;p<u.length;p++)P.set(u.charCodeAt(p),2)}return P}class I{static _createLink(u,p,_,T,E){let a=E-1;do{const l=p.charCodeAt(a);if(u.get(l)!==2)break;a--}while(a>T);if(T>0){const l=p.charCodeAt(T-1),v=p.charCodeAt(a);(l===40&&v===41||l===91&&v===93||l===123&&v===125)&&a--}return{range:{startLineNumber:_,startColumn:T+1,endLineNumber:_,endColumn:a+2},url:p.substring(T,a+1)}}static computeLinks(u,p=C()){const _=n();let T=[];for(let E=1,a=u.getLineCount();E<=a;E++){const l=u.getLineContent(E),v=l.length;let t=0,r=0,s=0,i=1,c=!1,f=!1,h=!1,b=!1;for(;t<v;){let S=!1;const o=l.charCodeAt(t);if(i===13){let w;switch(o){case 40:c=!0,w=0;break;case 41:w=c?0:1;break;case 91:h=!0,f=!0,w=0;break;case 93:h=!1,w=f?0:1;break;case 123:b=!0,w=0;break;case 125:w=b?0:1;break;case 39:w=s===34||s===96?0:1;break;case 34:w=s===39||s===96?0:1;break;case 96:w=s===39||s===34?0:1;break;case 42:w=s===42?1:0;break;case 124:w=s===124?1:0;break;case 32:w=h?0:1;break;default:w=_.get(o)}w===1&&(T.push(I._createLink(_,l,E,r,t)),S=!0)}else if(i===12){let w;o===91?(f=!0,w=0):w=_.get(o),w===1?S=!0:i=13}else i=p.nextState(i,o),i===0&&(S=!0);S&&(i=1,c=!1,f=!1,b=!1,r=t+1,s=o),t++}i===13&&T.push(I._createLink(_,l,E,r,v))}return T}}e.LinkComputer=I;function d(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:I.computeLinks(m)}e.computeLinks=d}),define(me[149],ge([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,C){return this._map.set(A,C),this.fire([A]),(0,L.toDisposable)(()=>{this._map.get(A)===C&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,C){let y=null,P=!1;return this._promises.set(A,C.then(n=>{this._promises.delete(A),!(P||!n)&&(y=this.register(A,n))})),(0,L.toDisposable)(()=>{P=!0,y&&y.dispose()})}getPromise(A){const C=this.get(A);if(C)return Promise.resolve(C);const y=this._promises.get(A);return y?y.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(me[111],ge([0,1,22,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function D(I){for(let d=0,m=I.length;d<m;d+=4){const u=I[d+0],p=I[d+1],_=I[d+2],T=I[d+3];I[d+0]=T,I[d+1]=_,I[d+2]=p,I[d+3]=u}}function A(I){const d=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||D(d),g.VSBuffer.wrap(d)}function C(I){const d=I.buffer;if(L.isLittleEndian()||D(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const m=new Uint8Array(d.byteLength);return m.set(d),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(I){const d=new Uint32Array(P(I));let m=0;if(d[m++]=I.id,I.type==="full")d[m++]=1,d[m++]=I.data.length,d.set(I.data,m),m+=I.data.length;else{d[m++]=2,d[m++]=I.deltas.length;for(const u of I.deltas)d[m++]=u.start,d[m++]=u.deleteCount,u.data?(d[m++]=u.data.length,d.set(u.data,m),m+=u.data.length):d[m++]=0}return A(d)}e.encodeSemanticTokensDto=y;function P(I){let d=0;if(d+=1+1,I.type==="full")d+=1+I.data.length;else{d+=1,d+=(1+1+1)*I.deltas.length;for(const m of I.deltas)m.data&&(d+=m.data.length)}return d}function n(I){const d=C(I);let m=0;const u=d[m++];if(d[m++]===1){const E=d[m++],a=d.subarray(m,m+E);return m+=E,{id:u,type:"full",data:a}}const _=d[m++];let T=[];for(let E=0;E<_;E++){const a=d[m++],l=d[m++],v=d[m++];let t;v>0&&(t=d.subarray(m,m+v),m+=v),T[E]={start:a,deleteCount:l,data:t}}return{id:u,type:"delta",deltas:T}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(A,C){this._prefixSumIndexOfResultBrand=void 0,this.index=A,this.remainder=C}}e.PrefixSumIndexOfResult=L;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,C){A=(0,g.toUint32)(A);const y=this.values,P=this.prefixSum,n=C.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,A),0),this.values.set(y.subarray(A),A+n),this.values.set(C,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,C){return A=(0,g.toUint32)(A),C=(0,g.toUint32)(C),this.values[A]===C?!1:(this.values[A]=C,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,C){A=(0,g.toUint32)(A),C=(0,g.toUint32)(C);const y=this.values,P=this.prefixSum;if(A>=y.length)return!1;let n=y.length-A;return C>=n&&(C=n),C===0?!1:(this.values=new Uint32Array(y.length-C),this.values.set(y.subarray(0,A),0),this.values.set(y.subarray(A+C),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=(0,g.toUint32)(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),A>=this.values.length&&(A=this.values.length-1);for(let y=C;y<=A;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let C=0,y=this.values.length-1,P=0,n=0,I=0;for(;C<=y;)if(P=C+(y-C)/2|0,n=this.prefixSum[P],I=n-this.values[P],A<I)y=P-1;else if(A>=n)C=P+1;else break;return new L(P,A-I)}}e.PrefixSumComputer=k}),define(me[150],ge([0,1,9,50,112]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class D{constructor(C,y,P,n){this._uri=C,this._lines=y,this._eol=P,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const y=C.changes;for(const P of y)this._acceptDeleteRange(P.range),this._acceptInsertText(new L.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,y=this._lines.length,P=new Uint32Array(y);for(let n=0;n<y;n++)P[n]=this._lines[n].length+C;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(C,y){this._lines[C]=y,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,y){if(y.length===0)return;let P=(0,g.splitLines)(y);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);let n=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(C.lineNumber+I-1,0,P[I]),n[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,n)}}e.MirrorTextModel=D}),define(me[151],ge([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(me[152],ge([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,D=k*24,A=D*7,C=D*30,y=D*365;function P(I,d){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,g.localize)(0,null,P(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let u;return m<L?(u=m,d?u===1?(0,g.localize)(2,null,u):(0,g.localize)(3,null,u):u===1?(0,g.localize)(4,null,u):(0,g.localize)(5,null,u)):m<k?(u=Math.floor(m/L),d?u===1?(0,g.localize)(6,null,u):(0,g.localize)(7,null,u):u===1?(0,g.localize)(8,null,u):(0,g.localize)(9,null,u)):m<D?(u=Math.floor(m/k),d?u===1?(0,g.localize)(10,null,u):(0,g.localize)(11,null,u):u===1?(0,g.localize)(12,null,u):(0,g.localize)(13,null,u)):m<A?(u=Math.floor(m/D),d?u===1?(0,g.localize)(14,null,u):(0,g.localize)(15,null,u):u===1?(0,g.localize)(16,null,u):(0,g.localize)(17,null,u)):m<C?(u=Math.floor(m/A),d?u===1?(0,g.localize)(18,null,u):(0,g.localize)(19,null,u):u===1?(0,g.localize)(20,null,u):(0,g.localize)(21,null,u)):m<y?(u=Math.floor(m/C),d?u===1?(0,g.localize)(22,null,u):(0,g.localize)(23,null,u):u===1?(0,g.localize)(24,null,u):(0,g.localize)(25,null,u)):(u=Math.floor(m/y),d?u===1?(0,g.localize)(26,null,u):(0,g.localize)(27,null,u):u===1?(0,g.localize)(28,null,u):(0,g.localize)(29,null,u))}e.fromNow=P;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[153],ge([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,20,14,153]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(P,n){return n&&(P.stack||P.stacktrace)?k.localize(0,null,C(P),A(P.stack)||A(P.stacktrace)):C(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function y(P=null,n=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const I=g.coalesce(P),d=y(I[0],n);return I.length>1?k.localize(4,null,d,I.length):d}if(L.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return D(I.error,n);if(I.exception)return D(I.exception,n)}return P.stack?D(P,n):P.message?P.message:k.localize(5,null)}e.toErrorMessage=y}),define(me[154],ge([18,19]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,23,8,11,38,14,143,28,154]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(l,v){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};v&&(t.cwd=v);const r=g.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(s=>{r.once("error",i=>{s({success:!1,error:i})}),r.once("exit",(i,c)=>{s(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{g.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(s,i,c)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function p(l=y.env){return l.comspec||"cmd.exe"}e.getWindowsShell=p;class _{constructor(v,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=v,this.args=t,this.shell=r,this.options=s;else{const i=v;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(y.env).forEach(c=>{i[c]=y.env[c]}),Object.keys(this.options.env).forEach(c=>{i[c]=this.options.env[c]}),this.options.env=i}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const t=v.lastIndexOf(A.sep);return t!==-1&&(v=v.substring(t+1)),_.WellKnowCommands[v]?v:"other"}start(v){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(t=>{let r,s;const i=new Promise((c,f)=>{r=c,s=f});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(f,h,b)=>{this.childProcess=null;const S=f;S&&S.killed?s({killed:this.terminateRequested,stdout:h.toString(),stderr:b.toString()}):this.handleExec(r,v,f,h,b)})}else{let c=null;const f=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,v,s);const b={terminated:this.terminateRequested};P.isNumber(h)&&(b.cmdCode=h),r(b)};if(this.shell&&C.isWindows){const h=D.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let b=!1,S=!1;const o=[];let w=this.ensureQuotes(this.cmd);o.push(w.value),b=w.quoted,this.args&&this.args.forEach(O=>{w=this.ensureQuotes(O),o.push(w.value),S=S&&w.quoted});const R=["/s","/c"];b?S?R.push('"'+o.join(" ")+'"'):o.length>1?R.push('"'+o[0]+'" '+o.slice(1).join(" ")):R.push('"'+o[0]+'"'):R.push(o.join(" ")),c=g.spawn(p(),R,h)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,s({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",f),this.handleSpawn(c,r,v,s,!0)))}return i})}handleClose(v,t,r,s){}ensureQuotes(v){return _.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,u(v,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!C.isWindows)return v(!1);const t=g.spawn(p(),["/s","/c"]);t.on("error",r=>v(!0)),t.on("exit",r=>v(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class T extends _{constructor(v,t,r,s){super(v,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,t,r,s,i){[s,i].forEach((c,f)=>{const h=new n.LineDecoder;h.write(c).forEach(o=>{t({line:o,source:f===0?0:1})});const S=h.end();S&&t({line:S,source:f===0?0:1})}),v({terminated:this.terminateRequested,error:r})}handleSpawn(v,t,r,s,i){const c=new n.LineDecoder,f=new n.LineDecoder;v.stdout.on("data",h=>{c.write(h).forEach(S=>r({line:S,source:0}))}),v.stderr.on("data",h=>{f.write(h).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=f}handleClose(v,t,r,s){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=T;function E(l){let v=[],t=!1;const r=function(s){if(t){v.push(s);return}(!l.send(s,c=>{if(c&&console.error(c),t=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(h=>r(h))}})||C.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=E;var a;(function(l){async function v(t,r,s){if(A.isAbsolute(t))return t;if(r===void 0&&(r=y.cwd()),A.dirname(t)!=="."||(s===void 0&&P.isString(y.env.PATH)&&(s=y.env.PATH.split(A.delimiter)),s===void 0||s.length===0))return A.join(r,t);async function c(f){if(await I.Promises.exists(f)){let h;try{h=await I.Promises.stat(f)}catch(b){b.message.startsWith("EACCES")&&(h=await I.Promises.lstat(f))}return h?!h.isDirectory():!1}return!1}for(let f of s){let h;if(A.isAbsolute(f)?h=A.join(f,t):h=A.join(r,f,t),await c(h))return h;let b=h+".com";if(await c(b)||(b=h+".exe",await c(b)))return b}return A.join(r,t)}l.findExecutable=v})(a=e.win32||(e.win32={}))}),define(me[155],ge([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(me[156],ge([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[157],ge([18,19]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[158],ge([18,19]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[159],ge([18,19]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[160],ge([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(me[161],ge([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(me[162],ge([18,19]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(me[163],ge([18,19]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(me[164],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[165],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[166],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(me[167],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[168],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[169],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[170],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[171],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[172],ge([18,19]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(me[173],ge([18,19]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(me[174],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[175],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[176],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[177],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[178],ge([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[179],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[180],ge([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function D(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=D;function A(d){if(!D(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=d.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=A;function C(d){if(!d)return null;let m=d.majorBase,u=d.majorMustEqual,p=d.minorBase,_=d.minorMustEqual,T=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(m===0||(_=!1),E=!1);let a=0;if(d.preRelease){const l=k.exec(d.preRelease);if(l){const[,v,t,r]=l;a=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:u,minorBase:p,minorMustEqual:_,patchBase:T,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:a}}e.normalizeVersion=C;function y(d,m,u){let p;typeof d=="string"?p=C(A(d)):p=d;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let T;if(typeof u=="string"?T=C(A(u)):T=u,!p||!T)return!1;let E=p.majorBase,a=p.minorBase,l=p.patchBase,v=T.majorBase,t=T.minorBase,r=T.patchBase,s=T.notBefore,i=T.majorMustEqual,c=T.minorMustEqual,f=T.patchMustEqual;return T.isMinimum?E>v?!0:E<v?!1:a>t?!0:a<t||_&&_<s?!1:l>=r:(E===1&&v===0&&(!i||!c||!f)&&(v=1,t=0,r=0,i=!0,c=!1,f=!1),E<v?!1:E>v?!i:a<t?!1:a>t?!c:l<r?!1:l>r?!f:!(_&&_<s))}e.isValidVersion=y;function P(d,m,u,p){return u.isBuiltin||typeof u.main=="undefined"?!0:I(d,m,u.engines.vscode,p)}e.isValidExtensionVersion=P;function n(d,m,u){return d==="*"||I(m,u,d)}e.isEngineValid=n;function I(d,m,u,p=[]){let _=C(A(u));if(!_)return p.push(g.localize(0,null,u)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return p.push(g.localize(1,null,u)),!1}else if(!_.majorMustEqual)return p.push(g.localize(2,null,u)),!1;return y(d,m,_)?!0:(p.push(g.localize(3,null,d,u)),!1)}}),define(me[114],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,D=[],A=!1){this.ctor=k,this.staticArguments=D,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=g}),define(me[82],ge([0,1,114]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(A,C,y){C instanceof g.SyncDescriptor||(C=new g.SyncDescriptor(C,[],y)),L.push([A,C])}e.registerSingleton=k;function D(){return L}e.getSingletonServiceDescriptors=D}),define(me[181],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=g;class L{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let A of this._nodes.values())A.outgoing.size===0&&D.push(A);return D}insertEdge(D,A){const C=this.lookupOrInsertNode(D),y=this.lookupOrInsertNode(A);C.outgoing.set(this._hashFn(A),y),y.incoming.set(this._hashFn(D),C)}removeNode(D){const A=this._hashFn(D);this._nodes.delete(A);for(let C of this._nodes.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(D){const A=this._hashFn(D);let C=this._nodes.get(A);return C||(C=new g(D),this._nodes.set(A,C)),C}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[A,C]of this._nodes)D.push(`${A}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,A]of this._nodes){const C=new Set([D]),y=this._findCycle(A,C);if(y)return y}}_findCycle(D,A){for(let[C,y]of D.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const P=this._findCycle(y,A);if(P)return P;A.delete(C)}}}e.Graph=L}),define(me[4],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(C,y,P,n){y[g.DI_TARGET]===y?y[g.DI_DEPENDENCIES].push({id:C,index:P,optional:n}):(y[g.DI_DEPENDENCIES]=[{id:C,index:P,optional:n}],y[g.DI_TARGET]=y)}function k(C){if(g.serviceIds.has(C))return g.serviceIds.get(C);const y=function(P,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,P,I,!1)};return y.toString=()=>C,g.serviceIds.set(C,y),y}e.createDecorator=k;function D(C){return C}e.refineServiceDecorator=D;function A(C){return function(y,P,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,y,n,!0)}}e.optional=A}),define(me[182],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[183],ge([0,1,3,58,6,24,77,81,182]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(P):!!p.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(_,T){let E={selector:_,provider:T,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(E){let a=this._entries.indexOf(E);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const T=[];for(let E of this._entries)E._score>0&&T.push(E.provider);return T}ordered(_){const T=[];return this._orderedForEach(_,E=>T.push(E.provider)),T}orderedGroups(_){const T=[];let E,a;return this._orderedForEach(_,l=>{E&&a===l._score?E.push(l.provider):(a=l._score,E=[l.provider],T.push(E))}),T}_orderedForEach(_,T){if(!!_){this._updateScores(_);for(const E of this._entries)E._score>0&&T(E)}}_updateScores(_){let T={uri:_.uri.toString(),language:_.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let E of this._entries)if(E._score=(0,C.score)(E.selector,_.uri,_.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(_)),P(E.selector)&&E._score>0){for(let a of this._entries)a._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(_,T){return _._score<T._score?1:_._score>T._score?-1:_._time<T._time?1:_._time>T._time?-1:0}}e.LanguageFeatureRegistry=n;const I=new WeakMap;let d=0;function m(p){let _=I.get(p);return _===void 0&&(_=++d,I.set(p,_)),_}class u{constructor(_,T,E=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=T,this.max=E,this._cache=new D.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((T,E)=>(0,L.doHash)(m(E),T),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const T=this._key(_),E=this._cache.get(T);return this._clamp(E?.value)}update(_,T){const E=this._key(_);let a=this._cache.get(E);return a||(a=new A.MovingAverage,this._cache.set(E,a)),a.update(T),this.get(_)}}e.LanguageFeatureRequestDelays=u}),define(me[83],ge([0,1,2,41,183,149,47]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class y{constructor(w,R){this.language=w,this.id=R}}e.LanguageIdentifier=y;var P;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let R=this.getForeground(w),O="mtk"+R,$=this.getFontStyle(w);return $&1&&(O+=" mtki"),$&2&&(O+=" mtkb"),$&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(w,R){const O=this.getForeground(w),$=this.getFontStyle(w);let K=`color: ${R[O]};`;return $&1&&(K+="font-style: italic;"),$&2&&(K+="font-weight: bold;"),$&4&&(K+="text-decoration: underline;"),K}}e.TokenMetadata=m;var u;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(w){const R=o[w];let O=R&&A.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+w),O=A.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(w,R){let O=o[w];return typeof O=="undefined"&&!R&&(O=9),O}}();var p;(function(o){o[o.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&g.URI.isUri(o.uri)&&L.Range.isIRange(o.range)&&(L.Range.isIRange(o.originSelectionRange)||L.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(G){return w.get(G)}o.fromString=O;function $(G){return R.get(G)}o.toString=$;function K(G,N){const x=R.get(G);let F=x&&A.iconRegistry.get("symbol-"+x);return F||(console.info("No codicon found for SymbolKind "+G),F=A.Codicon.symbolProperty),`${N?"inline":"block"} ${F.classNames}`}o.toCssClassName=K})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(w){this.value=w}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var f;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var b;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistryImpl;var S;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,11,9,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=g.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",g.isMacintosh),A.set("isLinux",g.isLinux),A.set("isWindows",g.isWindows),A.set("isWeb",g.isWeb),A.set("isMacNative",g.isMacintosh&&!g.isWeb),A.set("isEdge",D.indexOf("Edg/")>=0),A.set("isFirefox",D.indexOf("Firefox")>=0),A.set("isChrome",D.indexOf("Chrome")>=0),A.set("isSafari",D.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var y;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return I.INSTANCE}static true(){return d.INSTANCE}static has(o){return m.create(o)}static equals(o,w){return u.create(o,w)}static notEquals(o,w){return T.create(o,w)}static regex(o,w){return r.create(o,w)}static in(o,w){return p.create(o,w)}static not(o){return E.create(o)}static and(...o){return i.create(o)}static or(...o){return c.create(o)}static greater(o,w){return a.create(o,w)}static less(o,w){return v.create(o,w)}static deserialize(o,w=!1){if(!!o)return this._deserializeOrExpression(o,w)}static _deserializeOrExpression(o,w){let R=o.split("||");return c.create(R.map(O=>this._deserializeAndExpression(O,w)))}static _deserializeAndExpression(o,w){let R=o.split("&&");return i.create(R.map(O=>this._deserializeOne(O,w)))}static _deserializeOne(o,w){if(o=o.trim(),o.indexOf("!=")>=0){let R=o.split("!=");return T.create(R[0].trim(),this._deserializeValue(R[1],w))}if(o.indexOf("==")>=0){let R=o.split("==");return u.create(R[0].trim(),this._deserializeValue(R[1],w))}if(o.indexOf("=~")>=0){let R=o.split("=~");return r.create(R[0].trim(),this._deserializeRegexValue(R[1],w))}if(o.indexOf(" in ")>=0){let R=o.split(" in ");return p.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const R=o.split(">=");return l.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const R=o.split(">");return a.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const R=o.split("<=");return t.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const R=o.split("<");return v.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(o)?E.create(o.substr(1).trim()):m.create(o)}static _deserializeValue(o,w){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let R=/^'([^']*)'$/.exec(o);return R?R[1].trim():o}static _deserializeRegexValue(o,w){if((0,L.isFalsyOrWhitespace)(o)){if(w)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=o.indexOf("/"),O=o.lastIndexOf("/");if(R===O||R<0){if(w)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let $=o.slice(R+1,O),K=o[O+1]==="i"?"i":"";try{return new RegExp($,K)}catch(G){if(w)throw new Error(`bad regexp-value '${o}', parse error: ${G}`);return console.warn(`bad regexp-value '${o}', parse error: ${G}`),null}}}e.ContextKeyExpr=P;function n(S,o){return S.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class d{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class m{constructor(o){this.key=o,this.type=2}static create(o){const w=A.get(o);return typeof w=="boolean"?w?d.INSTANCE:I.INSTANCE:new m(o)}cmp(o){return o.type!==this.type?this.type-o.type:h(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=m;class u{constructor(o,w){this.key=o,this.value=w,this.type=4}static create(o,w){if(typeof w=="boolean")return w?m.create(o):E.create(o);const R=A.get(o);return typeof R=="boolean"?w===(R?"true":"false")?d.INSTANCE:I.INSTANCE:new u(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return T.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class p{constructor(o,w){this.key=o,this.valueKey=w,this.type=10}static create(o,w){return new p(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const w=o.getValue(this.valueKey),R=o.getValue(this.key);return Array.isArray(w)?w.indexOf(R)>=0:typeof R=="string"&&typeof w=="object"&&w!==null?C.call(w,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=p;class _{constructor(o){this._actual=o,this.type=11}static create(o){return new _(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new _(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class T{constructor(o,w){this.key=o,this.value=w,this.type=5}static create(o,w){if(typeof w=="boolean")return w?E.create(o):m.create(o);const R=A.get(o);return typeof R=="boolean"?w===(R?"true":"false")?I.INSTANCE:d.INSTANCE:new T(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=T;class E{constructor(o){this.key=o,this.type=3}static create(o){const w=A.get(o);return typeof w=="boolean"?w?I.INSTANCE:d.INSTANCE:new E(o)}cmp(o){return o.type!==this.type?this.type-o.type:h(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=E;class a{constructor(o,w){this.key=o,this.value=w,this.type=12}static create(o,w){return new a(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class l{constructor(o,w){this.key=o,this.value=w,this.type=13}static create(o,w){return new l(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class v{constructor(o,w){this.key=o,this.value=w,this.type=14}static create(o,w){return new v(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,w){this.key=o,this.value=w,this.type=15}static create(o,w){return new t(o,w)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,w){this.key=o,this.regexp=w,this.type=7}static create(o,w){return new r(o,w)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const w=this.regexp?this.regexp.source:"",R=o.regexp?o.regexp.source:"";return w<R?-1:w>R?1:0}equals(o){if(o.type===this.type){const w=this.regexp?this.regexp.source:"",R=o.regexp?o.regexp.source:"";return this.key===o.key&&w===R}return!1}evaluate(o){let w=o.getValue(this.key);return this.regexp?this.regexp.test(w):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let w=0,R=this.expr.length;w<R;w++){const O=n(this.expr[w],o.expr[w]);if(O!==0)return O}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let w=0,R=this.expr.length;w<R;w++)if(!this.expr[w].equals(o.expr[w]))return!1;return!0}return!1}evaluate(o){for(let w=0,R=this.expr.length;w<R;w++)if(!this.expr[w].evaluate(o))return!1;return!0}static _normalizeArr(o){const w=[];let R=!1;for(const O of o)if(!!O){if(O.type===1){R=!0;continue}if(O.type===0)return I.INSTANCE;if(O.type===6){w.push(...O.expr);continue}w.push(O)}if(w.length===0&&R)return d.INSTANCE;if(w.length!==0){if(w.length===1)return w[0];for(w.sort(n);w.length>1;){const O=w[w.length-1];if(O.type!==9)break;w.pop();const $=w.pop(),K=c.create(O.expr.map(G=>i.create([G,$])));K&&(w.push(K),w.sort(n))}return w.length===1?w[0]:new i(w)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let w of this.expr)o.push(...w.keys());return o}map(o){return new i(this.expr.map(w=>w.map(o)))}negate(){let o=[];for(let w of this.expr)o.push(w.negate());return c.create(o)}}e.ContextKeyAndExpr=i;class c{constructor(o){this.expr=o,this.type=9}static create(o){const w=c._normalizeArr(o);if(w.length!==0)return w.length===1?w[0]:new c(w)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let w=0,R=this.expr.length;w<R;w++){const O=n(this.expr[w],o.expr[w]);if(O!==0)return O}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let w=0,R=this.expr.length;w<R;w++)if(!this.expr[w].equals(o.expr[w]))return!1;return!0}return!1}evaluate(o){for(let w=0,R=this.expr.length;w<R;w++)if(this.expr[w].evaluate(o))return!0;return!1}static _normalizeArr(o){let w=[],R=!1;if(o){for(let O=0,$=o.length;O<$;O++){const K=o[O];if(!!K){if(K.type===0){R=!0;continue}if(K.type===1)return[d.INSTANCE];if(K.type===9){w=w.concat(K.expr);continue}w.push(K)}}if(w.length===0&&R)return[I.INSTANCE];w.sort(n)}return w}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let w of this.expr)o.push(...w.keys());return o}map(o){return new c(this.expr.map(w=>w.map(o)))}negate(){let o=[];for(let R of this.expr)o.push(R.negate());const w=R=>R.type===9?R.expr:[R];for(;o.length>1;){const R=o.shift(),O=o.shift(),$=[];for(const K of w(R))for(const G of w(O))$.push(P.and(K,G));o.unshift(P.or(...$))}return o[0]}}e.ContextKeyOrExpr=c;class f extends m{constructor(o,w,R){super(o);this._defaultValue=w,typeof R=="object"?f._info.push({...R,key:o}):R!==!0&&f._info.push({key:o,description:R,type:w!=null?typeof w:void 0})}static all(){return f._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(o){return P.equals(this.key,o)}notEqualsTo(o){return P.notEquals(this.key,o)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(S,o){return S<o?-1:S>o?1:0}function b(S,o,w,R){return S<w?-1:S>w?1:o<R?-1:o>R?1:0}}),define(me[184],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(me[185],ge([0,1,10,157,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=D;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var C;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var y;(function(I){I.Install="install",I.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var P;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(d,m){super(d);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=k;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,d){if(typeof I=="undefined"||I===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof I=="string"||typeof d=="string"){let m=typeof I=="string"?I:I.value,u=typeof d=="string"?d:d.value;return g.equalsIgnoreCase(m,u)}return I._lower===d._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function P(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[186],ge([0,1,9,26]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(u,p){return u.uuid&&p.uuid?u.uuid===p.uuid:u.id===p.id?!0:(0,g.compareIgnoreCase)(u.id,p.id)===0}e.areSameExtensions=k;class D{constructor(p,_){this.version=_,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof D?k(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=D;function A(u,p){return`${u}.${p}`}e.getExtensionId=A;function C(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(u,p){return C(A(u,p))}e.getGalleryExtensionId=y;function P(u,p){const _=[],T=E=>{for(const a of _)if(a.some(l=>k(p(l),p(E))))return a;return null};for(const E of u){const a=T(E);a?a.push(E):_.push([E])}return _}e.groupByExtension=P;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(u){const p=new Set;for(const _ of u)_.malicious&&p.add(_.id.id);return p}e.getMaliciousExtensionsSet=d;function m(u,p){const _=[],T=p.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const E=T.shift();if(E&&_.every(a=>!k(a.identifier,{id:E}))){const a=u.filter(l=>k(l.identifier,{id:E}));a.length===1&&(_.push(a[0]),T.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=m}),define(me[187],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(me[188],ge([0,1,39,10,8,11,141,28,113,159,187]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=P.localize(0,null);class d{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends d{openTerminal(l,v){return this.spawnTerminal(g,l,y.getWindowsShell(),v)}spawnTerminal(l,v,t,r){const s=v.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=k.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return l.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return s.indexOf(" ")>=0&&c.push('""'),c.push(s),(i==="wt"||i==="wt.exe")&&c.push("-d ."),new Promise((f,h)=>{const b=_(process),S=l.spawn(t,c,{cwd:r,env:b});S.on("error",h),S.on("exit",()=>f())})}runInTerminal(l,v,t,r,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:m.getDefaultTerminalWindows();return new Promise((c,f)=>{const h=`"${v} - ${I}"`,b=`""${t.join('" "')}" & pause"`,S=["/c","start",h,"/wait",i,"/c",b],o=Object.assign({},_(process),r);Object.keys(o).filter(O=>o[O]===null).forEach(O=>delete o[O]);const w={cwd:v,env:o,windowsVerbatimArguments:!0};g.spawn(m.CMD,S,w).on("error",O=>{f(T(O))}),c(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class u extends d{openTerminal(l,v){return this.spawnTerminal(g,l,v)}runInTerminal(l,v,t,r,s){const i=s.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((c,f)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,Y).fsPath,"-t",l||I,"-w",v];for(let R of t)S.push("-a"),S.push(R);if(r){const R=Object.assign({},_(process),r);for(let O in R){const $=R[O];$===null?(S.push("-u"),S.push(O)):(S.push("-e"),S.push(`${O}=${$}`))}}let o="";const w=g.spawn(u.OSASCRIPT,S);w.on("error",R=>{f(T(R))}),w.stderr.on("data",R=>{o+=R.toString()}),w.on("exit",R=>{if(R===0)c(void 0);else if(o){const O=o.split(`
`,1);f(new Error(O[0]))}else f(new Error(P.localize(1,null,h,R)))})}else f(new Error(P.localize(2,null,i)))})}spawnTerminal(l,v,t){const r=v.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const c=["-a",r];t&&c.push(t);const f=_(process),h=l.spawn("/usr/bin/open",c,{cwd:t,env:f});h.on("error",i),h.on("exit",()=>s())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class p extends d{openTerminal(l,v){return this.spawnTerminal(g,l,v)}runInTerminal(l,v,t,r,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,f)=>{let h=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const S=`${E(t)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;h.push(`''${S}''`);const o=Object.assign({},_(process),r);Object.keys(o).filter($=>o[$]===null).forEach($=>delete o[$]);const w={cwd:v,env:o};let R="";const O=g.spawn(b,h,w);O.on("error",$=>{f(T($))}),O.stderr.on("data",$=>{R+=$.toString()}),O.on("exit",$=>{if($===0)c(void 0);else if(R){const K=R.split(`
`,1);f(new Error(K[0]))}else f(new Error(P.localize(4,null,b,$)))})})})}static async getDefaultTerminalLinuxReady(){return p._DEFAULT_TERMINAL_LINUX_READY||(p._DEFAULT_TERMINAL_LINUX_READY=new Promise(async l=>{D.isLinux?await C.Promises.exists("/etc/debian_version")?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm"):l("xterm")})),p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,v,t){const r=v.linuxExec?Promise.resolve(v.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{r.then(c=>{const f=_(process),h=l.spawn(c,[],{cwd:t,env:f});h.on("error",i),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=P.localize(3,null);function _(a){const l={...a.env};return(0,A.sanitizeProcessEnvironment)(l),l}function T(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(P.localize(5,null,a.path)):a}function E(a){let l="";for(let v of a)v.indexOf(" ")>=0?l+='"'+v+'"':l+=v,l+=" ";return l}}),define(me[42],ge([0,1,24,8,9,14,2,160,4]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(N){return N.create===!0}e.isFileOpenForWriteOptions=P;var n;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var d;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function u(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=u;function p(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function _(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=_;var T;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(x,F){super(x);this.code=F}}e.FileSystemProviderError=E;function a(N,x){const F=new E(N.toString(),x);return v(F,x),F}e.createFileSystemProviderError=a;function l(N){return N||a((0,C.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=l;function v(N,x){return N.name=x?`${x} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=v;function t(N){if(!N)return T.Unknown;if(N instanceof E)return N.code;const x=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!x)return T.Unknown;switch(x[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=t;function r(N){if(N instanceof b)return N.fileOperationResult;switch(t(N)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(x,F,V){this.resource=x,this.operation=F,this.target=V}isOperation(x){return this.operation===x}}e.FileOperationEvent=i;var c;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class f{constructor(x,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const V of x)switch(V.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>F)),this.added.set(V.resource,V);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>F)),this.updated.set(V.resource,V);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>F)),this.deleted.set(V.resource,V);break}}contains(x,...F){return this.doContains(x,{includeChildren:!1},...F)}affects(x,...F){return this.doContains(x,{includeChildren:!0},...F)}doContains(x,F,...V){if(!x)return!1;const M=V.length>0;return!!((!M||V.includes(1))&&(this.added?.get(x)||F.includeChildren&&this.added?.findSuperstr(x))||(!M||V.includes(0))&&(this.updated?.get(x)||F.includeChildren&&this.updated?.findSuperstr(x))||(!M||V.includes(2))&&(this.deleted?.findSubstr(x)||F.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function h(N,x,F){return!N||!x||N===x||x.length>N.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),F?(0,k.startsWithIgnoreCase)(N,x):N.indexOf(x)===0)}e.isParent=h;class b extends Error{constructor(x,F,V){super(x);this.fileOperationResult=F,this.options=V}}e.FileOperationError=b;class S extends b{constructor(x,F,V){super(x,2,V);this.stat=F}}e.NotModifiedSinceFileOperationError=S;var o;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=R;async function O(N,x){if(!x.canHandleResource(A.URI.from({scheme:N.scheme})))return new Promise(F=>{const V=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===N.scheme&&M.added&&(V.dispose(),F())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(x){return(0,D.isNumber)(x)||(x=0),x<$.KB?(0,C.localize)(1,null,x.toFixed(0)):x<$.MB?(0,C.localize)(2,null,(x/$.KB).toFixed(2)):x<$.GB?(0,C.localize)(3,null,(x/$.MB).toFixed(2)):x<$.TB?(0,C.localize)(4,null,(x/$.GB).toFixed(2)):(0,C.localize)(5,null,(x/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var K;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function G(N){return{maxFileSize:N===0?300*$.MB:16*$.GB,maxHeapSize:N===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=G}),define(me[84],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[D,A]of k)this.set(D,A)}set(k,D){const A=this._entries.get(k);return this._entries.set(k,D),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(me[189],ge([0,1,17,16,114,181,4,84]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new C.ServiceCollection,p=!1,_){this._activeInstantiations=new Set,this._services=u,this._strict=p,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...p){let _=d.traceInvocation(u),T=!1;try{return u({get:(a,l)=>{if(T)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(a,_);if(!v&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return v}},...p)}finally{T=!0,_.stop()}}createInstance(u,...p){let _,T;return u instanceof k.SyncDescriptor?(_=d.traceCreation(u.ctor),T=this._createInstance(u.ctor,u.staticArguments.concat(p),_)):(_=d.traceCreation(u),T=this._createInstance(u,p,_)),_.stop(),T}_createInstance(u,p=[],_){let T=A._util.getServiceDependencies(u).sort((l,v)=>l.index-v.index),E=[];for(const l of T){let v=this._getOrCreateServiceInstance(l.id,_);if(!v&&this._strict&&!l.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${l.id}.`);E.push(v)}let a=T.length>0?T[0].index:p.length;if(p.length!==a){console.warn(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${p.length} static arguments`);let l=a-p.length;l>0?p=p.concat(new Array(l)):p=p.slice(0,a)}return new u(...[...p,...E])}_setServiceInstance(u,p){if(this._services.get(u)instanceof k.SyncDescriptor)this._services.set(u,p);else if(this._parent)this._parent._setServiceInstance(u,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let p=this._services.get(u);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):p}_getOrCreateServiceInstance(u,p){let _=this._getServiceInstanceOrDescriptor(u);return _ instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,_,p.branch(u,!0)):(p.branch(u,!1),_)}_safeCreateAndCacheServiceInstance(u,p,_){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,p,_)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,p,_){const T=new D.Graph(l=>l.id.toString());let E=0;const a=[{id:u,desc:p,_trace:_}];for(;a.length;){const l=a.pop();if(T.lookupOrInsertNode(l),E++>1e3)throw new P(T);for(let v of A._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:v.id,desc:t,_trace:l._trace.branch(v.id,!0)};T.insertEdge(l,r),a.push(r)}}}for(;;){const l=T.roots();if(l.length===0){if(!T.isEmpty())throw new P(T);break}for(const{data:v}of l){if(this._getServiceInstanceOrDescriptor(v.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}T.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,p,_=[],T,E){if(this._services.get(u)instanceof k.SyncDescriptor)return this._createServiceInstance(p,_,T,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,p,_,T,E);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(u,p=[],_,T){if(_){const E=new g.IdleValue(()=>this._createInstance(u,p,T));return new Proxy(Object.create(null),{get(a,l){if(l in a)return a[l];let v=E.value,t=v[l];return typeof t!="function"||(t=t.bind(v),a[l]=t),t},set(a,l,v){return E.value[l]=v,!0}})}else return this._createInstance(u,p,T)}}e.InstantiationService=n;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class d{constructor(u,p){this.type=u,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new d(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(u){return y?new d(0,u.name):d._None}branch(u,p){let _=new d(2,u.toString());return this._dep.push([u,p,_]),_}stop(){let u=Date.now()-this._start;d._totals+=u;let p=!1;function _(E,a){let l=[],v=new Array(E+1).join("	");for(const[t,r,s]of a._dep)if(r&&s){p=!0,l.push(`${v}CREATES -> ${t}`);let i=_(E+1,s);i&&l.push(i)}else l.push(`${v}uses -> ${t}`);return l.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(u>2||p)&&console.log(T.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(me[12],ge([0,1,60,3,6,11,4]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function C(){return new Date().toISOString()}var y;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class P extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class n extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class I extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class d extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class m extends P{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class u extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=p;class _ extends k.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class T{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=T;function E(v){if(v.verbose)return y.Trace;if(typeof v.logLevel=="string"){const t=a(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function a(v){switch(v){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function l(v){switch(v){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=l}),define(me[115],ge([0,1,42,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(y,P,n,I){try{const d=await new Promise((m,u)=>{Y(["spdlog"],m,u)});return d.setFlushOn(L.LogLevel.Trace),d.createAsyncRotatingLogger(y,P,n,I)}catch(d){console.error(d)}return null}function D(y,P,n,I){const d=Y.__$__nodeRequire("spdlog");return d.setFlushOn(L.LogLevel.Trace),d.createRotatingLogger(y,P,n,I)}e.createRotatingLogger=D;function A(y,P,n){switch(P){case L.LogLevel.Trace:y.trace(n);break;case L.LogLevel.Debug:y.debug(n);break;case L.LogLevel.Info:y.info(n);break;case L.LogLevel.Warning:y.warn(n);break;case L.LogLevel.Error:y.error(n);break;case L.LogLevel.Critical:y.critical(n);break;default:throw new Error("Invalid log level")}}class C extends L.AbstractMessageLogger{constructor(P,n,I,d){super();this.name=P,this.filepath=n,this.rotating=I,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const P=this.rotating?6:1,n=30/P*g.ByteSize.MB;return k(this.name,this.filepath,n,P).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:d,message:m}of this.buffer)A(this._logger,d,m);this.buffer=[]}})}log(P,n){this._logger?A(this._logger,P,n):this.getLevel()<=P&&this.buffer.push({level:P,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[116],ge([0,1,48,161,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var A;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(u,p){return p-u}y.compare=P;const n=Object.create(null);n[y.Error]=(0,L.localize)(0,null),n[y.Warning]=(0,L.localize)(1,null),n[y.Info]=(0,L.localize)(2,null);function I(u){return n[u]||""}y.toString=I;function d(u){switch(u){case g.default.Error:return y.Error;case g.default.Warning:return y.Warning;case g.default.Info:return y.Info;case g.default.Ignore:return y.Hint}}y.fromSeverity=d;function m(u){switch(u){case y.Error:return g.default.Error;case y.Warning:return g.default.Warning;case y.Info:return g.default.Info;case y.Hint:return g.default.Ignore}}y.toSeverity=m}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(y){const P="";function n(d){return I(d,!0)}y.makeKey=n;function I(d,m){let u=[P];return d.source?u.push(d.source.replace("\xA6","\\\xA6")):u.push(P),d.code?typeof d.code=="string"?u.push(d.code.replace("\xA6","\\\xA6")):u.push(d.code.value.replace("\xA6","\\\xA6")):u.push(P),d.severity!==void 0&&d.severity!==null?u.push(A.toString(d.severity)):u.push(P),d.message&&m?u.push(d.message.replace("\xA6","\\\xA6")):u.push(P),d.startLineNumber!==void 0&&d.startLineNumber!==null?u.push(d.startLineNumber.toString()):u.push(P),d.startColumn!==void 0&&d.startColumn!==null?u.push(d.startColumn.toString()):u.push(P),d.endLineNumber!==void 0&&d.endLineNumber!==null?u.push(d.endLineNumber.toString()):u.push(P),d.endColumn!==void 0&&d.endColumn!==null?u.push(d.endColumn.toString()):u.push(P),u.push(P),u.join("\xA6")}y.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(me[190],ge([0,1,3,48,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,k.createDecorator)("notificationService");var D;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new y,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=C;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(me[191],ge([0,1,6,9,2,4]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function A(C,y){return k.URI.isUri(C)?(0,L.equalsIgnoreCase)(C.scheme,y):(0,L.startsWithIgnoreCase)(C,y+":")}e.matchesScheme=A}),define(me[117],ge([0,1,10,11,38,25]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)A=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const C=(0,D.dirname)(g.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,D.joinPath)(C,"product.json").fsPath);const y=Y.__$__nodeRequire((0,D.joinPath)(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:y.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(me[118],ge([0,1,155,11,110,117]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=C;class y{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=y;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class n{constructor(te,pe,He,tt){this.id=te,this.name=pe,this.defaultValue=He,this.schema=tt}compute(te,pe,He){return He}}class I{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class d{constructor(te,pe,He,tt){this.id=te,this.name=pe,this.defaultValue=He,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,He){return He}}function m(Q,te){return typeof Q=="undefined"?te:Q==="false"?!1:Boolean(Q)}e.boolean=m;class u extends d{constructor(te,pe,He,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=He),super(te,pe,He,tt)}validate(te){return m(te,this.defaultValue)}}class p extends d{constructor(te,pe,He,tt,st,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=He,lt.minimum=tt,lt.maximum=st),super(te,pe,He,lt),this.minimum=tt,this.maximum=st}static clampedInt(te,pe,He,tt){if(typeof te=="undefined")return pe;let st=parseInt(te,10);return isNaN(st)?pe:(st=Math.max(He,st),st=Math.min(tt,st),st|0)}validate(te){return p.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class _ extends d{constructor(te,pe,He,tt,st){typeof st!="undefined"&&(st.type="number",st.default=He),super(te,pe,He,st),this.validationFn=tt}static clamp(te,pe,He){return te<pe?pe:te>He?He:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const He=parseFloat(te);return isNaN(He)?pe:He}validate(te){return this.validationFn(_.float(te,this.defaultValue))}}class T extends d{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,He,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=He),super(te,pe,He,tt)}validate(te){return T.string(te,this.defaultValue)}}function E(Q,te,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?te:Q}e.stringSet=E;class a extends d{constructor(te,pe,He,tt,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=tt,st.default=He),super(te,pe,He,st),this._allowedValues=tt}validate(te){return E(te,this.defaultValue,this._allowedValues)}}class l extends n{constructor(te,pe,He,tt,st,lt,wt=void 0){typeof wt!="undefined"&&(wt.type="string",wt.enum=st,wt.default=tt),super(te,pe,He,wt),this._allowedValues=st,this._convert=lt}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function v(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,He){return He===0?te.accessibilitySupport:He}}class r extends n{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:g.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:m(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(Q){switch(Q){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function h(Q){switch(Q){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class b extends I{constructor(){super(127,[65,32])}compute(te,pe,He){const tt=["monaco-editor"];return pe.get(32)&&tt.push(pe.get(32)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),pe.get(65)==="default"?tt.push("mouse-default"):pe.get(65)==="copy"&&tt.push("mouse-copy"),pe.get(100)&&tt.push("showUnused"),pe.get(125)&&tt.push("showDeprecated"),tt.join(" ")}}class S extends u{constructor(){super(31,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(te,pe,He){return He&&te.emptySelectionClipboard}}class o extends n{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:g.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:m(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":E(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":E(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(pe.loop,this.defaultValue.loop)}}}class w extends n{constructor(){super(43,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?w.OFF:te==="true"?w.ON:te:Boolean(te)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class R extends I{constructor(){super(42)}compute(te,pe,He){return te.fontInfo}}class O extends d{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(te){let pe=_.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(pe,6,100)}compute(te,pe,He){return te.fontInfo.fontSize}}class $ extends n{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(p.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class K extends n{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:He,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:He,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:He,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:He,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:He,description:g.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:E(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??E(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??E(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??E(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??E(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??E(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends n{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:g.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:m(pe.enabled,this.defaultValue.enabled),delay:p.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:m(pe.sticky,this.defaultValue.sticky)}}}var N;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class x extends I{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,He){return x.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,He=te.scrollBeyondLastLine?pe-1:0,tt=(te.viewLineCount+He)/(te.pixelRatio*te.height),st=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:He,desiredRatio:tt,minimapLineCount:st}}static _computeMinimapLayout(te,pe){const He=te.outerWidth,tt=te.outerHeight,st=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const lt=pe.stableMinimapLayoutInput,wt=lt&&te.outerHeight===lt.outerHeight&&te.lineHeight===lt.lineHeight&&te.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&te.pixelRatio===lt.pixelRatio&&te.scrollBeyondLastLine===lt.scrollBeyondLastLine&&te.minimap.enabled===lt.minimap.enabled&&te.minimap.side===lt.minimap.side&&te.minimap.size===lt.minimap.size&&te.minimap.showSlider===lt.minimap.showSlider&&te.minimap.renderCharacters===lt.minimap.renderCharacters&&te.minimap.maxColumn===lt.minimap.maxColumn&&te.minimap.scale===lt.minimap.scale&&te.verticalScrollbarWidth===lt.verticalScrollbarWidth&&te.isViewportWrapping===lt.isViewportWrapping,Ct=te.lineHeight,ce=te.typicalHalfwidthCharacterWidth,Pe=te.scrollBeyondLastLine,Ne=te.minimap.renderCharacters;let Ge=st>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const $e=te.minimap.maxColumn,at=te.minimap.size,Re=te.minimap.side,Se=te.verticalScrollbarWidth,Ce=te.viewLineCount,ne=te.remainingWidth,de=te.isViewportWrapping,be=Ne?2:3;let we=Math.floor(st*tt);const Me=we/st;let Ve=!1,We=!1,Je=be*Ge,nt=Ge/st,oe=1;if(at==="fill"||at==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:ot,desiredRatio:_t,minimapLineCount:vt}=x.computeContainedMinimapLineCount({viewLineCount:Ce,scrollBeyondLastLine:Pe,height:tt,lineHeight:Ct,pixelRatio:st});if(Ce/vt>1)Ve=!0,We=!0,Ge=1,Je=1,nt=Ge/st;else{let mt=!1,ht=Ge+1;if(at==="fit"){const yt=Math.ceil((Ce+ot)*Je);de&&wt&&ne<=pe.stableFitRemainingWidth?(mt=!0,ht=pe.stableFitMaxMinimapScale):mt=yt>we}if(at==="fill"||mt){Ve=!0;const yt=Ge;Je=Math.min(Ct*st,Math.max(1,Math.floor(1/_t))),de&&wt&&ne<=pe.stableFitRemainingWidth&&(ht=pe.stableFitMaxMinimapScale),Ge=Math.min(ht,Math.max(1,Math.floor(Je/be))),Ge>yt&&(oe=Math.min(2,Ge/yt)),nt=Ge/st/oe,we=Math.ceil(Math.max(Xe,Ce+ot)*Je),de?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ne,pe.stableFitMaxMinimapScale=Ge):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ee=Math.floor($e*nt),ue=Math.min(Ee,Math.max(0,Math.floor((ne-Se-2)*nt/(ce+nt)))+e.MINIMAP_GUTTER_WIDTH);let j=Math.floor(st*ue);const Ae=j/st;j=Math.floor(j*oe);const Ie=Ne?1:2,Ye=Re==="left"?0:He-ue-Se;return{renderMinimap:Ie,minimapLeft:Ye,minimapWidth:ue,minimapHeightIsEditorHeight:Ve,minimapIsSampling:We,minimapScale:Ge,minimapLineHeight:Je,minimapCanvasInnerWidth:j,minimapCanvasInnerHeight:we,minimapCanvasOuterWidth:Ae,minimapCanvasOuterHeight:Me}}static computeLayout(te,pe){const He=pe.outerWidth|0,tt=pe.outerHeight|0,st=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,wt=pe.typicalHalfwidthCharacterWidth,Ct=pe.maxDigitWidth,ce=pe.pixelRatio,Pe=pe.viewLineCount,Ne=te.get(122),Ge=Ne==="inherit"?te.get(121):Ne,$e=Ge==="inherit"?te.get(117):Ge,at=te.get(120),Re=te.get(2),Se=pe.isDominatedByLongLines,Ce=te.get(48),ne=te.get(59).renderType!==0,de=te.get(60),be=te.get(94),we=te.get(64),Me=te.get(92),Ve=Me.verticalScrollbarSize,We=Me.verticalHasArrows,Je=Me.arrowSize,nt=Me.horizontalScrollbarSize,oe=te.get(57),Ee=te.get(36);let ue;if(typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)){const Lt=parseFloat(oe.substr(0,oe.length-2));ue=p.clampedInt(Lt*wt,0,0,1e3)}else ue=p.clampedInt(oe,0,0,1e3);Ee&&(ue+=16);let j=0;if(ne){const Lt=Math.max(lt,de);j=Math.round(Lt*Ct)}let Ae=0;Ce&&(Ae=st);let Ie=0,Ye=Ie+Ae,Xe=Ye+j,ot=Xe+ue;const _t=He-Ae-j-ue;let vt=!1,gt=!1,mt=-1;Re!==2&&(Ge==="inherit"&&Se?(vt=!0,gt=!0):$e==="on"||$e==="bounded"?gt=!0:$e==="wordWrapColumn"&&(mt=at));const ht=x._computeMinimapLayout({outerWidth:He,outerHeight:tt,lineHeight:st,typicalHalfwidthCharacterWidth:wt,pixelRatio:ce,scrollBeyondLastLine:be,minimap:we,verticalScrollbarWidth:Ve,viewLineCount:Pe,remainingWidth:_t,isViewportWrapping:gt},pe.memory||new P);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Ie+=ht.minimapWidth,Ye+=ht.minimapWidth,Xe+=ht.minimapWidth,ot+=ht.minimapWidth);const yt=_t-ht.minimapWidth,At=Math.max(1,Math.floor((yt-Ve-2)/wt)),jt=We?Je:0;return gt&&(mt=Math.max(1,At),$e==="bounded"&&(mt=Math.min(mt,at))),{width:He,height:tt,glyphMarginLeft:Ie,glyphMarginWidth:Ae,lineNumbersLeft:Ye,lineNumbersWidth:j,decorationsLeft:Xe,decorationsWidth:ue,contentLeft:ot,contentWidth:yt,minimap:ht,viewportColumn:At,isWordWrapMinified:vt,isViewportWrapping:gt,wrappingColumn:mt,verticalScrollbarWidth:Ve,horizontalScrollbarHeight:nt,overviewRuler:{top:jt,width:Ve,height:tt-2*jt,right:0}}}}e.EditorLayoutInfoComputer=x;class F extends n{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:g.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:m(te.enabled,this.defaultValue.enabled)}}}class V extends n{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:g.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:m(pe.enabled,this.defaultValue.enabled),fontSize:p.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class M extends _{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>_.clamp(te,0,150),{markdownDescription:g.localize(46,null)})}compute(te,pe,He){return te.fontInfo.lineHeight}}class U extends n{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:te.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:g.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:m(pe.enabled,this.defaultValue.enabled),size:E(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(pe.side,this.defaultValue.side,["right","left"]),showSlider:E(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(pe.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(pe.scale,1,1,3),maxColumn:p.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function q(Q){return Q==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends n{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:p.clampedInt(pe.top,0,0,1e3),bottom:p.clampedInt(pe.bottom,0,0,1e3)}}}class X extends n{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:g.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:m(pe.enabled,this.defaultValue.enabled),cycle:m(pe.cycle,this.defaultValue.cycle)}}}class Z extends I{constructor(){super(128)}compute(te,pe,He){return te.pixelRatio}}class fe extends n{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:g.localize(61,null)},comments:{type:"boolean",default:te.comments,description:g.localize(62,null)},other:{type:"boolean",default:te.other,description:g.localize(63,null)}}}],default:te,description:g.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,He={other:m(pe.other,this.defaultValue.other),comments:m(pe.comments,this.defaultValue.comments),strings:m(pe.strings,this.defaultValue.strings)};return He.other&&He.comments&&He.strings?!0:!He.other&&!He.comments&&!He.strings?!1:He}return this.defaultValue}}var _e;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class De extends n{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,He=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:He}}}function Le(Q){const te=Q.get(87);return te==="editable"?Q.get(80):te!=="on"}e.filterValidationDecorations=Le;class qe extends n{constructor(){const te=[],pe={type:"number",description:g.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:te,description:g.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let He of te)if(typeof He=="number")pe.push({column:p.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const tt=He;pe.push({column:p.clampedInt(tt.column,0,0,1e4),color:tt.color})}return pe.sort((He,tt)=>He.column-tt.column),pe}return this.defaultValue}}function xe(Q,te){if(typeof Q!="string")return te;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends n{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:g.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,He=p.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=p.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:xe(pe.vertical,this.defaultValue.vertical),horizontal:xe(pe.horizontal,this.defaultValue.horizontal),useShadows:m(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:p.clampedInt(pe.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:p.clampedInt(pe.verticalSliderSize,tt,0,1e3),scrollByPage:m(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class H extends n{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:te.mode,description:g.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:m(pe.enabled,this.defaultValue.enabled),mode:E(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends n{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:g.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:m(te.enabled,this.defaultValue.enabled)}}}class re extends n{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(90,null),g.localize(91,null)],default:te.insertMode,description:g.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:g.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:g.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:g.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:g.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:g.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:g.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:g.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(100,null),g.localize(101,null),g.localize(102,null)],default:te.previewMode,description:g.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:g.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:E(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:m(pe.showIcons,this.defaultValue.showIcons),showStatusBar:m(pe.showStatusBar,this.defaultValue.showStatusBar),preview:m(pe.preview,this.defaultValue.preview),previewMode:E(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(pe.showMethods,this.defaultValue.showMethods),showFunctions:m(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:m(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:m(pe.showFields,this.defaultValue.showFields),showVariables:m(pe.showVariables,this.defaultValue.showVariables),showClasses:m(pe.showClasses,this.defaultValue.showClasses),showStructs:m(pe.showStructs,this.defaultValue.showStructs),showInterfaces:m(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:m(pe.showModules,this.defaultValue.showModules),showProperties:m(pe.showProperties,this.defaultValue.showProperties),showEvents:m(pe.showEvents,this.defaultValue.showEvents),showOperators:m(pe.showOperators,this.defaultValue.showOperators),showUnits:m(pe.showUnits,this.defaultValue.showUnits),showValues:m(pe.showValues,this.defaultValue.showValues),showConstants:m(pe.showConstants,this.defaultValue.showConstants),showEnums:m(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:m(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(pe.showKeywords,this.defaultValue.showKeywords),showWords:m(pe.showWords,this.defaultValue.showWords),showColors:m(pe.showColors,this.defaultValue.showColors),showFiles:m(pe.showFiles,this.defaultValue.showFiles),showReferences:m(pe.showReferences,this.defaultValue.showReferences),showFolders:m(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:m(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(pe.showSnippets,this.defaultValue.showSnippets),showUsers:m(pe.showUsers,this.defaultValue.showUsers),showIssues:m(pe.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends I{constructor(){super(129,[80])}compute(te,pe,He){return pe.get(80)?!0:te.tabFocusMode}}var ae;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function ve(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Fe extends I{constructor(){super(131,[130])}compute(te,pe,He){const tt=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Qe:L.isLinux?et:je,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:D.default.quality!=="stable"}},e.editorOptionsRegistry=[];function ke(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var ct;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.codeLens=13]="codeLens",Q[Q.codeLensFontFamily=14]="codeLensFontFamily",Q[Q.codeLensFontSize=15]="codeLensFontSize",Q[Q.colorDecorators=16]="colorDecorators",Q[Q.columnSelection=17]="columnSelection",Q[Q.comments=18]="comments",Q[Q.contextmenu=19]="contextmenu",Q[Q.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=21]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=23]="cursorStyle",Q[Q.cursorSurroundingLines=24]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=26]="cursorWidth",Q[Q.disableLayerHinting=27]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",Q[Q.domReadOnly=29]="domReadOnly",Q[Q.dragAndDrop=30]="dragAndDrop",Q[Q.emptySelectionClipboard=31]="emptySelectionClipboard",Q[Q.extraEditorClassName=32]="extraEditorClassName",Q[Q.fastScrollSensitivity=33]="fastScrollSensitivity",Q[Q.find=34]="find",Q[Q.fixedOverflowWidgets=35]="fixedOverflowWidgets",Q[Q.folding=36]="folding",Q[Q.foldingStrategy=37]="foldingStrategy",Q[Q.foldingHighlight=38]="foldingHighlight",Q[Q.foldingImportsByDefault=39]="foldingImportsByDefault",Q[Q.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=41]="fontFamily",Q[Q.fontInfo=42]="fontInfo",Q[Q.fontLigatures=43]="fontLigatures",Q[Q.fontSize=44]="fontSize",Q[Q.fontWeight=45]="fontWeight",Q[Q.formatOnPaste=46]="formatOnPaste",Q[Q.formatOnType=47]="formatOnType",Q[Q.glyphMargin=48]="glyphMargin",Q[Q.gotoLocation=49]="gotoLocation",Q[Q.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",Q[Q.hover=52]="hover",Q[Q.inDiffEditor=53]="inDiffEditor",Q[Q.inlineSuggest=54]="inlineSuggest",Q[Q.letterSpacing=55]="letterSpacing",Q[Q.lightbulb=56]="lightbulb",Q[Q.lineDecorationsWidth=57]="lineDecorationsWidth",Q[Q.lineHeight=58]="lineHeight",Q[Q.lineNumbers=59]="lineNumbers",Q[Q.lineNumbersMinChars=60]="lineNumbersMinChars",Q[Q.linkedEditing=61]="linkedEditing",Q[Q.links=62]="links",Q[Q.matchBrackets=63]="matchBrackets",Q[Q.minimap=64]="minimap",Q[Q.mouseStyle=65]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=67]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=69]="multiCursorModifier",Q[Q.multiCursorPaste=70]="multiCursorPaste",Q[Q.occurrencesHighlight=71]="occurrencesHighlight",Q[Q.overviewRulerBorder=72]="overviewRulerBorder",Q[Q.overviewRulerLanes=73]="overviewRulerLanes",Q[Q.padding=74]="padding",Q[Q.parameterHints=75]="parameterHints",Q[Q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=78]="quickSuggestions",Q[Q.quickSuggestionsDelay=79]="quickSuggestionsDelay",Q[Q.readOnly=80]="readOnly",Q[Q.renameOnType=81]="renameOnType",Q[Q.renderControlCharacters=82]="renderControlCharacters",Q[Q.renderIndentGuides=83]="renderIndentGuides",Q[Q.renderFinalNewline=84]="renderFinalNewline",Q[Q.renderLineHighlight=85]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=87]="renderValidationDecorations",Q[Q.renderWhitespace=88]="renderWhitespace",Q[Q.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",Q[Q.roundedSelection=90]="roundedSelection",Q[Q.rulers=91]="rulers",Q[Q.scrollbar=92]="scrollbar",Q[Q.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=94]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=95]="scrollPredominantAxis",Q[Q.selectionClipboard=96]="selectionClipboard",Q[Q.selectionHighlight=97]="selectionHighlight",Q[Q.selectOnLineNumbers=98]="selectOnLineNumbers",Q[Q.showFoldingControls=99]="showFoldingControls",Q[Q.showUnused=100]="showUnused",Q[Q.snippetSuggestions=101]="snippetSuggestions",Q[Q.smartSelect=102]="smartSelect",Q[Q.smoothScrolling=103]="smoothScrolling",Q[Q.stickyTabStops=104]="stickyTabStops",Q[Q.stopRenderingLineAfter=105]="stopRenderingLineAfter",Q[Q.suggest=106]="suggest",Q[Q.suggestFontSize=107]="suggestFontSize",Q[Q.suggestLineHeight=108]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",Q[Q.suggestSelection=110]="suggestSelection",Q[Q.tabCompletion=111]="tabCompletion",Q[Q.tabIndex=112]="tabIndex",Q[Q.unusualLineTerminators=113]="unusualLineTerminators",Q[Q.useShadowDOM=114]="useShadowDOM",Q[Q.useTabStops=115]="useTabStops",Q[Q.wordSeparators=116]="wordSeparators",Q[Q.wordWrap=117]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=120]="wordWrapColumn",Q[Q.wordWrapOverride1=121]="wordWrapOverride1",Q[Q.wordWrapOverride2=122]="wordWrapOverride2",Q[Q.wrappingIndent=123]="wrappingIndent",Q[Q.wrappingStrategy=124]="wrappingStrategy",Q[Q.showDeprecated=125]="showDeprecated",Q[Q.inlayHints=126]="inlayHints",Q[Q.editorClassName=127]="editorClassName",Q[Q.pixelRatio=128]="pixelRatio",Q[Q.tabFocusMode=129]="tabFocusMode",Q[Q.layoutInfo=130]="layoutInfo",Q[Q.wrappingInfo=131]="wrappingInfo"})(ct=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(137,null)})),acceptSuggestionOnEnter:ke(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(138,null),""],markdownDescription:g.localize(139,null)})),accessibilitySupport:ke(new t),accessibilityPageSize:ke(new p(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(140,null)})),ariaLabel:ke(new T(4,"ariaLabel",g.localize(141,null))),autoClosingBrackets:ke(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(142,null),g.localize(143,null),""],description:g.localize(144,null)})),autoClosingDelete:ke(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(145,null),""],description:g.localize(146,null)})),autoClosingOvertype:ke(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(147,null),""],description:g.localize(148,null)})),autoClosingQuotes:ke(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(149,null),g.localize(150,null),""],description:g.localize(151,null)})),autoIndent:ke(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null),g.localize(156,null)],description:g.localize(157,null)})),automaticLayout:ke(new u(10,"automaticLayout",!1)),autoSurround:ke(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(158,null),g.localize(159,null),g.localize(160,null),""],description:g.localize(161,null)})),bracketPairColorization:ke(new ee),stickyTabStops:ke(new u(104,"stickyTabStops",!1,{description:g.localize(162,null)})),codeLens:ke(new u(13,"codeLens",!0,{description:g.localize(163,null)})),codeLensFontFamily:ke(new T(14,"codeLensFontFamily","",{description:g.localize(164,null)})),codeLensFontSize:ke(new p(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(165,null)})),colorDecorators:ke(new u(16,"colorDecorators",!0,{description:g.localize(166,null)})),columnSelection:ke(new u(17,"columnSelection",!1,{description:g.localize(167,null)})),comments:ke(new r),contextmenu:ke(new u(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new u(20,"copyWithSyntaxHighlighting",!0,{description:g.localize(168,null)})),cursorBlinking:ke(new l(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:g.localize(169,null)})),cursorSmoothCaretAnimation:ke(new u(22,"cursorSmoothCaretAnimation",!1,{description:g.localize(170,null)})),cursorStyle:ke(new l(23,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:g.localize(171,null)})),cursorSurroundingLines:ke(new p(24,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(172,null)})),cursorSurroundingLinesStyle:ke(new a(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(173,null),g.localize(174,null)],description:g.localize(175,null)})),cursorWidth:ke(new p(26,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(176,null)})),disableLayerHinting:ke(new u(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new u(28,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new u(29,"domReadOnly",!1)),dragAndDrop:ke(new u(30,"dragAndDrop",!0,{description:g.localize(177,null)})),emptySelectionClipboard:ke(new S),extraEditorClassName:ke(new T(32,"extraEditorClassName","")),fastScrollSensitivity:ke(new _(33,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:g.localize(178,null)})),find:ke(new o),fixedOverflowWidgets:ke(new u(35,"fixedOverflowWidgets",!1)),folding:ke(new u(36,"folding",!0,{description:g.localize(179,null)})),foldingStrategy:ke(new a(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(180,null),g.localize(181,null)],description:g.localize(182,null)})),foldingHighlight:ke(new u(38,"foldingHighlight",!0,{description:g.localize(183,null)})),foldingImportsByDefault:ke(new u(39,"foldingImportsByDefault",!1,{description:g.localize(184,null)})),unfoldOnClickAfterEndOfLine:ke(new u(40,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(185,null)})),fontFamily:ke(new T(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(186,null)})),fontInfo:ke(new R),fontLigatures2:ke(new w),fontSize:ke(new O),fontWeight:ke(new $),formatOnPaste:ke(new u(46,"formatOnPaste",!1,{description:g.localize(187,null)})),formatOnType:ke(new u(47,"formatOnType",!1,{description:g.localize(188,null)})),glyphMargin:ke(new u(48,"glyphMargin",!0,{description:g.localize(189,null)})),gotoLocation:ke(new K),hideCursorInOverviewRuler:ke(new u(50,"hideCursorInOverviewRuler",!1,{description:g.localize(190,null)})),highlightActiveIndentGuide:ke(new u(51,"highlightActiveIndentGuide",!0,{description:g.localize(191,null)})),hover:ke(new G),inDiffEditor:ke(new u(53,"inDiffEditor",!1)),letterSpacing:ke(new _(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>_.clamp(Q,-5,20),{description:g.localize(192,null)})),lightbulb:ke(new F),lineDecorationsWidth:ke(new d(57,"lineDecorationsWidth",10)),lineHeight:ke(new M),lineNumbers:ke(new De),lineNumbersMinChars:ke(new p(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new u(61,"linkedEditing",!1,{description:g.localize(193,null)})),links:ke(new u(62,"links",!0,{description:g.localize(194,null)})),matchBrackets:ke(new a(63,"matchBrackets","always",["always","near","never"],{description:g.localize(195,null)})),minimap:ke(new U),mouseStyle:ke(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new _(66,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:g.localize(196,null)})),mouseWheelZoom:ke(new u(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(197,null)})),multiCursorMergeOverlapping:ke(new u(68,"multiCursorMergeOverlapping",!0,{description:g.localize(198,null)})),multiCursorModifier:ke(new l(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],q,{markdownEnumDescriptions:[g.localize(199,null),g.localize(200,null)],markdownDescription:g.localize(201,null)})),multiCursorPaste:ke(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),occurrencesHighlight:ke(new u(71,"occurrencesHighlight",!0,{description:g.localize(205,null)})),overviewRulerBorder:ke(new u(72,"overviewRulerBorder",!0,{description:g.localize(206,null)})),overviewRulerLanes:ke(new p(73,"overviewRulerLanes",3,0,3)),padding:ke(new W),parameterHints:ke(new X),peekWidgetDefaultFocus:ke(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(207,null),g.localize(208,null)],description:g.localize(209,null)})),definitionLinkOpensInPeek:ke(new u(77,"definitionLinkOpensInPeek",!1,{description:g.localize(210,null)})),quickSuggestions:ke(new fe),quickSuggestionsDelay:ke(new p(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(211,null)})),readOnly:ke(new u(80,"readOnly",!1)),renameOnType:ke(new u(81,"renameOnType",!1,{description:g.localize(212,null),markdownDeprecationMessage:g.localize(213,null)})),renderControlCharacters:ke(new u(82,"renderControlCharacters",!1,{description:g.localize(214,null)})),renderIndentGuides:ke(new u(83,"renderIndentGuides",!0,{description:g.localize(215,null)})),renderFinalNewline:ke(new u(84,"renderFinalNewline",!0,{description:g.localize(216,null)})),renderLineHighlight:ke(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(217,null)],description:g.localize(218,null)})),renderLineHighlightOnlyWhenFocus:ke(new u(86,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(219,null)})),renderValidationDecorations:ke(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(220,null),g.localize(221,null),g.localize(222,null),""],description:g.localize(223,null)})),revealHorizontalRightPadding:ke(new p(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new u(90,"roundedSelection",!0,{description:g.localize(224,null)})),rulers:ke(new qe),scrollbar:ke(new Ke),scrollBeyondLastColumn:ke(new p(93,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(225,null)})),scrollBeyondLastLine:ke(new u(94,"scrollBeyondLastLine",!0,{description:g.localize(226,null)})),scrollPredominantAxis:ke(new u(95,"scrollPredominantAxis",!0,{description:g.localize(227,null)})),selectionClipboard:ke(new u(96,"selectionClipboard",!0,{description:g.localize(228,null),included:L.isLinux})),selectionHighlight:ke(new u(97,"selectionHighlight",!0,{description:g.localize(229,null)})),selectOnLineNumbers:ke(new u(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(230,null),g.localize(231,null)],description:g.localize(232,null)})),showUnused:ke(new u(100,"showUnused",!0,{description:g.localize(233,null)})),showDeprecated:ke(new u(125,"showDeprecated",!0,{description:g.localize(234,null)})),inlayHints:ke(new V),snippetSuggestions:ke(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(235,null),g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),smartSelect:ke(new le),smoothScrolling:ke(new u(103,"smoothScrolling",!1,{description:g.localize(240,null)})),stopRenderingLineAfter:ke(new p(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new re),inlineSuggest:ke(new H),suggestFontSize:ke(new p(107,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestLineHeight:ke(new p(108,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(242,null)})),suggestOnTriggerCharacters:ke(new u(109,"suggestOnTriggerCharacters",!0,{description:g.localize(243,null)})),suggestSelection:ke(new a(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabCompletion:ke(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),tabIndex:ke(new p(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(252,null),g.localize(253,null),g.localize(254,null)],description:g.localize(255,null)})),useShadowDOM:ke(new u(114,"useShadowDOM",!0)),useTabStops:ke(new u(115,"useTabStops",!0,{description:g.localize(256,null)})),wordSeparators:ke(new T(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(257,null)})),wordWrap:ke(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(258,null),g.localize(259,null),g.localize(260,null),g.localize(261,null)],description:g.localize(262,null)})),wordWrapBreakAfterCharacters:ke(new T(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new T(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new p(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(263,null)})),wordWrapOverride1:ke(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new l(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[g.localize(264,null),g.localize(265,null),g.localize(266,null),g.localize(267,null)],description:g.localize(268,null)})),wrappingStrategy:ke(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(269,null),g.localize(270,null)],description:g.localize(271,null)})),editorClassName:ke(new b),pixelRatio:ke(new Z),tabFocusMode:ke(new J),layoutInfo:ke(new x),wrappingInfo:ke(new Fe)}});var Ue=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(me[119],ge([0,1,17,21,6,4]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,D.createDecorator)("progressService");var A;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(I,d){super();this.deferred=new g.DeferredPromise,d.withProgress(I,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=ze([Ue(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const d=++this.currentOperationId,m=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:m.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,D.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,54,14]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,C){g.ok(L.isString(A)),g.ok(L.isObject(C)),g.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,C)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(me[120],ge([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class D{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[k(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new D;L.Registry.add(e.Extensions.JSONContribution,A)}),define(me[85],ge([0,1,3,14,156,120,34]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(T){T.Multiline="multilineText",T.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(T){T[T.APPLICATION=1]="APPLICATION",T[T.MACHINE=2]="MACHINE",T[T.WINDOW=3]="WINDOW",T[T.RESOURCE=4]="RESOURCE",T[T.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",T[T.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=A.Registry.as(D.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,a=!0){this.registerConfigurations([E],a)}registerConfigurations(E,a=!0){const l=[];E.forEach(v=>{l.push(...this.validateAndRegisterProperties(v,a,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(E){const a=[],l=v=>{if(v.properties)for(const t in v.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>l(t))};for(const v of E){l(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(E){const a=[],l=[];for(const v of E)for(const t in v)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};l.push(d(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(E){const a=[];for(const l of E)for(const v in l)if(a.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const a of E)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,a=!0,l,v=3){v=L.isUndefinedOrNull(E.scope)?v:E.scope;let t=[],r=E.properties;if(r)for(let i in r){if(a&&p(i)){delete r[i];continue}const c=r[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=L.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=L.isUndefinedOrNull(c.restricted)?!!l?.restrictedConfigurations?.includes(i):c.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=E.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,a,l,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const a=l=>{let v=l.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=l.allOf;t&&t.forEach(a)};a(E)}updateSchema(E,a){switch(e.allSettings.properties[E]=a,a.scope){case 1:e.applicationSettings.properties[E]=a;break;case 2:e.machineSettings.properties[E]=a;break;case 6:e.machineOverridableSettings.properties[E]=a;break;case 3:e.windowSettings.properties[E]=a;break;case 4:e.resourceSettings.properties[E]=a;break;case 5:e.resourceSettings.properties[E]=a,this.resourceLanguageSettingsSchema.properties[E]=a;break}}removeFromSchema(E,a){switch(delete e.allSettings.properties[E],a.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const a=`[${E}]`,l={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,l),e.allSettings.properties[a]=l,e.applicationSettings.properties[a]=l,e.machineSettings.properties[a]=l,e.machineOverridableSettings.properties[a]=l,e.windowSettings.properties[a]=l,e.resourceSettings.properties[a]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,a){let l=this.defaultValues[E];L.isUndefined(l)&&(l=a.default),L.isUndefined(l)&&(l=m(a.type)),a.default=l}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function d(T){return T.substring(1,T.length-1)}e.overrideIdentifierFromKey=d;function m(T){switch(Array.isArray(T)?T[0]:T){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const u=new n;A.Registry.add(e.Extensions.Configuration,u);function p(T){return T.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(T)?k.localize(5,null,T):u.getConfigurationProperties()[T]!==void 0?k.localize(6,null,T):null:k.localize(4,null)}e.validateProperty=p;function _(){const T=[],E=u.getConfigurationProperties();for(const a of Object.keys(E))T.push([a,E[a].scope]);return T.push(["launch",4]),T.push(["task",4]),T}e.getScopes=_}),define(me[121],ge([0,1,23,14,2,85,4,34]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=y;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(r,s){const i=s?r?s.keys.filter(w=>r.keys.indexOf(w)===-1):[...s.keys]:[],c=r?s?r.keys.filter(w=>s.keys.indexOf(w)===-1):[...r.keys]:[],f=[];if(s&&r){for(const w of r.keys)if(s.keys.indexOf(w)!==-1){const R=T(r.contents,w),O=T(s.contents,w);g.equals(R,O)||f.push(w)}}const h=[],b=w=>{const R={};for(const O of w)for(const $ of O.identifiers)R[v($)]=O;return R},S=s?b(s.overrides):{},o=r?b(r.overrides):{};if(Object.keys(S).length)for(const w of i){const R=S[w];R&&h.push([(0,D.overrideIdentifierFromKey)(w),R.keys])}if(Object.keys(o).length)for(const w of c){const R=o[w];R&&h.push([(0,D.overrideIdentifierFromKey)(w),R.keys])}if(Object.keys(S).length&&Object.keys(o).length)for(const w of f){const R=o[w],O=S[w];if(R&&O){const $=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:O.contents,keys:O.keys,overrides:[]});h.push([(0,D.overrideIdentifierFromKey)(w),[...$.added,...$.removed,...$.updated]])}}return{added:i,removed:c,updated:f,overrides:h}}e.compare=I;function d(r,s){const i=[];for(const c of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(c)){const f={};for(const h in r[c])f[h]=r[c][h];i.push({identifiers:[(0,D.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(f),contents:m(f,s)})}return i}e.toOverrides=d;function m(r,s){const i=Object.create(null);for(let c in r)u(i,c,r[c],s);return i}e.toValuesTree=m;function u(r,s,i,c){const f=s.split("."),h=f.pop();let b=r;for(let S=0;S<f.length;S++){let o=f[S],w=b[o];switch(typeof w){case"undefined":w=b[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${s} as ${f.slice(0,S+1).join(".")} is ${JSON.stringify(w)}`);return}b=w}if(typeof b=="object"&&b!==null)try{b[h]=i}catch(S){c(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(b)}`)}else c(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=u;function p(r,s){const i=s.split(".");_(r,i)}e.removeFromValueTree=p;function _(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const c=r[i];typeof c=="object"&&!Array.isArray(c)&&(_(c,s),Object.keys(c).length===0&&delete r[i])}}function T(r,s,i){function c(b,S){let o=b;for(const w of S){if(typeof o!="object"||o===null)return;o=o[w]}return o}const f=s.split("."),h=c(r,f);return typeof h=="undefined"?i:h}e.getConfigurationValue=T;function E(r,s,i){Object.keys(s).forEach(c=>{c!=="__proto__"&&(c in r?L.isObject(r[c])&&L.isObject(s[c])?E(r[c],s[c],i):i&&(r[c]=s[c]):r[c]=s[c])})}e.merge=E;function a(){const r=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function l(){const r=Object.create(null),s=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let i in s){let c=s[i].default;u(r,i,c,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=l;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,s,i){const c=r.inspect(s),f=r.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:c.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,20,3,57,6,24,23,14,2,121,85,34]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,n.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of g.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[i],f=r[i];f&&(typeof c=="object"&&typeof f=="object"?(c=C.deepClone(c),this.mergeContents(c,f)):c=f),s[i]=c}return new m(s,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const f of c.overrides){const[h]=s.filter(b=>g.equals(b.identifiers,f.identifiers));h?this.mergeContents(h.contents,f.contents):s.push(C.deepClone(f))}for(const f of c.keys)i.indexOf(f)===-1&&i.push(f)}return new m(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&y.isObject(t[s])&&y.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=C.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class u extends m{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,I.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,s)}}e.DefaultConfigurationModel=u;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:c,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new m(s,i,c),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},s=null,i=[],c=[],f=[];function h(S){Array.isArray(i)?i.push(S):s!==null&&(i[s]=S)}let b={onObjectBegin:()=>{let S={};h(S),c.push(i),i=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let S=[];h(S),c.push(i),i=S,s=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:h,onError:(S,o,w)=>{f.push({error:S,offset:o,length:w})}};if(t)try{k.visit(t,b),r=i[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const s=d.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const c=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),f=Object.keys(t),h=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:c,keys:f,overrides:h,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},f=[];for(let h in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(h)&&s){const b=this.filter(t[h],r,!1,i);c[h]=b.raw,f.push(...b.restricted)}else{const b=r[h],S=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&f.push(h),(S===void 0||i.scopes===void 0||i.scopes.includes(S))&&(i.skipRestricted&&b?.restricted||(c[h]=t[h]))}return{raw:c,restricted:f}}}e.ConfigurationModelParser=p;class _ extends D.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class T{constructor(t,r,s=new m,i=new m,c=new A.ResourceMap,f=new m,h=new A.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=f,this._memoryConfigurationByResource=h,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new m,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),c=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),w=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,O=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),$=i.getValue(t),K=g.distinct(g.flatten(i.overrides.map(G=>G.identifiers))).filter(G=>i.getOverrideValue(t,G)!==void 0);return{defaultValue:h,userValue:b,userLocalValue:S,userRemoteValue:o,workspaceValue:w,workspaceFolderValue:R,memoryValue:O,value:$,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:w!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>I.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,I.overrideIdentifierFromKey)(i),f=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=t.getKeysForOverrideIdentifier(c),b=[...h.filter(S=>f.indexOf(S)===-1),...f.filter(S=>h.indexOf(S)===-1),...f.filter(S=>!C.equals(this._defaultConfiguration.override(c).getValue(S),t.override(c).getValue(S)))];return[c,b]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),f=[...r,...s,...i];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...r,...s,...i];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...r,...s,...i];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:c,removed:f,overrides:h}=(0,n.compare)(s,r);let b=[...i,...c,...f];return(b.length||!s)&&this.updateFolderConfiguration(t,r),{keys:b,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:c,overrides:f}=(0,n.compare)(r,void 0);return{keys:[...s,...i,...c],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const c=this._memoryConfigurationByResource.get(t);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((f,h)=>(f.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),f),new A.ResourceMap);return new T(r,s,new m,i,c,new m,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=T;function E(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,f])=>{const h=(0,A.getOrSet)(r,c,new Set);f.forEach(b=>h.add(b))});const s=[];return r.forEach((i,c)=>s.push([c,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class a{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(h=>c.add(h)),t.overrides.forEach(([,h])=>h.forEach(b=>c.add(b))),this.affectedKeys=[...c.values()];const f=new m;this.affectedKeys.forEach(h=>f.setValue(h,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=a;class l extends a{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(me[122],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,C=L.Unknown,y){super(A);this._message=A,this._code=C,this._detail=y,this.isHandled=C===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(me[86],ge([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(P){return P.scheme===g.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=L;function k(P){if(!P)return;const n=P.indexOf("+");return n<0?P:P.substr(0,n)}e.getRemoteName=k;function D(P){return P.scheme!==g.Schemas.file&&P.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=D;function A(P){if(P.folders.length)return P.folders.every(n=>D(n.uri))?P.folders[0].uri:void 0;if(P.configuration&&D(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function C(P){return A(P)?.scheme}e.getVirtualWorkspaceScheme=C;function y(P){return A(P)!==void 0}e.isVirtualWorkspace=y}),define(me[193],ge([0,1,3,11,4,12]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var A;(function(m){m.Http="http",m.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=n;function I(m,u){return u?u!==1&&m<1024:!L.isWindows&&m<1024}e.isPortPrivileged=I;let d=class{constructor(u){this.logService=u,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,p){return this._tunnelProvider=u,u?(this._canElevate=p.elevation,this._canMakePublic=p.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async u=>{const p=[],_=Array.from(this._tunnels.values());for(let T of _){const E=Array.from(T.values());for(let a of E){const l=await a.value;l&&p.push(l)}}u(p)})}async dispose(){for(const u of this._tunnels.values()){for(const{value:p}of u.values())await p.then(_=>_?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,p,_,T,E=!1,a=!1,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${_} on local port ${T}.`),!u)return;p||(p="localhost");const v=this.retainOrCreateTunnel(u,p,_,T,E,a,l);return v?v.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,public:u.public,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const p=this._tunnels.get(u.tunnelRemoteHost);if(p){const _=p.get(u.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,_))}}}}async tryDisposeTunnel(u,p,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${p}.`);const T=_.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(p),T}}async closeTunnel(u,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${p} `);const _=this._tunnels.get(u);if(_&&_.has(p)){const T=_.get(p);T.refcount=0,await this.tryDisposeTunnel(u,p,T)}}addTunnelToMap(u,p,_){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(p,{refcount:1,value:_})}async removeEmptyTunnelFromMap(u,p){const _=this._tunnels.get(u);_&&(await _.get(p)||_.delete(p),_.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,p){let _=[u];P(u)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):n(u)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const T=_.map(E=>this._tunnels.get(E));for(const E of T){const a=E?.get(p);if(a)return a}}canTunnel(u){return!!y(u)}createWithProvider(u,p,_,T,E,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${_} on local port ${T}.`);const t={elevationRequired:E?I(T===void 0?_:T):!1},r={remoteAddress:{host:p,port:_},localAddressPort:T,public:a,protocol:l},s=u.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(p,_,s),s}};d=ze([Ue(0,D.ILogService)],d),e.AbstractTunnelService=d}),define(me[194],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,D)=>Y(["vsda"],k,D))}async sign(k){try{const D=await this.vsda(),A=new D.signer;if(A)return A.sign(k)}catch(D){}return k}}e.SignService=g}),define(me[195],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,D,A=5){let C;return C=D(y=>{const P=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(k);if(n){n.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(k),A);n={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),C.dispose()}},this._terminalBufferMap.set(k,n)}),C}stopBuffering(k){const D=this._terminalBufferMap.get(k);D&&D.dispose()}flushBuffer(k){const D=this._terminalBufferMap.get(k);D&&(this._terminalBufferMap.delete(k),this._callback(k,D.data.join("")))}}e.TerminalDataBufferer=g}),define(me[196],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(me[62],ge([0,1,47,3,6,4,34,196]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var y;(function(_){function T(E){return E&&typeof E=="object"&&typeof E.id=="string"}_.isThemeColor=T})(y=e.ThemeColor||(e.ThemeColor={}));function P(_){return{id:_}}e.themeColorFromId=P;var n;(function(_){function T(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}_.isThemeIcon=T;const E=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const s=E.exec(r);if(!s)return;let[,i]=s;return{id:i}}_.fromString=a;function l(r,s){let i=r.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),s&&(i=`${i}~${s}`),{id:i}}_.modify=l;function v(r,s){return r.id===s.id&&r.color?.id===s.color?.id}_.isEqual=v;function t(r,s){return{id:r.id,color:s?P(s):void 0}}_.asThemeIcon=t,_.asClassNameArray=g.CSSIcon.asClassNameArray,_.asClassName=g.CSSIcon.asClassName,_.asCSSSelector=g.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(_){switch(_){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(T);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new d;A.Registry.add(e.Extensions.ThemingContribution,m);function u(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=u;class p extends k.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,E){let a=this.theme.getColor(T);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}e.Themable=p}),define(me[197],ge([0,1,17,47,3,162,120,34,62]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,E,a,l){const v=this.iconsById[T];if(v){if(a&&!v.description){v.description=a,this.iconSchema.properties[T].markdownDescription=`${a} $(${T})`;const s=this.iconReferenceSchema.enum.indexOf(T);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=a),this._onDidChange.fire()}return v}let t={id:T,description:a,defaults:E,deprecationMessage:l};this.iconsById[T]=t;let r={$ref:"#/definitions/icons"};return l&&(r.deprecationMessage=l),a&&(r.markdownDescription=`${a}: $(${T})`),this.iconSchema.properties[T]=r,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const E=this.iconReferenceSchema.enum.indexOf(T);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,E){const a=this.iconFontsById[T];if(a)return a;let l={id:T,definition:E};return this.iconFontsById[T]=l,this._onDidChange.fire(),l}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(v,t)=>v.id.localeCompare(t.id),E=v=>{for(;y.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of l.filter(t=>!!t.description).sort(T))a.push(`|<i class="${E(v)}"></i>|${v.id}|${y.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const v of l.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(T))a.push(`|<i class="${E(v)}"></i>|${v.id}|`);return a.join(`
`)}}const n=new P;C.Registry.add(e.Extensions.IconContribution,n);function I(_,T,E,a){return n.registerIcon(_,T,E,a)}e.registerIcon=I;function d(){return n}e.getIconRegistry=d;function m(){for(const _ of L.iconRegistry.all)n.registerIcon(_.id,_.definition,_.description);L.iconRegistry.onDidRegister(_=>n.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let u=C.Registry.as(A.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const p=new g.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,D.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,D.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,D.localize)(4,null)),e.syncing=y.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,25,2,4]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var A;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function C(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=C;function y(d){const m=d;return!!(m&&typeof m=="object"&&k.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(m,u,p,_){this._id=m,this._configuration=p,this._ignorePathCasing=_,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class n{constructor(m,u){this.raw=u,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(d){return new n({uri:d,index:0,name:(0,L.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=I}),define(me[198],ge([0,1,29,57,139,79,10,8,11,25,2,163,4,86,43]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(N){return(typeof N=="string"?(0,C.extname)(N):(0,P.extname)(N))===p}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,d.createDecorator)("workspacesService");function T(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=T;function E(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=E;function a(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=a;function l(N){const x=N;return typeof x?.id=="string"&&n.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=l;function v(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(N){const x=N;return typeof x?.id=="string"&&n.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(N){const x=N;if(x?.uri)return{id:x.id,uri:n.URI.revive(x.uri)};const F=N;if(F?.configPath)return{id:F.id,configPath:n.URI.revive(F.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=r;function s(N,x){return P.extUriBiasedIgnorePathCase.isEqualOrParent(N,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function i(N){return c(N)||f(N)}e.isStoredWorkspaceFolder=i;function c(N){const x=N;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=c;function f(N){const x=N;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=f;function h(N,x,F,V,M=!y.isWindows,U){if(N.scheme!==V.scheme)return{name:F,uri:N.toString(!0)};let q=x?void 0:U.relativePath(V,N);if(q!==void 0)q.length===0?q=".":y.isWindows&&N.scheme===A.Schemas.file&&!M&&(q=q.replace(/\//g,"\\"));else if(N.scheme===A.Schemas.file)q=N.fsPath,y.isWindows&&(q=(0,D.normalizeDriveLetter)(q),M&&(q=(0,g.toSlashes)(q)));else{if(!U.isEqualAuthority(N.authority,V.authority))return{name:F,uri:N.toString(!0)};q=N.path}return{name:F,path:q}}e.getStoredWorkspaceFolder=h;function b(N,x,F){let V=[],M=new Set;const U=F.dirname(x);for(let q of N){let W;if(c(q))q.path&&(W=F.resolvePath(U,q.path));else if(f(q))try{W=n.URI.parse(q.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(X){console.warn(X)}if(W){let X=F.getComparisonKey(W);if(!M.has(X)){M.add(X);const Z=q.name||F.basenameOrAuthority(W);V.push(new u.WorkspaceFolder({uri:W,name:Z,index:V.length},q))}}}return V}e.toWorkspaceFolders=b;function S(N,x,F,V,M){let U=o(x,N);const q=M.dirname(x),W=M.dirname(V),X=[],Z=w(U.folders);for(const Le of U.folders){const qe=c(Le)?M.resolvePath(q,Le.path):n.URI.parse(Le.uri);let xe;F?xe=!1:xe=!c(Le)||(0,C.isAbsolute)(Le.path),X.push(h(qe,xe,Le.name,W,Z,M))}const fe={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},_e=k.setProperty(N,["folders"],X,fe);let De=k.applyEdits(N,_e);return U.remoteAuthority===(0,m.getRemoteAuthority)(V)&&(De=k.applyEdits(De,k.removeProperty(De,["remoteAuthority"],fe))),De}e.rewriteWorkspaceFileForNewLocation=S;function o(N,x){let F=L.parse(x);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(V=>i(V));else throw new Error(`${N} looks like an invalid workspace file.`);return F}function w(N){return y.isWindows?N.some(x=>c(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=w;function R(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function O(N){return typeof N.folderUri=="string"}function $(N){return typeof N.fileUri=="string"}function K(N,x){const F={workspaces:[],files:[]};if(N){const V=function(U,q){for(let W=0;W<U.length;W++)try{q(U[W],W)}catch(X){x.warn(`Error restoring recent entry ${JSON.stringify(U[W])}: ${X.toString()}. Skip entry.`)}},M=N;if(Array.isArray(M.entries))V(M.entries,U=>{const q=U.label,W=U.remoteAuthority;R(U)?F.workspaces.push({label:q,remoteAuthority:W,workspace:{id:U.workspace.id,configPath:n.URI.parse(U.workspace.configPath)}}):O(U)?F.workspaces.push({label:q,remoteAuthority:W,folderUri:n.URI.parse(U.folderUri)}):$(U)&&F.files.push({label:q,remoteAuthority:W,fileUri:n.URI.parse(U.fileUri)})});else{const U=N;Array.isArray(U.workspaces3)&&V(U.workspaces3,(q,W)=>{const X=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[W]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?F.workspaces.push({label:X,workspace:{id:q.id,configPath:n.URI.parse(q.configURIPath)}}):typeof q=="string"&&F.workspaces.push({label:X,folderUri:n.URI.parse(q)})}),Array.isArray(U.files2)&&V(U.files2,(q,W)=>{const X=Array.isArray(U.fileLabels)&&U.fileLabels[W]||void 0;typeof q=="string"&&F.files.push({label:X,fileUri:n.URI.parse(q)})})}}return F}e.restoreRecentlyOpened=K;function G(N){const x={entries:[]};for(const F of N.workspaces)E(F)?x.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):x.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of N.files)x.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return x}e.toStoreData=G}),define(me[87],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const D=this._idPool++;return this._data.set(D,k),this.logDebugInfo(),D}get(k,D){return this._data.has(k)?this._data.get(k)[D]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class D{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(y=>({name:y.name,group:y.group,resource:g.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=D}),define(me[63],ge([0,1,10,4]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A):this._providerInfo.set(A,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(A,C,y){this._deferredPromises=new Map,this._id=A,this._shared=C,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of P.values())n.complete()}catch(n){for(const I of P.values())I.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,C){let y=this._value[A];return typeof y=="undefined"&&(y=C),y}update(A,C){this._value[A]=C;let y=this._deferredPromises.get(A);if(y!==void 0)return y.p;const P=new g.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(A,C){super(A.identifier.value,!0,C);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(me[200],ge([0,1,3,2,12]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let D=class{constructor(C,y){this._logService=C,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,y,P){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(C,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptDirty(y)}$acceptModelSaved(C){const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(C,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,y);const P=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};D=ze([Ue(0,k.ILogService)],D),e.ExtHostNotebookDocuments=D}),define(me[13],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=L});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[201],ge([0,1,26,3]),function(Y,e,g,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{constructor(C,y){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(C.identifier),rt(this,k,y,"f"),Be(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Be(this,k,"f").get(this._id,C)}store(C,y){return Be(this,k,"f").store(this._id,C,y)}delete(C){return Be(this,k,"f").delete(this._id,C)}}e.ExtensionSecrets=D,k=new WeakMap}),define(me[123],ge([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(me[88],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,k=(E,a)=>{const l={controllerId:a};return L.set(E,l),l};e.createPrivateApiFor=k;const D=E=>L.get(E);e.getPrivateApiFor=D;const A=(E,a,l,v)=>{let t=l;return{enumerable:!0,configurable:!1,get(){return t},set(r){v(t,r)||(t=r,E.listener?.({op:3,key:a,value:r}))}}},C=(E,a)=>E===a,y={range:(E,a)=>E===a?!0:!E||!a?!1:E.isEqual(a),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(E,a)=>!(E.length!==a.length||E.some(l=>!a.find(v=>l.id===v.id)))},P=Object.keys(y),n=(E,a)=>({range:A(E,"range",void 0,y.range),label:A(E,"label",a,y.label),description:A(E,"description",void 0,y.description),canResolveChildren:A(E,"canResolveChildren",!1,y.canResolveChildren),busy:A(E,"busy",!1,y.busy),error:A(E,"error",void 0,y.error),tags:A(E,"tags",[],y.tags)}),I=(E,a)=>{const l=new Map;for(const v of P)y[v](E[v],a[v])||l.set(v,a[v]);return l};e.diffTestItems=I;class d extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=d;class m extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class u extends Error{constructor(a,l,v){super(`TestItem with ID "${a}" is from controller "${l}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=u;const p=E=>{const a=(0,e.getPrivateApiFor)(E);let l=new Map;return{get size(){return l.size},forEach(v,t){for(const r of l.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(l.keys()),s={op:4,ops:[]};for(const i of v){if(!(i instanceof _))throw new m(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==a.controllerId)throw new u(i.id,c,a.controllerId);if(t.has(i.id))throw new d(i.id);t.set(i.id,i),r.delete(i.id),s.ops.push({op:0,item:i})}for(const i of r.keys())s.ops.push({op:1,id:i});a.listener?.(s),l=t},add(v){if(!(v instanceof _))throw new m(v.id);l.set(v.id,v),a.listener?.({op:0,item:v})},delete(v){l.delete(v)&&a.listener?.({op:1,id:v})},get(v){return l.get(v)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};class _{constructor(a,l,v,t){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const r=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof T?void 0:r.parent}},children:{value:p(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class T extends _{constructor(a,l){super(a,a,l,void 0)}}e.TestItemRootImpl=T}),define(me[52],ge([0,1,4,3,13]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var D;(function(C){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}C.fromApiTunnel=y;function P(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}C.fromServiceTunnel=P})(D=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let A=class{constructor(y){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,P){return{dispose:()=>{}}}async $providePortAttributes(y,P,n,I,d){return[]}async $forwardPort(y,P){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([Ue(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[7],ge([0,1,20,16,99,24,102,14,2,32,42,122]),function(Y,e,g,L,k,D,A,C,y,P,n,I){"use strict";var d,m,u,p,_,T,E,a,l,v,t,r,s,i,c,f,h,b,S,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function w(z){function B(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(B,z),Object.setPrototypeOf(B.prototype,z.prototype),B}let R=_=class{constructor(B){d.set(this,void 0),rt(this,d,B,"f")}static from(...B){let se=B;return new _(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}dispose(){typeof Be(this,d,"f")=="function"&&(Be(this,d,"f").call(this),rt(this,d,void 0,"f"))}};d=new WeakMap,R=_=ze([w],R),e.Disposable=R;let O=T=class{constructor(B,se){if(B<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=B,this._character=se}static Min(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let ye=1;ye<B.length;ye++){const Ze=B[ye];Ze.isBefore(se)&&(se=Ze)}return se}static Max(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let ye=1;ye<B.length;ye++){const Ze=B[ye];Ze.isAfter(se)&&(se=Ze)}return se}static isPosition(B){if(!B)return!1;if(B instanceof T)return!0;let{line:se,character:ye}=B;return typeof se=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,se=0){if(B===null||se===null)throw(0,L.illegalArgument)();let ye;return typeof B=="undefined"?ye=0:typeof B=="number"?ye=B:(ye=typeof B.lineDelta=="number"?B.lineDelta:0,se=typeof B.characterDelta=="number"?B.characterDelta:0),ye===0&&se===0?this:new T(this.line+ye,this.character+se)}with(B,se=this.character){if(B===null||se===null)throw(0,L.illegalArgument)();let ye;return typeof B=="undefined"?ye=this.line:typeof B=="number"?ye=B:(ye=typeof B.line=="number"?B.line:this.line,se=typeof B.character=="number"?B.character:this.character),ye===this.line&&se===this.character?this:new T(ye,se)}toJSON(){return{line:this.line,character:this.character}}};O=T=ze([w],O),e.Position=O;let $=E=class{constructor(B,se,ye,Ze){let it,ut;if(typeof B=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ze=="number"?(it=new O(B,se),ut=new O(ye,Ze)):B instanceof O&&se instanceof O&&(it=B,ut=se),!it||!ut)throw new Error("Invalid arguments");it.isBefore(ut)?(this._start=it,this._end=ut):(this._start=ut,this._end=it)}static isRange(B){return B instanceof E?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof E?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const se=O.Max(B.start,this._start),ye=O.Min(B.end,this._end);if(!se.isAfter(ye))return new E(se,ye)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const se=O.Min(B.start,this._start),ye=O.Max(B.end,this.end);return new E(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,se=this.end){if(B===null||se===null)throw(0,L.illegalArgument)();let ye;return B?O.isPosition(B)?ye=B:(ye=B.start||this.start,se=B.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new E(ye,se)}toJSON(){return[this.start,this.end]}};$=E=ze([w],$),e.Range=$;let K=a=class extends ${constructor(B,se,ye,Ze){let it,ut;if(typeof B=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ze=="number"?(it=new O(B,se),ut=new O(ye,Ze)):B instanceof O&&se instanceof O&&(it=B,ut=se),!it||!ut)throw new Error("Invalid arguments");super(it,ut);this._anchor=it,this._active=ut}static isSelection(B){return B instanceof a?!0:B?$.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};K=a=ze([w],K),e.Selection=K;class G{constructor(B,se,ye){if(typeof B!="string"||B.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,L.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=G;class N extends Error{constructor(B,se=I.RemoteAuthorityResolverErrorCode.Unknown,ye){super(B);this._message=B,this._code=se,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(B,se){return new N(B,I.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(B){return new N(B,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var x;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var F;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=l=class{constructor(B,se){this._range=B,this._newText=se}static isTextEdit(B){return B instanceof l?!0:B?$.isRange(B)&&typeof B.newText=="string":!1}static replace(B,se){return new l(B,se)}static insert(B,se){return l.replace(new $(B,B),se)}static delete(B){return l.replace(B,"")}static setEndOfLine(B){const se=new l(new $(new O(0,0),new O(0,0)),"");return se.newEol=B,se}get range(){return this._range}set range(B){if(B&&!$.isRange(B))throw(0,L.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,L.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,L.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=l=ze([w],V),e.TextEdit=V;var M;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,se,ye,Ze){this._edits.push({_type:1,from:B,to:se,options:ye,metadata:Ze})}createFile(B,se,ye){this._edits.push({_type:1,from:void 0,to:B,options:se,metadata:ye})}deleteFile(B,se,ye){this._edits.push({_type:1,from:B,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(B,se,ye){this._edits.push({_type:3,metadata:ye,uri:B,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(B,se,ye,Ze,it){let ut,ft,kt=[],Tt;if($t.isNotebookRange(se)&&Ft.isNotebookCellDataArray(ye)&&!Ft.isNotebookCellDataArray(Ze)?(ut=se.start,ft=se.end,kt=ye,Tt=Ze):typeof se=="number"&&typeof ye=="number"&&Ft.isNotebookCellDataArray(Ze)&&(ut=se,ft=ye,kt=Ze,Tt=it),ut===void 0||ft===void 0)throw new Error("Invalid arguments");(ut!==ft||kt.length>0)&&this._edits.push({_type:5,uri:B,index:ut,count:ft-ut,cells:kt,metadata:Tt})}replaceNotebookCellMetadata(B,se,ye,Ze){this._edits.push({_type:3,metadata:Ze,uri:B,edit:{editType:8,index:se,metadata:ye}})}replace(B,se,ye,Ze){this._edits.push({_type:2,uri:B,edit:new V(se,ye),metadata:Ze})}insert(B,se,ye,Ze){this.replace(B,new $(se,se),ye,Ze)}delete(B,se,ye){this.replace(B,se,"",ye)}has(B){return this._edits.some(se=>se._type===2&&se.uri.toString()===B.toString())}set(B,se){if(se)for(const ye of se)ye&&this._edits.push({_type:2,uri:B,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ze=this._edits[ye];Ze._type===2&&Ze.uri.toString()===B.toString()&&(this._edits[ye]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(B){const se=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===B.toString()&&se.push(ye.edit);return se}entries(){const B=new D.ResourceMap;for(let se of this._edits)if(se._type===2){let ye=B.get(se.uri);ye||(ye=[se.uri,[]],B.set(se.uri,ye)),ye[1].push(se.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=ze([w],U),e.WorkspaceEdit=U;let q=v=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof v?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=v._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,se=this._tabstop++){if(typeof B=="function"){const ye=new v;ye._tabstop=this._tabstop,B(ye),this._tabstop=ye._tabstop,B=ye.value}else B=v._escape(B);return this.value+="${",this.value+=se,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,se=this._tabstop++){const ye=B.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(B,se){if(typeof se=="function"){const ye=new v;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,se&&(this.value+=":",this.value+=se),this.value+="}",this}};q=v=ze([w],q),e.SnippetString=q;var W;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var X;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(X=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=t=class{constructor(B,se){if(this.uri=B,se)if(se instanceof $)this.range=se;else if(se instanceof O)this.range=new $(se,se);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof t?!0:B?$.isRange(B.range)&&y.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=t=ze([w],Z),e.Location=Z;let fe=class{constructor(B,se){this.location=B,this.message=se}static is(B){return B?typeof B.message=="string"&&B.location&&$.isRange(B.location.range)&&y.URI.isUri(B.location.uri):!1}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.location.range.isEqual(se.location.range)&&B.location.uri.toString()===se.location.uri.toString()}};fe=ze([w],fe),e.DiagnosticRelatedInformation=fe;let _e=class{constructor(B,se,ye=X.Error){if(!$.isRange(B))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=B,this.message=se,this.severity=ye}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.severity===se.severity&&B.code===se.code&&B.severity===se.severity&&B.source===se.source&&B.range.isEqual(se.range)&&(0,g.equals)(B.tags,se.tags)&&(0,g.equals)(B.relatedInformation,se.relatedInformation,fe.isEqual)}};_e=ze([w],_e),e.Diagnostic=_e;let De=class{constructor(B,se){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=se}};De=ze([w],De),e.Hover=De;var Le;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor(B,se=Le.Text){this.range=B,this.kind=se}toJSON(){return{range:this.range,kind:Le[this.kind]}}};qe=ze([w],qe),e.DocumentHighlight=qe;var xe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(z){z[z.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let H=r=class{constructor(B,se,ye,Ze,it){this.name=B,this.kind=se,this.containerName=it,typeof ye=="string"&&(this.containerName=ye),Ze instanceof Z?this.location=Ze:ye instanceof $&&(this.location=new Z(Ze,ye)),r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};H=r=ze([w],H),e.SymbolInformation=H;let ee=s=class{constructor(B,se,ye,Ze,it){this.name=B,this.detail=se,this.kind=ye,this.range=Ze,this.selectionRange=it,this.children=[],s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(s.validate)}};ee=s=ze([w],ee),e.DocumentSymbol=ee;var re;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(B,se){this.title=B,this.kind=se}};le=ze([w],le),e.CodeAction=le;let J=i=class{constructor(B){this.value=B}append(B){return new i(this.value?this.value+i.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+i.sep)}};J.sep=".",J=i=ze([w],J),e.CodeActionKind=J,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll");let ae=class{constructor(B,se){if(this.range=B,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=ze([w],ae),e.SelectionRange=ae;class ve{constructor(B,se,ye,Ze,it,ut){this.kind=B,this.name=se,this.detail=ye,this.uri=Ze,this.range=it,this.selectionRange=ut}}e.CallHierarchyItem=ve;class Fe{constructor(B,se){this.fromRanges=se,this.from=B}}e.CallHierarchyIncomingCall=Fe;class je{constructor(B,se){this.fromRanges=se,this.to=B}}e.CallHierarchyOutgoingCall=je;var Qe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(B,se){this.range=B,this.command=se}get isResolved(){return!!this.command}};et=ze([w],et),e.CodeLens=et;let ke=c=class{constructor(B,se=!1){m.set(this,void 0),rt(this,m,new k.MarkdownString(B,{supportThemeIcons:se}),"f")}static isMarkdownString(B){return B instanceof c?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return Be(this,m,"f").value}set value(B){Be(this,m,"f").value=B}get isTrusted(){return Be(this,m,"f").isTrusted}set isTrusted(B){Be(this,m,"f").isTrusted=B}get supportThemeIcons(){return Be(this,m,"f").supportThemeIcons}set supportThemeIcons(B){Be(this,m,"f").supportThemeIcons=B}appendText(B){return Be(this,m,"f").appendText(B),this}appendMarkdown(B){return Be(this,m,"f").appendMarkdown(B),this}appendCodeblock(B,se){return Be(this,m,"f").appendCodeblock(se??"",B),this}};m=new WeakMap,ke=c=ze([w],ke),e.MarkdownString=ke;let ct=class{constructor(B,se){this.label=B,this.documentation=se}};ct=ze([w],ct),e.ParameterInformation=ct;let Q=class{constructor(B,se){this.label=B,this.documentation=se,this.parameters=[]}};Q=ze([w],Q),e.SignatureInformation=Q;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=ze([w],te),e.SignatureHelp=te;var pe;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(pe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var He;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(He=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(B,se,ye){this.text=B,this.position=se,this.kind=ye}};tt=ze([w],tt),e.InlayHint=tt;var st;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var lt;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(lt=e.CompletionItemKind||(e.CompletionItemKind={}));var wt;(function(z){z[z.Deprecated=1]="Deprecated"})(wt=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor(B,se){this.label=B,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=ze([w],Ct),e.CompletionItem=Ct;let ce=class{constructor(B=[],se=!1){this.items=B,this.isIncomplete=se}};ce=ze([w],ce),e.CompletionList=ce;let Pe=class{constructor(B,se,ye){this.text=B,this.range=se,this.command=ye}};Pe=ze([w],Pe),e.InlineSuggestion=Pe;let Ne=class{constructor(B){this.items=B}};Ne=ze([w],Ne),e.InlineSuggestions=Ne;var Ge;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Ge=e.ViewColumn||(e.ViewColumn={}));var $e;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})($e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function B(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=B}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(B,se){if(se&&!y.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!$.isRange(B)||B.isEmpty)throw(0,L.illegalArgument)("range");this.range=B,this.target=se}};be=ze([w],be),e.DocumentLink=be;let we=class{constructor(B,se,ye,Ze){this.red=B,this.green=se,this.blue=ye,this.alpha=Ze}};we=ze([w],we),e.Color=we;let Me=class{constructor(B,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!$.isRange(B)||B.isEmpty)throw(0,L.illegalArgument)("range");this.range=B,this.color=se}};Me=ze([w],Me),e.ColorInformation=Me;let Ve=class{constructor(B){if(!B||typeof B!="string")throw(0,L.illegalArgument)("label");this.label=B}};Ve=ze([w],Ve),e.ColorPresentation=Ve;var We;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(We=e.ColorFormat||(e.ColorFormat={}));var Je;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class nt{constructor(B,se,ye){if(this.startIndex=B,this.length=se,this.tooltip=ye,typeof B!="number"||B<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=nt;class oe{constructor(B){this.options=B,typeof B!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=oe;var Ee;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let j=f=class{constructor(B,se){if(typeof B!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};j.Clean=new f("clean","Clean"),j.Build=new f("build","Build"),j.Rebuild=new f("rebuild","Rebuild"),j.Test=new f("test","Test"),j=f=ze([w],j),e.TaskGroup=j;function Ae(z){let B="";for(let se=0;se<z.length;se++)B+=z[se].replace(/,/g,",,")+",";return B}let Ie=class{constructor(B,se,ye){if(typeof B!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=B,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,L.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let se of this._args)B.push(se);return Ae(B)}};Ie=ze([w],Ie),e.ProcessExecution=Ie;let Ye=class{constructor(B,se,ye){if(this._args=[],Array.isArray(se)){if(!B)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,L.illegalArgument)("command");this._command=B,this._args=se,this._options=ye}else{if(typeof B!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=B,this._options=se}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,L.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)B.push(typeof se=="string"?se:se.value);return Ae(B)}};Ye=ze([w],Ye),e.ShellExecution=Ye;var Xe;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Xe=e.ShellQuoting||(e.ShellQuoting={}));var ot;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ot=e.TaskScope||(e.TaskScope={}));class _t{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=_t;let vt=h=class{constructor(B,se,ye,Ze,it,ut){this.__deprecated=!1,this._definition=this.definition=B;let ft;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=Ze,ft=it,this.__deprecated=!0):se===ot.Global||se===ot.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=Ze,this.execution=it,ft=ut):(this.target=se,this._name=this.name=ye,this._source=this.source=Ze,this.execution=it,ft=ut),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ye?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const se=this._definition.type;(h.EmptyType===se||h.ProcessType===se||h.ShellType===se||h.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=h=ze([w],vt),e.Task=vt;var gt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(B,se=ht.None){this.collapsibleState=se,y.URI.isUri(B)?this.resourceUri=B:this.label=B}};mt=ze([w],mt),e.TreeItem=mt;var ht;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(B,se){this.id=B,this.color=se}};yt=ze([w],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let At=class{constructor(B){this.id=B}};At=ze([w],At),e.ThemeColor=At;var jt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Lt=class{constructor(B,se){if(typeof B!="string"&&(!B||!y.URI.isUri(B)&&!y.URI.isUri(B.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=y.URI.file(B),this.base=B):y.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=se}};Lt=ze([w],Lt),e.RelativePattern=Lt;let Dt=class{constructor(B,se,ye,Ze){this.enabled=typeof B=="boolean"?B:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Dt=ze([w],Dt),e.Breakpoint=Dt;let Jt=class extends Dt{constructor(B,se,ye,Ze,it){super(se,ye,Ze,it);if(B===null)throw(0,L.illegalArgument)("location");this.location=B}};Jt=ze([w],Jt),e.SourceBreakpoint=Jt;let Yt=class extends Dt{constructor(B,se,ye,Ze,it){super(se,ye,Ze,it);this.functionName=B}};Yt=ze([w],Yt),e.FunctionBreakpoint=Yt;let bt=class extends Dt{constructor(B,se,ye,Ze,it,ut,ft){super(Ze,it,ut,ft);if(!se)throw(0,L.illegalArgument)("dataId");this.label=B,this.dataId=se,this.canPersist=ye}};bt=ze([w],bt),e.DataBreakpoint=bt;let qt=class{constructor(B,se,ye){this.command=B,this.args=se||[],this.options=ye}};qt=ze([w],qt),e.DebugAdapterExecutable=qt;let Ht=class{constructor(B,se){this.port=B,this.host=se}};Ht=ze([w],Ht),e.DebugAdapterServer=Ht;let Zt=class{constructor(B){this.path=B}};Zt=ze([w],Zt),e.DebugAdapterNamedPipeServer=Zt;let en=class{constructor(B){this.implementation=B}};en=ze([w],en),e.DebugAdapterInlineImplementation=en;let Pt=class{constructor(B,se){this.range=B,this.expression=se}};Pt=ze([w],Pt),e.EvaluatableExpression=Pt;var fn;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(fn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let tn=class{constructor(B,se){this.range=B,this.text=se}};tn=ze([w],tn),e.InlineValueText=tn;let Bt=class{constructor(B,se,ye=!0){this.range=B,this.variableName=se,this.caseSensitiveLookup=ye}};Bt=ze([w],Bt),e.InlineValueVariableLookup=Bt;let pt=class{constructor(B,se){this.range=B,this.expression=se}};pt=ze([w],pt),e.InlineValueEvaluatableExpression=pt;let nn=class{constructor(B,se){this.frameId=B,this.stoppedLocation=se}};nn=ze([w],nn),e.InlineValueContext=nn;var Ot;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=b=class extends Error{constructor(B,se=n.FileSystemProviderErrorCode.Unknown,ye){super(y.URI.isUri(B)?B.toString(!0):B);this.code=ye?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(B){return new b(B,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(B){return new b(B,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(B){return new b(B,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(B){return new b(B,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(B){return new b(B,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(B){return new b(B,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Nt=b=ze([w],Nt),e.FileSystemError=Nt;let Gt=class{constructor(B,se,ye){this.start=B,this.end=se,this.kind=ye}};Gt=ze([w],Gt),e.FoldingRange=Gt;var _n;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(_n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var mn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class gn{constructor(B,se=[]){this.tokenTypes=B,this.tokenModifiers=se}}e.SemanticTokensLegend=gn;function rn(z){return typeof z=="undefined"||(0,C.isStringArray)(z)}class sn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let se=0,ye=B.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(B.tokenTypes[se],se);for(let se=0,ye=B.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(B.tokenModifiers[se],se)}}push(B,se,ye,Ze,it){if(typeof B=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(B,se,ye,Ze,it);if($.isRange(B)&&typeof se=="string"&&rn(ye))return this._push(B,se,ye);throw(0,L.illegalArgument)()}_push(B,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ze=B.start.line,it=B.start.character,ut=B.end.character-B.start.character,ft=this._tokenTypeStrToInt.get(se);let kt=0;if(ye)for(const Tt of ye){if(!this._tokenModifierStrToInt.has(Tt))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(Tt);kt|=1<<Rt>>>0}this._pushEncoded(Ze,it,ut,ft,kt)}_pushEncoded(B,se,ye,Ze,it){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Tt=0,Rt=0;for(let Mt=0;Mt<kt;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=Tt,dn+=Rt):Ut+=Tt,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,Tt=Ut,Rt=dn}}let ut=B,ft=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=it,this._prevLine=B,this._prevChar=se}static _sortAndDeltaEncode(B){let se=[];const ye=B.length/5|0;for(let ft=0;ft<ye;ft++)se[ft]=ft;se.sort((ft,kt)=>{const Tt=B[5*ft],Rt=B[5*kt];if(Tt===Rt){const Mt=B[5*ft+1],Ut=B[5*kt+1];return Mt-Ut}return Tt-Rt});const Ze=new Uint32Array(B.length);let it=0,ut=0;for(let ft=0;ft<ye;ft++){const kt=5*se[ft],Tt=B[kt+0],Rt=B[kt+1],Mt=B[kt+2],Ut=B[kt+3],dn=B[kt+4],Un=Tt-it,qn=Un===0?Rt-ut:Rt,hn=5*ft;Ze[hn+0]=Un,Ze[hn+1]=qn,Ze[hn+2]=Mt,Ze[hn+3]=Ut,Ze[hn+4]=dn,it=Tt,ut=Rt}return Ze}build(B){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),B):new zt(sn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=sn;class zt{constructor(B,se){this.resultId=se,this.data=B}}e.SemanticTokens=zt;class on{constructor(B,se,ye){this.start=B,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=on;class yn{constructor(B,se){this.resultId=se,this.edits=B}}e.SemanticTokensEdits=yn;var Dn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Vt;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Vt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new yt("arrow-left")},Kt=ze([w],Kt),e.QuickInputButtons=Kt;var Cn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(B,se,ye){this.badge=B,this.tooltip=se,this.color=ye}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let an=class{constructor(B){this.kind=B}};an=ze([w],an),e.ColorTheme=an;var ln;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(B,se){if(B<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");B<=se?(this._start=B,this._end=se):(this._start=se,this._end=B)}static isNotebookRange(B){return B instanceof $t?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let se=this._start,ye=this._end;return B.start!==void 0&&(se=B.start),B.end!==void 0&&(ye=B.end),se===this._start&&ye===this._end?this:new $t(se,ye)}}e.NotebookRange=$t;class Ft{constructor(B,se,ye,Ze,it,ut,ft){this.kind=B,this.value=se,this.languageId=ye,this.mime=Ze,this.outputs=it??[],this.metadata=ut,this.executionSummary=ft,Ft.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(se=>Ft.isNotebookCellData(se))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Ft;class Qt{constructor(B){this.cells=B}}e.NotebookData=Qt;class Oe{constructor(B,se){this.data=B,this.mime=se;const ye=(0,A.normalizeMimeType)(se,!0);if(!ye)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(B){return B instanceof Oe?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const se={name:B.name,message:B.message,stack:B.stack};return Oe.json(se,"application/vnd.code.notebook.error")}static stdout(B){return Oe.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Oe.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,se="application/octet-stream"){return new Oe(B,se)}static text(B,se=A.Mimes.text){const ye=Be(Oe,u,"f",p).encode(String(B));return new Oe(ye,se)}static json(B,se="application/json"){const ye=JSON.stringify(B,void 0,"	");return Oe.text(ye,se)}}e.NotebookCellOutputItem=Oe,u=Oe,p={value:new TextEncoder};class Wt{constructor(B,se,ye){this.items=Wt.ensureUniqueMimeTypes(B,!0),typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,P.generateUuid)(),this.metadata=se??ye)}static isNotebookCellOutput(B){return B instanceof Wt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,C.isArray)(B.items)}static ensureUniqueMimeTypes(B,se=!1){const ye=new Set,Ze=new Set;for(let it=0;it<B.length;it++){const ut=B[it],ft=(0,A.normalizeMimeType)(ut.mime);if(!ye.has(ft)){ye.add(ft);continue}Ze.add(it),se&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ze.size===0?B:B.filter((it,ut)=>!Ze.has(ut))}}e.NotebookCellOutput=Wt;var pn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(pn=e.NotebookCellKind||(e.NotebookCellKind={}));var Et;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Et=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class vn{constructor(B,se){this.text=B,this.alignment=se}}e.NotebookCellStatusBarItem=vn;var wn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(B,se=[]){this.uri=B,this.provides=(0,g.asArray)(se)}}e.NotebookRendererScript=An;let cn=class{constructor(B,se){this.label=B,this.timestamp=se}};cn=ze([w],cn),e.TimelineItem=cn;var Tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var bn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(bn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(B,se){this.ranges=B,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor(B,se){this._port=B,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let un=class{constructor(B,se,ye){this.include=B,this.exclude=se,this.profile=ye}};un=ze([w],un),e.TestRunRequest=un;let ie=S=class{constructor(B){this.message=B}static diff(B,se,ye){const Ze=new S(B);return Ze.expectedOutput=se,Ze.actualOutput=ye,Ze}};ie=S=ze([w],ie),e.TestMessage=ie;let he=class{constructor(B,se){this.id=B,this.label=se}};he=ze([w],he),e.TestTag=he;let Te=class{constructor(B,se){this.covered=B,this.total=se}};Te=ze([w],Te),e.CoveredCount=Te;let dt=o=class{constructor(B,se,ye,Ze){this.uri=B,this.statementCoverage=se,this.branchCoverage=ye,this.functionCoverage=Ze}static fromDetails(B,se){const ye=new Te(0,0),Ze=new Te(0,0),it=new Te(0,0);for(const ft of se)if("branches"in ft){ye.total+=1,ye.covered+=ft.executionCount>0?1:0;for(const kt of ft.branches)Ze.total+=1,Ze.covered+=kt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ut=new o(B,ye,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return ut.detailedCoverage=se,ut}};dt=o=ze([w],dt),e.FileCoverage=dt;let St=class{constructor(B,se,ye=[]){this.executionCount=B,this.location=se,this.branches=ye}};St=ze([w],St),e.StatementCoverage=St;let It=class{constructor(B,se){this.executionCount=B,this.location=se}};It=ze([w],It),e.BranchCoverage=It;let Nn=class{constructor(B,se){this.executionCount=B,this.location=se}};Nn=ze([w],Nn),e.FunctionCoverage=Nn;var Hn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor(B,se,ye,Ze,it,ut){this.kind=B,this.name=se,this.detail=ye,this.uri=Ze,this.range=it,this.selectionRange=ut}}e.TypeHierarchyItem=jn}),define(me[124],ge([0,1,54,10,9,150,110,7,20]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function n(u,p){p?P.set(u,p):P.delete(u)}e.setWordDefinitionFor=n;function I(u){return P.get(u)}e.getWordDefinitionFor=I;class d extends D.MirrorTextModel{constructor(p,_,T,E,a,l,v,t){super(_,T,E,a);this._proxy=p,this._languageId=l,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,y.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===L.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(_){return _?p._getTextInRange(_):p.getText()},get eol(){return p._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(_){return p._lineAt(_)},offsetAt(_){return p._offsetAt(_)},positionAt(_){return p._positionAt(_)},validateRange(_){return p._validateRange(_)},validatePosition(_){return p._validatePosition(_)},getWordRangeAtPosition(_,T){return p._getWordRangeAtPosition(_,T)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,g.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,g.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const _=this._validateRange(p);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const T=this._eol,E=_.start.line,a=_.end.line,l=[];l.push(this._lines[E].substring(_.start.character));for(let v=E+1;v<a;v++)l.push(this._lines[v]);return l.push(this._lines[a].substring(0,_.end.character)),l.join(T)}_lineAt(p){let _;if(p instanceof C.Position?_=p.line:typeof p=="number"&&(_=p),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(p),T=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,T))}_validateRange(p){if(!(p instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(p.start),T=this._validatePosition(p.end);return _===p.start&&T===p.end?p:new C.Range(_.line,_.character,T.line,T.character)}_validatePosition(p){if(!(p instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:_,character:T}=p,E=!1;if(_<0)_=0,T=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,T=this._lines[_].length,E=!0;else{const a=this._lines[_].length;T<0?(T=0,E=!0):T>a&&(T=a,E=!0)}return E?new C.Position(_,T):p}_getWordRangeAtPosition(p,_){const T=this._validatePosition(p);if(!_)_=I(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=(0,A.getWordAtText)(T.character+1,(0,A.ensureValidWordDefinition)(_),this._lines[T.line],0);if(E)return new C.Range(T.line,E.startColumn-1,T.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class m{constructor(p,_,T){this._line=p,this._text=_,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[202],ge([0,1,7,3,112,6,81,24,2,32]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,m,u,p){this._notebook=u,this._selector=p,this._disposables=new D.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(T=>{const E=this._cellUris.get(T.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(T=>_(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const d=[],m=[];for(const u of this._notebook.getCells())u.kind===g.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),d.push(u.document.getText().length+1),m.push(u.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(d){if(!d){let E="";for(const a of this._cells)E+=a.document.getText()+`
`;return E=E.slice(0,-1),E}if(d.isEmpty)return"";const m=this.locationAt(d.start),u=this.locationAt(d.end),p=this._cellUris.get(m.uri),_=this._cellUris.get(u.uri);if(p===void 0||_===void 0)return"";if(p===_)return this._cells[p].document.getText(new g.Range(m.range.start,u.range.end));const T=[this._cells[p].document.getText(new g.Range(m.range.start,new g.Position(this._cells[p].document.lineCount,0)))];for(let E=p+1;E<_;E++)T.push(this._cells[E].document.getText());return T.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),u.range.end))),T.join(`
`)}offsetAt(d){const m=this._cellLines.getIndexOf(d.line),u=this._cellLengths.getPrefixSum(m.index-1),p=this._cells[m.index].document.offsetAt(d.with(m.remainder));return u+p}positionAt(d){if(typeof d=="number"){const u=this._cellLengths.getIndexOf(d),p=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(p)}const m=this._cellUris.get(d.uri);if(m!==void 0){const u=this._cellLines.getPrefixSum(m-1);return new g.Position(u+d.range.start.line,d.range.start.character)}return new g.Position(0,0)}locationAt(d){g.Range.isRange(d)||(d=new g.Range(d,d));const m=this._cellLines.getIndexOf(d.start.line);let u=m;d.isEmpty||(u=this._cellLines.getIndexOf(d.end.line));const p=new g.Position(m.remainder,d.start.character),_=new g.Position(u.remainder,d.end.character),T=new g.Range(p,_),E=this._cells[m.index];return new g.Location(E.document.uri,E.document.validateRange(T))}contains(d){return this._cellUris.has(d)}validateRange(d){const m=this.validatePosition(d.start),u=this.validatePosition(d.end);return d.with(m,u)}validatePosition(d){const m=this._cellLines.getIndexOf(d.line),u=new g.Position(m.remainder,d.character),p=this._cells[m.index].document.validatePosition(u),_=this._cellLines.getPrefixSum(m.index-1);return new g.Position(_+p.line,p.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[203],ge([0,1,7,13,3]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let D=class{constructor(C){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let y=C==="light"?g.ColorThemeKind.Light:C==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};D=ze([Ue(0,L.IExtHostRpcService)],D),e.ExtHostTheming=D}),define(me[64],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(D){D?(this.transformIncoming=D.transformIncoming.bind(D),this.transformOutgoing=D.transformOutgoing.bind(D),this.transformOutgoingURI=D.transformOutgoingURI.bind(D),this.transformOutgoingScheme=D.transformOutgoingScheme.bind(D)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=L}),define(me[204],ge([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function k(C,y){if(y.serializeBuffersForPostMessage){const P=new L,n=(m,u)=>{if(u instanceof ArrayBuffer){const p=P.add(u);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(u)){const p=D(u);if(p){const _=P.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:p,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},I=JSON.stringify(C,n),d=P.buffers.map(m=>{const u=new Uint8Array(m);return g.VSBuffer.wrap(u)});return{message:I,buffers:d}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=k;function D(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(C,y){const P=y.map(d=>{const m=new ArrayBuffer(d.byteLength);return new Uint8Array(m).set(d.buffer),m}),n=y.length?(d,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const u=m,{index:p}=u,_=P[p];if(u.view)switch(u.view.type){case 1:return new Int8Array(_,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(C,n),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(me[205],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function k(A){const C={items:new Map};return A.types.forEach((y,P)=>{C.items.set(y,{asString:async()=>A.items[P].asString})}),C}L.toITreeDataTransfer=k;async function D(A){const C={types:[],items:[]},y=Array.from(A.items.entries());for(const P of y)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}L.toTreeDataTransferDTO=D})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[89],ge([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(C,y){return C.scheme===g.Schemas.http||C.scheme===g.Schemas.https?C:(y&&y.authority&&y.isRemote&&C.scheme===g.Schemas.file&&(C=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:y.authority,path:C.path})),L.URI.from({scheme:g.Schemas.https,authority:`${C.scheme}+${D(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=k;function D(C){return C.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function A(C){return C.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=A}),define(me[206],ge([0,1,3,6,89]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(C,y,P){this._proxy=C,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,y,P,n,I){let d;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===C){d=a;break}if(!d)throw new Error("not a visible editor");const m=this,u=this._handlePool++,p=new g.Emitter,_=new g.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,k.asWebviewUri)(a,m._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(a){this._options=a,m._proxy.$setOptions(u,a)}get options(){return this._options}set html(a){this._html=a,m._proxy.$setHtml(u,a)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(a){return m._proxy.$postMessage(u,a)}},E=new class{constructor(){this.editor=C,this.line=y,this.height=P,this.webview=T,this.onDidDispose=_.event}dispose(){m._insets.has(u)&&(m._insets.delete(u),m._proxy.$disposeEditorInset(u),_.fire(),_.dispose(),p.dispose())}};return this._proxy.$createEditorInset(u,d.id,d.value.document.uri,y+1,P,n||{},I.identifier,I.extensionLocation),this._insets.set(u,{editor:C,inset:E,onDidReceiveMessage:p}),E}$onDidDispose(C){const y=this._insets.get(C);y&&y.inset.dispose()}$onDidReceiveMessage(C,y){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=D}),define(me[207],ge([0,1,172,14,2,6,4,61,34,20,10]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=I;function d(o){if(a(o))return!1;const w=o;return k.URI.isUri(w?.resource)}e.isResourceEditorInput=d;function m(o){if(a(o))return!1;const w=o;return w?.original!==void 0&&w.modified!==void 0}e.isResourceDiffEditorInput=m;function u(o){if(a(o))return!1;const w=o;return w?w.resource===void 0||w.resource.scheme===n.Schemas.untitled||w.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var p;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var _;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var T;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(T=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends D.Disposable{}e.AbstractEditorInput=E;function a(o){return o instanceof E}e.isEditorInput=a;function l(o){const w=o;return k.URI.isUri(w?.preferredResource)}function v(o){const w=o;return a(w?.primary)&&a(w?.secondary)}e.isSideBySideEditorInput=v;function t(o){return a(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const w=o;return t(o)&&w?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const w=o;return typeof w?.groupId=="number"&&a(w.editor)}e.isEditorIdentifier=s;var i;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(w,R){if(!w)return;const O=v(w)?w.primary:m(w)?w.modified:void 0,$=v(w)?w.secondary:m(w)?w.original:void 0;if(R?.supportSideBySide&&O&&$){if(R?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(O,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:R.filterByScheme})};w=R.supportSideBySide===i.PRIMARY?O:$}if(m(w))return;const K=l(w)?w.preferredResource:w.resource;return!K||!R||!R.filterByScheme?K:this.filterUri(K,R.filterByScheme)}getCanonicalUri(w,R){if(!w)return;const O=v(w)?w.primary:m(w)?w.modified:void 0,$=v(w)?w.secondary:m(w)?w.original:void 0;if(R?.supportSideBySide&&O&&$){if(R?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(O,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:R.filterByScheme})};w=R.supportSideBySide===i.PRIMARY?O:$}if(m(w))return;const K=w.resource;return!K||!R||!R.filterByScheme?K:this.filterUri(K,R.filterByScheme)}filterUri(w,R){if(Array.isArray(R)){if(R.some(O=>w.scheme===O))return w}else if(R===w.scheme)return w}}e.EditorResourceAccessor=new c;var f;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class h{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(w){const R=this.instantiationService=w.get(A.IInstantiationService);for(const[O,$]of this.editorSerializerConstructors)this.createEditorSerializer(O,$,R);this.editorSerializerConstructors.clear()}createEditorSerializer(w,R,O){const $=O.createInstance(R);this.editorSerializerInstances.set(w,$)}registerFileEditorFactory(w){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=w}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(w,R){if(this.editorSerializerConstructors.has(w)||this.editorSerializerInstances.has(w))throw new Error(`A editor serializer with type ID '${w}' was already registered.`);return this.instantiationService?this.createEditorSerializer(w,R,this.instantiationService):this.editorSerializerConstructors.set(w,R),(0,D.toDisposable)(()=>{this.editorSerializerConstructors.delete(w),this.editorSerializerInstances.delete(w)})}getEditorSerializer(w){return this.editorSerializerInstances.get(typeof w=="string"?w:w.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new h);async function b(o,w){if(!o||!o.length)return[];const R=await Promise.all(o.map(async O=>{const $=k.URI.revive(O.fileUri);if(!$||(await w.activateProvider($.scheme),!w.canHandleResource($)))return;const K=typeof O.exists=="boolean"?O.exists:await w.exists($);if(!K&&O.openOnlyIfExists)return;const G=K&&!(0,L.isUndefined)(O.selection)?{selection:O.selection,pinned:!0,override:O.editorOverrideId}:{pinned:!0,override:O.editorOverrideId};let N;return K?N={resource:$,options:G,forceFile:!0}:N={resource:$,options:G,forceUntitled:!0},N}));return(0,P.coalesce)(R)}e.pathsToEditors=b;var S;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(S=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[208],ge([0,1,3,61,173,4,6,24,34,20,55,23,47,197]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",d.Codicon.window,(0,k.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var p;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(p=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function T(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=T;class E extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(f,h,b){const S=this.get(f.id);if(S)return S;const o=f;return o.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,C.getOrSet)(this.viewContainers,h,[]).push(o),b?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:h}),o}deregisterViewContainer(f){for(const h of this.viewContainers.keys()){const b=this.viewContainers.get(h),S=b?.indexOf(f);if(S!==-1){b?.splice(S,1),b.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:h});return}}}get(f){return this.all.filter(h=>h.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(b=>b?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===f)}}y.Registry.add(u.ViewContainersRegistry,new E);var a;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function l(c,f){const h=c.group??a.More,b=f.group??a.More;return h!==b?h.localeCompare(b):(c.order??5)-(f.order??5)}class v extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(f,h){this.registerViews2([{views:f,viewContainer:h}])}registerViews2(f){f.forEach(({views:h,viewContainer:b})=>this.addViews(h,b)),this._onViewsRegistered.fire(f)}deregisterViews(f,h){const b=this.removeViews(f,h);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:h})}moveViews(f,h){for(const b of this._views.keys())if(b!==h){const S=this.removeViews(f,b);S.length&&(this.addViews(S,h),this._onDidChangeContainer.fire({views:S,from:b,to:h}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const h of this._viewContainers){const b=(this._views.get(h)||[]).filter(S=>S.id===f)[0];if(b)return b}return null}getViewContainer(f){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(S=>S.id===f)[0])return h;return null}registerViewWelcomeContent(f,h){return this._viewWelcomeContents.add(f,h),this._onDidChangeViewWelcomeContent.fire(f),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(f,h),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,h){const b=new Map;for(const[S,o]of h)this._viewWelcomeContents.add(f,o),b.set(S,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(f,o),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),b}getViewWelcomeContent(f){const h=[];return this._viewWelcomeContents.forEach(f,b=>h.push(b)),h.sort(l)}addViews(f,h){let b=this._views.get(h);b||(b=[],this._views.set(h,b),this._viewContainers.push(h));for(const S of f){if(this.getView(S.id)!==null)throw new Error((0,k.localize)(1,null,S.id));b.push(S)}}removeViews(f,h){const b=this._views.get(h);if(!b)return[];const S=[],o=[];for(const w of b)f.includes(w)?S.push(w):o.push(w);return S.length&&(o.length?this._views.set(h,o):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),S}}y.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,D.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var r;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(f,h){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,f),this._hasResolve=!!h,this.resolve=async b=>{if(h&&!this.resolved){const S=await h(b);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[125],ge([0,1,3,17,174]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class D{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,y,P,n){const I={command:C};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const m=this.pendingRequests.get(I.seq);if(m){this.pendingRequests.delete(I.seq);const u={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,k.localize)(0,null,n,C)};m(u)}},n)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,y){return C.type!=="event"||y.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const y=C,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}internalSend(C,y){y.type=C,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((y,P)=>C.set(P,y)),await(0,L.timeout)(500),C.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=D}),define(me[209],ge([0,1,9,2,8,23,10]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function y(s,i,c){return s.replace(C,function(f,h){return i&&h.length>0&&h[0]!=="_"?f:c&&c.hasOwnProperty(h)?c[h]:f})}e.formatPII=y;function P(s){const i={};for(const c of Object.keys(s))c.startsWith("!")||(i[c]=s[c]);return i}e.filterExceptionsFromTelemetry=P;function n(s){return s.configuration.request==="attach"&&!I(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function I(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(i,"extensionhost")||(0,g.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?I(s.parentSession):void 0}e.getExtensionHostDebugSession=I;function d(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=d;function m(s,i,c){let f,h=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=b.exec(s);){let o=S.index+1,w=o+S[0].length;if(o<=i&&w>=c){f=S[0],h=o;break}}if(f){let o=/\w+/g,w=null;for(;(w=o.exec(f))&&!(w.index+1+h+w[0].length>=c););w&&(f=f.substring(0,o.lastIndex))}return f?{start:h,end:h+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(s){return!!(s&&s.match(u))}e.isUri=p;function _(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(p(s.path))return L.URI.parse(s.path);if((0,k.isAbsolute)(s.path))return L.URI.file(s.path)}return s.path}function T(s){if(typeof s.path=="object"){const i=L.URI.revive(s.path);if(i)return i.scheme===A.Schemas.file?i.fsPath:i.toString()}return s.path}function E(s,i){const c=i?_:T,f=(0,D.deepClone)(s);return l(f,(h,b)=>{h&&b&&(b.path=c(b))}),f}e.convertToDAPaths=E;function a(s,i){const c=i?_:T,f=(0,D.deepClone)(s);return l(f,(h,b)=>{!h&&b&&(b.path=c(b))}),f}e.convertToVSCPaths=a;function l(s,i){switch(s.type){case"event":const c=s;switch(c.event){case"output":i(!1,c.body.source);break;case"loadedSource":i(!1,c.body.source);break;case"breakpoint":i(!1,c.body.breakpoint.source);break;default:break}break;case"request":const f=s;switch(f.command){case"setBreakpoints":i(!0,f.arguments.source);break;case"breakpointLocations":i(!0,f.arguments.source);break;case"source":i(!0,f.arguments.source);break;case"gotoTargets":i(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const h=s;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":h.body.sources.forEach(b=>i(!1,b));break;case"scopes":h.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":h.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function v(s){return s.filter(i=>!i.presentation?.hidden).sort((i,c)=>i.presentation?c.presentation?i.presentation.group?c.presentation.group?i.presentation.group!==c.presentation.group?i.presentation.group.localeCompare(c.presentation.group):t(i.presentation.order,c.presentation.order):-1:c.presentation.group?1:t(i.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function r(s,i){const c=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(c!=="none"&&(await i.saveAll(),c==="allEditorsInActiveGroup")){const f=i.activeEditorPane;f&&await i.save({editor:f.input,groupId:f.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(me[210],ge([0,1,28,39,175,126,8,9,23,11,185,125]),function(Y,e,g,L,k,D,A,C,y,P,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class d extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",l=>this.handleData(l))}sendMessage(E){if(this.outputStream){const a=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${d.TWO_CRLF}${a}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+a))}continue}}else{const a=this.rawData.indexOf(d.TWO_CRLF);if(a!==-1){const v=this.rawData.toString("utf8",0,a).split(d.HEADER_LINESEPARATOR);for(const t of v){const r=t.split(d.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(a+d.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=d,d.TWO_CRLF=`\r
\r
`,d.HEADER_LINESEPARATOR=/\r?\n/,d.HEADER_FIELDSEPARATOR=/: */;class m extends d{startSession(){return new Promise((E,a)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",v=>{l?this._onError.fire(v):a(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class u extends m{constructor(E){super();this.adapterServer=E}createConnection(E){return D.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=u;class p extends m{constructor(E){super();this.adapterServer=E}createConnection(E){return D.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=p;class _ extends d{constructor(E,a,l){super();this.adapterExecutable=E,this.debugType=a,this.outputService=l}async startSession(){const E=this.adapterExecutable.command,a=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(E)if(A.isAbsolute(E)){if(!await g.Promises.exists(E))throw new Error(k.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let v=process.env;if(l.env&&Object.keys(l.env).length>0&&(v=y.mixin(y.deepClone(process.env),l.env)),E==="node")if(Array.isArray(a)&&a.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:v,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(s.cwd=l.cwd);const i=L.fork(a[0],a.slice(1),s);if(!i.pid)throw new Error(k.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const r={env:v};l.cwd&&(r.cwd=l.cwd),this.serverProcess=L.spawn(E,a,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((E,a)=>{const l=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,r){if(v)return a(v)});l.on("exit",E),l.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,a){if(!E)return;const l=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?l.runtime=A.join(a,E.runtime):l.runtime=E.runtime),E.runtimeArgs&&(l.runtimeArgs=E.runtimeArgs),E.program&&(A.isAbsolute(E.program)?l.program=E.program:l.program=A.join(a,E.program)),E.args&&(l.args=E.args);const v=E;return v.win&&(l.win=_.extract(v.win,a)),v.winx86&&(l.winx86=_.extract(v.winx86,a)),v.windows&&(l.windows=_.extract(v.windows,a)),v.osx&&(l.osx=_.extract(v.osx,a)),v.linux&&(l.linux=_.extract(v.linux,a)),l}static platformAdapterExecutable(E,a){let l=Object.create(null);a=a.toLowerCase();for(const c of E)if(c.contributes){const f=c.contributes.debuggers;f&&f.length>0&&f.filter(h=>typeof h.type=="string"&&C.equalsIgnoreCase(h.type,a)).forEach(h=>{const b=_.extract(h,c.extensionLocation.fsPath);l=y.mixin(l,b,c.isBuiltin)})}let v;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=l.winx86||l.win||l.windows:P.isWindows?v=l.win||l.windows:P.isMacintosh?v=l.osx:P.isLinux&&(v=l.linux),v=v||l;let t=v.program||l.program;const r=v.args||l.args;let s=v.runtime||l.runtime;const i=v.runtimeArgs||l.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[211],ge([0,1,39,11,29,188]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(d,m){return new Promise((u,p)=>{let _="";const T=g.spawn(d,m);T.pid&&T.stdout.on("data",E=>{_+=E.toString()}),T.on("error",E=>{p(E)}),T.on("close",E=>{u(_)})})}let C;function y(d,m){if(!C)if(L.isWindows)C=new D.WindowsExternalTerminalService;else if(L.isMacintosh)C=new D.MacExternalTerminalService;else if(L.isLinux)C=new D.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const u=m.getConfiguration("terminal");return C.runInTerminal(d.title,d.cwd,d.args,d.env||{},u.external||{})}e.runInExternalTerminal=y;function P(d){return d?L.isWindows?new Promise(async m=>{(await new Promise((p,_)=>{Y(["windows-process-tree"],p,_)})).getProcessTree(d,p=>{m(p.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(d)]).then(m=>{const u=m.trim();return!(u.length===0||u.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var n;(function(d){d[d.cmd=0]="cmd",d[d.powershell=1]="powershell",d[d.bash=2]="bash"})(n||(n={}));function I(d,m,u,p){d=d.trim().toLowerCase();let _;d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0?_=1:d.indexOf("cmd.exe")>=0?_=0:d.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let T,E=" ";switch(_){case 1:if(T=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),u){const l=(0,k.getDriveLetter)(u);l&&(E+=`${l}:; `),E+=`cd ${T(u)}; `}if(p)for(let l in p){const v=p[l];v===null?E+=`Remove-Item env:${l}; `:E+=`\${env:${l}}='${v}'; `}if(m.length>0){const l=T(m.shift());E+=l[0]==="'"?`& ${l} `:`${l} `;for(let v of m)E+=`${T(v)} `}break;case 0:if(T=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),u){const l=(0,k.getDriveLetter)(u);l&&(E+=`${l}: && `),E+=`cd ${T(u)} && `}if(p){E+='cmd /C "';for(let l in p){let v=p[l];v===null?E+=`set "${l}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${l}=${v}" && `)}}for(let l of m)E+=`${T(l)} `;p&&(E+='"');break;case 2:T=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const a=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(u&&(E+=`cd ${T(u)} ; `),p){E+="/usr/bin/env";for(let l in p){const v=p[l];v===null?E+=` -u ${a(l)}`:E+=` ${a(`${l}=${v}`)}`}E+=" "}for(let l of m)E+=`${T(l)} `;break}return E}e.prepareCommand=I}),define(me[127],ge([0,1,30,102,10,8,11,61]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var _;(function(o){o.scheme=k.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function R(N,x){return N.with({scheme:o.scheme,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generate=R;function O(N){if(N.scheme!==o.scheme)return;const x=w.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parse=O;function $(N){if(N.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const x=w.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=$;function K(N,x,F){return N.with({scheme:F,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generateCellUri=K;function G(N,x){if(N.scheme!==x)return;const F=w.exec(N.fragment);return F?{handle:Number(F[1]),notebook:N.with({scheme:N.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellUri=G})(_=e.CellUri||(e.CellUri={}));const T=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(o){return T.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function a(o){return T.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function l(o){return T.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=l;function v(o,w){return A.isWindows&&(o=o.replace(/\//g,"\\"),w=w.replace(/\//g,"\\")),g.match(o,w)}function t(o,w,R){let O=0;for(let $=0;$<w.length;$++){if(v(w[$],o))return O;O++}for(let $=0;$<R.length;$++){if(v(R[$],o))return O;O++}return O}function r(o,w,R){return o.sort((O,$)=>t(O,w,R)-t($,w,R))}e.sortMimeTypes=r;function s(o,w,R,O=($,K)=>$===K){const $=[];function K(x,F,V){if(F===0&&V.length===0)return;const M=$[$.length-1];M&&M.start+M.deleteCount===x?(M.deleteCount+=F,M.toInsert.push(...V)):$.push({start:x,deleteCount:F,toInsert:V})}let G=0,N=0;for(;;){if(G===o.length){K(G,0,w.slice(N));break}if(N===w.length){K(G,o.length-G,[]);break}const x=o[G],F=w[N];if(O(x,F)){G+=1,N+=1;continue}R(F)?(K(G,1,[]),G+=1):(K(G,0,[F]),N+=1)}return $}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const w=o;return!!((typeof w.include=="string"||g.isRelativePattern(w.include))&&(typeof w.exclude=="string"||g.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=c;function f(o,w,R){if(Array.isArray(o.viewType)&&o.viewType.indexOf(w)>=0||o.viewType===w)return!0;if(o.filenamePattern){let O=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,$=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(g.match(O,(0,D.basename)(R.fsPath).toLowerCase()))return!($&&g.match($,(0,D.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class h{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)w[R]=this.textModel.cells[R].getHashValue();return w}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(w){return`${S._prefix}${w}`}static parse(w){if(w.startsWith(S._prefix))return w.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(me[212],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState",k[k.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(me[213],ge([0,1,177,4,61]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[214],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(me[128],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var D;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(D=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(I,d)=>{d.expand!==void 0&&(I.expand=d.expand),d.item!==void 0&&(I.item=I.item?Object.assign(I.item,d.item):d.item)};e.applyTestItemUpdate=A;var C;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(d){}update(d){}remove(d,m){}complete(){}}e.IncrementalChangeCollector=P;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(d){const m=this.createChangeCollector();for(const u of d)switch(u[0]){case 0:{const p=u[1];if(p.parent){if(this.items.has(p.parent)){const _=this.items.get(p.parent);_.children.add(p.item.extId);const T=this.createItem(p,_);this.items.set(p.item.extId,T),m.add(T)}}else{const _=this.createItem(p);this.roots.add(_),this.items.set(p.item.extId,_),m.add(_)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=u[1],_=this.items.get(p.extId);if(!_)break;p.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,p),m.update(_);break}case 2:{const p=this.items.get(u[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const _=[[u[1]]];for(;_.length;)for(const T of _.pop()){const E=this.items.get(T);E&&(_.push(E.children),this.items.delete(T),m.remove(E,E!==p),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break}m.complete()}retireTest(d){}updatePendingRoots(d){this.pendingRootCount+=d}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=n}),define(me[90],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(D){D.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class k{constructor(A,C=A.length){if(this.path=A,this.viewEnd=C,A.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,C,y=A.parent){if(A.id===C)return new k([C]);let P=[A.id];for(let n=y;n&&n.id!==C;n=n.parent)P.push(n.id);return P.push(C),new k(P.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new k(A.split("\0"))}static join(A,C){return new k([...A.path,C])}static joinToString(A,C){return A.toString()+"\0"+C}static compare(A,C){return A===C?0:C.startsWith(A+"\0")?2:A.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new k(this.path,A)}compare(A){if(typeof A=="string")return k.compare(this.toString(),A);for(let C=0;C<A.viewEnd&&C<this.viewEnd;C++)if(A.path[C]!==this.path[C])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=k}),define(me[215],ge([0,1,8,38,14,23,11,79,178]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,d,m){this._contributedVariables=new Map,this._context=I,this._labelService=d,m&&(this._envVariablesPromise=m.then(u=>this.prepareEnv(u)))}prepareEnv(I){if(A.isWindows){const d=Object.create(null);return Object.keys(I).forEach(m=>{d[m.toLowerCase()]=I[m]}),d}return I}resolveWithEnvironment(I,d,m){return this.recursiveResolve(this.prepareEnv(I),d?d.uri:void 0,m)}async resolveAsync(I,d){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d)}async resolveAnyBase(I,d,m,u){const p=D.deepClone(d);return A.isWindows&&p.windows?Object.keys(p.windows).forEach(_=>p[_]=p.windows[_]):A.isMacintosh&&p.osx?Object.keys(p.osx).forEach(_=>p[_]=p.osx[_]):A.isLinux&&p.linux&&Object.keys(p.linux).forEach(_=>p[_]=p.linux[_]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,p,m,u)}async resolveAnyAsync(I,d,m){return this.resolveAnyBase(I,d,m)}async resolveAnyMap(I,d,m){const u=new Map;return{newConfig:await this.resolveAnyBase(I,d,m,u),resolvedVariables:u}}resolveWithInteractionReplace(I,d,m,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,d,m,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,d){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,d)}recursiveResolve(I,d,m,u,p){if(k.isString(m))return this.resolveString(I,d,m,u,p);if(k.isArray(m))return m.map(_=>this.recursiveResolve(I,d,_,u,p));if(k.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(T=>{const E=this.resolveString(I,d,T,u,p);_[E]=this.recursiveResolve(I,d,m[T],u,p)}),_}return m}resolveString(I,d,m,u,p){return m.replace(P.VARIABLE_REGEXP,(T,E)=>{if(E.includes(P.VARIABLE_LHS))return T;let a=this.evaluateSingleVariable(I,T,E,d,u);return p&&p.set(E,a),a!==T&&k.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(I,d,a,u,p)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,d,m,u,p){let _;const T=m.split(":");T.length>1&&(m=T[0],_=T[1]);const E=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,y.localize)(0,null,d))},a=()=>{const v=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,d,g.basename(v)))},l=()=>{if(_){const v=this._context.getFolderUri(_);if(v)return v;throw new Error((0,y.localize)(2,null,d,_))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,d)):new Error((0,y.localize)(4,null,d))};switch(m){case"env":if(_){if(I){const v=I[A.isWindows?_.toLowerCase():_];if(k.isString(v))return v}return""}throw new Error((0,y.localize)(5,null,d));case"config":if(_){const v=this._context.getConfigurationValue(u,_);if(k.isUndefinedOrNull(v))throw new Error((0,y.localize)(6,null,d,_));if(k.isObject(v))throw new Error((0,y.localize)(7,null,d,_));return v}throw new Error((0,y.localize)(8,null,d));case"command":return this.resolveFromMap(d,_,p,"command");case"input":return this.resolveFromMap(d,_,p,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return u||_?(0,C.normalizeDriveLetter)(this.fsPath(l())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(l()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,y.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return a();case"relativeFile":return u||_?g.relative(this.fsPath(l()),E()):E();case"relativeFileDirname":const r=g.dirname(E());if(u||_){const f=g.relative(this.fsPath(l()),r);return f.length===0?".":f}return r;case"fileDirname":return g.dirname(E());case"fileExtname":return g.extname(E());case"fileBasename":return g.basename(E());case"fileBasenameNoExtension":const s=g.basename(E());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||d;case"execInstallFolder":const c=this._context.getAppRoot();return c||d;case"pathSeparator":return g.sep;default:try{const f=_?`${m}:${_}`:m;return this.resolveFromMap(d,f,p,void 0)}catch(f){return d}}}}resolveFromMap(I,d,m,u){if(d&&m){const p=u===void 0?m[d]:m[u+":"+d];if(typeof p=="string")return p;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[129],ge([0,1,4,207]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var D;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var C;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const _=p;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=P;var n;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(p){p[p.GROUP_ACTIVE=0]="GROUP_ACTIVE",p[p.GROUP_INDEX=1]="GROUP_INDEX",p[p.EDITOR_OPEN=2]="EDITOR_OPEN",p[p.EDITOR_CLOSE=3]="EDITOR_CLOSE",p[p.EDITOR_MOVE=4]="EDITOR_MOVE",p[p.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",p[p.EDITOR_LABEL=6]="EDITOR_LABEL",p[p.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",p[p.EDITOR_PIN=8]="EDITOR_PIN",p[p.EDITOR_STICKY=9]="EDITOR_STICKY",p[p.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var d;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(d=e.OpenEditorContext||(e.OpenEditorContext={}));function m(p){const _=p;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=m;function u(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(me[216],ge([0,1,4,129]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(D){const A=D;return typeof D=="number"||(0,L.isEditorGroup)(A)}e.isPreferredGroup=k}),define(me[15],ge([0,1,20,22,99,291,59,23,14,2,41,83,179,116,88,127,90,216,7]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(oe){function Ee(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Ie,positionLineNumber:Ye,positionColumn:Xe}=j,ot=new E.Position(Ae-1,Ie-1),_t=new E.Position(Ye-1,Xe-1);return new E.Selection(ot,_t)}oe.to=Ee;function ue(j){const{anchor:Ae,active:Ie}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}oe.from=ue})(a=e.Selection||(e.Selection={}));var l;(function(oe){function Ee(j){if(!j)return;const{start:Ae,end:Ie}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}oe.from=Ee;function ue(j){if(!j)return;const{startLineNumber:Ae,startColumn:Ie,endLineNumber:Ye,endColumn:Xe}=j;return new E.Range(Ae-1,Ie-1,Ye-1,Xe-1)}oe.to=ue})(l=e.Range||(e.Range={}));var v;(function(oe){function Ee(ue){switch(ue){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}oe.to=Ee})(v=e.TokenType||(e.TokenType={}));var t;(function(oe){function Ee(j){return new E.Position(j.lineNumber-1,j.column-1)}oe.to=Ee;function ue(j){return{lineNumber:j.line+1,column:j.character+1}}oe.from=ue})(t=e.Position||(e.Position={}));var r;(function(oe){function Ee(j){switch(j){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}oe.from=Ee;function ue(j){switch(j){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}oe.to=ue})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(oe){function Ee(j){let Ae;return j.code&&((0,y.isString)(j.code)||(0,y.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),{...l.from(j.range),message:j.message,source:j.source,code:Ae,severity:c.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(i.from),tags:Array.isArray(j.tags)?(0,g.coalesce)(j.tags.map(r.from)):void 0}}oe.from=Ee;function ue(j){const Ae=new E.Diagnostic(l.to(j),j.message,c.to(j.severity));return Ae.source=j.source,Ae.code=(0,y.isString)(j.code)?j.code:j.code?.value,Ae.relatedInformation=j.relatedInformation&&j.relatedInformation.map(i.to),Ae.tags=j.tags&&(0,g.coalesce)(j.tags.map(r.to)),Ae}oe.to=ue})(s=e.Diagnostic||(e.Diagnostic={}));var i;(function(oe){function Ee(j){return{...l.from(j.location.range),message:j.message,resource:j.location.uri}}oe.from=Ee;function ue(j){return new E.DiagnosticRelatedInformation(new E.Location(j.resource,l.to(j)),j.message)}oe.to=ue})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(oe){function Ee(j){switch(j){case E.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}oe.from=Ee;function ue(j){switch(j){case m.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}oe.to=ue})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(oe){function Ee(j){return typeof j=="number"&&j>=E.ViewColumn.One?j-1:j===E.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}oe.from=Ee;function ue(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}oe.to=ue})(f=e.ViewColumn||(e.ViewColumn={}));function h(oe){return typeof oe.range!="undefined"}function b(oe){return oe.length===0?!0:!!h(oe[0])}e.isDecorationOptionsArr=b;var S;(function(oe){function Ee(Xe){return Xe.map(oe.from)}oe.fromMany=Ee;function ue(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function j(Xe){let ot;if(ue(Xe)){const{language:mt,value:ht}=Xe;ot={value:"```"+mt+`
`+ht+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?ot={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?ot={value:Xe}:ot={value:""};const _t=Object.create(null);ot.uris=_t;const vt=mt=>{try{let ht=P.URI.parse(mt,!0);ht=ht.with({query:Ae(ht.query,_t)}),_t[mt]=ht}catch(ht){}return""},gt=new D.Renderer;return gt.link=vt,gt.image=mt=>vt(k.parseHrefAndDimensions(mt).href),D(ot.value,{renderer:gt}),ot}oe.from=j;function Ae(Xe,ot){if(!Xe)return Xe;let _t;try{_t=(0,A.parse)(Xe)}catch(gt){}if(!_t)return Xe;let vt=!1;return _t=(0,C.cloneAndChange)(_t,gt=>{if(P.URI.isUri(gt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[mt]=gt,vt=!0,mt}else return}),vt?JSON.stringify(_t):Xe}function Ie(Xe){const ot=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return ot.isTrusted=Xe.isTrusted,ot}oe.to=Ie;function Ye(Xe){if(!!Xe)return typeof Xe=="string"?Xe:oe.from(Xe)}oe.fromStrict=Ye})(S=e.MarkdownString||(e.MarkdownString={}));function o(oe){return b(oe)?oe.map(Ee=>({range:l.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?S.fromMany(Ee.hoverMessage):Ee.hoverMessage?S.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):oe.map(Ee=>({range:l.from(Ee)}))}e.fromRangeOrRangeWithMessage=o;function w(oe){return typeof oe=="undefined"?oe:typeof oe=="string"?P.URI.file(oe):oe}e.pathOrURIToURI=w;var R;(function(oe){function Ee(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?w(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}oe.from=Ee})(R=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(oe){function Ee(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?w(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?R.from(ue.before):void 0,after:ue.after?R.from(ue.after):void 0}}oe.from=Ee})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(oe){function Ee(ue){if(typeof ue=="undefined")return ue;switch(ue){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}oe.from=Ee})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(oe){function Ee(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?$.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?O.from(ue.light):void 0,dark:ue.dark?O.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?w(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?R.from(ue.before):void 0,after:ue.after?R.from(ue.after):void 0}}oe.from=Ee})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(oe){function Ee(j){return{text:j.newText,eol:j.newEol&&te.from(j.newEol),range:l.from(j.range)}}oe.from=Ee;function ue(j){const Ae=new E.TextEdit(l.to(j.range),j.text);return Ae.newEol=typeof j.eol=="undefined"?void 0:te.to(j.eol),Ae}oe.to=ue})(G=e.TextEdit||(e.TextEdit={}));var N;(function(oe){function Ee(j,Ae,Ie){const Ye={edits:[]};if(j instanceof E.WorkspaceEdit)for(let Xe of j._allEntries())if(Xe._type===1)Ye.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Ae?.getDocument(Xe.uri);Ye.edits.push({_type:2,resource:Xe.uri,edit:G.from(Xe.edit),modelVersionId:ot?.version,metadata:Xe.metadata})}else Xe._type===3?Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Ie?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Ge.from)}});return Ye}oe.from=Ee;function ue(j){const Ae=new E.WorkspaceEdit;for(const Ie of j.edits)Ie.edit?Ae.replace(P.URI.revive(Ie.resource),l.to(Ie.edit.range),Ie.edit.text):Ae.renameFile(P.URI.revive(Ie.oldUri),P.URI.revive(Ie.newUri),Ie.options);return Ae}oe.to=ue})(N=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(oe){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ue(Ae){return typeof Ee[Ae]=="number"?Ee[Ae]:6}oe.from=ue;function j(Ae){for(const Ie in Ee)if(Ee[Ie]===Ae)return Number(Ie);return E.SymbolKind.Property}oe.to=j})(x=e.SymbolKind||(e.SymbolKind={}));var F;(function(oe){function Ee(j){switch(j){case E.SymbolTag.Deprecated:return 1}}oe.from=Ee;function ue(j){switch(j){case 1:return E.SymbolTag.Deprecated}}oe.to=ue})(F=e.SymbolTag||(e.SymbolTag={}));var V;(function(oe){function Ee(j){return{name:j.name,kind:x.from(j.kind),tags:j.tags&&j.tags.map(F.from),containerName:j.containerName,location:X.from(j.location)}}oe.from=Ee;function ue(j){const Ae=new E.SymbolInformation(j.name,x.to(j.kind),j.containerName,X.to(j.location));return Ae.tags=j.tags&&j.tags.map(F.to),Ae}oe.to=ue})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(oe){function Ee(j){const Ae={name:j.name||"!!MISSING: name!!",detail:j.detail,range:l.from(j.range),selectionRange:l.from(j.selectionRange),kind:x.from(j.kind),tags:j.tags?.map(F.from)??[]};return j.children&&(Ae.children=j.children.map(Ee)),Ae}oe.from=Ee;function ue(j){const Ae=new E.DocumentSymbol(j.name,j.detail,x.to(j.kind),l.to(j.range),l.to(j.selectionRange));return(0,g.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(F.to)),j.children&&(Ae.children=j.children.map(ue)),Ae}oe.to=ue})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(oe){function Ee(j){const Ae=new E.CallHierarchyItem(x.to(j.kind),j.name,j.detail||"",P.URI.revive(j.uri),l.to(j.range),l.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}oe.to=Ee;function ue(j,Ae,Ie){if(Ae=Ae??j._sessionId,Ie=Ie??j._itemId,Ae===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ie,name:j.name,detail:j.detail,kind:x.from(j.kind),uri:j.uri,range:l.from(j.range),selectionRange:l.from(j.selectionRange),tags:j.tags?.map(F.from)}}oe.from=ue})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(oe){function Ee(ue){return new E.CallHierarchyIncomingCall(U.to(ue.from),ue.fromRanges.map(j=>l.to(j)))}oe.to=Ee})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(oe){function Ee(ue){return new E.CallHierarchyOutgoingCall(U.to(ue.to),ue.fromRanges.map(j=>l.to(j)))}oe.to=Ee})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var X;(function(oe){function Ee(j){return{range:j.range&&l.from(j.range),uri:j.uri}}oe.from=Ee;function ue(j){return new E.Location(P.URI.revive(j.uri),l.to(j.range))}oe.to=ue})(X=e.location||(e.location={}));var Z;(function(oe){function Ee(j){const Ae=j,Ie=j;return{originSelectionRange:Ae.originSelectionRange?l.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ie.uri,range:l.from(Ae.targetRange?Ae.targetRange:Ie.range),targetSelectionRange:Ae.targetSelectionRange?l.from(Ae.targetSelectionRange):void 0}}oe.from=Ee;function ue(j){return{targetUri:P.URI.revive(j.uri),targetRange:l.to(j.range),targetSelectionRange:j.targetSelectionRange?l.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?l.to(j.originSelectionRange):void 0}}oe.to=ue})(Z=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(oe){function Ee(j){return{range:l.from(j.range),contents:S.fromMany(j.contents)}}oe.from=Ee;function ue(j){return new E.Hover(j.contents.map(S.to),l.to(j.range))}oe.to=ue})(fe=e.Hover||(e.Hover={}));var _e;(function(oe){function Ee(j){return{range:l.from(j.range),expression:j.expression}}oe.from=Ee;function ue(j){return new E.EvaluatableExpression(l.to(j.range),j.expression)}oe.to=ue})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(oe){function Ee(j){if(j instanceof E.InlineValueText)return{type:"text",range:l.from(j.range),text:j.text};if(j instanceof E.InlineValueVariableLookup)return{type:"variable",range:l.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}oe.from=Ee;function ue(j){switch(j.type){case"text":return{range:l.to(j.range),text:j.text};case"variable":return{range:l.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:l.to(j.range),expression:j.expression}}}oe.to=ue})(De=e.InlineValue||(e.InlineValue={}));var Le;(function(oe){function Ee(j){return{frameId:j.frameId,stoppedLocation:l.from(j.stoppedLocation)}}oe.from=Ee;function ue(j){return new E.InlineValueContext(j.frameId,l.to(j.stoppedLocation))}oe.to=ue})(Le=e.InlineValueContext||(e.InlineValueContext={}));var qe;(function(oe){function Ee(j){return{range:l.from(j.range),kind:j.kind}}oe.from=Ee;function ue(j){return new E.DocumentHighlight(l.to(j.range),j.kind)}oe.to=ue})(qe=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(oe){function Ee(ue){switch(ue){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}oe.to=Ee})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(oe){function Ee(ue){return{triggerKind:xe.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}oe.to=Ee})(Ke=e.CompletionContext||(e.CompletionContext={}));var H;(function(oe){function Ee(j){switch(j){case E.CompletionItemTag.Deprecated:return 1}}oe.from=Ee;function ue(j){switch(j){case 1:return E.CompletionItemTag.Deprecated}}oe.to=ue})(H=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(oe){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ue(Ie){return Ee.get(Ie)??9}oe.from=ue;const j=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Ae(Ie){return j.get(Ie)??E.CompletionItemKind.Property}oe.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(oe){function Ee(ue,j){const Ae=new E.CompletionItem(ue.label);return Ae.insertText=ue.insertText,Ae.kind=ee.to(ue.kind),Ae.tags=ue.tags?.map(H.to),Ae.detail=ue.detail,Ae.documentation=k.isMarkdownString(ue.documentation)?S.to(ue.documentation):ue.documentation,Ae.sortText=ue.sortText,Ae.filterText=ue.filterText,Ae.preselect=ue.preselect,Ae.commitCharacters=ue.commitCharacters,n.Range.isIRange(ue.range)?Ae.range=l.to(ue.range):typeof ue.range=="object"&&(Ae.range={inserting:l.to(ue.range.insert),replacing:l.to(ue.range.replace)}),Ae.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Ae.insertText=new E.SnippetString(ue.insertText):(Ae.insertText=ue.insertText,Ae.textEdit=Ae.range instanceof E.Range?new E.TextEdit(Ae.range,Ae.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ue.additionalTextEdits.map(Ie=>G.to(Ie))),Ae.command=j&&ue.command?j.fromInternal(ue.command):void 0,Ae}oe.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var le;(function(oe){function Ee(j){return{label:j.label,documentation:j.documentation?S.fromStrict(j.documentation):void 0}}oe.from=Ee;function ue(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?S.to(j.documentation):j.documentation}}oe.to=ue})(le=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(oe){function Ee(j){return{label:j.label,documentation:j.documentation?S.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map(le.from):[],activeParameter:j.activeParameter}}oe.from=Ee;function ue(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?S.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(le.to):[],activeParameter:j.activeParameter}}oe.to=ue})(J=e.SignatureInformation||(e.SignatureInformation={}));var ae;(function(oe){function Ee(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(J.from):[]}}oe.from=Ee;function ue(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(J.to):[]}}oe.to=ue})(ae=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(oe){function Ee(j){return{text:j.text,position:t.from(j.position),kind:Fe.from(j.kind??E.InlayHintKind.Other),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}oe.from=Ee;function ue(j){const Ae=new E.InlayHint(j.text,t.to(j.position),Fe.to(j.kind));return Ae.whitespaceAfter=j.whitespaceAfter,Ae.whitespaceBefore=j.whitespaceBefore,Ae}oe.to=ue})(ve=e.InlayHint||(e.InlayHint={}));var Fe;(function(oe){function Ee(j){return j}oe.from=Ee;function ue(j){return j}oe.to=ue})(Fe=e.InlayHintKind||(e.InlayHintKind={}));var je;(function(oe){function Ee(j){return{range:l.from(j.range),url:j.target,tooltip:j.tooltip}}oe.from=Ee;function ue(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?P.URI.parse(j.url,!0):P.URI.revive(j.url)}catch(Ie){}return new E.DocumentLink(l.to(j.range),Ae)}oe.to=ue})(je=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(oe){function Ee(j){const Ae=new E.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=G.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Ie=>G.to(Ie))),Ae}oe.to=Ee;function ue(j){return{label:j.label,textEdit:j.textEdit?G.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>G.from(Ae)):void 0}}oe.from=ue})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(oe){function Ee(j){return new E.Color(j[0],j[1],j[2],j[3])}oe.to=Ee;function ue(j){return[j.red,j.green,j.blue,j.alpha]}oe.from=ue})(et=e.Color||(e.Color={}));var ke;(function(oe){function Ee(j){return{range:l.from(j.range)}}oe.from=Ee;function ue(j){return new E.SelectionRange(l.to(j.range))}oe.to=ue})(ke=e.SelectionRange||(e.SelectionRange={}));var ct;(function(oe){function Ee(ue){switch(ue){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}oe.to=Ee})(ct=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(oe){function Ee(j){switch(j){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}oe.from=Ee;function ue(j){switch(j){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}oe.to=ue})(Q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(oe){function Ee(j){if(j===E.EndOfLine.CRLF)return 1;if(j===E.EndOfLine.LF)return 0}oe.from=Ee;function ue(j){if(j===1)return E.EndOfLine.CRLF;if(j===0)return E.EndOfLine.LF}oe.to=ue})(te=e.EndOfLine||(e.EndOfLine={}));var pe;(function(oe){function Ee(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}oe.from=Ee})(pe=e.ProgressLocation||(e.ProgressLocation={}));var He;(function(oe){function Ee(ue){const j={start:ue.start+1,end:ue.end+1};return ue.kind&&(j.kind=tt.from(ue.kind)),j}oe.from=Ee})(He=e.FoldingRange||(e.FoldingRange={}));var tt;(function(oe){function Ee(ue){if(ue)switch(ue){case E.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}oe.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(oe){function Ee(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?l.from(ue.selection):void 0,override:typeof ue.override=="boolean"?d.EditorResolution.DISABLED:void 0}}oe.from=Ee})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var lt;(function(oe){function Ee(j){return j instanceof E.RelativePattern||typeof j=="string"?j:ue(j)?new E.RelativePattern(j.base,j.pattern):j}oe.from=Ee;function ue(j){const Ae=j;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(lt=e.GlobPattern||(e.GlobPattern={}));var wt;(function(oe){function Ee(ue){if(ue){if(Array.isArray(ue))return ue.map(Ee);if(typeof ue=="string")return ue;{const j=ue;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:lt.from(j.pattern),exclusive:j.exclusive}}}else return}oe.from=Ee})(wt=e.LanguageSelector||(e.LanguageSelector={}));var Ct;(function(oe){function Ee(j){return{start:j.start,end:j.end}}oe.from=Ee;function ue(j){return new E.NotebookRange(j.start,j.end)}oe.to=ue})(Ct=e.NotebookRange||(e.NotebookRange={}));var ce;(function(oe){function Ee(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}oe.to=Ee;function ue(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}oe.from=ue})(ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Pe;(function(oe){function Ee(j){switch(j){case E.NotebookCellKind.Markup:return p.CellKind.Markup;case E.NotebookCellKind.Code:default:return p.CellKind.Code}}oe.from=Ee;function ue(j){switch(j){case p.CellKind.Markup:return E.NotebookCellKind.Markup;case p.CellKind.Code:default:return E.NotebookCellKind.Code}}oe.to=ue})(Pe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ne;(function(oe){function Ee(j){const Ae={metadata:j.metadata??Object.create(null),cells:[]};for(let Ie of j.cells)E.NotebookCellData.validate(Ie),Ae.cells.push(Ge.from(Ie));return Ae}oe.from=Ee;function ue(j){const Ae=new E.NotebookData(j.cells.map(Ge.to));return(0,y.isEmptyObject)(j.metadata)||(Ae.metadata=j.metadata),Ae}oe.to=ue})(Ne=e.NotebookData||(e.NotebookData={}));var Ge;(function(oe){function Ee(j){return{cellKind:Pe.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:ce.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(at.from):[]}}oe.from=Ee;function ue(j){return new E.NotebookCellData(Pe.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(at.to):void 0,j.metadata,j.internalMetadata?ce.to(j.internalMetadata):void 0)}oe.to=ue})(Ge=e.NotebookCellData||(e.NotebookCellData={}));var $e;(function(oe){function Ee(j){return{mime:j.mime,valueBytes:L.VSBuffer.wrap(j.data)}}oe.from=Ee;function ue(j){return new E.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}oe.to=ue})($e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(oe){function Ee(j){return{outputId:j.id,items:j.items.map($e.from),metadata:j.metadata}}oe.from=Ee;function ue(j){const Ae=j.items.map($e.to);return new E.NotebookCellOutput(Ae,j.outputId,j.metadata)}oe.to=ue})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Re;(function(oe){function Ee(Ie){if(Ie!=null){if(Ie instanceof E.RelativePattern||typeof Ie=="string")return Ie;if(Ae(Ie))return new E.RelativePattern(Ie.base,Ie.pattern);if(j(Ie))return{include:lt.from(Ie.include)||void 0,exclude:lt.from(Ie.exclude)||void 0}}}oe.from=Ee;function ue(Ie){return typeof Ie=="string"?Ie:Ae(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}oe.to=ue;function j(Ie){const Ye=Ie,Xe=lt.from(Ye.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const ot=lt.from(Ye.exclude);return!!(ot&&ot instanceof E.RelativePattern||typeof ot=="string")}function Ae(Ie){const Ye=Ie;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Re=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Se;(function(oe){function Ee(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?R.from(ue.top):void 0}}oe.from=Ee})(Se=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ce;(function(oe){function Ee(ue,j,Ae){const Ie=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Ie,Ae),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}oe.from=Ee})(Ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(oe){function Ee(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{}}}oe.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(oe){function Ee(j){return{uri:j.uri,provides:j.provides}}oe.from=Ee;function ue(j){return new E.NotebookRendererScript(P.URI.revive(j.uri),j.provides)}oe.to=ue})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(oe){function Ee(j){return{message:S.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location?X.from(j.location):void 0}}oe.from=Ee;function ue(j){const Ae=new E.TestMessage(typeof j.message=="string"?j.message:S.to(j.message));return Ae.actualOutput=j.actual,Ae.expectedOutput=j.expected,Ae}oe.to=ue})(be=e.TestMessage||(e.TestMessage={}));var we;(function(oe){let Ee;(function(j){j.Delimiter="\0"})(Ee||(Ee={})),oe.namespace=(j,Ae)=>j+"\0"+Ae;function ue(j,Ae){return{displayId:Ae.id,id:oe.namespace(j,Ae.id),label:Ae.label}}oe.display=ue,oe.denamespace=j=>{const Ae=j.indexOf("\0");return{ctrlId:j.slice(0,Ae),tagId:j.slice(Ae+1)}}})(we=e.TestTag||(e.TestTag={}));var Me;(function(oe){function Ee(Ie){const Ye=(0,u.getPrivateApiFor)(Ie).controllerId;return{extId:_.TestId.fromExtHostTestItem(Ie,Ye).toString(),label:Ie.label,uri:Ie.uri,tags:Ie.tags.map(Xe=>we.namespace(Ye,Xe.id)),range:l.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&S.fromStrict(Ie.error)||null}}oe.from=Ee;function ue(Ie){return{id:_.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:P.URI.revive(Ie.uri),tags:(Ie.tags||[]).map(Ye=>{const{tagId:Xe}=we.denamespace(Ye);return new E.TestTag(Xe,Xe)}),range:l.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}oe.toPlain=ue;function j(Ie){const Ye=_.TestId.fromString(Ie.extId),Xe=new u.TestItemImpl(Ye.controllerId,Ye.localId,Ie.label,P.URI.revive(Ie.uri));return Xe.range=l.to(Ie.range||void 0),Xe.description=Ie.description||void 0,Xe}function Ae(Ie){let Ye;for(const Xe of Ie.tests){const ot=j(Xe.item);(0,u.getPrivateApiFor)(ot).parent=Ye,Ye=ot}return Ye}oe.toItemFromContext=Ae})(Me=e.TestItem||(e.TestItem={})),function(oe){function Ee(j){return{id:j.id,label:j.label}}oe.from=Ee;function ue(j){return new E.TestTag(j.id,j.label)}oe.to=ue}(we=e.TestTag||(e.TestTag={}));var Ve;(function(oe){const Ee=(j,Ae)=>{const Ie={...Me.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:j.children.map(Ye=>Ae.get(Ye)).filter(y.isDefined).map(Ye=>Ee(Ye,Ae))};for(const Ye of Ie.children)Ye.parent=Ie;return Ie};function ue(j){const Ae=[],Ie=new Map;for(const Ye of j.items)Ie.set(Ye.item.extId,Ye),j.request.targets.some(Xe=>Xe.controllerId===Ye.controllerId&&Xe.testIds.includes(Ye.item.extId))&&Ae.push(Ye);return{completedAt:j.completedAt,results:Ae.map(Ye=>Ee(Ye,Ie))}}oe.to=ue})(Ve=e.TestResults||(e.TestResults={}));var We;(function(oe){function Ee(Ie){return{covered:Ie.covered,total:Ie.covered}}function ue(Ie){return"line"in Ie?t.from(Ie):l.from(Ie)}function j(Ie){return"branches"in Ie?{count:Ie.executionCount,location:ue(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&ue(Ye.location)})):void 0}:{type:0,count:Ie.executionCount,location:ue(Ie.location)}}oe.fromDetailed=j;function Ae(Ie){return{uri:Ie.uri,statement:Ee(Ie.statementCoverage),branch:Ie.branchCoverage&&Ee(Ie.branchCoverage),function:Ie.functionCoverage&&Ee(Ie.functionCoverage),details:Ie.detailedCoverage?.map(j)}}oe.fromFile=Ae})(We=e.TestCoverage||(e.TestCoverage={}));var Je;(function(oe){function Ee(ue){switch(ue){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}oe.to=Ee})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var nt;(function(oe){function Ee(j){const Ae=new E.TypeHierarchyItem(x.to(j.kind),j.name,j.detail||"",P.URI.revive(j.uri),l.to(j.range),l.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}oe.to=Ee;function ue(j,Ae,Ie){if(Ae=Ae??j._sessionId,Ie=Ie??j._itemId,Ae===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ie,kind:x.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:l.from(j.range),selectionRange:l.from(j.selectionRange),tags:j.tags?.map(F.from)}}oe.from=ue})(nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[217],ge([0,1,2,16,7,15,95]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,n,I,d={timeout:1500,errors:3}){this._logService=P,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=d,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(n,I,d)=>{const u={dispose:this._callbacks.push([n,I,P])};return Array.isArray(d)&&d.push(u),u}}async $participateInSave(P,n){const I=g.URI.revive(P);let d=!1;const m=setTimeout(()=>d=!0,this._thresholds.timeout),u=[];try{for(let p of[...this._callbacks]){if(d)break;const _=this._documents.getDocument(I),T=await this._deliverEventAsyncAndBlameBadListeners(p,{document:_,reason:D.TextDocumentSaveReason.to(n)});u.push(T)}}finally{clearTimeout(m)}return u}_deliverEventAsyncAndBlameBadListeners([P,n,I],d){const m=this._badListeners.get(P);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,n,d).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const p=this._badListeners.get(P);this._badListeners.set(P,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,n,I,d){const m=[],u=Date.now(),{document:p,reason:_}=d,{version:T}=p,E=Object.freeze({document:p,reason:_,waitUntil(a){if(Object.isFrozen(m))throw(0,L.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(a))}});try{n.apply(I,[E])}catch(a){return Promise.reject(a)}return Object.freeze(m),new Promise((a,l)=>{const v=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),a(t)}).catch(t=>{clearTimeout(v),l(t)})}).then(a=>{const l={edits:[]};for(const v of a)if(Array.isArray(v)&&v.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:r,range:s}of v)l.edits.push({_type:2,resource:p.uri,edit:{range:s&&D.Range.from(s),text:t,eol:r&&D.EndOfLine.from(r)}});if(l.edits.length!==0)return T===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[218],ge([0,1,3,30,2,15,7]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(n,I,d,m,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,d&&(this._config+=1),m&&(this._config+=2),u&&(this._config+=4);const p=(0,L.parse)(I),_=n(T=>{if(!d)for(let E of T.created){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidCreate.fire(a)}if(!m)for(let E of T.changed){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidChange.fire(a)}if(!u)for(let E of T.deleted){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,I,d){this._logService=I,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,I,d,m){return new C(this._onFileSystemEvent.event,n,I,d,m)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,I){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(d=>k.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(d=>k.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,I){return(d,m,u)=>{const p=function(T){d.call(m,T)};return p.extension=n,I.event(p,void 0,u)}}async $onWillRunFileOperation(n,I,d,m){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(u=>({oldUri:k.URI.revive(u.source),newUri:k.URI.revive(u.target)}))},d,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(u=>k.URI.revive(u.target))},d,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(u=>k.URI.revive(u.target))},d,m)}}async _fireWillEvent(n,I,d,m){const u=new Set,p=[];if(await n.fireAsync(I,m,async(T,E)=>{const a=Date.now(),l=await Promise.resolve(T);l instanceof A.WorkspaceEdit&&(p.push(l),u.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-a>d&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),m.isCancellationRequested||p.length===0)return;const _={edits:[]};for(let T of p){let{edits:E}=D.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(E)}return{edit:_,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=y}),define(me[219],ge([0,1,10,23,2,15,7,127]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(d,m,u,p){this.start=d,this.deletedCount=m,this.deletedItems=u,this.items=p}static asApiEvents(d){return d.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(u=>u.apiCell)}))}}class P{constructor(d,m,u){this.notebook=d,this._extHostDocument=m,this._cellData=u,this.handle=u.handle,this.uri=k.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(d,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return d._mime},set mime(u){d._mime=u},get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(D.NotebookCellOutput.to)}setOutputItems(d,m,u){const p=u.map(D.NotebookCellOutputItem.to),_=this._outputs.find(T=>T.id===d);_&&(m||(_.items.length=0),_.items.push(...p))}setMetadata(d){this._metadata=Object.freeze(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(d))}setMime(d){}}e.ExtHostCell=P;class n{constructor(d,m,u,p,_,T){this._proxy=d,this._textDocumentsAndEditors=m,this._textDocuments=u,this._emitter=p,this.uri=_,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get notebookType(){return d._notebookType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===g.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(m){return m=d._validateIndex(m),d._cells[m].apiCell},getCells(m){return(m?d._getCells(m):d._cells).map(p=>p.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=Object.freeze({...this._metadata,...d.metadata}))}acceptDirty(d){this._isDirty=d}acceptModelChanged(d,m){this._versionId=d.versionId,this._isDirty=m;for(const u of d.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===C.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let m=d.start|0,u=d.end|0;return m<0&&(m=0),u>this._cells.length&&(u=this._cells.length),d.with({start:m,end:u})}_getCells(d){d=this._validateRange(d);const m=[];for(let u=d.start;u<d.end;u++)m.push(this._cells[u]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,m){if(this._disposed)return;const u=[],p=[],_=[];d.reverse().forEach(T=>{const a=T[2].map(t=>{const r=new P(this,this._textDocumentsAndEditors,t);return m||p.push(P.asModelAddData(this.apiNotebook,t)),r}),l=new y(T[0],T[1],[],a),v=this._cells.splice(T[0],T[1],...a);for(const t of v)_.push(t.uri),l.deletedItems.push(t.apiCell);u.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:_}),m||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(u)}))}_moveCell(d,m){const u=this._cells.splice(d,1);this._cells.splice(m,0,...u);const p=[new y(d,1,u.map(_=>_.apiCell),[]),new y(m,0,[],u)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(p)}))}_setCellOutputs(d,m){const u=this._cells[d];u.setOutputs(m),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(d,m,u,p){const _=this._cells[d];_.setOutputItems(m,u,p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(d,m){const u=this._cells[d];u.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(u.uri,m)}_changeCellMime(d,m){const u=this._cells[d];u.apiCell.mime=m}_changeCellMetadata(d,m){const u=this._cells[d],p=u.apiCell.metadata;u.setMetadata(m);const _=u.apiCell.metadata;(0,L.equals)(p,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(d,m){const u=this._cells[d],p=u.internalMetadata;if(u.setInternalMetadata(m),p.runState!==m.runState){const _=m.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:_}))}}getCellFromApiCell(d){return this._cells.find(m=>m.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(m=>m.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[130],ge([0,1,7,15,16]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,n){this._throwIfFinalized(),!(y===P&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:n.map(L.NotebookCellData.from)})}}class A{constructor(y,P,n,I,d,m){this.id=y,this._proxy=P,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._visibleRanges=I,this._viewColumn=m}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,n){y._proxy.$tryRevealRange(y.id,L.NotebookRange.from(P),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const n=new D(this.document.version);return P(n),y._applyEdit(n.finalize())},setDecorations(P,n){return y.setDecorations(P,n)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(L.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let n=-1;for(let I=0;I<y.cellEdits.length;I++){if(n<0){P.push(y.cellEdits[I]),n++;continue}const m=P[n],u=y.cellEdits[I];if(m.editType===1&&u.editType===1&&m.index===u.index){m.cells.push(...y.cellEdits[I].cells),m.count+=y.cellEdits[I].count;continue}P.push(y.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(me[220],ge([0,1,15,119,166,21,56]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,d,m){const u=this._handles++,{title:p,location:_,cancellable:T}=d,E={label:(0,k.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(u,{location:g.ProgressLocation.from(_),title:p,source:E,cancellable:T},I),this._withProgress(u,m,!!T)}_withProgress(I,d,m){let u;m&&(u=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,u));const p=T=>{this._proxy.$progressEnd(T),this._mapHandleToCancellationSource.delete(T),u&&u.dispose()};let _;try{_=d(new P(this._proxy,I),m&&u?u.token:D.CancellationToken.None)}catch(T){throw p(I),T}return _.then(T=>p(I),T=>p(I)),_}$acceptProgressCanceled(I){const d=this._mapHandleToCancellationSource.get(I);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function y(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class P extends L.Progress{constructor(I,d){super(m=>this.throttledReport(m));this._proxy=I,this._handle=d}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}ze([(0,A.throttle)(100,(n,I)=>y(n,I),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[131],ge([0,1,54,16,75,15,7]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(d,m,u){const p=C._Keys.nextId();d.$registerTextEditorDecorationType(m.identifier,p,D.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:p,dispose(){d.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=C,C._Keys=new k.IdGenerator("TextEditorDecorationType");class y{constructor(d,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,m){this._throwIfFinalized();let u=null;if(d instanceof A.Position)u=new A.Range(d,d);else if(d instanceof A.Range)u=d;else throw new Error("Unrecognized location");this._pushEdit(u,m,!1)}insert(d,m){this._throwIfFinalized(),this._pushEdit(new A.Range(d,d),m,!0)}delete(d){this._throwIfFinalized();let m=null;if(d instanceof A.Range)m=d;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(d,m,u){const p=this._document.validateRange(d);this._collectedEdits.push({range:p,text:m,forceMoveMarkers:u})}setEndOfLine(d){if(this._throwIfFinalized(),d!==A.EndOfLine.LF&&d!==A.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=y;class P{constructor(d,m,u,p){this._proxy=d,this._id=m,this._accept(u),this._logService=p;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(T){_._setTabSize(T)},get insertSpaces(){return _._insertSpaces},set insertSpaces(T){_._setInsertSpaces(T)},get cursorStyle(){return _._cursorStyle},set cursorStyle(T){_._setCursorStyle(T)},get lineNumbers(){return _._lineNumbers},set lineNumbers(T){_._setLineNumbers(T)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=D.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const m=Math.floor(d);return m>0?m:null}if(typeof d=="string"){const m=parseInt(d,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(d){const m=this._validateTabSize(d);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const m=this._validateInsertSpaces(d);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:D.TextEditorLineNumbersStyle.from(d)})))}assign(d){const m={};let u=!1;if(typeof d.tabSize!="undefined"){const p=this._validateTabSize(d.tabSize);p==="auto"?(u=!0,m.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,u=!0,m.tabSize=p)}if(typeof d.insertSpaces!="undefined"){const p=this._validateInsertSpaces(d.insertSpaces);p==="auto"?(u=!0,m.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,u=!0,m.insertSpaces=p)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,u=!0,m.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,u=!0,m.lineNumbers=D.TextEditorLineNumbersStyle.from(d.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(d){d.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=P;class n{constructor(d,m,u,p,_,T,E,a){this.id=d,this._proxy=m,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,T,u),this._visibleRanges=E,this._viewColumn=a;const l=this;this.value=Object.freeze({get document(){return p.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,L.illegalArgument)("selection");l._selections=[v],l._trySetSelection()},get selections(){return l._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof A.Selection)))throw(0,L.illegalArgument)("selections");l._selections=v,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return l._options.value},set options(v){l._disposed||l._options.assign(v)},get viewColumn(){return l._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(p.getValue(),t);return v(r),l._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=l._selections.map(i=>D.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:c}=D.Position.from(t);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof A.Range)s=[D.Range.from(t)];else{s=[];for(const i of t)if(i instanceof A.Range)s.push(D.Range.from(i));else{const{lineNumber:c,column:f}=D.Position.from(i);s.push({startLineNumber:c,startColumn:f,endLineNumber:c,endColumn:f})}}return m.$tryInsertSnippet(d,v.value,s,r)},setDecorations(v,t){const r=t.length===0;r&&!l._hasDecorationsForKey.has(v.key)||(r?l._hasDecorationsForKey.delete(v.key):l._hasDecorationsForKey.add(v.key),l._runOnProxy(()=>{if(D.isDecorationOptionsArr(t))return m.$trySetDecorations(d,v.key,D.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const f=t[i];s[4*i]=f.start.line+1,s[4*i+1]=f.start.character+1,s[4*i+2]=f.end.line+1,s[4*i+3]=f.end.character+1}return m.$trySetDecorationsFast(d,v.key,s)}}))},revealRange(v,t){l._runOnProxy(()=>m.$tryRevealRange(d,D.Range.from(v),t||A.TextEditorRevealType.Default))},show(v){m.$tryShowEditor(d,D.ViewColumn.from(v))},hide(){m.$tryHideEditor(d)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,g.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,g.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,g.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,g.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(D.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const m=d.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const u=m.edits.map(_=>_.range);u.sort((_,T)=>_.end.line===T.end.line?_.end.character===T.end.character?_.start.line===T.start.line?_.start.character-T.start.character:_.start.line-T.start.line:_.end.character-T.end.character:_.end.line-T.end.line);for(let _=0,T=u.length-1;_<T;_++){const E=u[_].end;if(u[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=m.edits.map(_=>({range:D.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,p,{setEndOfLine:typeof m.setEndOfLine=="number"?D.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=n}),define(me[221],ge([0,1,169,25,2,3,6,208,17,7,14,20,15,21,205]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,a){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let l;return Array.isArray(E.highlights)&&(l=E.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),l=l.length?l:void 0),{label:E.label,highlights:l}}}class _{constructor(a,l,v){this._proxy=a,this.commands=l,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}l.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,l,v){const t=this.createTreeView(a,{treeDataProvider:l},v);return{dispose:()=>t.dispose()}}createTreeView(a,l,v){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=l.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(a,l,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,c)=>s.reveal(i,c),dispose:async()=>{await r,this.treeViews.delete(a),s.dispose()}}}$getChildren(a,l){const v=this.treeViews.get(a);return v?v.getChildren(l):Promise.reject(new Error((0,g.localize)(0,null,a)))}async $onDrop(a,l,v){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,a)));const r=u.TreeDataTransferConverter.toITreeDataTransfer(l);if(r.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?r.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(a){const l=this.treeViews.get(a);if(!l)throw new Error((0,g.localize)(2,null,a));return l.hasResolve}$resolve(a,l,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(3,null,a));return t.resolveTreeItem(l,v)}$setExpanded(a,l,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(4,null,a));t.setExpanded(l,v)}$setSelection(a,l){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(5,null,a));v.setSelection(l)}$setVisible(a,l){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(6,null,a));v.setVisible(l)}createExtHostTreeView(a,l,v){const t=new T(a,l,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(a,t),t}convertArgument(a){const l=this.treeViews.get(a.$treeViewId);return l?l.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=_;class T extends A.Disposable{constructor(a,l,v,t,r,s){super();if(this.viewId=a,this.proxy=v,this.commands=t,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,s.contributes&&s.contributes.views)for(const f in s.contributes.views)for(const h of s.contributes.views[f])h.id===a&&(this._title=h.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let i,c;this._register(D.Event.debounce(this._onDidChangeData.event,(f,h)=>(f||(f={message:!1,elements:[]}),h.element!==!1&&(i||(i=new Promise(b=>c=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(h.element)?f.elements.push(...h.element):f.elements.push(h.element)),h.message&&(f.message=!0),f),200,!0)(({message:f,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=c;return i=null,this.refresh(h).then(()=>b())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}async getChildren(a){const l=a?this.getExtensionElement(a):void 0;if(a&&!l)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(a);return v||(v=await this.fetchChildrenNodes(l)),v?v.map(t=>t.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,l){l=l||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(l.select)?!0:l.select,t=(0,n.isUndefinedOrNull)(l.focus)?!1:l.focus,r=(0,n.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(c=>c.item)},{select:v,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,l){const v=this.getExtensionElement(a);v&&(l?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,l){const v=this.getExtensionElement(l);if(!!v)return(0,y.asPromise)(()=>this.dndController?.onDrop(a,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,l){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(a);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,l)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(l=>l?this.resolveUnknownParentChain(l).then(v=>this.resolveTreeNode(l,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(a){const l=this.nodes.get(a);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,l){const v=this.nodes.get(a);return v?Promise.resolve(v):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,l,!0)).then(t=>this.getChildren(l?l.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let l;if(typeof a=="string"){const v=this.getExtensionElement(a);l=v?this.nodes.get(v):void 0}else l=a;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const l=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(l.token.isCancellationRequested)return;const r=await Promise.all((0,I.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,v):null}));return l.token.isCancellationRequested?void 0:(0,I.coalesce)(r)}finally{l.dispose()}}refresh(a){if(a.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(a);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const l=new Set,v=a.map(r=>this.nodes.get(r));for(const r of v)if(r&&!l.has(r.item.handle)){let s=r;for(;s&&s.parent&&v.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&l.add(r.item.handle)}const t=[];return l.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!l.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(a){const l={};return Promise.all(a.map(v=>this.refreshNode(v).then(t=>{t&&(l[v]=t.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(a){const l=this.getExtensionElement(a);if(l){const v=this.nodes.get(l);if(v)return this.clearChildren(l),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>{if(t){const r=this.createTreeNode(l,t,v.parent);return this.updateNodeCache(l,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,l,v){const t=this.createTreeNode(a,l,v);if(l.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,l.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,v),t}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?d.MarkdownString.from(a):a}getCommand(a,l){return l?this.commands.toInternal(l,a):void 0}createTreeNode(a,l,v){const t=new A.DisposableStore,r=this.createHandle(a,l,v),s=this.getLightIconPath(l);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:p(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(t,l.command),contextValue:l.contextValue,icon:s,iconDark:this.getDarkIconPath(l)||s,themeIcon:this.getThemeIcon(l),collapsibleState:(0,n.isUndefinedOrNull)(l.collapsibleState)?P.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:l,label:v,resourceUri:t},r,s){if(l)return`${T.ID_HANDLE_PREFIX}/${l}`;const i=p(v,this.extension),c=r?r.item.handle:T.LABEL_HANDLE_PREFIX;let f=i?i.label:t?(0,L.basename)(t):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const h=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,b=this.getChildrenNodes(r)||[];let S,o=0;do{if(S=`${c}/${o}:${f}`,s||!this.elements.has(S)||h===S)break;o++}while(o<=b.length);return S}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||k.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return k.URI.isUri(a)?a:k.URI.file(a)}addNodeToCache(a,l){this.elements.set(l.item.handle,a),this.nodes.set(a,l)}updateNodeCache(a,l,v,t){this.elements.delete(l.item.handle),this.nodes.delete(a),l.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(a,l);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===v.item.handle)[0];s&&r.splice(r.indexOf(s),1,l)}addNodeToParentCache(a,l){l?(l.children||(l.children=[]),l.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const l=this.nodes.get(a);if(l){if(l.children)for(const v of l.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}l.children=void 0}}else this.clearAll()}clear(a){const l=this.nodes.get(a);if(l){if(l.children)for(const v of l.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,17,3,6,14,88,15,128,90]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends k.Disposable{constructor(d){super();this.controllerId=d,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(d){this._resolveHandler=d;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const d=this.diff;return this.diff=[],d}*tags(){const d=new Set;for(const m of this.tree.values())for(const u of m.actual.tags)d.has(u.id)||(d.add(u.id),yield u)}pushDiff(d){const m=this.diff[this.diff.length-1];if(m&&d[0]===1){if(m[0]===1&&m[1].extId===d[1].extId){(0,y.applyTestItemUpdate)(m[1],d[1]);return}if(m[0]===0&&m[1].item.extId===d[1].extId){(0,y.applyTestItemUpdate)(m[1],d[1]);return}}this.diff.push(d),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(d,m){const u=this.tree.get(d);if(!!u){if((u.expandLevels===void 0||m>u.expandLevels)&&(u.expandLevels=m),u.expand===1){const p=this.resolveChildren(u);return p.isOpen()?this.expandChildren(u,m-1):p.wait().then(()=>this.expandChildren(u,m-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,m-1)):this.expandChildren(u,m-1)}}dispose(){for(const d of this.tree.values())(0,A.getPrivateApiFor)(d.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(d,m){switch(m.op){case 2:this.pushDiff([4,d.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(d.fullId,m.id));break;case 0:this.upsertItem(m.item,d);break;case 4:for(const T of m.ops)this.onTestItemEvent(d,T);break;case 3:const{key:u,value:p}=m,_=d.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(d);break;case"tags":this.pushDiff([1,{extId:_,item:{tags:p.map(T=>T.id)}}]);break;case"range":this.pushDiff([1,{extId:_,item:{range:C.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:C.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[u]:p??null}}]);break}break;default:(0,D.assertNever)(m)}}upsertItem(d,m){if(!(d instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);const u=P.TestId.fromExtHostTestItem(d,this.root.id,m?.actual),p=(0,A.getPrivateApiFor)(d);p.parent&&p.parent!==m?.actual&&p.parent.children.delete(d.id);let _=this.tree.get(u.toString());if(!_){_={fullId:u,actual:d,parent:m?u.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(_.fullId.toString(),_),this.setItemParent(d,m),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:C.TestItem.from(d)}]),this.connectItemAndChildren(d,_,m);return}if(_.actual===d){this.connectItem(d,_,m);return}const T=_.actual.children,E=_.actual,a=(0,A.diffTestItems)(E,d);(0,A.getPrivateApiFor)(E).listener=void 0,_.actual=d,_.expand=0;for(const[l,v]of a)this.onTestItemEvent(_,{op:3,key:l,value:v});this.connectItemAndChildren(d,_,m);for(const l of T)d.children.get(l.id)||this.removeItem(P.TestId.joinToString(u,l.id))}setItemParent(d,m){(0,A.getPrivateApiFor)(d).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(d,m,u){this.setItemParent(d,u);const p=(0,A.getPrivateApiFor)(d);p.parent=u?.actual,p.listener=_=>this.onTestItemEvent(m,_),this.updateExpandability(m)}connectItemAndChildren(d,m,u){this.connectItem(d,m,u);for(const p of d.children)this.upsertItem(p,m)}updateExpandability(d){let m;this._resolveHandler?d.resolveBarrier?m=d.resolveBarrier.isOpen()?3:2:m=d.actual.canResolveChildren?1:0:m=0,m!==d.expand&&(d.expand=m,this.pushDiff([1,{extId:d.fullId.toString(),expand:m}]),m===1&&d.expandLevels!==void 0&&this.resolveChildren(d))}expandChildren(d,m){if(m<0)return;const u=[];for(const p of d.actual.children){const _=this.expand(P.TestId.joinToString(d.fullId,p.id),m);(0,g.isThenable)(_)&&u.push(_)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}d.expand=2,this.pushExpandStateUpdate(d);const m=d.resolveBarrier=new g.Barrier,u=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),d.actual!==this.root&&(d.actual.error=_.stack||_.message||String(_))};let p;try{p=this._resolveHandler(d.actual===this.root?void 0:d.actual)}catch(_){u(_)}return(0,g.isThenable)(p)?p.catch(u).then(()=>{m.open(),this.updateExpandability(d)}):(m.open(),this.updateExpandability(d)),d.resolveBarrier}pushExpandStateUpdate(d){this.pushDiff([1,{extId:d.fullId.toString(),expand:d.expand}])}removeItem(d){const m=this.tree.get(d);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,d]);const u=[m];for(;u.length;){const p=u.pop();if(!!p){(0,A.getPrivateApiFor)(p.actual).listener=void 0,this.tree.delete(p.fullId.toString());for(const _ of p.actual.children)u.push(this.tree.get(P.TestId.joinToString(p.fullId,_.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.diffOpEmitter.fire(d)}}e.SingleUseTestCollection=n}),define(me[223],ge([0,1,4,184]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(me[224],ge([0,1,26,3,8]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class D{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=D;class A{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(d=>I.add(g.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>I.has(g.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(d.map(m=>m.identifier)),I.length>0){const m=new Set;I.forEach(u=>m.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!m.has(g.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new D(d)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,T){this.addNode(_),this.addNode(T),this._arcs.has(_)?this._arcs.get(_).push(T):this._arcs.set(_,[T])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,T){const E=I.getArcs(_);for(let a=0;a<E.length;a++)if(!T.has(E[a]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let _ of n){const T=g.ExtensionIdentifier.toKey(_.identifier);if(d.set(T,_),_.extensionDependencies)for(let E of _.extensionDependencies){const a=g.ExtensionIdentifier.toKey(E);I.addArc(T,a)}}let m=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>m.add(_));let u=I.getNodes().filter(_=>!m.has(_)),p;do{p=!1;for(let _=0;_<u.length;_++){const T=u[_];I.hasOnlyGoodArcs(T,m)&&(u.splice(_,1),_--,m.add(T),p=!0)}}while(p);return u.map(_=>d.get(_))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=A;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function y(P,n){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==d)return I-d;const m=k.posix.basename(P.extensionLocation.path),u=k.posix.basename(n.extensionLocation.path);return m<u?-1:m>u?1:0}}),define(me[225],ge([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function D(C){const y=g.VSBuffer.alloc(1);switch(C){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=D;function A(C,y){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=A}),define(me[35],ge([0,1,3,2,4,26,186]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var C;(function(E){E[E.None=0]="None",E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(a){this.dependency=a}}e.MissingExtensionDependency=y;var P;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(a,l,v,t){this.codeLoadingTime=a,this.activateCallTime=l,this.activateResolvedTime=v,this.activationReason=t}}e.ActivationTimes=n;class I{constructor(a,l){this.description=a,this.value=l}}e.ExtensionPointContribution=I,e.ExtensionHostLogFileName="exthost";var d;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function m(E){E.enableProposedApi||u(E)}e.checkProposedApiEnabled=m;function u(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=u;function p(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=p;function _(E,a){return{identifier:new D.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!a,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=_;class T{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(a){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,l){return Promise.resolve()}_onWillActivateExtension(a){}_onDidActivateExtension(a,l,v,t,r){}_onDidActivateExtensionError(a,l){}_onExtensionRuntimeError(a,l){}_onExtensionHostExit(a){}}e.NullExtensionService=T}),define(me[226],ge([0,1,26,35,12]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class A{constructor(u,p,_,T){this.startup=u,this.codeLoadingTime=p,this.activateCallTime=_,this.activateResolvedTime=T}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,p){return u===-1||p===-1?-1:p-u}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class y{constructor(u,p,_,T,E,a){this.activationFailed=u,this.activationFailedError=p,this.activationTimes=_,this.module=T,this.exports=E,this.subscriptions=a}}e.ActivatedExtension=y;class P extends y{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class n extends y{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends y{constructor(u){super(!0,u,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let d=class{constructor(u,p,_,T,E){this._logService=E,this._registry=u,this._resolvedExtensionsSet=new Set,p.forEach(a=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,_.forEach(a=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(a),a)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const p=g.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(p)}getActivatedExtension(u){const p=g.ExtensionIdentifier.toKey(u),_=this._activatedExtensions.get(p);if(!_)throw new Error("Extension `"+u.value+"` is not known or not activated");return _}activateByEvent(u,p){if(this._alreadyActivatedEvents[u])return D;const _=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(_.map(T=>({id:T.identifier,reason:{startup:p,extensionId:T.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,p){const _=this._registry.getExtensionDescription(u);if(!_)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:_.identifier,reason:p}])}_handleActivateRequest(u,p,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(u.id))){p[g.ExtensionIdentifier.toKey(u.id)]=u;return}const T=this._registry.getExtensionDescription(u.id);if(!T){const l=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,l,new L.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(u.id),new I(l));return}const E=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let a=!0;for(let l=0,v=E.length;l<v;l++){const t=E[l];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const f=T.displayName||T.identifier.value,h=this._registry.getExtensionDescription(t),b=h&&h.displayName||t,S=new Error(`Cannot activate the '${f}' extension because its dependency '${b}' failed to activate`);S.detail=r.activationFailedError,this._host.onExtensionActivationError(T.identifier,S,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(S));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){a=!1,p[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){a=!1,p[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:u.reason};continue}const i=T.displayName||T.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(T.identifier,c,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(c));return}a?p[g.ExtensionIdentifier.toKey(T.identifier)]=u:_.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(E=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(E.id))),u.length===0))return Promise.resolve(void 0);const p=Object.create(null),_=[];for(let E=0,a=u.length;E<a;E++)this._handleActivateRequest(u[E],p,_);for(let E=0,a=_.length;E<a;E++){const l=g.ExtensionIdentifier.toKey(_[E].id);p[l]&&delete p[l]}const T=Object.keys(p).map(E=>p[E]);return _.length===0?Promise.all(T.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(T).then(E=>this._activateExtensions(_))}_activateExtension(u,p){const _=g.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const T=this._activatingExtensions.get(_);if(T)return T;const E=this._host.actualActivateExtension(u,p).then(void 0,a=>{const l=new Error;return a&&a.name&&(l.name=a.name),a&&a.message?l.message=`Activating extension '${u.value}' failed: ${a.message}.`:l.message=`Activating extension '${u.value}' failed: ${a}.`,a&&a.stack&&(l.stack=a.stack),this._host.onExtensionActivationError(u,l,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(_,a),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};d=ze([Ue(4,k.ILogService)],d),e.ExtensionsActivator=d}),define(me[227],ge([0,1,12,35,27,10,115]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.LogService{constructor(P){if(P.logFile.scheme!==D.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(L.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};C=ze([Ue(0,k.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[228],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,A)=>{this._actualOk=D,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,g.onUnexpectedError)(D))}then(D,A){return this._ensureActual().then(D,A)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=L}),define(me[65],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(P,n){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=n,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function k(y){const P=new g(!0,y);return L[P.nid]=P,P}e.createMainContextProxyIdentifier=k;function D(y){const P=new g(!1,y);return L[P.nid]=P,P}e.createExtHostContextProxyIdentifier=D;function A(y){return L[y].sid}e.getStringIdentifierForProxy=A;class C{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=C}),define(me[5],ge([0,1,59,2,65]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var A;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(a){a.name="$ident";function l(t,r){return Object.defineProperty(t,a.name,{value:r,enumerable:!0}),t}a.mixin=l;function v(t){return t[a.name]}a.of=v})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(l){return l._id=m._n++,l}}e.IdObject=m,m._n=0;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(a){if(a&&a.edits)for(const l of a.edits)typeof l.resource=="object"?l.resource=L.URI.revive(l.resource):(l.newUri=L.URI.revive(l.newUri),l.oldUri=L.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,g.revive)(l.metadata));return a}e.reviveWorkspaceEditDto=T;var E;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class D{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,y){return this._proxy.$getPassword(C,y)}store(C,y,P){return this._proxy.$setPassword(C,y,P)}delete(C,y){return this._proxy.$deletePassword(C,y)}}e.ExtHostSecretState=D,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(me[66],ge([0,1,4,12,5,13]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,P,n){const I=this.getUsageKey(y,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};A=ze([Ue(0,D.IExtHostRpcService),Ue(1,L.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(C,y,P){}})}),define(me[229],ge([0,1,3,5,7,26]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,n,I={}){const d=D.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(d)||[],u=[...n].sort().join(" ");let p=m.find(_=>_.scopes===u);if(p)return p.result;{const _=this._getSession(y,d,P,n,I);p={scopes:u,result:_},m.push(p),this._inFlightRequests.set(d,m);try{await _}finally{const T=m.findIndex(E=>E.scopes===u);T>-1&&(m.splice(T),this._inFlightRequests.set(d,m))}return _}}async _getSession(y,P,n,I,d={}){await this._proxy.$ensureProvider(n);const m=y.displayName||y.name;return this._proxy.$getSession(n,I,P,m,d)}async removeSession(y,P){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,n,I){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===y)||this._providers.push({id:y,label:P});const d=n.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(y,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,I?.supportsMultipleAccounts??!1),new k.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(y);const m=this._providers.findIndex(u=>u.id===y);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(me[230],ge([0,1,5,13,15]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(C,y){this._extHostDocumentsAndEditors=y,this._proxy=C.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const y=k.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};D=ze([Ue(0,L.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(me[231],ge([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(D){const A=D.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(C){return A.$writeText(C)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,14,7,15,23,5,20,12,59,41,50,2,6,4,13]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=r,this.converter=new T(this,s=>{const i=this._apiCommands.get(s);return i?.result===a.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,P.revive)(s)}},{processArgument(s){return(0,D.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return k.Range.to(i);if(I.Position.isIPosition(i))return k.Position.to(i);if(n.Range.isIRange(i.range)&&d.URI.isUri(i.uri))return k.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((f,h)=>{if(!f.validate(s[h]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${s[h]}`);return f.convert(s[h])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:c}),t&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,D.cloneAndChange)(r,function(c){if(c instanceof L.Position)return k.Position.from(c);if(c instanceof L.Range)return k.Range.from(c);if(c instanceof L.Location)return k.location.from(c);if(L.NotebookRange.isNotebookRange(c))return k.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,s);return(0,P.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:c,description:f}=s;if(f)for(let h=0;h<f.args.length;h++)try{(0,g.validateConstraint)(r[h],f.args[h].constraint)}catch(b){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[h].name}' - ${f.args[h].description}`)}try{return await i.apply(c,r)}catch(h){if(t===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...r);b&&(t=b.command)}throw this._logService.error(h,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};_=ze([Ue(0,p.IExtHostRpcService),Ue(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class T{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((c,f)=>c.convert(t.arguments&&t.arguments[f]));else if((0,C.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),s.$ident=c,s.id=this.delegatingCommandId,s.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return s}fromInternal(t){const r=A.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=T;class E{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",v=>d.URI.isUri(v),v=>v),E.Position=new E("position","A position in a text document",v=>L.Position.isPosition(v),k.Position.from),E.Range=new E("range","A range in a text document",v=>L.Range.isRange(v),k.Range.from),E.Selection=new E("selection","A selection in a text document",v=>L.Selection.isSelection(v),k.Selection.from),E.Number=new E("number","",v=>typeof v=="number",v=>v),E.String=new E("string","",v=>typeof v=="string",v=>v),E.CallHierarchyItem=new E("item","A call hierarchy item",v=>v instanceof L.CallHierarchyItem,k.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",v=>v instanceof L.TypeHierarchyItem,k.TypeHierarchyItem.from);class a{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",v=>v);class l{constructor(t,r,s,i,c){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=c}}e.ApiCommand=l}),define(me[232],ge([0,1,15,7,83,44,20,111]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,m)=>{if((0,A.isFalsyOrEmpty)(d))return;class u extends L.SymbolInformation{static to(_){const T=new u(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new L.Location(m[0],g.Range.to(_.range)));return T.detail=_.detail,T.range=T.location.range,T.selectionRange=g.Range.to(_.selectionRange),T.children=_.children?_.children.map(u.to):[],T}}return d.map(u.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(m=>L.Position.isPosition(m)),d=>d.map(g.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(m=>{let u;for(const p of m.reverse())u=new L.SelectionRange(g.Range.to(p),u);return u}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>{const m=[];if(Array.isArray(d))for(let u of d)m.push(...u[1].map(g.WorkspaceSymbol.to));return m})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return g.WorkspaceEdit.to(d)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(g.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new L.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,C.decodeSemanticTokensDto)(d);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new L.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,C.decodeSemanticTokensDto)(d);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,m,u)=>{if(!d)return new L.CompletionList([]);const p=d.suggestions.map(_=>g.CompletionItem.to(_,u));return new L.CompletionList(p,d.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return g.SignatureHelp.to(d)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,m,u)=>n(p=>new L.CodeLens(g.Range.to(p.range),p.command&&u.fromInternal(p.command)))(d))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>L.Range.isRange(d),d=>L.Selection.isSelection(d)?g.Selection.from(d):g.Range.from(d)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,m,u)=>n(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(p.command)}else{const _=new L.CodeAction(p.title,p.kind?new L.CodeActionKind(p.kind):void 0);return p.edit&&(_.edit=g.WorkspaceEdit.to(p.edit)),p.command&&(_.command=u.fromInternal(p.command)),_.isPreferred=p.isPreferred,_}})(d))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(m=>new L.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",d=>d instanceof L.Color,g.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:g.Range.from(d.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(g.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",d=>d.map(g.InlayHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(g.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to)))];class P{static register(m){y.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=P;function n(d){return m=>{if(Array.isArray(m))return m.map(d)}}function I(d){if(!Array.isArray(d))return;const m=[];for(const u of d)k.isLocationLink(u)?m.push(g.DefinitionLink.to(u)):m.push(g.location.to(u));return m}}),define(me[233],ge([0,1,17,56,3,6,2,83,26,15,7,5]),function(Y,e,g,L,k,D,A,C,y,P,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function d(m,u,p){const _=m.getProxy(I.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.commentThreadHandle);return f||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.thread.commentThreadHandle);return f?{thread:f,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let h=i.commentUniqueId,b=f.getCommentByUniqueId(h);return b||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let h=i.text,b=i.commentUniqueId,S=f.getCommentByUniqueId(b);return S?(S.body=h,S):i}return i}})}createCommentController(i,c,f){const h=T.handlePool++,b=new a(i,h,c,f);this._commentControllers.set(b.handle,b);const S=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return S.push(b),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),S),b.value}$createCommentThreadTemplate(i,c,f){const h=this._commentControllers.get(i);!h||h.$createCommentThreadTemplate(c,f)}async $updateCommentThreadTemplate(i,c,f){const h=this._commentControllers.get(i);!h||h.$updateCommentThreadTemplate(c,f)}$deleteCommentThread(i,c){const f=this._commentControllers.get(i);f&&f.$deleteCommentThread(c)}$provideCommentingRanges(i,c,f){const h=this._commentControllers.get(i);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const b=p.getDocument(A.URI.revive(c));return(0,g.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(b,f)).then(S=>S?S.map(o=>P.Range.from(o)):void 0)}$toggleReaction(i,c,f,h,b){const S=this._commentControllers.get(i);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const o=S.getCommentThread(c);if(o){const w=o.getCommentByUniqueId(h.uniqueIdInThread);if(S!==void 0&&w&&S.reactionHandler)return S.reactionHandler(w,t(b))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class E{constructor(i,c,f,h,b,S,o){this._commentControllerHandle=c,this._id=f,this._uri=h,this._range=b,this._comments=S,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputDisposables.value=new D.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),_.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(c,this.handle)}});const w=this;this.value={get uri(){return w.uri},get range(){return w.range},set range(R){w.range=R},get comments(){return w.comments},set comments(R){w.comments=R},get collapsibleState(){return w.collapsibleState},set collapsibleState(R){w.collapsibleState=R},get canReply(){return w.canReply},set canReply(R){w.canReply=R},get contextValue(){return w.contextValue},set contextValue(R){w.contextValue=R},get label(){return w.label},set label(R){w.label=R},dispose:()=>{w.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new D.DisposableStore);const i=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),c={};i("range")&&(c.range=P.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(f=>l(this,f,this._commentsMap))),i("collapsibleState")&&(c.collapseState=r(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let f=c[0],h=c[1];if(i===h)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,ze([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,c,f,h){this._extension=i,this._handle=c,this._id=f,this._label=h,this._threads=new Map,_.$registerCommentController(this.handle,f,h);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(S){b.options=S},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(S){b.commentingRangeProvider=S},get reactionHandler(){return b.reactionHandler},set reactionHandler(S){b.reactionHandler=S},createCommentThread(S,o,w){return b.createCommentThread(S,o,w).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,f,h){if(typeof i=="string"){const b=new E(this.id,this.handle,i,c,f,h,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new E(this.id,this.handle,void 0,i,c,f,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,c){const f=new E(this.id,this.handle,void 0,A.URI.revive(i),P.Range.to(c),[],this._extension.identifier);return f.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(i,c){let f=this._threads.get(i);f&&(f.range=P.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function l(s,i,c){let f=c.get(i);f||(f=++s.commentHandle,c.set(i,f));const h=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:f,body:P.MarkdownString.from(i.body),userName:i.author.name,userIconPath:h,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>v(b)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?A.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=d}),define(me[132],ge([0,1,2,5,7,4,13,12,20,9,8]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class En{constructor(m,u){this._logService=u,this._provider=new Map,this._proxy=m.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,u){const p=En._handlePool++;this._provider.set(p,{provider:m,extensionId:u}),this._proxy.$registerDecorationProvider(p,u.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(p,null);return}let E=(0,y.asArray)(T);if(E.length<=En._maxEventSize){this._proxy.$onDidChange(p,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,E.length);const a=E.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),l=(0,y.groupBy)(a,(t,r)=>t.rank-r.rank||(0,P.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of l){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,v.push(s.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(p,v)});return new k.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(m,u,p){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:T,extensionId:E}=this._provider.get(m);return await Promise.all(u.map(async a=>{try{const{uri:l,id:v}=a,t=await Promise.resolve(T.provideFileDecoration(g.URI.revive(l),p));if(!t)return;try{k.FileDecoration.validate(t),_[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(l){this._logService.error(l)}})),_}};I._handlePool=0,I._maxEventSize=250,I=ze([Ue(0,A.IExtHostRpcService),Ue(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,D.createDecorator)("IExtHostDecorations")}),define(me[234],ge([0,1,164,116,2,5,7,15,3,12,24]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(u,p,_,T,E){this._name=u,this._owner=p,this._maxDiagnosticsPerFile=_,this._proxy=T,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,p){if(!u){this.clear();return}this._checkDisposed();let _=[];if(k.URI.isUri(u)){if(!p){this.delete(u);return}this._data.set(u,p.slice()),_=[u]}else if(Array.isArray(u)){_=[];let E;u=[...u].sort(I._compareIndexedTuplesByUri);for(const a of u){const[l,v]=a;if((!E||l.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=l,_.push(l),this._data.set(l,[])),v){const t=this._data.get(l);t&&t.push(...v)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const T=[];for(let E of _){let a=[];const l=this._data.get(E);if(l)if(l.length>this._maxDiagnosticsPerFile){a=[];const v=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of l)if(r.severity===v[t]&&a.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;a.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=l.map(v=>C.Diagnostic.from(v));T.push([E,a])}this._proxy.$changeMany(this._owner,T)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,p){this._checkDisposed();for(let _ of this._data.keys())u.apply(p,[_,this.get(_),this])}get(u){this._checkDisposed();const p=this._data.get(u);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,p){return u[0].toString()<p[0].toString()?-1:u[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=I;let d=class Xt{constructor(u,p){this._logService=p,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Xt._mapper),this._proxy=u.getProxy(D.MainContext.MainThreadDiagnostics)}static _mapper(u){const p=new n.ResourceMap;for(const _ of u)p.set(_,_);return{uris:Object.freeze(Array.from(p.values()))}}createDiagnosticCollection(u,p){const{_collections:_,_proxy:T,_onDidChangeDiagnostics:E,_logService:a}=this,l=new class{$changeMany(r,s){T.$changeMany(r,s),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,r,s.length===0?"CLEARING":s)}$clear(r){T.$clear(r),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,r)}dispose(){T.dispose()}};let v;if(!p)p="_generated_diagnostic_collection_name_#"+Xt._idPool++,v=p;else if(!_.has(p))v=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do v=p+Xt._idPool++;while(_.has(v))}return new class extends I{constructor(){super(p,v,Xt._maxDiagnosticsPerFile,l,E);_.set(v,this)}dispose(){super.dispose(),_.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const p=new Map,_=[];for(const T of this._collections.values())T.forEach((E,a)=>{let l=p.get(E.toString());typeof l=="undefined"&&(l=_.length,p.set(E.toString(),l),_.push([E,[]])),_[l][1]=_[l][1].concat(...a)});return _}}_getDiagnostics(u){let p=[];for(let _ of this._collections.values())_.has(u)&&(p=p.concat(_.get(u)));return p}$acceptMarkersChange(u){if(!this._mirrorCollection){const p="_generated_mirror",_=new I(p,p,Xt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(p,_),this._mirrorCollection=_}for(const[p,_]of u)this._mirrorCollection.set(k.URI.revive(p),_.map(C.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([Ue(1,P.ILogService)],d),e.ExtHostDiagnostics=d}),define(me[235],ge([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(C=>C?C.map(y=>g.URI.revive(y)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(C=>C?g.URI.revive(C):void 0)}}e.ExtHostDialogs=k}),define(me[236],ge([0,1,16,2,7,5,10,21,9]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,d,m){this._documentsAndEditors=d,this._logService=m,this._documentContentProviders=new Map,this._proxy=I.getProxy(D.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,d){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const m=P._handlePool++;this._documentContentProviders.set(m,d),this._proxy.$registerTextContentProvider(m,I);let u;return typeof d.onDidChange=="function"&&(u=d.onDidChange(p=>{if(p.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(m,p).then(_=>{if(!_&&typeof _!="string")return;const T=this._documentsAndEditors.getDocument(p);if(!T)return;const E=(0,y.splitLines)(_);if(!T.equalLines(E))return this._proxy.$onVirtualDocumentChange(p,_)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(I,d){const m=this._documentContentProviders.get(I);return m?Promise.resolve(m.provideTextDocumentContent(L.URI.revive(d),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[237],ge([0,1,3,6,2,5,124,15,14,23,7]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(m,u){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(D.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const _ of p)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const _ of p)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const u=this._documentsAndEditors.getDocument(m);if(u)return u}getDocument(m){const u=this.getDocumentData(m);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return u.document}ensureDocumentData(m){const u=this._documentsAndEditors.getDocument(m);if(u)return Promise.resolve(u);let p=this._documentLoader.get(m.toString());return p||(p=this._proxy.$tryOpenDocument(m).then(_=>{this._documentLoader.delete(m.toString());const T=k.URI.revive(_);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(T))},_=>(this._documentLoader.delete(m.toString()),Promise.reject(_))),this._documentLoader.set(m.toString(),p)),p}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(u=>k.URI.revive(u))}$acceptModelModeChanged(m,u){const p=k.URI.revive(m),_=this._documentsAndEditors.getDocument(p);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(u),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(m){const u=k.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(m,u){const p=k.URI.revive(m),_=this._documentsAndEditors.getDocument(p);if(!_)throw new Error("unknown document");_._acceptIsDirty(u),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,u,p){const _=k.URI.revive(m),T=this._documentsAndEditors.getDocument(_);if(!T)throw new Error("unknown document");T._acceptIsDirty(p),T.onEvents(u);let E;u.isUndoing?E=n.TextDocumentChangeReason.Undo:u.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:T.document,contentChanges:u.changes.map(a=>({range:C.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:E}))}setWordDefinitionFor(m,u){(0,A.setWordDefinitionFor)(m,u)}}e.ExtHostDocuments=I}),define(me[45],ge([0,1,54,3,6,2,4,5,124,13,131,15,12,24,10,76,140]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,v){this._extHostRpc=l,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const v=[],t=[],r=[];if(l.removedDocuments)for(const s of l.removedDocuments){const i=D.URI.revive(s),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(l.addedDocuments)for(const s of l.addedDocuments){const i=D.URI.revive(s.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new T(new y.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(l.removedEditors)for(const s of l.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(l.addedEditors)for(const s of l.addedEditors){const i=D.URI.revive(s.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(i).value,f=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>c.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(h=>I.Range.to(h)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,f)}l.newActiveEditor!==void 0&&(g.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,k.dispose)(v),(0,k.dispose)(r),l.removedDocuments&&this._onDidRemoveDocuments.fire(v),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return l?v:v?.value}allEditors(){return[...this._editors.values()]}};E=ze([Ue(0,P.IExtHostRpcService),Ue(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[238],ge([0,1,2,5,6,7,15,148,9,22]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const u=this._schemes.indexOf(m);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),u=[];let p,_,T=14,E=14;for(const a of m){let l=p?(0,y.commonPrefixLength)(p,a):0;for(l===0?_=1:_=E;l<a.length;l++)l+1===a.length?(T=E,E=9):E+=1,u.push([_,a.toUpperCase().charCodeAt(l),E]),u.push([_,a.toLowerCase().charCodeAt(l),E]),_=E;p=a,E=T}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new C.StateMachine(u)}}provideDocumentLinks(m){this._initStateMachine();const u=[],p=C.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of p){const T=A.DocumentLink.to(_);T.target&&u.push(T)}return u}}class I{constructor(m,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,u,p,_={},T){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(E,p),this._enableProposedApi.set(E,T??!1);let a=2;_.isCaseSensitive&&(a+=1024),_.isReadonly&&(a+=2048),typeof p.copy=="function"&&(a+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(E,u,a).catch(v=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${u}`),console.error(v)});const l=p.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:s,type:i}=r;if(s.scheme!==u)continue;let c;switch(i){case D.FileChangeType.Changed:c=0;break;case D.FileChangeType.Created:c=1;break;case D.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:c})}this._proxy.$onFileSystemChange(E,t)});return(0,k.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(m,u){const{type:p,ctime:_,mtime:T,size:E,permissions:a}=m;return u?{type:p,ctime:_,mtime:T,size:E,permissions:a}:{type:p,ctime:_,mtime:T,size:E}}$stat(m,u){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(u))).then(p=>I._asIStat(p,this._enableProposedApi.get(m)??!1))}$readdir(m,u){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(u)))}$readFile(m,u){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(u))).then(p=>P.VSBuffer.wrap(p))}$writeFile(m,u,p,_){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(u),p.buffer,_))}$delete(m,u,p){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(u),p))}$rename(m,u,p,_){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(u),g.URI.revive(p),_))}$copy(m,u,p,_){const T=this._getFsProvider(m);if(!T.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(T.copy(g.URI.revive(u),g.URI.revive(p),_))}$mkdir(m,u){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(u)))}$watch(m,u,p,_){const T=this._getFsProvider(m).watch(g.URI.revive(p),_);this._watches.set(u,T)}$unwatch(m,u){const p=this._watches.get(u);p&&(p.dispose(),this._watches.delete(u))}$open(m,u,p){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(u),p))}$close(m,u){const p=this._getFsProvider(m);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(u))}$read(m,u,p,_){const T=this._getFsProvider(m);if(!T.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(_);return Promise.resolve(T.read(u,p,E.buffer,0,_)).then(a=>E.slice(0,a))}$write(m,u,p,_){const T=this._getFsProvider(m);if(!T.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(T.write(u,p,_.buffer,0,_.byteLength))}_getFsProvider(m){const u=this._fsProvider.get(m);if(!u){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return u}}e.ExtHostFileSystem=I}),define(me[92],ge([0,1,5,42,7,22,4,13,63]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class xt{constructor(I,d){const m=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return m.$stat(u).catch(xt._handleError)},readDirectory(u){return m.$readdir(u).catch(xt._handleError)},createDirectory(u){return m.$mkdir(u).catch(xt._handleError)},async readFile(u){return m.$readFile(u).then(p=>p.buffer).catch(xt._handleError)},writeFile(u,p){return m.$writeFile(u,D.VSBuffer.wrap(p)).catch(xt._handleError)},delete(u,p){return m.$delete(u,{recursive:!1,useTrash:!1,...p}).catch(xt._handleError)},rename(u,p,_){return m.$rename(u,p,{overwrite:!1,..._}).catch(xt._handleError)},copy(u,p,_){return m.$copy(u,p,{overwrite:!1,..._}).catch(xt._handleError)},isWritableFileSystem(u){const p=d.getCapabilities(u);if(typeof p=="number")return!(p&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};P=ze([Ue(0,C.IExtHostRpcService),Ue(1,y.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(me[239],ge([0,1,2,44]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(A,C,y,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=y,this._commands=P;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const d=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:d.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(A,C,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:y,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=k}),define(me[240],ge([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,A),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=k}),define(me[241],ge([0,1,2,23,15,7,5,9,41,20,14,145,6,111,75,87,46,16,3]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(H,ee){this._documents=H,this._provider=ee}async provideDocumentSymbols(H,ee){const re=this._documents.getDocument(H),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,P.isFalsyOrEmpty)(le))return le[0]instanceof D.DocumentSymbol?le.map(k.DocumentSymbol.from):a._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((le,J)=>{let ae=le.location.range.start.compareTo(J.location.range.start);return ae===0&&(ae=J.location.range.end.compareTo(le.location.range.end)),ae});const ee=[],re=[];for(const le of H){const J={name:le.name||"!!MISSING: name!!",kind:k.SymbolKind.from(le.kind),tags:le.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:k.Range.from(le.location.range),selectionRange:k.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(J),ee.push(J);break}const ae=re[re.length-1];if(y.Range.containsRange(ae.range,J.range)&&!y.Range.equalsRange(ae.range,J.range)){ae.children&&ae.children.push(J),re.push(J);break}re.pop()}}return ee}}class l{constructor(H,ee,re){this._documents=H,this._commands=ee,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,ee){const re=this._documents.getDocument(H),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const J=this._cache.add(le),ae=new d.DisposableStore;this._disposables.set(J,ae);const ve={cacheId:J,lenses:[]};for(let Fe=0;Fe<le.length;Fe++)ve.lenses.push({cacheId:[J,Fe],range:k.Range.from(le[Fe].range),command:this._commands.toInternal(le[Fe].command,ae)});return ve}async resolveCodeLens(H,ee){const re=H.cacheId&&this._cache.get(...H.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const J=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!J)return H.command=this._commands.toInternal(le.command??l._badCmd,J),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(Ke){return Array.isArray(Ke)?Ke.map(k.DefinitionLink.from):Ke?[k.DefinitionLink.from(Ke)]:[]}class t{constructor(H,ee){this._documents=H,this._provider=ee}async provideDefinition(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideDefinition(le,J,re);return v(ae)}}class r{constructor(H,ee){this._documents=H,this._provider=ee}async provideDeclaration(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideDeclaration(le,J,re);return v(ae)}}class s{constructor(H,ee){this._documents=H,this._provider=ee}async provideImplementation(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideImplementation(le,J,re);return v(ae)}}class i{constructor(H,ee){this._documents=H,this._provider=ee}async provideTypeDefinition(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideTypeDefinition(le,J,re);return v(ae)}}class c{constructor(H,ee){this._documents=H,this._provider=ee}async provideHover(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideHover(le,J,re);if(!(!ae||(0,P.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(J)),ae.range||(ae.range=new D.Range(J,J)),k.Hover.from(ae)}}class f{constructor(H,ee){this._documents=H,this._provider=ee}async provideEvaluatableExpression(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideEvaluatableExpression(le,J,re);if(ae)return k.EvaluatableExpression.from(ae)}}class h{constructor(H,ee){this._documents=H,this._provider=ee}async provideInlineValues(H,ee,re,le){const J=this._documents.getDocument(H),ae=await this._provider.provideInlineValues(J,k.Range.to(ee),k.InlineValueContext.to(re),le);if(Array.isArray(ae))return ae.map(ve=>k.InlineValue.from(ve))}}class b{constructor(H,ee){this._documents=H,this._provider=ee}async provideDocumentHighlights(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideDocumentHighlights(le,J,re);if(Array.isArray(ae))return ae.map(k.DocumentHighlight.from)}}class S{constructor(H,ee){this._documents=H,this._provider=ee}async provideLinkedEditingRanges(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.provideLinkedEditingRanges(le,J,re);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,P.coalesce)(ae.ranges.map(k.Range.from)),wordPattern:ae.wordPattern}}}class o{constructor(H,ee){this._documents=H,this._provider=ee}async provideReferences(H,ee,re,le){const J=this._documents.getDocument(H),ae=k.Position.to(ee),ve=await this._provider.provideReferences(J,ae,re,le);if(Array.isArray(ve))return ve.map(k.location.from)}}class w{constructor(H,ee,re,le,J,ae,ve){this._documents=H,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=J,this._extension=ae,this._apiDeprecation=ve,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,ee,re,le){const J=this._documents.getDocument(H),ae=I.Selection.isISelection(ee)?k.Selection.to(ee):k.Range.to(ee),ve=[];for(const ct of this._diagnostics.getDiagnostics(H))if(ae.intersection(ct.range)&&ve.push(ct)>w._maxCodeActionsPerFile)break;const Fe={diagnostics:ve,only:re.only?new D.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(J,ae,Fe,le);if(!(0,P.isNonEmptyArray)(je)||le.isCancellationRequested)return;const Qe=this._cache.add(je),et=new d.DisposableStore;this._disposables.set(Qe,et);const ke=[];for(let ct=0;ct<je.length;ct++){const Q=je[ct];!Q||(w._isCommand(Q)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ke.push({_isSynthetic:!0,title:Q.title,command:this._commands.toInternal(Q,et)})):(Fe.only&&(Q.kind?Fe.only.contains(Q.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${Q.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ke.push({cacheId:[Qe,ct],title:Q.title,command:Q.command&&this._commands.toInternal(Q.command,et),diagnostics:Q.diagnostics&&Q.diagnostics.map(k.Diagnostic.from),edit:Q.edit&&k.WorkspaceEdit.from(Q.edit),kind:Q.kind&&Q.kind.value,isPreferred:Q.isPreferred,disabled:Q.disabled?.reason})))}return{cacheId:Qe,actions:ke}}async resolveCodeAction(H,ee){const[re,le]=H,J=this._cache.get(re,le);if(!J||w._isCommand(J)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(J,ee)??J;return ae?.edit?k.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}w._maxCodeActionsPerFile=1e3;class R{constructor(H,ee){this._documents=H,this._provider=ee}async provideDocumentFormattingEdits(H,ee,re){const le=this._documents.getDocument(H),J=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(J))return J.map(k.TextEdit.from)}}class O{constructor(H,ee){this._documents=H,this._provider=ee}async provideDocumentRangeFormattingEdits(H,ee,re,le){const J=this._documents.getDocument(H),ae=k.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(J,ae,re,le);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class ${constructor(H,ee){this._documents=H,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,ee,re,le,J){const ae=this._documents.getDocument(H),ve=k.Position.to(ee),Fe=await this._provider.provideOnTypeFormattingEdits(ae,ve,re,le,J);if(Array.isArray(Fe))return Fe.map(k.TextEdit.from)}}class K{constructor(H,ee){this._provider=H,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,ee){const re=A.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(H,ee);if((0,P.isNonEmptyArray)(le))for(const J of le){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ae=A.IdObject.mixin(k.WorkspaceSymbol.from(J));this._symbolCache.set(ae._id,J),re.symbols.push(ae)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(H,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const re=this._symbolCache.get(H._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,L.mixin)(H,k.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(H){const ee=this._resultCache.get(H);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(H)}}}class G{constructor(H,ee,re){this._documents=H,this._provider=ee,this._logService=re}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,ee,re,le){const J=this._documents.getDocument(H),ae=k.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(J,ae,re,le);return ve?k.WorkspaceEdit.from(ve):void 0}catch(ve){const Fe=G._asMessage(ve);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(H,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(H),J=k.Position.to(ee);try{const ae=await this._provider.prepareRename(le,J,re);let ve,Fe;if(D.Range.isRange(ae)?(ve=ae,Fe=le.getText(ae)):(0,n.isObject)(ae)&&(ve=ae.range,Fe=ae.placeholder),!ve||!Fe)return;if(ve.start.line>J.line||ve.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Fe}}catch(ae){const ve=G._asMessage(ae);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class N{constructor(H,ee){this.resultId=H,this.tokens=ee}}class x{constructor(H,ee){this._documents=H,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,ee,re){const le=this._documents.getDocument(H),J=ee!==0?this._previousResults.get(ee):null;let ae=typeof J?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,J.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return J&&this._previousResults.delete(ee),ae?(ae=x._fixProvidedSemanticTokens(ae),this._send(x._convertToEdits(J,ae),ae)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return x._isSemanticTokens(H)?x._isCorrectSemanticTokens(H)?H:new D.SemanticTokens(new Uint32Array(H.data),H.resultId):x._isSemanticTokensEdits(H)?x._isCorrectSemanticTokensEdits(H)?H:new D.SemanticTokensEdits(H.edits.map(ee=>new D.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const ee of H.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,ee){if(!x._isSemanticTokens(ee)||!H||!H.tokens)return ee;const re=H.tokens,le=re.length,J=ee.data,ae=J.length;let ve=0;const Fe=Math.min(le,ae);for(;ve<Fe&&re[ve]===J[ve];)ve++;if(ve===le&&ve===ae)return new D.SemanticTokensEdits([],ee.resultId);let je=0;const Qe=Fe-ve;for(;je<Qe&&re[le-je-1]===J[ae-je-1];)je++;return new D.SemanticTokensEdits([{start:ve,deleteCount:le-ve-je,data:J.subarray(ve,ae-je)}],ee.resultId)}_send(H,ee){if(x._isSemanticTokens(H)){const re=this._nextResultId++;return this._previousResults.set(re,new N(H.resultId,H.data)),(0,m.encodeSemanticTokensDto)({id:re,type:"full",data:H.data})}if(x._isSemanticTokensEdits(H)){const re=this._nextResultId++;return x._isSemanticTokens(ee)?this._previousResults.set(re,new N(ee.resultId,ee.data)):this._previousResults.set(re,new N(H.resultId)),(0,m.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(H.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class F{constructor(H,ee){this._documents=H,this._provider=ee}async provideDocumentRangeSemanticTokens(H,ee,re){const le=this._documents.getDocument(H),J=await this._provider.provideDocumentRangeSemanticTokens(le,k.Range.to(ee),re);return J?this._send(J):null}_send(H){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=F;class V{constructor(H,ee,re,le,J){this._documents=H,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=J,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,ee,re,le){const J=this._documents.getDocument(H),ae=k.Position.to(ee),ve=J.getWordRangeAtPosition(ae)||new D.Range(ae,ae),Fe=ve.with({end:ae}),je=new _.StopWatch(!0),Qe=await this._provider.provideCompletionItems(J,ae,le,k.CompletionContext.to(re));if(!Qe||le.isCancellationRequested)return;const et=Array.isArray(Qe)?new D.CompletionList(Qe):Qe,ke=V.supportsResolving(this._provider)?this._cache.add(et.items):this._cache.add([]),ct=new d.DisposableStore;this._disposables.set(ke,ct);const Q=[],te={x:ke,b:Q,a:{replace:k.Range.from(ve),insert:k.Range.from(Fe)},c:et.isIncomplete||void 0,d:je.elapsed()};for(let pe=0;pe<et.items.length;pe++){const He=et.items[pe],tt=this._convertCompletionItem(He,[ke,pe],Fe,ve);Q.push(tt)}return te}async resolveCompletionItem(H,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...H);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,ee,re,le){const J=this._disposables.get(ee[0]);if(!J)throw Error("DisposableStore is missing...");const ae={x:ee,a:H.label,b:H.kind!==void 0?k.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(k.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(H.command,J)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=H.textEdit.newText):typeof H.insertText=="string"?ae.h=H.insertText:H.insertText instanceof D.SnippetString&&(ae.h=H.insertText.value,ae.i|=4);let ve;return H.textEdit?ve=H.textEdit.range:H.range&&(ve=H.range),D.Range.isRange(ve)?ae.j=k.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(ae.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),ae}}class M{constructor(H,ee,re){this._documents=H,this._provider=ee,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,ee,re,le){const J=this._documents.getDocument(H),ae=k.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(J,ae,re,le);if(!ve||le.isCancellationRequested)return;const Fe=(0,n.isArray)(ve)?{items:ve}:ve,je=this._cache.add(Fe.items);let Qe;return{pid:je,items:Fe.items.map((et,ke)=>{let ct;return et.command&&(Qe||(Qe=new d.DisposableStore,this._disposables.set(je,Qe)),ct=this._commands.toInternal(et.command,Qe)),{text:et.text,range:et.range?k.Range.from(et.range):void 0,command:ct,idx:ke}})}}disposeCompletions(H){this._cache.delete(H);const ee=this._disposables.get(H);ee&&ee.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,ee){const re=this._cache.get(H,ee);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let ee=U.map.get(H);return ee||(ee=new U,U.map.set(H,ee)),ee}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=U,U.map=new WeakMap;class q{constructor(H,ee){this._documents=H,this._provider=ee,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(H,ee,re,le){const J=this._documents.getDocument(H),ae=k.Position.to(ee),ve=this.reviveContext(re),Fe=await this._provider.provideSignatureHelp(J,ae,le,ve);if(Fe){const je=this._cache.add([Fe]);return{...k.SignatureHelp.from(Fe),id:je}}}reviveContext(H){let ee;if(H.activeSignatureHelp){const re=k.SignatureHelp.to(H.activeSignatureHelp),le=this._cache.get(H.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...H,activeSignatureHelp:ee}}releaseSignatureHelp(H){this._cache.delete(H)}}class W{constructor(H,ee){this._documents=H,this._provider=ee}async provideInlayHints(H,ee,re){const le=this._documents.getDocument(H),J=await this._provider.provideInlayHints(le,k.Range.to(ee),re);return J?{hints:J.map(k.InlayHint.from)}:void 0}}class X{constructor(H,ee){this._documents=H,this._provider=ee,this._cache=new p.Cache("DocumentLink")}async provideLinks(H,ee){const re=this._documents.getDocument(H),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(X._validateLink).map(k.DocumentLink.from)};{const J=this._cache.add(le),ae={links:[],id:J};for(let ve=0;ve<le.length;ve++){if(!X._validateLink(le[ve]))continue;const Fe=k.DocumentLink.from(le[ve]);Fe.cacheId=[J,ve],ae.links.push(Fe)}return ae}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...H);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!X._validateLink(le)))return k.DocumentLink.from(le)}releaseLinks(H){this._cache.delete(H)}}class Z{constructor(H,ee){this._documents=H,this._provider=ee}async provideColors(H,ee){const re=this._documents.getDocument(H),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(ae=>({color:k.Color.from(ae.color),range:k.Range.from(ae.range)})):[]}async provideColorPresentations(H,ee,re){const le=this._documents.getDocument(H),J=k.Range.to(ee.range),ae=k.Color.to(ee.color),ve=await this._provider.provideColorPresentations(ae,{document:le,range:J},re);if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)}}class fe{constructor(H,ee){this._documents=H,this._provider=ee}async provideFoldingRanges(H,ee,re){const le=this._documents.getDocument(H),J=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(J))return J.map(k.FoldingRange.from)}}class _e{constructor(H,ee,re){this._documents=H,this._provider=ee,this._logService=re}async provideSelectionRanges(H,ee,re){const le=this._documents.getDocument(H),J=ee.map(k.Position.to),ae=await this._provider.provideSelectionRanges(le,J,re);if(!(0,P.isNonEmptyArray)(ae))return[];if(ae.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Fe=0;Fe<J.length;Fe++){const je=[];ve.push(je);let Qe=J[Fe],et=ae[Fe];for(;;){if(!et.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(k.SelectionRange.from(et)),!et.parent)break;Qe=et.range,et=et.parent}}return ve}}class De{constructor(H,ee){this._documents=H,this._provider=ee,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.prepareCallHierarchy(le,J,re);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Fe=>this._cacheAndConvertItem(ve,Fe)):[this._cacheAndConvertItem(ve,ae)]}async provideCallsTo(H,ee,re){const le=this._itemFromCache(H,ee);if(!le)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!J)return J.map(ae=>({from:this._cacheAndConvertItem(H,ae.from),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(H,ee,re){const le=this._itemFromCache(H,ee);if(!le)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!J)return J.map(ae=>({to:this._cacheAndConvertItem(H,ae.to),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,ee){const re=this._cache.get(H),le=k.CallHierarchyItem.from(ee,H,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(H,ee){return this._cache.get(H)?.get(ee)}}class Le{constructor(H,ee){this._documents=H,this._provider=ee,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(H,ee,re){const le=this._documents.getDocument(H),J=k.Position.to(ee),ae=await this._provider.prepareTypeHierarchy(le,J,re);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Fe=>this._cacheAndConvertItem(ve,Fe)):[this._cacheAndConvertItem(ve,ae)]}async provideSupertypes(H,ee,re){const le=this._itemFromCache(H,ee);if(!le)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!J)return J.map(ae=>this._cacheAndConvertItem(H,ae))}async provideSubtypes(H,ee,re){const le=this._itemFromCache(H,ee);if(!le)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!J)return J.map(ae=>this._cacheAndConvertItem(H,ae))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,ee){const re=this._cache.get(H),le=k.TypeHierarchyItem.from(ee,H,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(H,ee){return this._cache.get(H)?.get(ee)}}class qe{constructor(H,ee){this.adapter=H,this.extension=ee}}class xe{constructor(H,ee,re,le,J,ae,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=H.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=J,this._logService=ae,this._apiDeprecation=ve}_transformDocumentSelector(H){return(0,P.coalesce)((0,P.asArray)(H).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(H){if(typeof H=="string")return{$serialized:!0,language:H};if(H)return{$serialized:!0,language:H.language,scheme:this._transformScheme(H.scheme),pattern:typeof H.pattern=="undefined"?void 0:k.GlobPattern.from(H.pattern),exclusive:H.exclusive}}_transformScheme(H){return this._uriTransformer&&typeof H=="string"?this._uriTransformer.transformOutgoingScheme(H):H}_createDisposable(H){return new D.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return xe._handlePool++}_withAdapter(H,ee,re,le,J=!1){const ae=this._adapter.get(H);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof ee){let ve;ae.extension&&(ve=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Fe=re(ae.adapter,ae.extension),je=ae.extension;return je&&Promise.resolve(Fe).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Qe=>{J&&Qe instanceof T.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Qe))}),Fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,ee){const re=this._nextHandle();return this._adapter.set(re,new qe(H,ee)),re}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,ee,re,le){const J=this._addNewAdapter(new a(this._documents,re),H),ae=le&&le.label||xe._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(ee),ae),this._createDisposable(J)}$provideDocumentSymbols(H,ee,re){return this._withAdapter(H,a,le=>le.provideDocumentSymbols(g.URI.revive(ee),re),void 0)}registerCodeLensProvider(H,ee,re){const le=this._nextHandle(),J=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new l(this._documents,this._commands.converter,re),H)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),J);let ae=this._createDisposable(le);if(J!==void 0){const ve=re.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(J));ae=D.Disposable.from(ae,ve)}return ae}$provideCodeLenses(H,ee,re){return this._withAdapter(H,l,le=>le.provideCodeLenses(g.URI.revive(ee),re),void 0)}$resolveCodeLens(H,ee,re){return this._withAdapter(H,l,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(H,ee){this._withAdapter(H,l,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(H,ee,re){const le=this._addNewAdapter(new t(this._documents,re),H);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(H,ee,re,le){return this._withAdapter(H,t,J=>J.provideDefinition(g.URI.revive(ee),re,le),[])}registerDeclarationProvider(H,ee,re){const le=this._addNewAdapter(new r(this._documents,re),H);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(H,ee,re,le){return this._withAdapter(H,r,J=>J.provideDeclaration(g.URI.revive(ee),re,le),[])}registerImplementationProvider(H,ee,re){const le=this._addNewAdapter(new s(this._documents,re),H);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(H,ee,re,le){return this._withAdapter(H,s,J=>J.provideImplementation(g.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(H,ee,re){const le=this._addNewAdapter(new i(this._documents,re),H);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(H,ee,re,le){return this._withAdapter(H,i,J=>J.provideTypeDefinition(g.URI.revive(ee),re,le),[])}registerHoverProvider(H,ee,re,le){const J=this._addNewAdapter(new c(this._documents,re),H);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(ee)),this._createDisposable(J)}$provideHover(H,ee,re,le){return this._withAdapter(H,c,J=>J.provideHover(g.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(H,ee,re,le){const J=this._addNewAdapter(new f(this._documents,re),H);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(ee)),this._createDisposable(J)}$provideEvaluatableExpression(H,ee,re,le){return this._withAdapter(H,f,J=>J.provideEvaluatableExpression(g.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(H,ee,re,le){const J=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new h(this._documents,re),H);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(ee),J);let ve=this._createDisposable(ae);if(J!==void 0){const Fe=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(J));ve=D.Disposable.from(ve,Fe)}return ve}$provideInlineValues(H,ee,re,le,J){return this._withAdapter(H,h,ae=>ae.provideInlineValues(g.URI.revive(ee),re,le,J),void 0)}registerDocumentHighlightProvider(H,ee,re){const le=this._addNewAdapter(new b(this._documents,re),H);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(H,ee,re,le){return this._withAdapter(H,b,J=>J.provideDocumentHighlights(g.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(H,ee,re){const le=this._addNewAdapter(new S(this._documents,re),H);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(H,ee,re,le){return this._withAdapter(H,S,async J=>{const ae=await J.provideLinkedEditingRanges(g.URI.revive(ee),re,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?xe._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(H,ee,re){const le=this._addNewAdapter(new o(this._documents,re),H);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(H,ee,re,le,J){return this._withAdapter(H,o,ae=>ae.provideReferences(g.URI.revive(ee),re,le,J),void 0)}registerCodeActionProvider(H,ee,re,le){const J=new d.DisposableStore,ae=this._addNewAdapter(new w(this._documents,this._commands.converter,this._diagnostics,re,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,J)}))},xe._extLabel(H),Boolean(re.resolveCodeAction)),J.add(this._createDisposable(ae)),J}$provideCodeActions(H,ee,re,le,J){return this._withAdapter(H,w,ae=>ae.provideCodeActions(g.URI.revive(ee),re,le,J),void 0)}$resolveCodeAction(H,ee,re){return this._withAdapter(H,w,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(H,ee){this._withAdapter(H,w,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(H,ee,re){const le=this._addNewAdapter(new R(this._documents,re),H);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),H.identifier,H.displayName||H.name),this._createDisposable(le)}$provideDocumentFormattingEdits(H,ee,re,le){return this._withAdapter(H,R,J=>J.provideDocumentFormattingEdits(g.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(H,ee,re){const le=this._addNewAdapter(new O(this._documents,re),H);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),H.identifier,H.displayName||H.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(H,ee,re,le,J){return this._withAdapter(H,O,ae=>ae.provideDocumentRangeFormattingEdits(g.URI.revive(ee),re,le,J),void 0)}registerOnTypeFormattingEditProvider(H,ee,re,le){const J=this._addNewAdapter(new $(this._documents,re),H);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(ee),le,H.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(H,ee,re,le,J,ae){return this._withAdapter(H,$,ve=>ve.provideOnTypeFormattingEdits(g.URI.revive(ee),re,le,J,ae),void 0)}registerWorkspaceSymbolProvider(H,ee){const re=this._addNewAdapter(new K(ee,this._logService),H);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(H,ee,re){return this._withAdapter(H,K,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(H,ee,re){return this._withAdapter(H,K,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(H,ee){this._withAdapter(H,K,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(H,ee,re){const le=this._addNewAdapter(new G(this._documents,re,this._logService),H);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),G.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(H,ee,re,le,J){return this._withAdapter(H,G,ae=>ae.provideRenameEdits(g.URI.revive(ee),re,le,J),void 0)}$resolveRenameLocation(H,ee,re,le){return this._withAdapter(H,G,J=>J.resolveRenameLocation(g.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(H,ee,re,le){const J=this._nextHandle(),ae=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new qe(new x(this._documents,re),H)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(ee),le,ae);let ve=this._createDisposable(J);if(ae){const Fe=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(ae));ve=D.Disposable.from(ve,Fe)}return ve}$provideDocumentSemanticTokens(H,ee,re,le){return this._withAdapter(H,x,J=>J.provideDocumentSemanticTokens(g.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(H,ee){this._withAdapter(H,x,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(H,ee,re,le){const J=this._addNewAdapter(new F(this._documents,re),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(ee),le),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(H,ee,re,le){return this._withAdapter(H,F,J=>J.provideDocumentRangeSemanticTokens(g.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(H,ee,re,le){const J=this._addNewAdapter(new V(this._documents,this._commands.converter,re,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(ee),le,V.supportsResolving(re),`${H.identifier.value}(${le.join("")})`),this._createDisposable(J)}$provideCompletionItems(H,ee,re,le,J){return this._withAdapter(H,V,ae=>ae.provideCompletionItems(g.URI.revive(ee),re,le,J),void 0)}$resolveCompletionItem(H,ee,re){return this._withAdapter(H,V,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(H,ee){this._withAdapter(H,V,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(H,ee,re){const le=this._addNewAdapter(new M(this._documents,re,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(H,ee,re,le,J){return this._withAdapter(H,M,ae=>ae.provideInlineCompletions(g.URI.revive(ee),re,le,J),void 0)}$handleInlineCompletionDidShow(H,ee,re){this._withAdapter(H,M,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(H,ee){this._withAdapter(H,M,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(H,ee,re,le){const J=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new q(this._documents,re),H);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(ee),J),this._createDisposable(ae)}$provideSignatureHelp(H,ee,re,le,J){return this._withAdapter(H,q,ae=>ae.provideSignatureHelp(g.URI.revive(ee),re,le,J),void 0)}$releaseSignatureHelp(H,ee){this._withAdapter(H,q,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(H,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new W(this._documents,re),H);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(ee),le);let ae=this._createDisposable(J);if(le!==void 0){const ve=re.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(le));ae=D.Disposable.from(ae,ve)}return ae}$provideInlayHints(H,ee,re,le){return this._withAdapter(H,W,J=>J.provideInlayHints(g.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(H,ee,re){const le=this._addNewAdapter(new X(this._documents,re),H);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(H,ee,re){return this._withAdapter(H,X,le=>le.provideLinks(g.URI.revive(ee),re),void 0)}$resolveDocumentLink(H,ee,re){return this._withAdapter(H,X,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(H,ee){this._withAdapter(H,X,re=>re.releaseLinks(ee),void 0)}registerColorProvider(H,ee,re){const le=this._addNewAdapter(new Z(this._documents,re),H);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(H,ee,re){return this._withAdapter(H,Z,le=>le.provideColors(g.URI.revive(ee),re),[])}$provideColorPresentations(H,ee,re,le){return this._withAdapter(H,Z,J=>J.provideColorPresentations(g.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(H,ee,re){const le=this._nextHandle(),J=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new fe(this._documents,re),H)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),J);let ae=this._createDisposable(le);if(J!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ae=D.Disposable.from(ae,ve)}return ae}$provideFoldingRanges(H,ee,re,le){return this._withAdapter(H,fe,J=>J.provideFoldingRanges(g.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(H,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),H);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(H,ee,re,le){return this._withAdapter(H,_e,J=>J.provideSelectionRanges(g.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(H,ee,re){const le=this._addNewAdapter(new De(this._documents,re),H);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(H,ee,re,le){return this._withAdapter(H,De,J=>Promise.resolve(J.prepareSession(g.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(H,ee,re,le){return this._withAdapter(H,De,J=>J.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(H,ee,re,le){return this._withAdapter(H,De,J=>J.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(H,ee){this._withAdapter(H,De,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(H,ee,re){const le=this._addNewAdapter(new Le(this._documents,re),H);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(H,ee,re,le){return this._withAdapter(H,Le,J=>Promise.resolve(J.prepareSession(g.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(H,ee,re,le){return this._withAdapter(H,Le,J=>J.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(H,ee,re,le){return this._withAdapter(H,Le,J=>J.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(H,ee){this._withAdapter(H,Le,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,C.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:xe._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:xe._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?xe._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?xe._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:xe._serializeRegExp(H.beforeText),afterText:H.afterText?xe._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?xe._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(xe._serializeOnEnterRule)}setLanguageConfiguration(H,ee,re){let{wordPattern:le}=re;if(le&&(0,C.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const J=this._nextHandle(),ae={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?xe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?xe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?xe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,ee,ae),this._createDisposable(J)}$setWordDefinitions(H){for(const ee of H)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=xe,xe._handlePool=0}),define(me[242],ge([0,1,5,15,7,48,17]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(P,n){this._handlePool=0,this._proxy=P.getProxy(g.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,n){await this._proxy.$changeLanguage(P,n);const I=this._documents.getDocumentData(P);if(!I)throw new Error(`document '${P.toString}' NOT found`);return I.document}async tokenAtPosition(P,n){const I=P.version,d=L.Position.from(n),m=await this._proxy.$tokensAtPosition(P.uri,d),u={type:k.StandardTokenType.Other,range:P.getWordRangeAtPosition(n)??new k.Range(n.line,n.character,n.line,n.character)};if(!m)return u;const p={range:L.Range.to(m.range),type:L.TokenType.to(m.type)};return!p.range.contains(n)||I!==P.version?u:p}createLanguageStatusItem(P){const n=this._handlePool++,I=this._proxy,d={selector:P,text:"",detail:"",severity:k.LanguageStatusSeverity.Information};let m;const u=()=>{m?.dispose(),m=(0,A.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:d.selector,text:d.text,message:typeof d.detail=="string"?d.detail:L.MarkdownString.from(d.detail),severity:d.severity===k.LanguageStatusSeverity.Error?D.default.Error:d.severity===k.LanguageStatusSeverity.Warning?D.default.Warning:D.default.Info})},0)},p={get selector(){return d.selector},set selector(_){d.selector=_,u()},get text(){return d.text},set text(_){d.text=_,u()},get detail(){return d.detail},set detail(_){d.detail=_,u()},get severity(){return d.severity},set severity(_){d.severity=_,u()},dispose(){m?.dispose(),I.$removeLanguageStatus(n)}};return u(),p}}e.ExtHostLanguages=C}),define(me[243],ge([0,1,5,12,35]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function D(C){return C&&C.title}let A=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(g.MainContext.MainThreadMessageService)}showMessage(y,P,n,I,d){const m={extension:y};let u;typeof I=="string"||D(I)?u=[I,...d]:(m.modal=I?.modal,m.useCustom=I?.useCustom,m.detail=I?.detail,u=d),m.useCustom&&(0,k.checkProposedApiEnabled)(y);const p=[];for(let _=0;_<u.length;_++){const T=u[_];if(typeof T=="string")p.push({title:T,handle:_,isCloseAffordance:!1});else if(typeof T=="object"){let{title:E,isCloseAffordance:a}=T;p.push({title:E,isCloseAffordance:!!a,handle:_})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(P,n,m,p).then(_=>{if(typeof _=="number")return u[_]})}};A=ze([Ue(1,L.ILogService)],A),e.ExtHostMessageService=A}),define(me[244],ge([0,1,22,3,58,6,24,9,14,2,87,5,15,7,65,219,130]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(a,l,v,t,r){this._textDocumentsAndEditors=v,this._textDocuments=t,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,c=s.cell.handle,h=this._documents.get(i)?.getCell(c);if(h)return h.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const l=this._editors.get(a);if(!l)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(a){for(const[l,v]of this._editors)if(v.apiEditor===a)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,l){const v=this._documents.get(a);if(!v&&!l)throw new Error(`NO notebook document for '${a}'`);return v}_getProviderData(a){const l=this._notebookContentProviders.get(a);if(!l)throw new Error(`NO provider for '${a}'`);return l}registerNotebookContentProvider(a,l,v,t,r){if((0,C.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:a,provider:v});let s;return v.onDidChangeNotebookContentOptions&&(s=v.onDidChangeNotebookContentOptions(()=>{const i=d.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(l,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},l,d.NotebookDocumentContentOptions.from(t),T._convertNotebookRegistrationData(a,r)),new m.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(a,l){if(!l)return;const v=l.filenamePattern.map(t=>d.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(l.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:l.displayName,filenamePattern:v,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,l,v){const t=T._notebookStatusBarItemProviderHandlePool++,r=typeof v.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,r,l);let s;return r!==void 0&&(s=v.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,r),s&&s.dispose()})}async createNotebookDocument(a){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&d.NotebookData.from(a.content)});return P.URI.revive(l)}async openNotebookDocument(a){const l=this._documents.get(a);if(l)return l.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(a),t=this._documents.get(P.URI.revive(v));return(0,y.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(a,l){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let v;typeof l=="object"?v={position:d.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(d.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,v),r=t&&this._editors.get(t)?.apiEditor;if(r)return r;throw t?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,l,v,t){const r=this._notebookStatusBarItemProviders.get(a),s=P.URI.revive(l),i=this._documents.get(s);if(!i||!r)return;const c=i.getCellFromIndex(v);if(!c)return;const f=await r.provideCellStatusBarItems(c.apiCell,t);if(!f)return;const h=new D.DisposableStore,b=this._statusBarCache.add([h]),o=(Array.isArray(f)?f:[f]).map(w=>d.NotebookStatusBarItem.from(w,this._commandsConverter,h));return{cacheId:b,items:o}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,l,v,t,r){if((0,C.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,v),this._notebookProxy.$registerNotebookSerializer(s,{id:a.identifier,location:a.extensionLocation},l,d.NotebookDocumentContentOptions.from(t),T._convertNotebookRegistrationData(a,r)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(a,l,v){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const r=await t.deserializeNotebook(l.buffer,v);return new u.SerializableObjectWithBuffers(d.NotebookData.from(r))}async $notebookToData(a,l,v){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const r=await t.serializeNotebook(d.NotebookData.to(l.value),v);return g.VSBuffer.wrap(r)}async $openNotebook(a,l,v,t,r){const{provider:s}=this._getProviderData(a),i=await s.openNotebook(P.URI.revive(l),{backupId:v,untitledDocumentData:t?.buffer},r);return new u.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(d.NotebookCellData.from)})}async $saveNotebook(a,l,v){const t=this.getNotebookDocument(P.URI.revive(l)),{provider:r}=this._getProviderData(a);return await r.saveNotebook(t.apiNotebook,v),!0}async $saveNotebookAs(a,l,v,t){const r=this.getNotebookDocument(P.URI.revive(l)),{provider:s}=this._getProviderData(a);return await s.saveNotebookAs(P.URI.revive(v),r.apiNotebook,t),!0}async $backupNotebook(a,l,v){const t=this.getNotebookDocument(P.URI.revive(l)),r=this._getProviderData(a),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,k.hash)([t.uri.toString(),this._backupIdPool++])),c=P.URI.joinPath(s,i),f=await r.provider.backupNotebook(t.apiNotebook,{destination:c},v);return t.updateBackup(f),f.id}_createExtHostEditor(a,l,v){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const t=new _.ExtHostNotebookEditor(l,this._notebookEditorsProxy,a,v.visibleRanges.map(d.NotebookRange.to),v.selections.map(d.NotebookRange.to),typeof v.viewColumn=="number"?d.ViewColumn.to(v.viewColumn):void 0);this._editors.set(l,t)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const v of a.value.removedDocuments){const t=P.URI.revive(v),r=this._documents.get(t);r&&(r.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===t.toString()&&this._editors.delete(s.id)}if(a.value.addedDocuments){const v=[];for(const t of a.value.addedDocuments){const r=P.URI.revive(t.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=this,i=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){s._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){s._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){s._onDidChangeCellMetadata.fire(c)},emitCellExecutionStateChange(c){s._onDidChangeCellExecutionState.fire(c)}},r,t);v.push(...t.cells.map(c=>p.ExtHostCell.asModelAddData(i.apiNotebook,c))),this._documents.get(r)?.dispose(),this._documents.set(r,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const v of a.value.addedEditors){if(this._editors.has(v.id))return;const t=P.URI.revive(v.documentUri),r=this._documents.get(t);r&&this._createExtHostEditor(r,v.id,v)}const l=[];if(a.value.removedEditors)for(const v of a.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),l.push(t))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const r=v.has(t.id);t._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(me[245],ge([0,1,3,75,12,5,13,15]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(I,d){const m=y._Keys.nextId();I.$registerNotebookEditorDecorationType(m,C.NotebookDecorationRenderOptions.from(d)),this.value={key:m,dispose(){I.$removeNotebookEditorDecorationType(m)}}}}y._Keys=new L.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(I,d,m){this._logService=I,this._extHostRpc=d,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new y(this._extHostRpc.getProxy(D.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,d){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,d);const m=this._notebooksAndEditors.getEditorById(I);d.visibleRanges&&m._acceptVisibleRanges(d.visibleRanges.ranges.map(C.NotebookRange.to)),d.selections&&m._acceptSelections(d.selections.selections.map(C.NotebookRange.to)),d.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),d.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const d in I)this._notebooksAndEditors.getEditorById(d)._acceptViewColumn(C.ViewColumn.to(I[d]))}};P=ze([Ue(0,k.ILogService),Ue(1,A.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(me[246],ge([0,1,20,17,21,3,6,24,2,26,12,5,15,7,89,212,35,65]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(r,s,i,c){this._initData=s,this._extHostNotebook=i,this._logService=c,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels)}createNotebookController(r,s,i,c,f,h){for(let U of this._kernelData.values())if(U.controller.id===s&&P.ExtensionIdentifier.equals(r.identifier,U.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const b=this._handlePool++,S=this;this._logService.trace(`NotebookController[${b}], CREATED by ${r.identifier.value}, ${s}`);const o=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${r.identifier}'`);let w=!1;const R=new A.DisposableStore,O=new D.Emitter,$=new D.Emitter,K={id:`${r.identifier.value}/${s}`,notebookType:i,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:c||r.identifier.value,preloads:h?h.map(d.NotebookRendererScript.from):[]};let G=f??o,N;this._proxy.$addKernel(b,K).catch(U=>{console.log(U),w=!0});let x=0;const F=()=>{if(w)return;const U=++x;Promise.resolve().then(()=>{U===x&&this._proxy.$updateKernel(b,K)})},V=new C.ResourceMap,M={get id(){return s},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return K.label},set label(U){K.label=U??r.displayName??r.name,F()},get detail(){return K.detail??""},set detail(U){K.detail=U,F()},get description(){return K.description??""},set description(U){K.description=U,F()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(U){K.supportedLanguages=U,F()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(U){K.supportsExecutionOrder=U,F()},get rendererScripts(){return K.preloads?K.preloads.map(d.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(U){G=U??o},get interruptHandler(){return N},set interruptHandler(U){N=U,K.supportsInterrupt=Boolean(U),F()},createNotebookCellExecution(U){if(w)throw new Error("notebook controller is DISPOSED");if(!V.has(U.notebook.uri))throw S._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(q=>q.toString())),new Error(`notebook controller is NOT associated to notebook: ${U.notebook.uri.toString()}`);return S._createNotebookCellExecution(U)},dispose:()=>{w||(this._logService.trace(`NotebookController[${b}], DISPOSED`),w=!0,this._kernelData.delete(b),R.dispose(),O.dispose(),$.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(U,q){S._proxy.$updateNotebookPriority(b,U.uri,q)},onDidReceiveMessage:$.event,postMessage(U,q){return(0,_.checkProposedApiEnabled)(r),S._proxy.$postMessage(b,q&&S._extHostNotebook.getIdByEditor(q),U)},asWebviewUri(U){return(0,_.checkProposedApiEnabled)(r),(0,u.asWebviewUri)(U,S._initData.remote)}};return this._kernelData.set(b,{extensionId:r.identifier,controller:M,onDidReceiveMessage:$,onDidChangeSelection:O,associatedNotebooks:V}),M}$acceptNotebookAssociation(r,s,i){const c=this._kernelData.get(r);if(c){const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));i?c.associatedNotebooks.set(f.uri,!0):c.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,f.uri.toString(),i),c.onDidChangeSelection.fire({selected:i,notebook:f.apiNotebook})}}async $executeCells(r,s,i){const c=this._kernelData.get(r);if(!c)return;const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(s)),h=[];for(let b of i){const S=f.getCell(b);S&&h.push(S.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,f.uri.toString(),h.length),await c.controller.executeHandler.call(c.controller,h,f.apiNotebook,c.controller)}catch(b){this._logService.error(`NotebookController[${r}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(r,s,i){const c=this._kernelData.get(r);if(!c)return;const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,f.apiNotebook);else for(let h of i){const b=f.getCell(h);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,i){const c=this._kernelData.get(r);if(!c)return;const f=this._extHostNotebook.getEditorById(s);c.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:i}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const c=new l(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,c);const f=c.onDidChangeState(()=>{c.state===a.Resolved&&(c.dispose(),f.dispose(),this._activeExecutions.delete(i.uri))});return c.asApiObject()}};E=ze([Ue(3,n.ILogService)],E),e.ExtHostNotebookKernels=E;var a;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(a||(a={}));class l extends A.Disposable{constructor(r,s,i){super();this._document=r,this._cell=s,this._proxy=i,this._handle=l.HANDLE++,this._onDidChangeState=new D.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new v(10,c=>this.update(c)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new T.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const i=m.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?d.NotebookCellOutput.from(s):d.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,i){const c=this.cellIndexToHandle(s),f=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:c,append:i,outputs:f})}async updateOutputItems(r,s,i){return r=m.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(d.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(i){r._executionOrder=i,r.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(i){if(r._state===a.Resolved||r._state===a.Started)throw new Error("Cannot call start again");r._state=a.Started,r._onDidChangeState.fire(),r.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:i})},end(i,c){if(r._state===a.Resolved)throw new Error("Cannot call resolve twice");r._state=a.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:c,lastRunSuccess:i}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(i){return r.verifyStateForOutput(),r.updateOutputs([],i,!1)},appendOutput(i,c){return r.verifyStateForOutput(),r.updateOutputs(i,c,!0)},replaceOutput(i,c){return r.verifyStateForOutput(),r.updateOutputs(i,c,!1)},appendOutputItems(i,c){return r.verifyStateForOutput(),r.updateOutputItems(i,c,!0)},replaceOutputItems(i,c){return r.verifyStateForOutput(),r.updateOutputItems(i,c,!1)}})}}l.HANDLE=0;class v{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.lastFlush=Date.now()}addItem(r){return this.batch.push(r),this.waitPromise||(this.waitPromise=(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.lastFlush>this.delay&&this.flush(),this.waitPromise}flush(){if(this.batch.length===0)return;this.lastFlush=Date.now(),this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)}}}),define(me[247],ge([0,1,3,5,130]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class D{constructor(C,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,y,P){const n=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:P})}createRendererMessaging(C,y){if(!C.contributes?.notebookRenderer?.some(d=>d.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const P=!!C.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(d,m,u)=>{const p=P?d:_=>{const T={};n.set(T,_.editor),d({editor:T,message:_.message})};return this.getOrCreateEmitterFor(y).event(p,m,u)},postMessage:(d,m)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,m]=[m,d]);const u=P?m:n.get(m),p=u&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(p?.id,y,d)}}}getOrCreateEmitterFor(C){let y=this._rendererMessageEmitters.get(C);return y||(y=new g.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,y),y)}}e.ExtHostNotebookRenderers=D}),define(me[67],ge([0,1,5,3,6,22,4,13]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends k.Disposable{constructor(u,p,_,T,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=E,this._id=E.$register(this.name,p,_,T),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?D.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(p=>this._proxy.$clear(p,u))}show(u,p){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof u=="boolean"?u:p)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class P extends y{constructor(u,p,_){super(u,!1,void 0,p,_)}append(u){super.append(u),this._id.then(p=>this._proxy.$append(p,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class n extends y{constructor(u,p,_){super(u,!0,p,void 0,_)}append(u){throw new Error("Not supported")}}class I{constructor(u,p){this.name=u,this._channel=p}append(u){this._channel.then(p=>p.append(u))}appendLine(u){this._channel.then(p=>p.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,p){this._channel.then(_=>_.show(u,p))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=I;let d=class{constructor(u){this._proxy=u.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,p){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new P(u,p.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,p){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!p)throw new Error("illegal argument `file`. must not be falsy");return new n(u,p,this._proxy)}};d=ze([Ue(0,C.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(me[248],ge([0,1,17,21,3,6,5,2,7,16,20,48,62]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(u,p,_){const T=u.getProxy(A.MainContext.MainThreadQuickOpen);class E{constructor(f,h){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=h}showQuickPick(f,h,b,S=L.CancellationToken.None){this._onDidSelectItem=void 0;const o=Promise.resolve(f),w=++this._instances,R=T.$show(w,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},S),O={},$=R.then(()=>O);return Promise.race([$,o]).then(K=>{if(K!==O)return o.then(G=>{const N=[];for(let x=0;x<G.length;x++){const F=G[x];let V,M,U,q,W;typeof F=="string"?V=F:(V=F.label,M=F.description,U=F.detail,q=F.picked,W=F.alwaysShow),N.push({label:V,description:M,handle:x,detail:U,picked:q,alwaysShow:W})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{b.onDidSelectItem(G[x])}),T.$setItems(w,N),R.then(x=>{if(typeof x=="number")return G[x];if(Array.isArray(x))return x.map(F=>G[F])})})}).then(void 0,K=>{if(!(0,P.isPromiseCanceledError)(K))return T.$setError(w,K),Promise.reject(K)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,h=L.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,T.$input(f,typeof this._validateInput=="function",h).then(void 0,b=>{if(!(0,P.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(f){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,h=L.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!b)return;const S=await this._workspace.getWorkspaceFolders2();if(!!S)return S.find(o=>o.uri.toString()===b.uri.toString())}createQuickPick(f,h){const b=new s(f,h,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(f){const h=new i(f,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(f,h){const b=this._sessions.get(f);b&&b._fireDidChangeValue(h)}$onDidAccept(f){const h=this._sessions.get(f);h&&h._fireDidAccept()}$onDidChangeActive(f,h){const b=this._sessions.get(f);b instanceof s&&b._fireDidChangeActive(h)}$onDidChangeSelection(f,h){const b=this._sessions.get(f);b instanceof s&&b._fireDidChangeSelection(h)}$onDidTriggerButton(f,h){const b=this._sessions.get(f);b&&b._fireDidTriggerButton(h)}$onDidTriggerItemButton(f,h,b){const S=this._sessions.get(f);S instanceof s&&S._fireDidTriggerItemButton(h,b)}$onDidHide(f){const h=this._sessions.get(f);h&&h._fireDidHide()}}class a{constructor(f,h){this._extensionId=f,this._onDidDispose=h,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((h,b)=>{const S=h===y.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(S,h)}),this.update({buttons:f.map((h,b)=>({...r(h),tooltip:h.tooltip,handle:h===y.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const h=this._handlesToButtons.get(f);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(f){if(!this._disposed){for(const h of Object.keys(f)){const b=f[h];this._pendingUpdate[h]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function l(c){if(c instanceof y.ThemeIcon)return{id:c.id};const f=t(c),h=v(c);return{dark:typeof f=="string"?C.URI.file(f):f,light:typeof h=="string"?C.URI.file(h):h}}function v(c){return typeof c=="object"&&"light"in c?c.light:c}function t(c){return typeof c=="object"&&"dark"in c?c.dark:c}function r(c){const f=l(c.iconPath);let h,b;return"id"in f?b=d.ThemeIcon.asClassName(f):h=f,{iconPath:h,iconClass:b}}class s extends a{constructor(f,h,b){super(f,b);this.enableProposedApi=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((h,b)=>{this._handlesToItems.set(b,h),this._itemsToHandles.set(h,b)}),this.update({items:f.map((h,b)=>({label:h.label,description:h.description,handle:b,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons&&this.enableProposedApi?h.buttons.map((S,o)=>({...r(S),tooltip:S.tooltip,handle:o})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(f){const h=(0,n.coalesce)(f.map(b=>this._handlesToItems.get(b)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(f){const h=(0,n.coalesce)(f.map(b=>this._handlesToItems.get(b)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(f,h){const b=this._handlesToItems.get(f);if(!b||!b.buttons||!b.buttons.length)return;const S=b.buttons[h];S&&this._onDidTriggerItemButtonEmitter.fire({button:S,item:b})}}class i extends a{constructor(f,h){super(f,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?I.default.Error:I.default.Ignore})}}return new E(p,_)}e.createExtHostQuickOpen=m}),define(me[249],ge([0,1,2,3,56,6,17,5,20,100,12,26,35,62,15]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(f){if(f)return typeof f.iconPath=="string"?g.URI.file(f.iconPath):g.URI.isUri(f.iconPath)||m.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function _(f,h){if(!f.iconPath&&!h.iconPath)return 0;if(f.iconPath){if(!h.iconPath)return 1}else return-1;const b=typeof f.iconPath=="string"?f.iconPath:g.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,S=typeof h.iconPath=="string"?h.iconPath:g.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,P.comparePaths)(b,S)}function T(f,h){let b=0;if(f.strikeThrough!==h.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==h.faded)return f.faded?1:-1;if(f.tooltip!==h.tooltip)return(f.tooltip||"").localeCompare(h.tooltip||"");if(b=_(f,h),b!==0)return b;if(f.light&&h.light)b=_(f.light,h.light);else{if(f.light)return 1;if(h.light)return-1}if(b!==0)return b;if(f.dark&&h.dark)b=_(f.dark,h.dark);else{if(f.dark)return 1;if(h.dark)return-1}return b}function E(f,h){if(f.command!==h.command)return f.command<h.command?-1:1;if(f.title!==h.title)return f.title<h.title?-1:1;if(f.tooltip!==h.tooltip){if(f.tooltip!==void 0&&h.tooltip!==void 0)return f.tooltip<h.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(f.arguments===h.arguments)return 0;if(f.arguments)if(h.arguments){if(f.arguments.length!==h.arguments.length)return f.arguments.length-h.arguments.length}else return 1;else return-1;for(let b=0;b<f.arguments.length;b++){const S=f.arguments[b],o=h.arguments[b];if(S!==o)return S<o?-1:1}return 0}function a(f,h){let b=(0,P.comparePaths)(f.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(b!==0)return b;if(f.command&&h.command)b=E(f.command,h.command);else{if(f.command)return 1;if(h.command)return-1}if(b!==0)return b;if(f.decorations&&h.decorations)b=T(f.decorations,h.decorations);else{if(f.decorations)return 1;if(h.decorations)return-1}return b}function l(f,h){for(let b=0;b<f.length;b++)if(f[b]!==h[b])return!1;return!0}function v(f,h){return f.command===h.command&&f.title===h.title&&f.tooltip===h.tooltip&&(f.arguments&&h.arguments?l(f.arguments,h.arguments):f.arguments===h.arguments)}function t(f,h){return(0,y.equals)(f,h,v)}class r{constructor(h,b,S){this._extension=h,this._proxy=b,this._sourceControlHandle=S,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(h){this._proxy.$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(h){if((0,d.checkProposedApiEnabled)(this._extension),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,h))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(h,b){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,h,b)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=r;class s{constructor(h,b,S,o,w){this._proxy=h,this._commands=b,this._sourceControlHandle=S,this._id=o,this._label=w,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,b){const S=this._resourceStatesCommandsMap.get(h);return S?(0,A.asPromise)(()=>this._commands.executeCommand(S.command,...S.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(a),S=(0,y.sortedDiff)(this._resourceSnapshot,h,a).map(R=>{const O=R.toInsert.map($=>{const K=this._resourceHandlePool++;this._resourceStatesMap.set(K,$);const G=$.resourceUri;let N;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const fe=new D.DisposableStore;N=this._commands.converter.toInternal($.command,fe),this._resourceStatesDisposablesMap.set(K,fe)}else this._resourceStatesCommandsMap.set(K,$.command);const x=p($.decorations),F=$.decorations&&p($.decorations.light)||x,V=$.decorations&&p($.decorations.dark)||x,M=[F,V],U=$.decorations&&$.decorations.tooltip||"",q=$.decorations&&!!$.decorations.strikeThrough,W=$.decorations&&!!$.decorations.faded,X=$.contextValue||"";return{rawResource:[K,G,M,U,q,W,X,N],handle:K}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),o=S.map(({start:R,deleteCount:O,toInsert:$})=>[R,O,$.map(K=>K.rawResource)]),w=S.reverse();for(const{start:R,deleteCount:O,toInsert:$}of w){const K=$.map(N=>N.handle),G=this._handlesSnapshot.splice(R,O,...K);for(const N of G)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=h,o}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(h,b,S,o,w,R){this._proxy=b,this._commands=S,this._id=o,this._label=w,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new D.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(h,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,o,w,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,this._proxy.$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,this._proxy.$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new D.DisposableStore,this._acceptInputCommand=h;const b=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&t(this._statusBarCommands,h))return;this._statusBarDisposables.value=new D.DisposableStore,this._statusBarCommands=h;const b=(h||[]).map(S=>this._commands.converter.toInternal(S,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(h,b){const S=new s(this._proxy,this._commands,this.handle,h,b),o=L.Event.once(S.onDidDispose)(()=>this.createdResourceGroups.delete(S));return this.createdResourceGroups.set(S,o),this.eventuallyAddResourceGroups(),S}eventuallyAddResourceGroups(){const h=[],b=[];for(const[S,o]of this.createdResourceGroups){o.dispose();const w=S.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(S),this.eventuallyUpdateResourceStates()});L.Event.once(S.onDidDispose)(()=>{this.updatedResourceGroups.delete(S),w.dispose(),this._groups.delete(S.handle),this._proxy.$unregisterGroup(this.handle,S.handle)}),h.push([S.handle,S.id,S.label,S.features]);const R=S._takeResourceStateSnapshot();R.length>0&&b.push([S.handle,R]),this._groups.set(S.handle,S)}this._proxy.$registerGroups(this.handle,h,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(b=>{const S=b._takeResourceStateSnapshot();S.length!==0&&h.push([b.handle,S])}),h.length>0&&this._proxy.$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,ze([(0,k.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),ze([(0,k.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let c=class xn{constructor(h,b,S){this._commands=b,this.logService=S,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=h.getProxy(C.MainContext.MainThreadSCM),this._telemetry=h.getProxy(C.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===3){const w=this._sourceControls.get(o.sourceControlHandle);if(!w)return o;const R=w.getResourceGroup(o.groupHandle);return R?R.getResourceState(o.handle):o}else if(o&&o.$mid===4){const w=this._sourceControls.get(o.sourceControlHandle);return w?w.getResourceGroup(o.groupHandle):o}else if(o&&o.$mid===5){const w=this._sourceControls.get(o.handle);return w||o}return o}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,b,S,o){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,b,S,o),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const w=xn._handlePool++,R=new i(h,this._proxy,this._commands,b,S,o);this._sourceControls.set(w,R);const O=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier))||[];return O.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(h.identifier),O),R}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const b=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier)),S=b&&b[b.length-1];return S&&S.inputBox}$provideOriginalResource(h,b,S){const o=g.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,o.toString());const w=this._sourceControls.get(h);return!w||!w.quickDiffProvider||!w.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>w.quickDiffProvider.provideOriginalResource(o,S)).then(R=>R||null)}$onInputBoxValueChange(h,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const S=this._sourceControls.get(h);return S&&S.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(h,b,S,o){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,b,S);const w=this._sourceControls.get(h);if(!w)return Promise.resolve(void 0);const R=w.getResourceGroup(b);return R?R.$executeResourceCommand(S,o):Promise.resolve(void 0)}$validateInput(h,b,S){this.logService.trace("ExtHostSCM#$validateInput",h);const o=this._sourceControls.get(h);return!o||!o.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>o.inputBox.validateInput(b,S)).then(w=>{if(!w)return Promise.resolve(void 0);const R=u.MarkdownString.fromStrict(w.message);return R?Promise.resolve([R,w.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};c._handlePool=0,c=ze([Ue(2,n.ILogService)],c),e.ExtHostSCM=c});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[250],ge([0,1,7,5,167,6,15]),function(Y,e,g,L,k,D,A){"use strict";var C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(m,u,p,_,T=g.StatusBarAlignment.Left,E){C.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new D.DisposableStore,rt(this,C,m,"f"),rt(this,y,u,"f"),this._entryId=P.ID_GEN++,this._extension=p,this._id=_,this._alignment=T,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!P.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Be(this,y,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Be(this,y,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let u;this._name?u=this._name:u=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,C,"f").$setEntry(this._entryId,m,u,this._text,_,this._command?.internal,p,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,C=new WeakMap,y=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const u={message:m};return this._messages.unshift(u),this._update(),new g.Disposable(()=>{const p=this._messages.indexOf(u);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(m,u){this._proxy=m.getProxy(L.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(m,u,p,_){return new P(this._proxy,this._commands,m,u,p,_)}setStatusBarMessage(m,u){const p=this._statusMessage.setMessage(m);let _;return typeof u=="number"?_=setTimeout(()=>p.dispose(),u):typeof u!="undefined"&&u.then(()=>p.dispose(),()=>p.dispose()),new g.Disposable(()=>{p.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=I}),define(me[93],ge([0,1,5,3,4]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class D{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,y){this._proxy.$registerExtensionStorageKeysToSync(C,y)}getValue(C,y,P){return this._proxy.$getValue(C,y).then(n=>n||P)}setValue(C,y,P){return this._proxy.$setValue(C,y,P)}$acceptValue(C,y,P){this._onDidChangeStorage.fire({shared:C,key:y,value:P})}}e.ExtHostStorage=D,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(me[68],ge([0,1,4,27,12,92,2]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,n,I){this._logService=n,this._extHostFileSystem=I,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getWorkspaceStorageURI(P){return A.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,n=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=ze([Ue(0,L.IExtHostInitDataService),Ue(1,k.ILogService),Ue(2,D.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,13,6,7,168,16,214,21,32,195,62,14]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class T{constructor(c,f,h,b){this._proxy=c,this._id=f,this._creationOptions=h,this._name=b,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(o=>this._pidPromiseComplete=o);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(o,w=!0){S._checkDisposed(),S._proxy.$sendText(S._id,o,w)},show(o){S._checkDisposed(),S._proxy.$show(S._id,o)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(c,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,_.withNullAsUndefined)(c.shellPath),shellArgs:(0,_.withNullAsUndefined)(c.shellArgs),cwd:(0,_.withNullAsUndefined)(c.cwd),env:(0,_.withNullAsUndefined)(c.env),icon:(0,_.withNullAsUndefined)(r(c.iconPath)),color:p.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,_.withNullAsUndefined)(c.message),strictEnv:(0,_.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(f?.useShellEnvironment),isSplitTerminal:f?.isSplitTerminal,target:f?.target})}async createExtensionTerminal(c,f,h,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:p.ThemeColor.isThemeColor(b)?b.id:void 0,isSplitTerminal:c,target:f}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,f){return c===this._cols&&f===this._rows||c===0||f===0?!1:(this._cols=c,this._rows=f,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=T;class E{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,f){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:f})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose&&this._pty.onDidClose((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f&&{cols:f.columns,rows:f.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(f=>this._onProcessTitleChanged.fire(f)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let a=1,l=class extends C.Disposable{constructor(c,f){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=f.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[h,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,f){const h=new T(this._proxy,(0,m.generateUuid)(),c,c.name),b=new E(c.pty);return h.createExtensionTerminal(f?.isSplitTerminal,f?.target,r(c.iconPath),s(c.color)).then(S=>{const o=this._setupExtHostProcessListeners(S,b);this._terminalProcessDisposables[S]=o}),this._terminals.push(h),h.value}attachPtyToTerminal(c,f){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const b=new E(f),S=this._setupExtHostProcessListeners(c,b);this._terminalProcessDisposables[c]=S}async $acceptActiveTerminalChanged(c){const f=this._activeTerminal;if(c===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(c);h&&(this._activeTerminal=h,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,f){const h=this._getTerminalById(c);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:f})}async $acceptTerminalDimensions(c,f,h){const b=this._getTerminalById(c);b&&b.setDimensions(f,h)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(c,f,h){this._terminalProcesses.get(c)?.resize(f,h)}async $acceptTerminalTitleChange(c,f){const h=this._getTerminalById(c);h&&(h.name=f)}async $acceptTerminalClosed(c,f){const h=this._getTerminalObjectIndexById(this._terminals,c);if(h!==null){const b=this._terminals.splice(h,1)[0];b.setExitCode(f),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(c,f,h,b){if(f){const w=this._getTerminalObjectIndexById(this._terminals,f);if(w!==null){this._terminals[w]._id=c,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const S={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:D.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},o=new T(this._proxy,c,S,h);this._terminals.push(o),this._onDidOpenTerminal.fire(o.value),o.isOpen=!0}async $acceptTerminalProcessId(c,f){const h=this._getTerminalById(c);h&&h._setProcessId(f)}async $startExtensionTerminal(c,f){const h=this._getTerminalById(c);if(!h)return{message:(0,P.localize)(0,null,c)};h.isOpen||await new Promise(S=>{const o=this.onDidOpenTerminal(async w=>{w===h.value&&(o.dispose(),S())})});const b=this._terminalProcesses.get(c);b?b.startSendingEvents(f):this._extensionTerminalAwaitingStart[c]={initialDimensions:f}}_setupExtHostProcessListeners(c,f){const h=new C.DisposableStore;h.add(f.onProcessReady(S=>this._proxy.$sendProcessReady(c,S.pid,S.cwd))),h.add(f.onProcessTitleChanged(S=>this._proxy.$sendProcessTitle(c,S))),this._bufferer.startBuffering(c,f.onProcessData),h.add(f.onProcessExit(S=>this._onProcessExit(c,S))),f.onProcessOverrideDimensions&&h.add(f.onProcessOverrideDimensions(S=>this._proxy.$sendOverrideDimensions(c,S))),this._terminalProcesses.set(c,f);const b=this._extensionTerminalAwaitingStart[c];return b&&f instanceof E&&(f.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),h}$acceptProcessAckDataEvent(c,f){this._terminalProcesses.get(c)?.acknowledgeDataEvent(f)}$acceptProcessInput(c,f){this._terminalProcesses.get(c)?.input(f)}$acceptTerminalInteraction(c){const f=this._getTerminalById(c);f?.setInteractedWith()&&this._onDidChangeTerminalState.fire({terminal:f.value,state:f.value.state})}$acceptProcessResize(c,f,h){try{this._terminalProcesses.get(c)?.resize(f,h)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(c,f){this._terminalProcesses.get(c)?.shutdown(f)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(f=>this._proxy.$sendProcessInitialCwd(c,f))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(f=>this._proxy.$sendProcessCwd(c,f))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,f,h){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,h),this._proxy.$registerProfileProvider(f,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}async $createContributedProfileTerminal(c,f){const h=new d.CancellationTokenSource().token,b=await this._profileProviders.get(c)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,f);return}this.createTerminalFromOptions(b.options,f)}}async $provideLinks(c,f){const h=this._getTerminalById(c);if(!h)return[];this._terminalLinkCache.delete(c);const b=this._terminalLinkCancellationSource.get(c);b&&b.dispose(!0);const S=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,S);const o=[],w={terminal:h.value,line:f},R=[];for(const K of this._linkProviders)R.push(new Promise(async G=>{S.token.onCancellationRequested(()=>G({provider:K,links:[]}));const N=await K.provideTerminalLinks(w,S.token)||[];S.token.isCancellationRequested||G({provider:K,links:N})}));const O=await Promise.all(R);if(S.token.isCancellationRequested)return[];const $=new Map;for(const K of O)K&&K.links.length>0&&o.push(...K.links.map(G=>{const N={id:a++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return $.set(N.id,{provider:K.provider,link:G}),N}));return this._terminalLinkCache.set(c,$),o}$activateLink(c,f){const h=this._terminalLinkCache.get(c)?.get(f);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(c,f){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const h=this._terminalProcessDisposables[c];h&&(h.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,f)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,f){const h=this._getTerminalObjectIndexById(c,f);return h!==null?c[h]:null}_getTerminalObjectIndexById(c,f){let h=null;return c.some((b,S)=>b._id===f?(h=S,!0):!1),h}getEnvironmentVariableCollection(c){let f=this._environmentVariableCollections.get(c.identifier.value);return f||(f=new v,this._setEnvironmentVariableCollection(c.identifier.value,f)),f}_syncEnvironmentVariableCollection(c,f){const h=(0,I.serializeEnvironmentVariableCollection)(f.map);this._proxy.$setEnvironmentVariableCollection(c,f.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(c){c.forEach(f=>{const h=f[0],b=new v(f[1]);this._setEnvironmentVariableCollection(h,b)})}$acceptDefaultProfile(c,f){this._defaultProfile=c,this._defaultAutomationProfile=f}_setEnvironmentVariableCollection(c,f){this._environmentVariableCollections.set(c,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,f)})}};l=ze([Ue(1,A.IExtHostRpcService)],l),e.BaseExtHostTerminalService=l;class v{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,f){this._setIfDiffers(c,{value:f,type:y.EnvironmentVariableMutatorType.Replace})}append(c,f){this._setIfDiffers(c,{value:f,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,f){this._setIfDiffers(c,{value:f,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,f){const h=this.map.get(c);(!h||h.value!==f.value||h.type!==f.type)&&(this.map.set(c,f),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,f){this.map.forEach((h,b)=>c.call(f,b,h,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends l{constructor(c){super(!1,c)}createTerminal(c,f,h){throw new n.NotSupportedError}createTerminalFromOptions(c,f){throw new n.NotSupportedError}};t=ze([Ue(0,A.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function s(i){return p.ThemeColor.isThemeColor(i)?i:void 0}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[251],ge([0,1,22,21,3,74,58,76,6,23,14,32,5,13,88,15,7,222,128,90]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(R,O){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(d.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new r(this.proxy),O.registerArgumentProcessor({processArgument:$=>$?.$mid===13?p.TestItem.toItemFromContext($):$})}createTestController(R,O){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const $=new y.DisposableStore,K=$.add(new T.SingleUseTestCollection(R));K.root.label=O;const G=new Map,N=this.proxy,x={items:K.root.children,get label(){return O},set label(V){O=V,K.root.label=V,N.$updateControllerLabel(R,O)},get id(){return R},createRunProfile:(V,M,U,q,W)=>{let X=(0,A.hash)(V);for(;G.has(X);)X++;const Z=new S(this.proxy,R,X,V,M,U,q,W);return G.set(X,Z),Z},createTestItem(V,M,U){return new u.TestItemImpl(R,V,M,U)},createTestRun:(V,M,U=!0)=>this.runTracker.createTestRun(R,K,V,M,U),set resolveHandler(V){K.resolveHandler=V},get resolveHandler(){return K.resolveHandler},dispose:()=>{$.dispose()}};x.createRunConfiguration=x.createRunProfile,N.$registerTestController(R,O),$.add((0,y.toDisposable)(()=>N.$unregisterTestController(R)));const F={controller:x,collection:K,profiles:G};return this.controllers.set(R,F),$.add((0,y.toDisposable)(()=>this.controllers.delete(R))),$.add(K.onDidGenerateDiff(V=>N.$publishDiff(R,V))),x}createTestObserver(){return this.observer.checkout()}async runTests(R,O=L.CancellationToken.None){const $=s(R);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const K=this.controllers.get($.controllerId);if(!K)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(G=>G.id)??[K.collection.root.id],profileGroup:o[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:R.exclude?.map(G=>G.id)},O)}$provideFileCoverage(R,O,$){return C.Iterable.find(this.runTracker.trackers,K=>K.id===R)?.getCoverage(O)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(R,O,$,K){return C.Iterable.find(this.runTracker.trackers,G=>G.id===R)?.getCoverage(O)?.resolveFileCoverage($,K)??Promise.resolve([])}$configureRunProfile(R,O){this.controllers.get(R)?.profiles.get(O)?.configureHandler?.()}$getTestTags(R){const O=this.controllers.get(R);if(!O)return Promise.resolve([]);const $=new Map;for(const K of O.profiles.values())if(K.tag){const G=p.TestTag.display(R,K.tag);$.set(G.id,G)}for(const K of O.collection.tags()){const G=p.TestTag.display(R,K);$.set(G.id,G)}return Promise.resolve([...$.values()])}$publishTestResults(R){this.results=Object.freeze(R.map(O=>(0,P.deepFreeze)(p.TestResults.to(O))).concat(this.results).sort((O,$)=>$.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,O){const $=this.controllers.get(a.TestId.fromString(R).controllerId)?.collection;$&&(await $.expand(R,O<0?Infinity:O),$.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,O){const $=this.controllers.get(R.controllerId);if(!$)return;const{collection:K,profiles:G}=$,N=G.get(R.profileId);if(!N)return;const x=R.testIds.map(U=>K.tree.get(U)).filter(n.isDefined),F=R.excludeExtIds.map(U=>$.collection.tree.get(U)).filter(n.isDefined).filter(U=>x.some(q=>q.fullId.compare(U.fullId)===2));if(!x.length)return;const V=new _.TestRunRequest(x.some(U=>U.actual instanceof u.TestItemRootImpl)?void 0:x.map(U=>U.actual),F.map(U=>U.actual),N),M=this.runTracker.prepareForMainThreadTestRun(V,i.fromInternal(R,$.collection),O);try{await N.runHandler(V,O)}finally{M.isRunning&&!O.isCancellationRequested&&await k.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};v=ze([Ue(0,m.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends y.Disposable{constructor(R,O,$){super();this.dto=R,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:K}of this.tasks.values())K.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const O=this.dto.id,$=this.dto.controllerId,K=(0,I.generateUuid)(),G=new c(this.proxy,O,K),N=V=>(M,...U)=>{if(x){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),V(M,...U))};let x=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return G.coverageProvider},set coverageProvider(V){G.coverageProvider=V},enqueued:N(V=>{this.proxy.$updateTestStateInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),1)}),skipped:N(V=>{this.proxy.$updateTestStateInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),5)}),started:N(V=>{this.proxy.$updateTestStateInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),2)}),errored:N((V,M,U)=>{this.proxy.$appendTestMessagesInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),M instanceof Array?M.map(p.TestMessage.from):[p.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),6,U)}),failed:N((V,M,U)=>{this.proxy.$appendTestMessagesInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),M instanceof Array?M.map(p.TestMessage.from):[p.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(O,K,a.TestId.fromExtHostTestItem(V,$).toString(),4,U)}),passed:N((V,M)=>{this.proxy.$updateTestStateInRun(O,K,a.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,M)}),appendOutput:(V,M,U)=>{x||(U&&(this.dto.isIncluded(U)?this.ensureTestIsKnown(U):U=void 0),this.proxy.$appendOutputToRun(O,K,g.VSBuffer.fromString(V),M&&p.location.from(M),U&&a.TestId.fromExtHostTestItem(U,$).toString()))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(O,K),this.tasks.delete(K),this.isRunning||this.dispose())}};return this.tasks.set(K,{run:F,coverage:G}),this.proxy.$startedTestRunTask(O,{id:K,name:R,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof u.TestItemImpl))throw new u.InvalidTestItemError(R.id);if(this.sharedTestIds.has(R.id))return;const O=[];for(;O.unshift(p.TestItem.from(R)),!(this.sharedTestIds.has(R.id)||(this.sharedTestIds.add(R.id),!R.parent));)R=R.parent;const $=this.dto.colllection.root;this.sharedTestIds.has($.id)||(this.sharedTestIds.add($.id),O.unshift(p.TestItem.from($))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class r{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,O,$){return this.getTracker(R,O,$)}cancelRunById(R){for(const O of this.tracked.values())if(O.id===R){O.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,O,$,K,G){const N=this.tracked.get($);if(N)return N.createRun(K);const x=i.fromPublic(R,O,$,G),F=s($);this.proxy.$startedExtensionTestRun({controllerId:R,profile:F&&{group:o[F.kind],id:F.profileId},exclude:$.exclude?.map(M=>M.id)??[],id:x.id,include:$.include?.map(M=>M.id)??[O.root.id],persist:G});const V=this.getTracker($,x);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),V.createRun(K)}getTracker(R,O,$){const K=new t(O,this.proxy,$);return this.tracked.set(R,K),K.onEnd(()=>this.tracked.delete(R)),K}}e.TestRunCoordinator=r;const s=w=>{if(!!w.profile){if(!(w.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return w.profile}};class i{constructor(R,O,$,K,G,N){this.controllerId=R,this.id=O,this.isPersisted=G,this.colllection=N,this.includePrefix=$.map(x=>x+"\0"),this.excludePrefix=K.map(x=>x+"\0")}static fromPublic(R,O,$,K){return new i(R,(0,I.generateUuid)(),$.include?.map(G=>a.TestId.fromExtHostTestItem(G,R).toString())??[R],$.exclude?.map(G=>a.TestId.fromExtHostTestItem(G,R).toString())??[],K,O)}static fromInternal(R,O){return new i(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,O)}isIncluded(R){const O=a.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(O===$||O.startsWith($))return!1;for(const $ of this.includePrefix)if(O===$||O.startsWith($))return!0;return!1}}e.TestRunDto=i;class c{constructor(R,O,$){this.proxy=R,this.runId=O,this.taskId=$}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(R,O){const $=await this.fileCoverage;let K=$?.[R];return!this._coverageProvider||!$||!K?[]:(K.detailedCoverage||(K=$[R]=await this._coverageProvider.resolveFileCoverage?.(K,O)??K),K.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class f extends E.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,p.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:O,removed:$}=this;return{get added(){return[...R].map(K=>K.revived)},get updated(){return[...O].map(K=>K.revived)},get removed(){return[...$].map(K=>K.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,O){return{...R,revived:p.TestItem.toPlain(R.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=h;class b{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(O=>O.revived)},dispose:(0,D.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class S{constructor(R,O,$,K,G,N,x=!1,F=void 0){this.controllerId=O,this.profileId=$,this._label=K,this.kind=G,this.runHandler=N,this._isDefault=x,this._tag=F,l.set(this,void 0),rt(this,l,R,"f");const V=o[G];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Be(this,l,"f").$publishTestRunProfile({profileId:$,controllerId:O,tag:F?p.TestTag.namespace(this.controllerId,F.id):null,label:K,group:V,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Be(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Be(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Be(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?p.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Be(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Be(this,l,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=S,l=new WeakMap;const o={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[252],ge([0,1,3,20,5,131,15,7]),function(Y,e,g,L,k,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(d=>d.value)}async showTextDocument(n,I,d){let m;typeof I=="number"?m={position:A.ViewColumn.from(I),preserveFocus:d}:typeof I=="object"?m={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:m={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,m),p=u&&this._extHostDocumentsAndEditors.getEditor(u);if(p)return p.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new D.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(I.options&&d._acceptOptions(I.options),I.selections){const m=I.selections.selections.map(A.Selection.to);d._acceptSelections(m)}if(I.visibleRanges){const m=L.coalesce(I.visibleRanges.map(A.Range.to));d._acceptVisibleRanges(m)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const m=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),u=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:u,kind:m})}if(I.visibleRanges){const m=L.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:m})}}$acceptEditorPositionData(n){for(const I in n){const d=this._extHostDocumentsAndEditors.getEditor(I);if(!d)throw new Error("Unknown text editor");const m=A.ViewColumn.to(n[I]);d.value.viewColumn!==m&&(d._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:m}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(me[253],ge([0,1,2,4,5,6,7]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===11){const m=d.uri===void 0?void 0:g.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(y(m))?.get(d.handle)}return d}})}async $getTimeline(n,I,d,m,u){return this._providers.get(n)?.provideTimeline(g.URI.revive(I),d,m,u)}registerTimelineProvider(n,I,d,m){const u=new D.DisposableStore,p=this.convertTimelineItem(I.id,m,u).bind(this);let _;I.onDidChange&&(_=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:I.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:n,onDidChange:void 0,async provideTimeline(E,a,l,v){v?.resetCache&&(u.clear(),T.get(I.id)?.clear());const t=await I.provideTimeline(E,a,l);if(t==null)return;const r=p(E,v);return{...t,source:I.id,items:t.items.map(r)}},dispose(){for(const E of T.values())E.get(I.id)?.clear();_?.dispose(),u.dispose()}})}convertTimelineItem(n,I,d){return(m,u)=>{let p;if(u?.cacheResults){let _=this._itemsBySourceAndUriMap.get(n);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(n,_));const T=y(m);p=_.get(T),p===void 0&&(p=new Map,_.set(T,p))}return _=>{const{iconPath:T,...E}=_,a=`${n}|${_.id??_.timestamp}`;p?.set(a,_);let l,v,t;return _.iconPath&&(T instanceof A.ThemeIcon?t={id:T.id,color:T.color}:g.URI.isUri(T)?(l=T,v=T):{light:l,dark:v}=T),{...E,id:E.id??void 0,handle:a,source:n,command:_.command?I.toInternal(_.command,d):void 0,icon:l,iconDark:v,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,D.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=C;function y(P){return P?.toString()}}),define(me[254],ge([0,1,6,10,2,5]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(y){this._openers=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,n,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const d=I.schemes.find(m=>!A.supportedSchemes.has(m));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,n),this._proxy.$registerUriOpener(P,I.schemes,y,I.label),(0,g.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,n){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const d=k.URI.revive(P);return I.canOpenExternalUri(d,n)}async $openUri(y,P,n){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},n)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[255],ge([0,1,5,2,6,16,26]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(P,n){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=C.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,P),(0,k.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,n){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(n))}catch(d){(0,D.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(P){return L.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[69],ge([0,1,3,2,180,204,89,5]),function(Y,e,g,L,k,D,A,C){"use strict";var y,P,n,I,d,m,u,p,_,T,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(h,b,S,o,w,R,O){y.set(this,void 0),P.set(this,void 0),n.set(this,void 0),I.set(this,void 0),d.set(this,void 0),m.set(this,void 0),u.set(this,""),p.set(this,void 0),_.set(this,!1),T.set(this,!1),E.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=Be(this,a,"f").event,rt(this,y,h,"f"),rt(this,P,b,"f"),rt(this,p,S,"f"),rt(this,I,o,"f"),rt(this,d,w,"f"),rt(this,m,R,"f"),rt(this,E,v(R),"f"),rt(this,n,O,"f")}dispose(){rt(this,_,!0,"f"),Be(this,a,"f").fire(),Be(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return rt(this,T,!0,"f"),(0,A.asWebviewUri)(h,Be(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,u,"f")}set html(h){this.assertNotDisposed(),Be(this,u,"f")!==h&&(rt(this,u,h,"f"),!Be(this,T,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(rt(this,T,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,P,"f").$setHtml(Be(this,y,"f"),h))}get options(){return this.assertNotDisposed(),Be(this,p,"f")}set options(h){this.assertNotDisposed(),Be(this,P,"f").$setOptions(Be(this,y,"f"),s(Be(this,m,"f"),Be(this,d,"f"),h)),rt(this,p,h,"f")}async postMessage(h){if(Be(this,_,"f"))return!1;const b=(0,D.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Be(this,E,"f")});return Be(this,P,"f").$postMessage(Be(this,y,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Be(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,y=new WeakMap,P=new WeakMap,n=new WeakMap,I=new WeakMap,d=new WeakMap,m=new WeakMap,u=new WeakMap,p=new WeakMap,_=new WeakMap,T=new WeakMap,E=new WeakMap,a=new WeakMap;function v(f){try{const h=(0,k.normalizeVersion)((0,k.parseVersion)(f.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(h,b,S,o,w){this.initData=b,this.workspace=S,this._logService=o,this._deprecationService=w,this._webviews=new Map,this._webviewProxy=h.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(h,b,...S){const o=this.getWebview(h);if(o){const{message:w}=(0,D.deserializeWebviewMessage)(b,S);o._onMessageEmitter.fire(w)}}$onMissingCsp(h,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,b,S){const o=new l(h,this._webviewProxy,i(b),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(h,o),o._onDidDispose(()=>{this._webviews.delete(h)}),o}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=t;function r(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=r;function s(f,h,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||c(f,h)}}e.serializeWebviewOptions=s;function i(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(h=>L.URI.from(h))}}e.reviveOptions=i;function c(f,h){return[...(h?.getWorkspaceFolders()||[]).map(b=>b.uri),f.extensionLocation]}}),define(me[256],ge([0,1,21,58,6,10,25,2,15,69,87,5,7]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const c=new m(r,s);return this._documents.set(i,c),c}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var p;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(p||(p={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new d.Disposable(()=>this._providers.delete(r))}}class T{constructor(t,r,s,i,c){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new _,this._documents=new u,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const c=new k.DisposableStore;return E(s)?(c.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&c.add(s.onDidChangeCustomDocument(f=>{const h=this.getCustomDocumentEntry(r,f.document.uri);if(a(f)){const b=h.addEdit(f);this._proxy.$onDidEdit(f.document.uri,r,b,f.label)}else this._proxy.$onContentChange(f.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(c,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,c){const f=this._editorProviders.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const h=C.URI.revive(t),b=await f.provider.openCustomDocument(h,{backupId:s,untitledDocumentData:i?.buffer},c);let S;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(S=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(r,b,S),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=C.URI.revive(t),{document:c}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,c),c.dispose()}async $resolveWebviewEditor(t,r,s,i,c,f){const h=this._editorProviders.get(s);if(!h)throw new Error(`No provider found for '${s}'`);const b=y.ViewColumn.to(c),S=this._extHostWebview.createNewWebview(r,i.webviewOptions,h.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,b,i.panelOptions,S),w=C.URI.revive(t);switch(h.type){case 1:{const{document:R}=this.getCustomDocumentEntry(s,w);return h.provider.resolveCustomEditor(R,o,f)}case 0:{const R=this._extHostDocuments.getDocument(w);return h.provider.resolveCustomTextEditor(R,o,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const f=C.URI.revive(r),h=this._extHostDocuments.getDocument(f);await i.provider.moveCustomTextEditor(h,c,g.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const c=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(c.document,C.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),f=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(f),f.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,C.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function E(v){return typeof v.resolveCustomTextEditor=="function"}function a(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function l(v){const t=v.scheme===D.Schemas.file||v.scheme===D.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[257],ge([0,1,3,6,2,32,15,69,5,7]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";var n,I,d,m,u,p,_,T,E,a,l,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends L.Disposable{constructor(f,h,b,S,o,w,R){super();n.set(this,void 0),I.set(this,void 0),d.set(this,void 0),m.set(this,void 0),u.set(this,void 0),p.set(this,void 0),_.set(this,void 0),T.set(this,void 0),E.set(this,!0),a.set(this,!0),l.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,v,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,rt(this,n,f,"f"),rt(this,I,h,"f"),rt(this,d,b,"f"),rt(this,u,w,"f"),rt(this,T,o,"f"),rt(this,p,S,"f"),rt(this,m,R,"f")}dispose(){Be(this,l,"f")||(rt(this,l,!0,"f"),Be(this,v,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,n,"f")),Be(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,m,"f")}get viewType(){return this.assertNotDisposed(),Be(this,d,"f")}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(f){this.assertNotDisposed(),Be(this,p,"f")!==f&&(rt(this,p,f,"f"),Be(this,I,"f").$setTitle(Be(this,n,"f"),f))}get iconPath(){return this.assertNotDisposed(),Be(this,_,"f")}set iconPath(f){this.assertNotDisposed(),Be(this,_,"f")!==f&&(rt(this,_,f,"f"),Be(this,I,"f").$setIconPath(Be(this,n,"f"),k.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Be(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,T,"f")=="number"&&Be(this,T,"f")<0))return Be(this,T,"f")}get active(){return this.assertNotDisposed(),Be(this,a,"f")}get visible(){return this.assertNotDisposed(),Be(this,E,"f")}_updateViewState(f){Be(this,l,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(rt(this,a,f.active,"f"),rt(this,E,f.visible,"f"),rt(this,T,f.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(f,h){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,n,"f"),{viewColumn:f?A.ViewColumn.from(f):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Be(this,l,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,d=new WeakMap,m=new WeakMap,u=new WeakMap,p=new WeakMap,_=new WeakMap,T=new WeakMap,E=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(f,h,b){this.webviews=h,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,D.generateUuid)()}createWebviewPanel(f,h,b,S,o={}){const w=typeof S=="object"?S.viewColumn:S,R={viewColumn:A.ViewColumn.from(w),preserveFocus:typeof S=="object"&&!!S.preserveFocus},O=(0,C.shouldSerializeBuffersForPostMessage)(f),$=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(f),$,h,{title:b,panelOptions:i(o),webviewOptions:(0,C.serializeWebviewOptions)(f,this.workspace,o),serializeBuffersForPostMessage:O},R);const K=this.webviews.createNewWebview($,o,f);return this.createNewWebviewPanel($,h,b,w,o,K)}$onDidChangeWebviewPanelViewStates(f){const h=Object.keys(f);h.sort((b,S)=>{const o=f[b],w=f[S];return o.active?1:w.active?-1:+o.visible-+w.visible});for(const b of h){const S=this.getWebviewPanel(b);if(!S)continue;const o=f[b];S._updateViewState({active:o.active,visible:o.visible,viewColumn:A.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,h,b){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:b,extension:f}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(f,h,b,S){const o=this._serializers.get(h);if(!o)throw new Error(`No serializer found for '${h}'`);const{serializer:w,extension:R}=o,O=this.webviews.createNewWebview(f,b.webviewOptions,R),$=this.createNewWebviewPanel(f,h,b.title,S,b.panelOptions,O);await w.deserializeWebviewPanel($,b.state)}createNewWebviewPanel(f,h,b,S,o,w){const R=new r(f,this._proxy,h,b,S,o,w);return this._webviewPanels.set(f,R),R}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=s;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[258],ge([0,1,3,6,69,5,7]),function(Y,e,g,L,k,D,A){"use strict";var C,y,P,n,I,d,m,u,p,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends L.Disposable{constructor(l,v,t,r,s,i){super();C.set(this,void 0),y.set(this,void 0),P.set(this,void 0),n.set(this,void 0),I.set(this,!1),d.set(this,void 0),m.set(this,void 0),u.set(this,void 0),p.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Be(this,p,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,_,"f").event,rt(this,P,t,"f"),rt(this,m,r,"f"),rt(this,C,l,"f"),rt(this,y,v,"f"),rt(this,n,s,"f"),rt(this,d,i,"f")}dispose(){Be(this,I,"f")||(rt(this,I,!0,"f"),Be(this,_,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,m,"f")}set title(l){this.assertNotDisposed(),Be(this,m,"f")!==l&&(rt(this,m,l,"f"),Be(this,y,"f").$setWebviewViewTitle(Be(this,C,"f"),l))}get description(){return this.assertNotDisposed(),Be(this,u,"f")}set description(l){this.assertNotDisposed(),Be(this,u,"f")!==l&&(rt(this,u,l,"f"),Be(this,y,"f").$setWebviewViewDescription(Be(this,C,"f"),l))}get visible(){return Be(this,d,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,P,"f")}_setVisible(l){l===Be(this,d,"f")||Be(this,I,"f")||(rt(this,d,l,"f"),Be(this,p,"f").fire())}show(l){this.assertNotDisposed(),Be(this,y,"f").$show(Be(this,C,"f"),!!l)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,y=new WeakMap,P=new WeakMap,n=new WeakMap,I=new WeakMap,d=new WeakMap,m=new WeakMap,u=new WeakMap,p=new WeakMap,_=new WeakMap;class E{constructor(l,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(l),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(l,v,t,r,s){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:f}=i,h=this._extHostWebview.createNewWebview(l,{},f),b=new T(l,this._proxy,v,t,h,!0);this._webviewViews.set(l,b),await c.resolveWebviewView(b,{state:r},s)}async $onDidChangeWebviewViewVisibility(l,v){this.getWebviewView(l)._setVisible(v)}async $disposeWebviewView(l){const v=this.getWebviewView(l);this._webviewViews.delete(l),v.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const v=this._webviewViews.get(l);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=E}),define(me[133],ge([0,1,3,5,2,10,9,4,13]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Bn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,d){let m;if(typeof I=="string"){m=I;try{I=k.URI.parse(I)}catch(u){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,A.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,m,d)}async asExternalUri(I,d){if((0,A.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(I,d);return k.URI.from(m)}};P.InitialState={focused:!0},P=ze([Ue(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[259],ge([0,1,8,80,32,44,6,5,2,13]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends A.Disposable{constructor(d,m){super();const u=d.getProxy(C.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async p=>{const _=y.URI.file((0,g.join)((0,L.tmpdir)(),(0,k.generateUuid)()));return await u.$download(p,_),_})}};n=ze([Ue(0,P.IExtHostRpcService),Ue(1,D.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[260],ge([0,1,2,8,152,28,67,27,13,6,12,115,42]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(T,E,a){this.name=T,this.file=E,this.appender=a}static async create(T,E){const a=await(0,I.createRotatingLogger)(T,E,30*d.ByteSize.MB,1);return a.clearFormatters(),new m(T,E,a)}append(T){this.appender.critical(T)}flush(){this.appender.flush()}}class u extends A.AbstractExtHostOutputChannel{constructor(T,E,a,l){super(T,!1,g.URI.file(E.file),a,l);this._appender=E}append(T){super.append(T),this._appender.append(T),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(T,E){this._appender.flush(),super.show(T,E)}clear(){this._appender.flush(),super.clear()}}let p=class extends A.ExtHostOutputService{constructor(T,E,a){super(T);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=a.logsLocation}$setVisibleChannel(T){if(T){const E=this._channels.get(T);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(T,E){if(T=T.trim(),!T)throw new Error("illegal argument `name`. must not be falsy");const a=this._doCreateOutChannel(T,E);return a.then(l=>l._id.then(v=>this._channels.set(v,l))),new A.LazyOutputChannel(T,a)}async _doCreateOutChannel(T,E){try{const a=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await D.SymlinkSupport.existsDirectory(a)||await D.Promises.mkdir(a,{recursive:!0});const v=`${this._namePool++}-${T.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(a,`${v}.log`)),r=await m.create(v,t.fsPath);return new u(T,r,E.identifier.value,this._proxy)}catch(a){return this.logService.error(a),new A.ExtHostPushOutputChannel(T,E.identifier.value,this._proxy)}}};p=ze([Ue(0,y.IExtHostRpcService),Ue(1,n.ILogService),Ue(2,C.IExtHostInitDataService)],p),e.ExtHostOutputService2=p}),define(me[261],ge([0,1,49,292,2,68,6,10,17]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends D.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==C.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let s=0;do{let i;s===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await n(i);const c=L.join(i,"vscode.lock"),f=await u(this._logService,c,!1);if(f)return this._workspaceStorageLock=f,process.on("exit",()=>{f.dispose()}),k.URI.file(i);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function n(l){try{await g.promises.stat(l);return}catch{}try{await g.promises.mkdir(l,{recursive:!0})}catch{}}const I=1e3,d=10*60*1e3;class m extends A.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await p(v,t);(!r||r.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(s){v.error(s),v.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function u(l,v,t){try{const s={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(v,JSON.stringify(s),{flag:"wx"})}catch(s){l.error(s)}const r=await p(l,v);return!r||r.pid!==process.pid?t?(l.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(l.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),E(l,v)):(l.info(`Lock '${v}': Lock acquired.`),new m(l,v))}async function p(l,v){let t;try{t=await g.promises.readFile(v)}catch(r){return l.error(r),null}try{return JSON.parse(String(t))}catch(r){return l.error(r),null}}async function _(l,v){let t;try{t=await g.promises.stat(v)}catch(r){return l.error(r),0}return t.mtime.getTime()}function T(l){try{return process.kill(l,0),!0}catch(v){return!1}}async function E(l,v){const t=await p(l,v);if(!t)return l.info(`Lock '${v}': Could not read pid of lock holder.`),a(l,v);if(t.willReleaseAt){let f=t.willReleaseAt-Date.now();if(f<5e3){for(f>0?l.info(`Lock '${v}': The lockfile is scheduled to be released in ${f} ms.`):l.info(`Lock '${v}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,y.timeout)(Math.min(100,f)),await _(l,v)===0)return a(l,v);f=t.willReleaseAt-Date.now()}return a(l,v)}}if(!T(t.pid))return l.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),a(l,v);const r=await _(l,v),s=Date.now()-r;if(s<=d)return l.info(`Lock '${v}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;l.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const i=await _(l,v),c=Date.now()-i;return c<=d?(l.info(`Lock '${v}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(l.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),a(l,v))}async function a(l,v){l.info(`Lock '${v}': Deleting a stale lock.`);try{await g.promises.unlink(v)}catch(t){}return u(l,v,!0)}}),define(me[262],ge([0,1,32,13,33]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let D=class extends k.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,y,P){return this.createTerminalFromOptions({name:C,shellPath:y,shellArgs:P})}createTerminalFromOptions(C,y){const P=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),C,C.name);return this._terminals.push(P),P.create(C,y),P.value}};D=ze([Ue(0,L.IExtHostRpcService)],D),e.ExtHostTerminalService=D}),define(me[263],ge([0,1,5,13,6,27,2,39,25,28,7,11,52,3,193,77,12]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class T{constructor(h,b,S){this.remoteAddress=h,this.localAddress=b,this._dispose=S,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(f){const h=f.trim().split(`
`),b=[];return h.forEach(o=>{const w=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);w&&w.length>=3&&b.push({pid:parseInt(w[1],10),socket:parseInt(w[2],10)})}),b.reduce((o,w)=>(o[w.socket]=w,o),{})}e.getSockets=E;function a(...f){const h=[].concat(...f.map(v));return[...new Map(h.filter(b=>b.st==="0A").map(b=>{const S=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:l(S[0]),port:parseInt(S[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=a;function l(f){let h="";if(f.length===8)for(let b=f.length-2;b>=0;b-=2)h+=parseInt(f.substr(b,2),16),b!==0&&(h+=".");else for(let b=f.length-4;b>=0;b-=4)h+=parseInt(f.substr(b,4),16).toString(16),b!==0&&(h+=":");return h}e.parseIpAddress=l;function v(f){const h=f.trim().split(`
`),b=h.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return h.map(o=>o.trim().split(/\s+/).reduce((w,R,O)=>(w[b[O]||O]=R,w),{}))}e.loadConnectionTable=v;function t(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/vs/server/main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function r(f){const h=f.trim().split(`
`),b=[];return h.forEach(S=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);o&&o.length>=4&&b.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),b}e.getRootProcesses=r;async function s(f,h,b){const S=b.reduce((w,R)=>(w[R.pid]=R,w),{}),o=[];return f.forEach(({socket:w,ip:R,port:O})=>{const $=h[w]?h[w].pid:void 0,K=$?S[$]?.cmd:void 0;$&&K&&!t(K)&&o.push({host:R,port:O,detail:K,pid:$})}),o}e.findPorts=s;function i(f,h,b){const S=new Map,o=r(h);for(const w of f){const R=b.get(w.port);if(R){S.set(w.port,R);continue}const O=o.find($=>$.cmd.includes(`${w.port}`));if(O){let $=O,K;do K=o.find(G=>G.ppid===$.pid),K&&($=K);while(K);S.set(w.port,{host:w.ip,port:w.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else S.set(w.port,{host:w.ip,port:w.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=i;let c=class extends k.Disposable{constructor(h,b,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(g.MainContext.MainThreadTunnelService),I.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(b,h.displayName);if(S){const o=new T(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,b){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:h,provider:b}),this._proxy.$registerPortsAttributesProvider(h,S),new n.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(h,b,S,o,w){const R=[];for(const $ of h){const K=this._portAttributesProviders.get($);if(!K)return[];R.push(...await Promise.all(b.map(async G=>K.provider.providePortAttributes(G,S,o,w))))}const O=R.filter($=>!!$);return O.length>0?O.map($=>({autoForwardAction:$.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let b=new p.MovingAverage,S;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),w=(await this.findCandidatePorts()).filter(O=>(0,u.isLocalhost)(O.host)||(0,u.isAllInterfaces)(O.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${w.map(O=>O.port).join(", ")}`);const R=new Date().getTime()-o;b.update(R),(!S||JSON.stringify(S)!==JSON.stringify(w))&&(S=w,await this._proxy.$onFoundNewCandidates(S)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(h){return h?(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory&&(this._forwardPortProvider=h.tunnelFactory,this._proxy.$setTunnelProvider(h.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,b){if(this._extensionTunnels.has(h.host)){const S=this._extensionTunnels.get(h.host);S.has(h.port)&&(b&&S.get(h.port).disposeListener.dispose(),await S.get(h.port).tunnel.dispose(),S.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(h,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const o=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const w=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:o,disposeListener:w}),d.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const b=await Promise.all(h.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),S=h.filter((o,w)=>b[w]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(o=>o.port).join(", ")} to ${S.map(o=>o.port).join(", ")}`),S}async findCandidatePorts(){let h="",b="";try{h=await P.Promises.readFile("/proc/net/tcp","utf8"),b=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const S=a(h,b),o=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,V,M)=>{x(V)})}),w=E(o),R=await P.Promises.readdir("/proc"),O=[];for(let x of R)try{const F=Number(x),V=y.joinPath(A.URI.file("/proc"),x);if((await P.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(F)){const U=await P.Promises.readlink(y.joinPath(V,"cwd").fsPath),q=await P.Promises.readFile(y.joinPath(V,"cmdline").fsPath,"utf8");O.push({pid:F,cwd:U,cmd:q})}}catch(F){}const $=[],K=S.filter(x=>{const F=w[x.socket];return F||$.push(x),F}),G=s(K,w,O);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const x=await new Promise(F=>{(0,C.exec)("ps -F -A -l | grep root",(V,M,U)=>{F(M)})});this._foundRootPorts=i($,x,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return G.then(x=>N?x.concat(N):x)}};c=ze([Ue(0,L.IExtHostRpcService),Ue(1,D.IExtHostInitDataService),Ue(2,_.ILogService)],c),e.ExtHostTunnelService=c}),define(me[264],ge([0,1,17,22,21,16,3,6,103,228,65]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function d(o,w){try{return JSON.stringify(o,w)}catch(R){return"null"}}const m="$$ref$$",u={[m]:-1};class p{constructor(w,R){this.jsonString=w,this.referencedBuffers=R}}function _(o,w=null,R=!1){const O=[];return{jsonString:(R?d:JSON.stringify)(o,(K,G)=>{if(typeof G=="undefined")return u;if(typeof G=="object"){if(G instanceof L.VSBuffer){const N=O.push(G)-1;return{[m]:N}}if(w)return w(K,G)}return G}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=_;function T(o,w,R){return JSON.parse(o,(O,$)=>{if($){const K=$[m];if(typeof K=="number")return w[K];if(R&&$.$mid===1)return R.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=T;function E(o,w){return JSON.stringify(o,w)}function a(o){return o?(w,R)=>R&&R.$mid===1?o.transformOutgoing(R):R:null}var l;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends C.Disposable{constructor(w,R=null,O=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=w,this._logger=R,this._uriTransformer=O,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,K=n.ProxyIdentifier.count;$<K;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(w=>{this._pendingRPCReplies[w].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(w){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(w){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(w){this._responsiveState!==w&&(this._responsiveState=w,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(w){return this._uriTransformer?(0,y.transformIncomingURIs)(w,this._uriTransformer):w}getProxy(w){const{nid:R,sid:O}=w;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,O)),this._proxies[R]}_createProxy(w,R){let O={get:($,K)=>(typeof K=="string"&&!$[K]&&K.charCodeAt(0)===36&&($[K]=(...G)=>this._remoteCall(w,K,G)),K===s?R:$[K])};return new Proxy(Object.create(null),O)}set(w,R){return this._locals[w.nid]=R,R}assertRegistered(w){for(let R=0,O=w.length;R<O;R++){const $=w[R];if(!this._locals[$.nid])throw new Error(`Missing actor ${$.sid} (isMain: ${$.isMain})`)}}_receiveOneMessage(w){if(this._isDisposed)return;const R=w.byteLength,O=c.read(w,0),$=O.readUInt8(),K=O.readUInt32();switch($){case 1:case 2:{let{rpcId:G,method:N,args:x}=h.deserializeRequestJSONArgs(O);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(R,K,G,N,x,$===2);break}case 3:case 4:{let{rpcId:G,method:N,args:x}=h.deserializeRequestMixedArgs(O);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(R,K,G,N,x,$===4);break}case 5:{this._logger&&this._logger.logIncoming(R,K,0,"ack"),this._onDidReceiveAcknowledge(K);break}case 6:{this._receiveCancel(R,K);break}case 7:{this._receiveReply(R,K,void 0);break}case 9:{let G=h.deserializeReplyOKJSON(O);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReply(R,K,G);break}case 10:{const G=h.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(R,K,G);break}case 8:{let G=h.deserializeReplyOKVSBuffer(O);this._receiveReply(R,K,G);break}case 11:{let G=h.deserializeReplyErrError(O);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReplyErr(R,K,G);break}case 12:{this._receiveReplyErr(R,K,void 0);break}default:console.error("received unexpected message"),console.error(w)}}_receiveRequest(w,R,O,$,K,G){this._logger&&this._logger.logIncoming(w,R,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(O)}.${$}(`,K);const N=String(R);let x,F;if(G){const M=new k.CancellationTokenSource;K.push(M.token),x=this._invokeHandler(O,$,K),F=()=>M.cancel()}else x=this._invokeHandler(O,$,K),F=t;this._cancelInvokedHandlers[N]=F;const V=h.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(V.byteLength,R,1,"ack"),this._protocol.send(V),x.then(M=>{delete this._cancelInvokedHandlers[N];const U=h.serializeReplyOK(R,M,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"reply:",M),this._protocol.send(U)},M=>{delete this._cancelInvokedHandlers[N];const U=h.serializeReplyErr(R,M);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"replyErr:",M),this._protocol.send(U)})}_receiveCancel(w,R){this._logger&&this._logger.logIncoming(w,R,1,"receiveCancel");const O=String(R);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(w,R,O){this._logger&&this._logger.logIncoming(w,R,0,"receiveReply:",O);const $=String(R);if(!this._pendingRPCReplies.hasOwnProperty($))return;const K=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],K.resolveOk(O)}_receiveReplyErr(w,R,O){this._logger&&this._logger.logIncoming(w,R,0,"receiveReplyErr:",O);const $=String(R);if(!this._pendingRPCReplies.hasOwnProperty($))return;const K=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let G;O&&(O.$isError?(G=new Error,G.name=O.name,G.message=O.message,G.stack=O.stack):G=O),K.resolveErr(G)}_invokeHandler(w,R,O){try{return Promise.resolve(this._doInvokeHandler(w,R,O))}catch($){return Promise.reject($)}}_doInvokeHandler(w,R,O){const $=this._locals[w];if(!$)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(w));let K=$[R];if(typeof K!="function")throw new Error("Unknown method "+R+" on actor "+(0,n.getStringIdentifierForProxy)(w));return K.apply($,O)}_remoteCall(w,R,O){if(this._isDisposed)return Promise.reject(D.canceled());let $=null;if(O.length>0&&k.CancellationToken.isCancellationToken(O[O.length-1])&&($=O.pop()),$&&$.isCancellationRequested)return Promise.reject(D.canceled());const K=h.serializeRequestArguments(O,this._uriReplacer),G=++this._lastMessageId,N=String(G),x=new P.LazyPromise;$&&$.onCancellationRequested(()=>{const V=h.serializeCancel(G);this._logger&&this._logger.logOutgoing(V.byteLength,G,0,"cancel"),this._protocol.send(h.serializeCancel(G))}),this._pendingRPCReplies[N]=x,this._onWillSendRequest(G);const F=h.serializeRequest(G,w,R,K,!!$);return this._logger&&this._logger.logOutgoing(F.byteLength,G,0,`request: ${(0,n.getStringIdentifierForProxy)(w)}.${R}(`,O),this._protocol.send(F),x}}e.RPCProtocol=i,I=r,i.UNRESPONSIVE_TIME=3*1e3;class c{constructor(w,R){this._buff=w,this._offset=R}static alloc(w,R,O){let $=new c(L.VSBuffer.alloc(O+1+4),0);return $.writeUInt8(w),$.writeUInt32(R),$}static read(w,R){return new c(w,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(w){this._buff.writeUInt8(w,this._offset),this._offset+=1}readUInt8(){const w=this._buff.readUInt8(this._offset);return this._offset+=1,w}writeUInt32(w){this._buff.writeUInt32BE(w,this._offset),this._offset+=4}readUInt32(){const w=this._buff.readUInt32BE(this._offset);return this._offset+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this._buff.writeUInt8(w.byteLength,this._offset),this._offset+=1,this._buff.set(w,this._offset),this._offset+=w.byteLength}readShortString(){const w=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,O}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readLongString(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,O}writeBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readVSBuffer(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+w);return this._offset+=w,R}static sizeMixedArray(w){let R=0;R+=1;for(let O=0,$=w.length;O<$;O++){const K=w[O];switch(R+=1,K.type){case 1:R+=this.sizeLongString(K.value);break;case 2:R+=this.sizeVSBuffer(K.value);break;case 3:R+=this.sizeUInt8(),R+=this.sizeLongString(K.value);for(let G=0;G<K.buffers.length;++G)R+=this.sizeVSBuffer(K.buffers[G]);break;case 4:break}}return R}writeMixedArray(w){this._buff.writeUInt8(w.length,this._offset),this._offset+=1;for(let R=0,O=w.length;R<O;R++){const $=w[R];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt8($.buffers.length),this.writeLongString($.value);for(let K=0;K<$.buffers.length;++K)this.writeBuffer($.buffers[K]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(w);for(let O=0;O<w;O++)switch(this.readUInt8()){case 1:R[O]=this.readLongString();break;case 2:R[O]=this.readVSBuffer();break;case 3:const K=this.readUInt8(),G=this.readLongString(),N=[];for(let x=0;x<K;++x)N.push(this.readVSBuffer());R[O]=new n.SerializableObjectWithBuffers(T(G,N,null));break;case 4:R[O]=void 0;break}return R}}var f;(function(o){o[o.Simple=0]="Simple",o[o.Mixed=1]="Mixed"})(f||(f={}));class h{static _useMixedArgSerialization(w){for(let R=0,O=w.length;R<O;R++)if(w[R]instanceof L.VSBuffer||w[R]instanceof n.SerializableObjectWithBuffers||typeof w[R]=="undefined")return!0;return!1}static serializeRequestArguments(w,R){if(this._useMixedArgSerialization(w)){const O=[];for(let $=0,K=w.length;$<K;$++){const G=w[$];if(G instanceof L.VSBuffer)O[$]={type:2,value:G};else if(typeof G=="undefined")O[$]={type:4};else if(G instanceof n.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:x}=_(G.value,R);O[$]={type:3,value:L.VSBuffer.fromString(N),buffers:x}}else O[$]={type:1,value:L.VSBuffer.fromString(E(G,R))}}return{type:1,args:O}}return{type:0,args:E(w,R)}}static serializeRequest(w,R,O,$,K){switch($.type){case 0:return this._requestJSONArgs(w,R,O,$.args,K);case 1:return this._requestMixedArgs(w,R,O,$.args,K)}}static _requestJSONArgs(w,R,O,$,K){const G=L.VSBuffer.fromString(O),N=L.VSBuffer.fromString($);let x=0;x+=c.sizeUInt8(),x+=c.sizeShortString(G),x+=c.sizeLongString(N);let F=c.alloc(K?2:1,w,x);return F.writeUInt8(R),F.writeShortString(G),F.writeLongString(N),F.buffer}static deserializeRequestJSONArgs(w){const R=w.readUInt8(),O=w.readShortString(),$=w.readLongString();return{rpcId:R,method:O,args:JSON.parse($)}}static _requestMixedArgs(w,R,O,$,K){const G=L.VSBuffer.fromString(O);let N=0;N+=c.sizeUInt8(),N+=c.sizeShortString(G),N+=c.sizeMixedArray($);let x=c.alloc(K?4:3,w,N);return x.writeUInt8(R),x.writeShortString(G),x.writeMixedArray($),x.buffer}static deserializeRequestMixedArgs(w){const R=w.readUInt8(),O=w.readShortString(),$=w.readMixedArray(),K=new Array($.length);for(let G=0,N=$.length;G<N;G++){const x=$[G];typeof x=="string"?K[G]=JSON.parse(x):K[G]=x}return{rpcId:R,method:O,args:K}}static serializeAcknowledged(w){return c.alloc(5,w,0).buffer}static serializeCancel(w){return c.alloc(6,w,0).buffer}static serializeReplyOK(w,R,O){if(typeof R=="undefined")return this._serializeReplyOKEmpty(w);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(w,R);if(R instanceof n.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:K}=_(R.value,O,!0);return this._serializeReplyOKJSONWithBuffers(w,$,K)}else return this._serializeReplyOKJSON(w,d(R,O))}static _serializeReplyOKEmpty(w){return c.alloc(7,w,0).buffer}static _serializeReplyOKVSBuffer(w,R){let O=0;O+=c.sizeVSBuffer(R);let $=c.alloc(8,w,O);return $.writeVSBuffer(R),$.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static _serializeReplyOKJSON(w,R){const O=L.VSBuffer.fromString(R);let $=0;$+=c.sizeLongString(O);let K=c.alloc(9,w,$);return K.writeLongString(O),K.buffer}static _serializeReplyOKJSONWithBuffers(w,R,O){const $=L.VSBuffer.fromString(R);let K=0;K+=c.sizeUInt8(),K+=c.sizeLongString($);for(const N of O)K+=c.sizeVSBuffer(N);let G=c.alloc(10,w,K);G.writeUInt8(O.length),G.writeLongString($);for(const N of O)G.writeBuffer(N);return G.buffer}static deserializeReplyOKJSON(w){const R=w.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(w,R){const O=w.readUInt8(),$=w.readLongString(),K=[];for(let G=0;G<O;++G)K.push(w.readVSBuffer());return new n.SerializableObjectWithBuffers(T($,K,R))}static serializeReplyErr(w,R){return R?this._serializeReplyErrEror(w,R):this._serializeReplyErrEmpty(w)}static _serializeReplyErrEror(w,R){const O=L.VSBuffer.fromString(d(D.transformErrorForSerialization(R),null));let $=0;$+=c.sizeLongString(O);let K=c.alloc(11,w,$);return K.writeLongString(O),K.buffer}static deserializeReplyErrError(w){const R=w.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(w){return c.alloc(12,w,0).buffer}}var b;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",o[o.ReplyErrError=11]="ReplyErrError",o[o.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var S;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",o[o.Undefined=4]="Undefined"})(S||(S={}))}),define(me[265],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(me[266],ge([0,1,10,8,11,2,4,86,43,223,265]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let I=class $n{constructor(m,u,p,_){this.localUserHome=m,this.remoteAgentService=u,this.environmentService=p,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,u){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const p=(0,C.getVirtualWorkspaceScheme)(u.getWorkspace());if(p)return p;const _=u.getWorkspace().folders[0];if(_)return _.uri.scheme;const T=u.getWorkspace().configuration;return T?T.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?L.win32:L.posix)}async fileURI(m){let u="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(u=m.substring(2),m="/"):(u=m.substring(2,_),m=m.substring(_)||"/")}return D.URI.from({scheme:g.Schemas.file,authority:u,path:m,query:"",fragment:""})}};I=ze([Ue(1,n.IRemoteAgentService),Ue(2,P.IWorkbenchEnvironmentService),Ue(3,y.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[70],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(A,C){this.line=A,this.character=C}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,C){return new g(0,0)}with(A){return new g(0,0)}}e.Position=g;class L{constructor(A,C,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(A,C),this.end=new g(y,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.Range=L;var k;(function(D){D[D.Information=1]="Information",D[D.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,23,29,9,4,8,16,70]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",d=" characters skipped \u27EB",m=(I.length+d.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var u;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function _(F){return!!F.preview}e.resultIsMatch=_;function T(F){return!!F.resource}e.isFileMatch=T;function E(F){return!!F.message}e.isProgressMessage=E;var a;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=l;class v{constructor(V,M,U){this.ranges=M;const q=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(q)){V=(0,A.getNLines)(V,U.matchLines);let W="",X=0,Z=0;const fe=Math.floor(U.charsPerLine/5),_e=[];for(const De of q){const Le=Math.max(De.startColumn-fe,0),qe=De.startColumn+U.charsPerLine;if(Le>Z+fe+m){const xe=I+(Le-Z)+d;W+=xe+V.slice(Le,qe),X+=Le-(Z+xe.length)}else W+=V.slice(Z,qe);_e.push(new s(0,De.startColumn-X,De.endColumn-X)),Z=qe}this.preview={text:W,matches:Array.isArray(this.ranges)?_e:_e[0]}}else{const W=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:V,matches:(0,g.mapArrayOrNot)(M,X=>new r(X.startLineNumber-W,X.startColumn,X.endLineNumber-W,X.endColumn))}}}}e.TextSearchMatch=v;function t(F){const V=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==V||M.endLineNumber!==V)return!1;return!0}class r{constructor(V,M,U,q){this.startLineNumber=V,this.startColumn=M,this.endLineNumber=U,this.endColumn=q}}e.SearchRange=r;class s extends r{constructor(V,M,U){super(V,M,V,U)}}e.OneLineRange=s;var i;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(F,V=!0){const M=F&&F.files&&F.files.exclude,U=V&&F&&F.search&&F.search.exclude;if(!M&&!U)return;if(!M||!U)return M||U;let q=Object.create(null);return q=k.mixin(q,k.deepClone(M)),q=k.mixin(q,k.deepClone(U),!0),q}e.getExcludes=c;function f(F,V){return F.excludePattern&&L.match(F.excludePattern,V)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&L.match(F.includePattern,V)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const U=M.folder.fsPath;if(D.isEqualOrParent(V,U)){const q=y.relative(U,V);return!M.includePattern||!!L.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var h;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(V,M){super(V);this.code=M}}e.SearchError=b;function S(F){const V=F.message;if((0,P.isPromiseCanceledError)(F))return new b(V,h.canceled);try{const M=JSON.parse(V);return new b(M.message,M.code)}catch(M){return new b(V,h.other)}}e.deserializeSearchError=S;function o(F){const V={message:F.message,code:F.code};return new Error(JSON.stringify(V))}e.serializeSearchError=o;function w(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=w;function R(F){return F.type==="success"}e.isSerializedSearchSuccess=R;function O(F){return!!F.path}e.isSerializedFileMatch=O;function $(F,V){const M=F.searchPath?F.searchPath:F.relativePath;return(0,A.fuzzyContains)(M,V)}e.isFilePatternMatch=$;class K{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function G(F,V){const M={...F||{},...V||{}};return Object.keys(M).filter(U=>{const q=M[U];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=G;class N{constructor(V,M){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let U=V.includePattern;M.includePattern&&(U?U={...U,...M.includePattern}:U=M.includePattern),U&&(this._parsedIncludeExpression=L.parse(U))}includedInQuerySync(V,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,M,U))}includedInQuery(V,M,U){return Promise.resolve(this._parsedExcludeExpression(V,M,U)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(V,M,U)).then(X=>!!X):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=N;function x(F){for(const V in F)if(typeof F[V]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,20,17,21,3,24,10,77,25,9,14,2,170,4,12,190,43,63,27,13,7,31,5]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a,l,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(w,R,O){return new P.ExtUri($=>h($,O)).isEqual(w,R)}function i(w,R,O){return s(w.uri,R.uri,O)?0:(0,n.compare)(w.uri.toString(),R.uri.toString())}function c(w,R,O){return w.index!==R.index?w.index<R.index?-1:1:s(w.uri,R.uri,O)?(0,n.compare)(w.name,R.name):(0,n.compare)(w.uri.toString(),R.uri.toString())}function f(w,R,O,$){const K=w.slice(0).sort((N,x)=>O(N,x,$)),G=R.slice(0).sort((N,x)=>O(N,x,$));return(0,g.delta)(K,G,(N,x)=>O(N,x,$))}function h(w,R){const O=R.getCapabilities(w.scheme);return!(O&&O&1024)}class b extends T.Workspace{constructor(R,O,$,K,G,N){super(R,$.map(x=>new T.WorkspaceFolder(x)),K,N);this._name=O,this._isUntitled=G,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(N),$.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(R,O,$,K){if(!R)return{workspace:null,added:[],removed:[]};const{id:G,name:N,folders:x,configuration:F,isUntitled:V}=R,M=[],U=O;O?x.forEach((Z,fe)=>{const _e=d.URI.revive(Z.uri),De=b._findFolder($||O,_e,K);De?(De.name=Z.name,De.index=Z.index,M.push(De)):M.push({uri:_e,name:Z.name,index:fe})}):M.push(...x.map(({uri:Z,name:fe,index:_e})=>({uri:d.URI.revive(Z),name:fe,index:_e}))),M.sort((Z,fe)=>Z.index<fe.index?-1:1);const q=new b(G,N,M,F?d.URI.revive(F):null,!!V,Z=>h(Z,K)),{added:W,removed:X}=f(U?U.workspaceFolders:[],q.workspaceFolders,i,K);return{workspace:q,added:W,removed:X}}static _findFolder(R,O,$){for(let K=0;K<R.folders.length;K++){const G=R.workspaceFolders[K];if(s(G.uri,O,$))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,O){return O&&this._structure.get(R)&&(R=(0,P.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let S=class{constructor(R,O,$,K){this._onDidChangeWorkspace=new D.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new D.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=K,this._extHostFileSystemInfo=$,this._requestIdProvider=new y.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(r.MainContext.MainThreadMessageService);const G=O.workspace;this._confirmedWorkspace=G?new b(G.id,G.name,[],G.configuration?d.URI.revive(G.configuration):null,!!G.isUntitled,N=>h(N,$)):void 0}$initializeWorkspace(R,O){this._trusted=O,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,O,$,...K){const G=[];if(Array.isArray(K)&&K.forEach(M=>{d.URI.isUri(M.uri)&&!G.some(U=>s(U.uri,M.uri,this._extHostFileSystemInfo))&&G.push({uri:M.uri,name:M.name||(0,P.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[O,$].some(M=>typeof M!="number"||M<0)||$===0&&G.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(O+$>N.length)return!1;const x=N.slice(0);x.splice(O,$,...G.map(M=>({uri:M.uri,name:M.name||(0,P.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const U=x[M];if(x.some((q,W)=>W!==M&&s(U.uri,q.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,U)=>M.index=U);const{added:F,removed:V}=f(N,x,c,this._extHostFileSystemInfo);if(F.length===0&&V.length===0)return!1;if(this._proxy){const M=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(M,O,$,G).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,M,U.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(R,O){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,O)}async getWorkspaceFolder2(R,O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,O)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,O){let $,K="";if(typeof R=="string"?($=d.URI.file(R),K=R):typeof R!="undefined"&&($=R,K=R.fsPath),!$)return K;const G=this.getWorkspaceFolder($,!0);if(!G)return K;typeof O=="undefined"&&this._actualWorkspace&&(O=this._actualWorkspace.folders.length>1);let N=(0,P.relativePath)(G.uri,$);return O&&G.name&&(N=`${G.name}/${N}`),N}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:O,added:$,removed:K}=b.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=O||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:K}))}findFiles(R,O,$,K,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let N;if(O===null?N=!1:O&&(typeof O=="string"?N=O:N=O.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:F}=o(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)($),G).then(V=>Array.isArray(V)?V.map(M=>d.URI.revive(M)):[])}async findTextInFiles(R,O,$,K,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),x=typeof O.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:F,folder:V}=o(O.include),M=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,U={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:x,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:F,excludePattern:M},q=!1;if(this._activeSearchCallbacks[N]=W=>{if(q)return;const X=d.URI.revive(W.resource);W.results.forEach(Z=>{(0,t.resultIsMatch)(Z)?$({uri:X,preview:{text:Z.preview.text,matches:(0,g.mapArrayOrNot)(Z.preview.matches,fe=>new v.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,g.mapArrayOrNot)(Z.ranges,fe=>new v.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):$({uri:X,text:Z.text,lineNumber:Z.lineNumber})})},G.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(V),U,N,G);return delete this._activeSearchCallbacks[N],W||{}}catch(W){throw delete this._activeSearchCallbacks[N],W}}$handleTextSearchResult(R,O){this._activeSearchCallbacks[O]&&this._activeSearchCallbacks[O](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=ze([Ue(0,l.IExtHostRpcService),Ue(1,a.IExtHostInitDataService),Ue(2,E.IExtHostFileSystemInfo),Ue(3,p.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function o(w){let R,O;return w&&(typeof w=="string"?R=w:(R=w.pattern,O=w.baseFolder||d.URI.file(w.base))),{includePattern:R,folder:O}}}),define(me[37],ge([0,1,23,3,36,5,7,192,85,14,17,4,13,12,2]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(r,s){if(s){const i=s.split(".");let c=r;for(let f=0;c&&f<i.length;f++)c=c[i[f]];return c}}function _(r){return r instanceof u.URI}function T(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function l(r){if(_(r))return{resource:r};if(T(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,i,c){this._proxy=s.getProxy(D.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};v=ze([Ue(0,d.IExtHostRpcService),Ue(1,k.IExtHostWorkspace),Ue(2,m.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,i,c,f){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=f,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(s,i,c){const f=l(i)||{},h=this._toReadonlyValue(s?p(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,f,c?.identifier);function b(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const S={has(o){return typeof p(h,o)!="undefined"},get:(o,w)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,f,c?.identifier);let R=p(h,o);if(typeof R=="undefined")R=w;else{let O;const $=(K,G)=>{let N;const x=()=>{O=O||(0,g.deepClone)(h),N=N||p(O,G)};return(0,P.isObject)(K)?new Proxy(K,{get:(F,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return x(),()=>N;if(O)return N=N||p(O,G),N[V];const M=F[V];return typeof V=="string"?$(M,`${G}.${V}`):M},set:(F,V,M)=>(x(),N&&(N[V]=M),!0),deleteProperty:(F,V)=>(x(),N&&delete N[V],!0),defineProperty:(F,V,M)=>(x(),N&&Object.defineProperty(N,V,M),!0)}):K};R=$(R,o)}return R},update:(o,w,R,O)=>{o=s?`${s}.${o}`:o;const $=b(R);return w!==void 0?this._proxy.$updateConfigurationOption($,o,w,f,O):this._proxy.$removeConfigurationOption($,o,f,O)},inspect:o=>{o=s?`${s}.${o}`:o;const w=(0,g.deepClone)(this._configuration.inspect(o,f,this._extHostWorkspace.workspace));if(w)return{key:o,defaultValue:w.default?.value,globalValue:w.user?.value,workspaceValue:w.workspace?.value,workspaceFolderValue:w.workspaceFolder?.value,defaultLanguageValue:w.default?.override,globalLanguageValue:w.user?.override,workspaceLanguageValue:w.workspace?.override,workspaceFolderLanguageValue:w.workspaceFolder?.override,languageIds:w.overrideIdentifiers}}};return typeof h=="object"&&(0,g.mixin)(S,h,!1),Object.freeze(S)}_toReadonlyValue(s){const i=c=>(0,P.isObject)(c)?new Proxy(c,{get:(f,h)=>i(f[h]),set:(f,h,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(f,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(f,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}_validateConfigurationAccess(s,i,c){const f=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),h=c?`[${c.value}] `:"";if(f===4){typeof i?.resource=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const c=new C.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,h)=>c.affectsConfiguration(f,l(h))})}_toMap(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[71],ge([0,1,2,17,3,5,23,7,36,45,37,21,33,13,27,4,10,11,12,66,213,16]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a,l,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(N){function x(V){if(V!=null)return V}N.from=x;function F(V){if(V!=null)return V}N.to=F})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(N){function x(V){if(V!=null)return V}N.from=x;function F(V){if(V!=null)return V}N.to=F})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(N){function x(V){if(V!=null)return V}N.from=x;function F(V){if(V!=null)return V}N.to=F})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(N){function x(M){if(M){const U=M;return U&&!!U.process}else return!1}N.is=x;function F(M){if(M==null)return;const U={process:M.process,args:M.args};return M.options&&(U.options=i.from(M.options)),U}N.from=F;function V(M){if(M!=null)return new C.ProcessExecution(M.process,M.args,M.options)}N.to=V})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(N){function x(V){if(V!=null)return V}N.from=x;function F(V){if(V!=null)return V}N.to=F})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(N){function x(M){if(M){const U=M;return U&&(!!U.commandLine||!!U.command)}else return!1}N.is=x;function F(M){if(M==null)return;const U={};return M.commandLine!==void 0?U.commandLine=M.commandLine:(U.command=M.command,U.args=M.args),M.options&&(U.options=f.from(M.options)),U}N.from=F;function V(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new C.ShellExecution(M.commandLine,M.options):new C.ShellExecution(M.command,M.args?M.args:[],M.options)}N.to=V})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(N){function x(M){if(M){let U=M;return U&&U.customExecution==="customExecution"}else return!1}N.is=x;function F(M){return{customExecution:"customExecution"}}N.from=F;function V(M,U){return U.get(M)}N.to=V})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(N){function x(F,V){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&V&&V.workspaceFile?M=V.workspaceFile:M=l.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}N.from=x})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var o;(function(N){function x(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=x})(o=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(N){function x(M,U){if(M==null)return[];const q=[];for(let W of M){const X=F(W,U);X&&q.push(X)}return q}N.fromMany=x;function F(M,U){if(M==null)return;let q;M.execution instanceof C.ProcessExecution?q=c.from(M.execution):M.execution instanceof C.ShellExecution?q=h.from(M.execution):M.execution&&M.execution instanceof C.CustomExecution&&(q=b.from(M.execution));const W=r.from(M.definition);let X;return M.scope?typeof M.scope=="number"?X=M.scope:X=M.scope.uri:X=C.TaskScope.Workspace,!W||!X?void 0:{_id:M._id,definition:W,name:M.name,source:{extensionId:U.identifier.value,label:M.source,scope:X},execution:q,isBackground:M.isBackground,group:o.from(M.group),presentationOptions:s.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=F;async function V(M,U,q){if(M==null)return;let W;c.is(M.execution)?W=c.to(M.execution):h.is(M.execution)?W=h.to(M.execution):b.is(M.execution)&&(W=b.to(M._id,q));const X=r.to(M.definition);let Z;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Z=M.source.scope:Z=await U.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):Z=C.TaskScope.Workspace),!X||!Z)return;const fe=new C.Task(X,Z,M.name,M.source.label,W,M.problemMatchers);return M.isBackground!==void 0&&(fe.isBackground=M.isBackground),M.group!==void 0&&(fe.group=C.TaskGroup.from(M.group._id),fe.group&&(fe.group=A.deepClone(fe.group),M.group.isDefault&&(fe.group.isDefault=M.group.isDefault))),M.presentationOptions&&(fe.presentationOptions=s.to(M.presentationOptions)),M._id&&(fe._id=M._id),M.detail&&(fe.detail=M.detail),fe}N.to=V})(w=e.TaskDTO||(e.TaskDTO={}));var R;(function(N){function x(V){return V}N.from=x;function F(V){if(!!V)return Object.assign(Object.create(null),V)}N.to=F})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(x,F,V){this._id=F,this._task=V,t.set(this,void 0),rt(this,t,x,"f")}get task(){return this._task}terminate(){Be(this,t,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}t=new WeakMap;var $;(function(N){function x(F){return{id:F._id,task:void 0}}N.from=x})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let K=class{constructor(x,F,V,M,U,q,W,X){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=x.getProxy(D.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=M,this._configurationService=U,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=X,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,F,V){if(!V)return new C.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:V,extension:x}),this._proxy.$registerTaskProvider(M,F),new C.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,F){this._proxy.$registerTaskSystem(x,F)}fetchTasks(x){return this._proxy.$fetchTasks(R.from(x)).then(async F=>{const V=[];for(let M of F){const U=await w.to(M,this._workspaceProvider,this._providedCustomExecutions2);U&&V.push(U)}return V})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(F=>x.push(F)),x}terminateTask(x){if(!(x instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,F,V){const M=this._providedCustomExecutions2.get(x.id);if(M){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(V))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const F=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:F,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:x.exitCode})}$provideTasks(x,F){const V=this._handlers.get(x);if(!V)return Promise.reject(new Error("no handler found"));const M=[],U=(0,L.asPromise)(()=>V.provider.provideTasks(I.CancellationToken.None)).then(q=>this.provideTasksInternal(F,M,V,q));return new Promise(q=>{U.then(W=>{Promise.all(M).then(()=>{q(W)})})})}async $resolveTask(x,F){const V=this._handlers.get(x);if(!V)return Promise.reject(new Error("no handler found"));if(F.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${V.type}].`);const M=await w.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const U=await V.provider.resolveTask(M,I.CancellationToken.None);if(!U)return;this.checkDeprecation(U,V);const q=w.from(U,V.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(q.execution)&&await this.addCustomExecution(q,U,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,F,V){const M=await this._proxy.$createTaskId(x);!V&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(x,F){if(typeof x=="string"){const U=this._taskExecutionPromises.get(x);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let V=this._taskExecutionPromises.get(x.id);if(V)return V;const M=new Promise(async(U,q)=>{const W=F||await w.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);W?U(new O(this,x.id,W)):q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,M),M.then(U=>(this._taskExecutions.set(x.id,U),U),U=>Promise.reject(U))}checkDeprecation(x,F){x._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let V=this._notProvidedCustomExecutions.values(),M=V.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=V.next()}};K=ze([Ue(0,m.IExtHostRpcService),Ue(1,u.IExtHostInitDataService),Ue(2,y.IExtHostWorkspace),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,d.IExtHostTerminalService),Ue(6,E.ILogService),Ue(7,a.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let G=class extends K{constructor(x,F,V,M,U,q,W,X){super(x,F,V,M,U,q,W,X);this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:"",platform:T.PlatformToString(0)})}async executeTask(x,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const V=w.from(F,x);if(V===void 0)throw new Error("Task is not valid");if(b.is(V.execution))await this.addCustomExecution(V,F,!1);else throw new v.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),F);return this._proxy.$executeTask(V).catch(U=>{throw new Error(U)}),M}provideTasksInternal(x,F,V,M){const U=[];if(M)for(let q of M){this.checkDeprecation(q,V),(!q.definition||!x[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const W=w.from(q,V.extension);W&&b.is(W.execution)?(U.push(W),F.push(this.addCustomExecution(W,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:V.extension}}async resolveTaskInternal(x){if(b.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,F,V){}};G=ze([Ue(0,m.IExtHostRpcService),Ue(1,u.IExtHostInitDataService),Ue(2,y.IExtHostWorkspace),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,d.IExtHostTerminalService),Ue(6,E.ILogService),Ue(7,a.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(me[267],ge([0,1,20,55,30,79,24,10,8,25,9,14,2,146,176,121,43,129,266,31]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(b,S,o,w){this.configurationService=b,this.workspaceContextService=S,this.editorGroupsService=o,this.pathService=w}text(b,S,o={}){b=this.getContentPattern(b,o);const w=this.configurationService.getValue(),R=S&&S.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(S?.map(_.toWorkspaceFolder),o),type:2,contentPattern:b,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:w.search.usePCRE2||R||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(b,S){const o=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const w={...b,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(b,S)&&(w.isCaseSensitive=!0),this.isMultiline(b)&&(w.isMultiline=!0),w}file(b,S={}){return{...this.commonQuery(b,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(b,S){return b?(b=Array.isArray(b)?b.map(i):i(b),S?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],S={}){const o=this.handleIncludeExclude(S.includePattern,S.expandPatterns),w=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),R=b.length>1,O=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,S,w)):b.map(G=>this.getFolderQueryForRoot(G,S,w,R))).filter(G=>!!G),$={_reason:S._reason,folderQueries:O,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:w.pattern,includePattern:o.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const N=g.coalesce(g.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(V=>V.resource)))).filter(F=>(0,a.pathIncludedInQuery)($,F.fsPath)),x=this.commonQueryFromFileList(N);return{...$,...x}}const K=S.extraFileResources&&S.extraFileResources.filter(G=>(0,a.pathIncludedInQuery)($,G.fsPath));return $.extraFileResources=K&&K.length?K:void 0,$}commonQueryFromFileList(b){const S=[],o=new A.ResourceMap,w={};let R=!1;return b.forEach(O=>{if(O.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(O)){const K=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:y.dirname(O.fsPath)});let G=o.get(K);G||(R=!0,G={folder:K,includePattern:{}},S.push(G),o.set(K,G));const N=y.relative(K.fsPath,O.fsPath);(0,I.assertIsDefined)(G.includePattern)[N.replace(/\\/g,"/")]=!0}else O.fsPath&&(R=!0,w[O.fsPath]=!0)}),{folderQueries:S,includePattern:w,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(b,S){if(S.isSmartCase){if(b.isRegExp){if(n.containsUppercaseCharacter(b.pattern,!0))return!0}else if(n.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const S=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),w=(Array.isArray(b)?b:r(b)).map(x=>{const F=this.pathService.resolvedUserHome;return F?(0,D.untildify)(x,F.scheme===C.Schemas.file?F.fsPath:F.path):x}),R=L.groupBy(w,x=>S(x)?"searchPaths":"exprSegments"),O=(R.exprSegments||[]).map(x=>n.rtrim(x,"/")).map(x=>n.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),$={},K=this.expandSearchPathPatterns(R.searchPaths||[]);K&&K.length&&($.searchPaths=K);const G=g.flatten(O),N=t(...G);return N&&($.pattern=N),$}getExcludesForFolder(b,S){return S.disregardExcludeSettings?void 0:(0,a.getExcludes)(b,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const S=g.flatten(b.map(w=>{let{pathPortion:R,globPortion:O}=v(w);O&&(O=c(O));const $=this.expandOneSearchPath(R);return g.flatten($.map(K=>this.resolveOneSearchPathPattern(K,O)))})),o=new Map;return S.forEach(w=>{const R=w.searchPath.toString(),O=o.get(R);O?w.pattern&&(O.pattern=O.pattern||{},O.pattern[w.pattern]=!0):o.set(R,{searchPath:w.searchPath,pattern:w.pattern?t(w.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(b){if(y.isAbsolute(b)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==C.Schemas.file?[{searchPath:S[0].uri.with({path:b})}]:[{searchPath:d.URI.file(y.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const w=y.posix.resolve(S.path,b);return[{searchPath:S.with({path:w})}]}const o=c(b);return[{searchPath:S,pattern:o}]}else{if(b==="./"||b===".\\")return[];{const S=b.replace(/^\.[\/\\]/,""),w=this.workspaceContextService.getWorkspace().folders.map(R=>{const O=S.match(new RegExp(`^${n.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return O?{match:O,folder:R}:null}).filter(I.isDefined);if(w.length)return w.map(R=>{const O=R.match[1];return{searchPath:R.folder.uri,pattern:O&&c(O)}});{const R=b.match(/\.[\/\\](.+)[\/\\]?/),O=R?R[1]:b,$=u.localize(0,null,O);throw new Error($)}}}}resolveOneSearchPathPattern(b,S){const o=b.pattern&&S?`${b.pattern}/${S}`:b.pattern||S,w=[{searchPath:b.searchPath,pattern:o}];return o&&!o.endsWith("**")&&w.push({searchPath:b.searchPath,pattern:o+"/**"}),w}getFolderQueryForSearchPath(b,S,o){const w=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(b.searchPath),S,o,!1);return w?{...w,includePattern:b.pattern}:null}getFolderQueryForRoot(b,S,o,w){let R;const O=d.URI.isUri(b)?b:b.uri;if(o.searchPaths){const x=o.searchPaths.filter(F=>(0,P.isEqual)(F.searchPath,O))[0];if(x&&!x.pattern)return null;x&&(R=x.pattern)}const $=this.configurationService.getValue({resource:O}),G={...this.getExcludesForFolder($,S)||{},...R||{}},N=d.URI.isUri(b)?(0,P.basename)(b):b.name;return{folder:O,folderName:w?N:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!$.search.followSymlinks}}};l=ze([Ue(0,p.IConfigurationService),Ue(1,_.IWorkspaceContextService),Ue(2,T.IEditorGroupsService),Ue(3,E.IPathService)],l),e.QueryBuilder=l;function v(h){const b=h.match(/[\*\{\}\(\)\[\]\?]/);if(b){const S=b.index,o=h.substr(0,S).match(/[/|\\][^/\\]*$/);if(o){let w=h.substr(0,o.index);return w.match(/[/\\]/)||(w+="/"),{pathPortion:w,globPortion:h.substr((o.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((b,S)=>(b[S]=!0,b),Object.create(null)):void 0}function r(h){return k.splitGlobAware(h,",").map(b=>b.trim()).filter(b=>!!b.length)}function s(h){return[`**/${h}/**`,`**/${h}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function c(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(h,b){h=g.distinct(h,w=>w.toString());const S=[],o=b.getWorkspace();return h&&h.forEach(w=>{let R;if(b.getWorkbenchState()===2)R=(0,P.relativePath)(o.folders[0].uri,w),R&&R!=="."&&(R="./"+R);else{const O=b.getWorkspaceFolder(w);if(O){const $=O.name;if(o.folders.filter(G=>G.name===$).length===1){const G=(0,P.relativePath)(O.uri,w);G===""?R=`./${O.name}`:R=`./${O.name}/${G}`}else R=w.fsPath}}R&&S.push(R)}),S}e.resolveResourcesForSearchIncludes=f}),define(me[268],ge([0,1,25,2,21,16,4,267,31,43]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(p,_){const T=_.activationEvents;if(!T)return Promise.resolve(void 0);const E=[],a=[];for(const i of T)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||p.forceUsingSearch?a.push(c):E.push(c)}if(E.length===0&&a.length===0)return Promise.resolve(void 0);let l;const v=new Promise((i,c)=>{l=i}),t=i=>l({activationEvent:i}),r=Promise.all(E.map(i=>d(p,i,t))).then(()=>{}),s=m(p,_.identifier,a,t);return Promise.all([r,s]).then(()=>{l(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function d(p,_,T){for(const E of p.folders)if(await p.exists(g.joinPath(L.URI.revive(E),_))){T(`workspaceContains:${_}`);return}}async function m(p,_,T,E){if(T.length===0)return Promise.resolve(void 0);const a=new k.CancellationTokenSource,l=p.checkExists(p.folders,T,a.token),v=setTimeout(async()=>{a.cancel(),E(`workspaceContainsTimeout:${T.join(",")}`)},n);let t=!1;try{t=await l}catch(r){D.isPromiseCanceledError(r)||D.onUnexpectedError(r)}a.dispose(),clearTimeout(v),t&&E(`workspaceContains:${T.join(",")}`)}function u(p,_,T,E){const a=p.get(A.IInstantiationService),l=p.get(y.ISearchService),t=a.createInstance(C.QueryBuilder).file(_.map(r=>(0,P.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:T,exists:!0});return l.fileSearch(t,E).then(r=>!!r.limitHit,r=>D.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},Be=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[40],ge([0,1,165,8,72,25,17,6,24,2,12,5,37,226,93,36,35,224,16,26,22,199,7,122,4,27,68,13,84,52,33,3,268,91,201]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a,l,v,t,r,s,i,c,f,h,b,S,o,w,R,O){"use strict";var $,K,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let N=class Wn extends C.Disposable{constructor(M,U,q,W,X,Z,fe,_e,De,Le){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=q,this._initData=fe,this._extHostWorkspace=W,this._extHostConfiguration=X,this._logService=Z,this._extHostTunnelService=De,this._extHostTerminalService=Le,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=M.createChild(new h.ServiceCollection([u.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(xe=>qe.add(a.ExtensionIdentifier.toKey(xe))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(xe,Ke,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(xe,E.transformErrorForSerialization(Ke),H)},actualActivateExtension:async(xe,Ke)=>{if(qe.has(a.ExtensionIdentifier.toKey(xe)))return await this._mainThreadExtensionsProxy.$activateExtension(xe,Ke),new m.HostExtension;const H=this._registry.getExtensionDescription(xe);return this._activateExtension(H,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this._deactivate(X))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=y.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(W=>M.set(P.URI.file(W).fsPath,q))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const q=this._activator.getActivatedExtension(M);if(!q)return U;try{typeof q.module.deactivate=="function"&&(U=Promise.resolve(q.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,C.dispose)(q.subscriptions)}catch(W){this._logService.error(W)}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(q=>{const W=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",W),q},q=>{throw this._logExtensionActivationTimes(M,U,"failure"),q})}_logExtensionActivationTimes(M,U,q,W){const X=x(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...X,...W||{},outcome:q})}_doActivateExtension(M,U){const q=x(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const W=this._getEntryPoint(M);if(!W)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const X=new m.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,D.joinPath)(M.extensionLocation,W),X),this._loadExtensionContext(M)]).then(Z=>(k.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Wn._callActivate(this._logService,M.identifier,Z[0],Z[1],X))).then(Z=>(k.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),Z))}_loadExtensionContext(M){const U=new v.ExtensionGlobalMemento(M,this._storage),q=new v.ExtensionMemento(M.identifier.value,!1,this._storage),W=new O.ExtensionSecrets(M,this._secretState),X=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Z=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let _e;return Object.freeze({globalState:U,workspaceState:q,secrets:W,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(De){return L.join(M.extensionLocation.fsPath,De)},get storagePath(){return fe._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(M).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return P.URI.joinPath(fe._initData.logsLocation,M.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(M)},get globalStorageUri(){return fe._storagePath.globalValue(M)},get extensionMode(){return X},get extension(){return _e===void 0&&(_e=new F(fe,M.identifier,M,Z)),_e},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(M),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,q,W,X){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,q,W,X).then(Z=>new m.ActivatedExtension(!1,null,X.build(),q,Z,W.subscriptions))}static _callActivateOptional(M,U,q,W,X){if(typeof q.activate=="function")try{X.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const Z=typeof global=="object"?global:self,fe=q.activate.apply(Z,[W]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(fe).then(_e=>(X.activateResolveStop(),_e))}catch(Z){return Promise.reject(Z)}else return Promise.resolve(q)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,X=>{this._logService.error(X)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(X=>this._handleWorkspaceContainsEagerExtensions(X.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(U),W=Promise.all([M,q]).then(()=>{});return Promise.race([W,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(this.isActivated(U.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:M.map(Z=>Z.uri),forceUsingSearch:q,exists:Z=>this._hostUtils.exists(Z.fsPath),checkExists:(Z,fe,_e)=>this._mainThreadWorkspaceProxy.$checkExists(Z,fe,_e)},X=await(0,w.checkActivateWorkspaceContainsExtension)(W,U);if(!!X)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:X.activationEvent}).then(void 0,Z=>this._logService.error(Z))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(g.localize(0,null));const q=await this._loadCommonJSModule(null,U,new m.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(g.localize(1,null,U.toString()));return new Promise((W,X)=>{const Z=(De,Le)=>{De?X(De):W(typeof Le=="number"&&Le>0?1:0)},fe=(0,D.originalFSPath)(U),_e=q.run(fe,Z);_e&&_e.then&&_e.then(()=>{W(0)}).catch(De=>{X(De.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const U=M.indexOf("+");if(U===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,U);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,U){const{authorityPrefix:q,resolver:W}=await this._activateAndGetResolver(M);if(!W)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),k.mark(`code/extHost/willResolveAuthority/${q}`);const X=await W.resolve(M,{resolveAttempt:U});k.mark(`code/extHost/didResolveAuthorityOK/${q}`);const Z={authority:M,host:X.host,port:X.port,connectionToken:X.connectionToken},fe={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted};return{type:"ok",value:{authority:Z,options:fe,tunnelInformation:{environmentTunnels:X.environmentTunnels}}}}catch(X){if(k.mark(`code/extHost/didResolveAuthorityError/${q}`),X instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X}}async $getCanonicalURI(M,U){const{authorityPrefix:q,resolver:W}=await this._activateAndGetResolver(M);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const X=P.URI.revive(U);if(typeof W.getCanonicalURI=="undefined")return X;const Z=await(0,A.asPromise)(()=>W.getCanonicalURI(X));return Z||X}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(W=>W.extensionLocation=P.URI.revive(W.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(U.map(async W=>{const X=this._registry.getExtensionDescription(W);if(!X)return;const Z=await this._hostUtils.realpath(X.extensionLocation.fsPath);q.delete(P.URI.file(Z).fsPath)})),await Promise.all(M.map(async W=>{const X=await this._hostUtils.realpath(W.extensionLocation.fsPath);q.set(P.URI.file(X).fsPath,W)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=l.VSBuffer.alloc(M),q=Math.random()%256;for(let W=0;W<M;W++)U.writeUInt8(q,W);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};N=ze([Ue(0,s.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,f.IExtHostRpcService),Ue(3,p.IExtHostWorkspace),Ue(4,d.IExtHostConfiguration),Ue(5,n.ILogService),Ue(6,i.IExtHostInitDataService),Ue(7,c.IExtensionStoragePaths),Ue(8,b.IExtHostTunnelService),Ue(9,S.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function x(V,M){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class F{constructor(M,U,q,W){$.set(this,void 0),K.set(this,void 0),G.set(this,void 0),rt(this,$,M,"f"),rt(this,K,U,"f"),rt(this,G,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=L.normalize((0,D.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=W}get isActive(){return Be(this,$,"f").isActivated(Be(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,$,"f").getExtensionExports(Be(this,G,"f"))}activate(){return Be(this,$,"f").activateByIdWithErrors(Be(this,G,"f"),{startup:!1,extensionId:Be(this,K,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,$=new WeakMap,K=new WeakMap,G=new WeakMap}),define(me[53],ge([0,1,8,2,3,17,5,7,125,36,40,45,215,37,209,13,4,14,38,51]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let l=class{constructor(h,b,S,o,w,R){this._workspaceService=b,this._extensionService=S,this._editorsService=o,this._configurationService=w,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=h.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange($=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,b){const S=h;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let o=`debug:${encodeURIComponent(S.path||"")}`,w="?";return b&&(o+=`${w}session=${encodeURIComponent(b.id)}`,w="&"),o+=`${w}ref=${S.sourceReference}`,L.URI.parse(o)}else{if(S.path)return L.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const b=[];for(const S of h.getAllExtensionDescriptions())if(S.contributes){const o=S.contributes.debuggers;if(o&&o.length>0)for(const w of o)(0,u.isDebuggerMainContribution)(w)&&b.push(w.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(b=>h.push(b)),h}addBreakpoints(h){this.startBreakpoints();const b=h.filter(w=>{const R=w.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,w),!0)});this.fireBreakpointChanges(b,[],[]);const S=[],o=new Map;for(const w of b)if(w instanceof C.SourceBreakpoint){let R=o.get(w.location.uri.toString());R||(R={type:"sourceMulti",uri:w.location.uri,lines:[]},o.set(w.location.uri.toString(),R),S.push(R)),R.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof C.FunctionBreakpoint&&S.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(h){this.startBreakpoints();const b=h.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],b,[]);const S=b.filter(R=>R instanceof C.SourceBreakpoint).map(R=>R.id),o=b.filter(R=>R instanceof C.FunctionBreakpoint).map(R=>R.id),w=b.filter(R=>R instanceof C.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(S,o,w)}startDebugging(h,b,S){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,b,{parentSessionID:S.parentSession?S.parentSession.id:void 0,lifecycleManagedByParent:S.lifecycleManagedByParent,repl:S.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact,debugUI:S.debugUI})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,b,S){if(!b)return new C.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:o,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,S,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,o),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(h,b,S){if(!S)return new C.Disposable(()=>{});if(!this.definesDebugType(h,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:o,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,o),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(h,b){if(!b)return new C.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:S,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==b)})}async $runInTerminal(h,b){return Promise.resolve(void 0)}async $substituteVariables(h,b){if(!this._variableResolver){const[w,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,R)}let S;const o=await this.getFolder(h);return o&&(S={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,b)}createDebugAdapter(h,b){if(h.type==="implementation")return new i(h.implementation)}createSignService(){}async $startDASession(h,b){const S=this,o=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const R=this.convertToDto(w),O=this.createDebugAdapter(R,o);if(!O)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const $=O;return this._debugAdapters.set(h,$),this.getDebugAdapterTrackers(o).then(K=>(K&&this._debugAdaptersTrackers.set(h,K),$.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const N=G,x={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(N.arguments.value);x.body={signature:F},$.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,$.sendResponse(x)}}else K&&K.onDidSendMessage&&K.onDidSendMessage(G),G=(0,u.convertToVSCPaths)(G,!0),S._debugServiceProxy.$acceptDAMessage(h,G)}),$.onError(G=>{K&&K.onError&&K.onError(G),this._debugServiceProxy.$acceptDAError(h,G.name,G.message,G.stack)}),$.onExit(G=>{K&&K.onExit&&K.onExit((0,T.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,T.withNullAsUndefined)(G),void 0)}),K&&K.onWillStartSession&&K.onWillStartSession(),$.startSession()))})}$sendDAMessage(h,b){b=(0,u.convertToDAPaths)(b,!1);const S=this._debugAdaptersTrackers.get(h);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(b);const o=this._debugAdapters.get(h);o&&o.sendMessage(b)}$stopDASession(h){const b=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),b&&b.onWillStopSession&&b.onWillStopSession();const S=this._debugAdapters.get(h);return this._debugAdapters.delete(h),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const b=[],S=[],o=[];if(h.added)for(const w of h.added){const R=w.id;if(R&&!this._breakpoints.has(R)){let O;if(w.type==="function")O=new C.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")O=new C.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const $=L.URI.revive(w.uri);O=new C.SourceBreakpoint(new C.Location($,new C.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}O._id=R,this._breakpoints.set(R,O),b.push(O)}}if(h.removed)for(const w of h.removed){const R=this._breakpoints.get(w);R&&(this._breakpoints.delete(w),S.push(R))}if(h.changed){for(const w of h.changed)if(w.id){const R=this._breakpoints.get(w.id);if(R){if(R instanceof C.FunctionBreakpoint&&w.type==="function"){const O=R;O.enabled=w.enabled,O.condition=w.condition,O.hitCondition=w.hitCondition,O.logMessage=w.logMessage,O.functionName=w.functionName}else if(R instanceof C.SourceBreakpoint&&w.type==="source"){const O=R;O.enabled=w.enabled,O.condition=w.condition,O.hitCondition=w.hitCondition,O.logMessage=w.logMessage,O.location=new C.Location(L.URI.revive(w.uri),new C.Position(w.line,w.character))}o.push(R)}}}this.fireBreakpointChanges(b,S,o)}$provideDebugConfigurations(h,b,S){return(0,D.asPromise)(async()=>{const o=this.getConfigProviderByHandle(h);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(b);return o.provideDebugConfigurations(w,S)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(h,b,S,o){return(0,D.asPromise)(async()=>{const w=this.getConfigProviderByHandle(h);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(b);return w.resolveDebugConfiguration(R,S,o)})}$resolveDebugConfigurationWithSubstitutedVariables(h,b,S,o){return(0,D.asPromise)(async()=>{const w=this.getConfigProviderByHandle(h);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(b);return w.resolveDebugConfigurationWithSubstitutedVariables(R,S,o)})}async $provideDebugAdapter(h,b){const S=this.getAdapterDescriptorFactoryByHandle(h);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(b);return this.getAdapterDescriptor(S,o).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(h){const b=await this.getSession(h);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(h){const b=await this.getSession(h);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,b){const S=await this.getSession(h);S&&S._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(h,b){const o={session:await this.getSession(h),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(h){if(h instanceof C.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof C.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const b=this._adapterFactories.filter(S=>S.type===h);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(h){const b=this._adapterFactories.filter(S=>S.handle===h);if(b.length>0)return b[0].factory}getConfigProviderByHandle(h){const b=this._configProviders.filter(S=>S.handle===h);if(b.length>0)return b[0].provider}definesDebugType(h,b){if(h.contributes){const S=h.contributes.debuggers;if(S&&S.length>0){for(const o of S)if(o.label&&o.type&&o.type===b)return!0}}return!1}getDebugAdapterTrackers(h){const S=h.configuration.type,o=this._trackerFactories.filter(w=>w.type===S||w.type==="*").map(w=>(0,D.asPromise)(()=>w.factory.createDebugAdapterTracker(h)).then(R=>R,R=>null));return Promise.race([Promise.all(o).then(w=>{const R=w.filter(O=>!!O);if(R.length>0)return new s(R)}),new Promise((w,R)=>{const O=setTimeout(()=>{clearTimeout(O),R(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(h,b){const S=b.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new C.DebugAdapterServer(S));if(h){const w=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>h.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,w))).then(R=>{if(R)return R})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,o))}daExecutableFromPackage(h,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,b,S){(h.length>0||b.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:b,changed:S}))}async getSession(h){if(h)if(typeof h=="string"){const b=this._debugSessions.get(h);if(b)return b}else{let b=this._debugSessions.get(h.id);if(!b){const S=await this.getFolder(h.folderUri),o=h.parent?this._debugSessions.get(h.parent):void 0;b=new v(this._debugServiceProxy,h.id,h.type,h.name,S,h.configuration,o),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(h){if(h){const b=L.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};l=ze([Ue(0,p.IExtHostRpcService),Ue(1,P.IExtHostWorkspace),Ue(2,n.IExtHostExtensionService),Ue(3,I.IExtHostDocumentsAndEditors),Ue(4,m.IExtHostConfiguration),Ue(5,a.IExtHostEditorTabs)],l),e.ExtHostDebugServiceBase=l;class v{constructor(h,b,S,o,w,R,O){this._debugServiceProxy=h,this._id=b,this._type=S,this._name=o,this._workspaceFolder=w,this._configuration=R,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,b)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=v;class t{constructor(h){this.value=Object.freeze({append(b){h.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class r extends d.AbstractVariableResolverService{constructor(h,b,S,o,w){function R(){if(b){const O=b.activeEditor();if(O)return O.document.uri;const $=o.tabs.filter(K=>K.isActive);if($.length>0)return $[0].resource}}super({getFolderUri:O=>{const $=h.filter(K=>K.name===O);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(O,$)=>S.getConfiguration(void 0,O).get($),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=R();if(O)return g.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const O=R();if(O){const $=w.getWorkspaceFolder(O);if($)return g.normalize($.uri.fsPath)}}},getSelectedText:()=>{if(b){const O=b.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(b){const O=b.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=r;class s{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(b=>b.onError?b.onError(h):void 0)}onExit(h,b){this.trackers.forEach(S=>S.onExit?S.onExit(h,b):void 0)}}class i extends y.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends l{constructor(h,b,S,o,w,R){super(h,b,S,o,w,R)}createVariableResolver(h,b,S){return new r(h,b,S,this._editorTabs)}};c=ze([Ue(0,p.IExtHostRpcService),Ue(1,P.IExtHostWorkspace),Ue(2,n.IExtHostExtensionService),Ue(3,I.IExtHostDocumentsAndEditors),Ue(4,m.IExtHostConfiguration),Ue(5,a.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(me[269],ge([0,1,72,2,5,37,35,26,13,27,4,40,38,12]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(a,l,v,t,r,s,i){this._apiFactory=a,this._extensionRegistry=l,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,l,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,l,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let l of a.nodeModuleName)this._factories.set(l,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(l=>a.alternativeModuleName(l))}};u=ze([Ue(2,n.IInstantiationService),Ue(3,D.IExtHostConfiguration),Ue(4,I.IExtHostExtensionService),Ue(5,P.IExtHostInitDataService),Ue(6,m.ILogService)],u),e.RequireInterceptor=u;class p{constructor(a,l,v,t,r){this._apiFactory=a,this._extensionPaths=l,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,l){const v=this._extensionPaths.findSubstr(l.fsPath);if(v){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(a,l){this.nodeModuleName="keytar";const{environment:v}=l,t=a.getProxy(k.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;d.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(a,l){return this._impl}alternativeModuleName(a){const l=a.length;if(l<=7||!this.alternativeNames)return;const v=l-7;if((a.charAt(v)==="/"||a.charAt(v)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};_=ze([Ue(0,y.IExtHostRpcService),Ue(1,P.IExtHostInitDataService)],_);let T=class{constructor(a,l,v){this._extensionPaths=a,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(k.MainContext.MainThreadTelemetry);const t=v.getProxy(k.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=L.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(a,l,v){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(a),this._impl}callOriginal(a,l){return this.sendNoForwardTelemetry(),this._original(a,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=ze([Ue(2,y.IExtHostRpcService)],T)}),define(me[270],ge([0,1,171,11,7,210,36,40,45,37,33,13,53,194,17,211,51]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let T=class extends d.ExtHostDebugServiceBase{constructor(l,v,t,r,s,i,c){super(l,v,t,r,s,c);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(l,v){switch(l.type){case"server":return new D.SocketDebugAdapter(l);case"pipeServer":return new D.NamedPipeDebugAdapter(l);case"executable":return new D.ExecutableDebugAdapter(l,v.type)}return super.createDebugAdapter(l,v)}daExecutableFromPackage(l,v){const t=D.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),l.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(l,v){if(l.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),i=l.title||g.localize(0,null),c=JSON.stringify({shell:r,shellArgs:s});let f=await this._integratedTerminalInstances.checkout(c,i),h,b=!1;if(f)h=l.cwd;else{const R={shellPath:r,shellArgs:s,cwd:l.cwd,name:i,iconPath:new k.ThemeIcon("debug")};b=!0,f=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,c)}f.show(!0);const S=await f.processId;b?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?f.sendText("cls"):r.indexOf("bash")>=0?f.sendText("clear"):L.isWindows?f.sendText("cls"):f.sendText("clear"));const o=(0,p.prepareCommand)(r,l.args,h,l.env);f.sendText(o);const w=this.onDidTerminateDebugSession(R=>{R.id===v&&(this._integratedTerminalInstances.free(f),w.dispose())});return S}else if(l.kind==="external")return(0,p.runInExternalTerminal)(l,await this._configurationService.getConfigProvider());return super.$runInTerminal(l,v)}createVariableResolver(l,v,t){return new d.ExtHostVariableResolverService(l,v,t,this._editorTabs,this._workspaceService)}};T=ze([Ue(0,I.IExtHostRpcService),Ue(1,A.IExtHostWorkspace),Ue(2,C.IExtHostExtensionService),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,P.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,_.IExtHostEditorTabs)],T),e.ExtHostDebugService=T;class E{constructor(){this._terminalInstances=new Map}async checkout(l,v){const r=[...this._terminalInstances.entries()].map(([s,i])=>(0,u.createCancelablePromise)(async c=>{if(s.name!==v||i.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await s.processId))return null;const f=Date.now();return i.lastUsedAt+E.minUseDelay>f||c.isCancellationRequested||i.config!==l?null:(i.lastUsedAt=f,s)}));return await(0,u.firstParallel)(r,s=>!!s)}insert(l,v){this._terminalInstances.set(l,{lastUsedAt:Date.now(),config:v})}free(l){const v=this._terminalInstances.get(l);v&&(v.lastUsedAt=-1)}onTerminalClosed(l){this._terminalInstances.delete(l)}}E.minUseDelay=1e3}),define(me[271],ge([0,1,8,2,113,36,53,45,37,43,33,13,27,71,10,12,66,51,25,80]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let l=class extends m.ExtHostTaskBase{constructor(t,r,s,i,c,f,h,b,S){super(t,r,s,i,c,f,h,b);this.workspaceService=s,this.editorTabs=S,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(u.Schemas.file,{scheme:u.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const s=r;if(!r.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const i=m.TaskHandleDTO.from(s,this.workspaceService),c=await this._proxy.$getTaskExecution(i);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.getTaskExecution(c,r);return this._proxy.$executeTask(i).catch(()=>{}),f}else{const i=m.TaskDTO.from(r,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,r,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),r);return this._proxy.$executeTask(i).catch(()=>{}),c}}provideTasksInternal(t,r,s,i){const c=[];if(i)for(let f of i){this.checkDeprecation(f,s),(!f.definition||!t[f.definition.type])&&this._logService.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const h=m.TaskDTO.from(f,s.extension);h&&(c.push(h),m.CustomExecutionDTO.is(h.execution)&&r.push(this.addCustomExecution(h,f,!0)))}return{tasks:c,extension:s.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const s=L.URI.file((0,a.homedir)());r=new P.WorkspaceFolder({uri:s,name:E.basename(s),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const s=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(s),f=await this._workspaceProvider.getWorkspaceFolders2()??[],h=await this.getVariableResolver(f),b=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(f);for(let S of r.variables)i.variables[S]=await h.resolveAsync(b,S);if(r.process!==void 0){let S;if(r.process.path!==void 0){S=r.process.path.split(g.delimiter);for(let o=0;o<S.length;o++)S[o]=await h.resolveAsync(b,S[o])}i.process=await k.win32.findExecutable(await h.resolveAsync(b,r.process.name),r.process.cwd!==void 0?await h.resolveAsync(b,r.process.cwd):void 0,S)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,s){return k.win32.findExecutable(t,r,s)}};l=ze([Ue(0,I.IExtHostRpcService),Ue(1,d.IExtHostInitDataService),Ue(2,D.IExtHostWorkspace),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,p.ILogService),Ue(7,_.IExtHostApiDeprecationService),Ue(8,T.IExtHostEditorTabs)],l),e.ExtHostTask=l}),define(me[272],ge([0,1,17,16,72,6,2,5,264,12,82,84,27,189,13,64,40,33]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,v,t,r){this._disposables=new D.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(l,null,r),v=E._transform(v,this._rpcProtocol);const s=new I.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),s.set(p.IURITransformerService,new p.URITransformerService(r)),s.set(_.IHostUtils,t);const i=new m.InstantiationService(s,!0),c=i.invokeFunction(S=>S.get(T.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(S=>S.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(S=>S.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(S=>{Error.prepareStackTrace=(o,w)=>{let R="",O,$;for(const K of w)R+=`
	at ${K.toString()}`,$=K.getFileName(),!O&&$&&(O=S.findSubstr($));return f.set(o,O),`${o.name||"Error"}: ${o.message||""}${R}`}});const h=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(S=>{const o=L.transformErrorForSerialization(S),w=f.get(S);w?h.$onExtensionRuntimeError(w.identifier,o):b.$onUnexpectedError(o)})}terminate(l){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(l,v){l.extensions.forEach(r=>r.extensionLocation=A.URI.revive(v.transformIncomingURIs(r.extensionLocation))),l.environment.appRoot=A.URI.revive(v.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(r=>A.URI.revive(v.transformIncomingURIs(r)))),l.environment.extensionTestsLocationURI=A.URI.revive(v.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=A.URI.revive(v.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=A.URI.revive(v.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=A.URI.revive(v.transformIncomingURIs(l.logsLocation)),l.logFile=A.URI.revive(v.transformIncomingURIs(l.logFile)),l.workspace=v.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(me[273],ge([0,1,8,21,60,30,25,46,31]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(d,m,u){this.config=d,this.provider=m,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&D.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&D.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const m=this.config.folderQueries||[];return new Promise((u,p)=>{const _=T=>{this.resultCount++,d(T)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const E=T.toString(),a=g.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,a)||this.matchFile(_,{base:T,basename:a})}),Promise.all(m.map(T=>this.searchInFolder(T,_))).then(T=>{u({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{p(new Error((0,k.toErrorMessage)(T)))})})}async searchInFolder(d,m){const u=new L.CancellationTokenSource,p=this.getSearchOptionsForFolder(d),_=this.initDirectoryTree(),T=new y.QueryGlobTester(this.config,d),E=!T.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(u),a=C.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,u.token),v=a.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(r=>{const s=g.posix.relative(d.folder.path,r.path);if(E){const i=g.basename(r.path);this.matchFile(m,{base:d.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(_,d.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,T,m),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(d){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),u=(0,y.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:u,includes:m,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},m,u,p){if(u===this.filePattern){const T=g.basename(this.filePattern);this.matchFile(p,{base:m,relativePath:this.filePattern,basename:T})}function _(T){const E=g.basename(T),a=g.dirname(T);let l=d[a];l||(l=d[a]=[],_(a)),l.push({base:m,relativePath:T,basename:E})}_(u)}matchDirectoryTree({rootEntries:d,pathToEntries:m},u,p){const _=this,T=this.filePattern;function E(a){const l=D.hasSiblingFn(()=>a.map(v=>v.basename));for(let v=0,t=a.length;v<t;v++){const r=a[v],{relativePath:s,basename:i}=r;if(!u.includedInQuerySync(s,i,T!==i?l:void 0))continue;const c=m[s];if(c)E(c);else{if(s===T)continue;_.matchFile(p,r)}if(_.isLimitHit)break}}E(d)}matchFile(d,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(m))}}class n{constructor(){this.sessions=new Map}fileSearch(d,m,u,p){const _=this.getSessionTokenSource(d.cacheKey),T=new P(d,m,_&&_.token);let E=0;const a=l=>{E+=l.length,u(l.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(T,n.BATCH_SIZE,a,p).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(d){const m=this.getSessionTokenSource(d);m&&m.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new L.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:A.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,m,u,p){p.onCancellationRequested(()=>{d.cancel()});const _=E=>{E&&(T.push(E),m>0&&T.length>=m&&(u(T),T=[]))};let T=[];return d.search(_).then(E=>(T.length&&u(T),E),E=>(T.length&&u(T),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[134],ge([0,1,8,20,21,60,25,30,2,31,10,14]),function(Y,e,g,L,k,D,A,C,y,P,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(a,l,v){this.query=a,this.provider=l,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,l){const v=this.query.folderQueries||[],t=new k.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new u(a);let i=!1;const c=(f,h)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(f);_(f)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const S=this.resultSize(f);this.resultCount+=S,(S>0||!_(f))&&this.collector.add(f,h)}};Promise.all(v.map((f,h)=>this.searchInFolder(f,b=>c(b,h),t.token))).then(f=>{t.dispose(),this.collector.flush();const h=f.some(b=>!!b&&!!b.limitHit);r({limitHit:this.isLimitHit||h,messages:(0,L.flatten)(f.map(b=>b?.message?(0,I.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const h=(0,D.toErrorMessage)(f);s(new Error(h))})})}resultSize(a){return _(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,l){const v=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:v.slice(0,l),preview:{matches:t.slice(0,l),text:a.preview.text},uri:a.uri}}async searchInFolder(a,l,v){const t=new P.QueryGlobTester(this.query,a),r=[],s={report:f=>{if(!this.validateProviderResult(f))return;const h=a.folder.scheme===n.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(f.uri))):void 0,b=A.relativePath(a.folder,f.uri);b&&r.push(t.includedInQuery(b,g.basename(b),h).then(S=>{S&&l(f)}))}},i=this.getSearchOptionsForFolder(a),c=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,s,v);return await Promise.all(r),c}validateProviderResult(a){if(_(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const l=(0,P.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),v=(0,P.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:y.URI.from(a.folder),excludes:v,includes:l,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function m(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class u{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,l=>this.sendItems(l))}add(a,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!A.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(p(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=u;function p(E){return _(E)?{preview:{matches:(0,L.mapArrayOrNot)(E.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:E.preview.text},ranges:(0,L.mapArrayOrNot)(E.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class T{constructor(a,l){this.maxBatchSize=a,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,l){!a||this.addItemToBatch(a,l)}addItems(a,l){!a||this.addItemsToBatch(a,l)}addItemToBatch(a,l){this.batch.push(a),this.batchSize+=l,this.onUpdate()}addItemsToBatch(a,l){this.batch=this.batch.concat(a),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(me[73],ge([0,1,6,5,4,273,13,64,12,2,134]),function(Y,e,g,L,k,D,A,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let I=class{constructor(p,_,T){this.extHostRpc=p,this._uriTransformer=_,this._logService=T,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new D.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,_){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const T=this._handlePool++;return this._textSearchProvider.set(T,_),this._proxy.$registerTextSearchProvider(T,this._transformScheme(p)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(p,_){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const T=this._handlePool++;return this._fileSearchProvider.set(T,_),this._proxy.$registerFileSearchProvider(T,this._transformScheme(p)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(p,_,T,E){const a=d(T),l=this._fileSearchProvider.get(p);if(l)return this._fileSearchManager.fileSearch(a,l,v=>{this._proxy.$handleFileMatch(p,_,v.map(t=>t.resource))},E);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,_,T,E){const a=this._textSearchProvider.get(p);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const l=d(T);return this.createTextSearchManager(l,a).search(t=>this._proxy.$handleTextMatch(p,_,t),E)}createTextSearchManager(p,_){return new n.TextSearchManager(p,_,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T})}};I=ze([Ue(0,A.IExtHostRpcService),Ue(1,C.IURITransformerService),Ue(2,y.ILogService)],I),e.ExtHostSearch=I;function d(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(m),extraFileResources:u.extraFileResources&&u.extraFileResources.map(p=>P.URI.revive(p))}}e.reviveQuery=d;function m(u){return{...u,folder:P.URI.revive(u.folder)}}}),define(me[274],ge([0,1,21,16,3,48,2,118,109,147,81,42,5,232,231,44,233,37,234,235,236,217,237,45,40,238,218,241,242,243,67,220,248,249,250,93,33,252,221,15,7,255,69,133,36,35,55,206,240,86,132,71,53,73,12,64,13,27,244,203,52,66,229,253,202,68,92,258,256,257,230,63,251,254,91,51,123,246,70,247,10,191,245,200,239]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a,l,v,t,r,s,i,c,f,h,b,S,o,w,R,O,$,K,G,N,x,F,V,M,U,q,W,X,Z,fe,_e,De,Le,qe,xe,Ke,H,ee,re,le,J,ae,ve,Fe,je,Qe,et,ke,ct,Q,te,pe,He,tt,st,lt,wt,Ct,ce,Pe,Ne,Ge,$e,at,Re,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(He.IExtHostFileSystemInfo),we=ne.get(ke.IExtHostConsumerFileSystem),Me=ne.get(s.IExtHostExtensionService),Ve=ne.get(q.IExtHostWorkspace),We=ne.get(Ct.IExtHostTelemetry),Je=ne.get(T.IExtHostConfiguration),nt=ne.get(H.IURITransformerService),oe=ne.get(ee.IExtHostRpcService),Ee=ne.get($.IExtHostStorage),ue=ne.get(et.IExtensionStoragePaths),j=ne.get(Ke.ILogService),Ae=ne.get(ae.IExtHostTunnelService),Ie=ne.get(ve.IExtHostApiDeprecationService),Ye=ne.get(U.IExtHostWindow),Xe=ne.get(lt.IExtHostSecretState),ot=ne.get(wt.IExtHostEditorTabs);oe.set(d.ExtHostContext.ExtHostFileSystemInfo,be),oe.set(d.ExtHostContext.ExtHostLogService,j),oe.set(d.ExtHostContext.ExtHostWorkspace,Ve),oe.set(d.ExtHostContext.ExtHostConfiguration,Je),oe.set(d.ExtHostContext.ExtHostExtensionService,Me),oe.set(d.ExtHostContext.ExtHostStorage,Ee),oe.set(d.ExtHostContext.ExtHostTunnelService,Ae),oe.set(d.ExtHostContext.ExtHostWindow,Ye),oe.set(d.ExtHostContext.ExtHostSecretState,Xe),oe.set(d.ExtHostContext.ExtHostTelemetry,We),oe.set(d.ExtHostContext.ExtHostEditorTabs,ot);const _t=oe.set(d.ExtHostContext.ExtHostDecorations,ne.get(De.IExtHostDecorations)),vt=oe.set(d.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(r.IExtHostDocumentsAndEditors)),gt=oe.set(d.ExtHostContext.ExtHostCommands,ne.get(p.IExtHostCommands)),mt=oe.set(d.ExtHostContext.ExtHostTerminalService,ne.get(K.IExtHostTerminalService)),ht=oe.set(d.ExtHostContext.ExtHostDebugService,ne.get(qe.IExtHostDebugService)),yt=oe.set(d.ExtHostContext.ExtHostSearch,ne.get(xe.IExtHostSearch)),At=oe.set(d.ExtHostContext.ExtHostTask,ne.get(Le.IExtHostTask)),jt=oe.set(d.ExtHostContext.ExtHostOutputService,ne.get(S.IExtHostOutputService)),Lt=oe.set(d.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(oe)),Dt=oe.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(oe,vt)),Jt=oe.set(d.ExtHostContext.ExtHostDocumentContentProviders,new l.ExtHostDocumentContentProvider(oe,vt,j)),Yt=oe.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(j,Dt,oe.getProxy(d.MainContext.MainThreadBulkEdits))),bt=oe.set(d.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(oe,gt,vt,Dt,ue)),qt=oe.set(d.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(j,bt)),Ht=oe.set(d.ExtHostContext.ExtHostNotebookEditors,new at.ExtHostNotebookEditors(j,oe,bt)),Zt=oe.set(d.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(oe,de,bt,j)),en=oe.set(d.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(oe,bt)),Pt=oe.set(d.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(oe,vt)),fn=oe.set(d.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(oe.getProxy(d.MainContext.MainThreadTreeViews),gt,j)),tn=oe.set(d.ExtHostContext.ExtHostEditorInsets,new Z.ExtHostEditorInsets(oe.getProxy(d.MainContext.MainThreadEditorInsets),Pt,de)),Bt=oe.set(d.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(oe,j)),pt=oe.set(d.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(oe,nt,Dt,gt,Bt,j,Ie)),nn=oe.set(d.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(oe,pt)),Ot=oe.set(d.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(oe,j,vt)),Nt=oe.set(d.ExtHostContext.ExtHostQuickOpen,(0,w.createExtHostQuickOpen)(oe,Ve,gt)),Gt=oe.set(d.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(oe,gt,j)),_n=oe.set(d.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(oe,gt,Dt)),mn=oe.set(d.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(oe.getProxy(d.MainContext.MainThreadProgress))),Sn=oe.set(d.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(oe)),gn=oe.set(d.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(oe)),rn=oe.set(d.ExtHostContext.ExtHostAuthentication,new Fe.ExtHostAuthentication(oe)),sn=oe.set(d.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(oe,gt)),zt=oe.set(d.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(oe,{remote:de.remote},Ve,j,Ie)),on=oe.set(d.ExtHostContext.ExtHostWebviewPanels,new te.ExtHostWebviewPanels(oe,zt,Ve)),yn=oe.set(d.ExtHostContext.ExtHostCustomEditors,new Q.ExtHostCustomEditors(oe,Dt,ue,zt,on)),Dn=oe.set(d.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(oe,zt)),Vt=oe.set(d.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(oe,gt)),Kt=oe.set(d.ExtHostContext.ExtHostUriOpeners,new st.ExtHostUriOpeners(oe));oe.set(d.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(oe,bt,vt,gt));const Cn=(0,X.values)(d.ExtHostContext);oe.assertRegistered(Cn);const kn=new pe.ExtHostBulkEdits(oe,vt),an=new u.ExtHostClipboard(oe),ln=new b.ExtHostMessageService(oe,j),$t=new a.ExtHostDialogs(oe),Ft=new O.ExtHostStatusBar(oe,gt.converter),Qt=new h.ExtHostLanguages(oe,Dt);return m.ExtHostApiCommands.register(gt),function(Oe,Wt,pn){const Et=function(){let ie=!Oe.isUnderDevelopment;function he(Te){ie||(j.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Te(dt){if(Array.isArray(dt))dt.forEach(Te);else if(typeof dt=="string")he(dt);else{const St=dt;typeof St.scheme=="undefined"&&he(dt),!Oe.enableProposedApi&&typeof St.exclusive=="boolean"&&(0,W.throwProposedApiError)(Oe)}return dt}}(),In={getSession(ie,he,Te){return Te?.forceNewSession&&(0,W.checkProposedApiEnabled)(Oe),rn.getSession(Oe,ie,he,Te)},get onDidChangeSessions(){return rn.onDidChangeSessions},registerAuthenticationProvider(ie,he,Te,dt){return rn.registerAuthenticationProvider(ie,he,Te,dt)}},Pn={registerCommand(ie,he,Te){return gt.registerCommand(!0,ie,he,Te)},registerTextEditorCommand(ie,he,Te){return gt.registerCommand(!0,ie,(...dt)=>{const St=Pt.getActiveTextEditor();if(!St){j.warn("Cannot execute "+ie+" because there is no active text editor.");return}return St.edit(It=>{he.apply(Te,[St,It,...dt])}).then(It=>{It||j.warn("Edits from command "+ie+" were not applied.")},It=>{j.warn("An error occurred while running command "+ie,It)})})},registerDiffInformationCommand:(ie,he,Te)=>((0,W.checkProposedApiEnabled)(Oe),gt.registerCommand(!0,ie,async(...dt)=>{const St=vt.activeEditor(!0);if(!St){j.warn("Cannot execute "+ie+" because there is no active text editor.");return}const It=await Pt.getDiffInformation(St.id);he.apply(Te,[It,...dt])})),executeCommand(ie,...he){return gt.executeCommand(ie,...he)},getCommands(ie=!1){return gt.getCommands(ie)}},vn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get embedderIdentifier(){return de.environment.embedderIdentifier},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return an.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return We.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return We.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Ye.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return Lt.createAppUri(ie);try{return await Ye.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(he){if((0,$e.matchesScheme)(ie,Ge.Schemas.http)||(0,$e.matchesScheme)(ie,Ge.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(vn);const wn=de.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,An={createTestController(ie,he){return Vt.createTestController(ie,he)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Oe),Vt.createTestObserver()},runTests(ie){return(0,W.checkProposedApiEnabled)(Oe),Vt.runTests(ie)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Oe),Vt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Oe),Vt.results}},cn={getExtension(ie){const he=Wt.getExtensionDescription(ie);if(he)return new s.Extension(Me,Oe.identifier,he,wn)},get all(){return Wt.getAllExtensionDescriptions().map(ie=>new s.Extension(Me,Oe.identifier,ie,wn))},get onDidChange(){return Wt.onDidChange}},Tn={createDiagnosticCollection(ie){return Bt.createDiagnosticCollection(Oe.identifier,ie)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:ie=>Bt.getDiagnostics(ie),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(ie,he){return Qt.changeLanguage(ie.uri,he)},match(ie,he){return(0,n.score)(x.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Te){return pt.registerCodeActionProvider(Oe,Et(ie),he,Te)},registerCodeLensProvider(ie,he){return pt.registerCodeLensProvider(Oe,Et(ie),he)},registerDefinitionProvider(ie,he){return pt.registerDefinitionProvider(Oe,Et(ie),he)},registerDeclarationProvider(ie,he){return pt.registerDeclarationProvider(Oe,Et(ie),he)},registerImplementationProvider(ie,he){return pt.registerImplementationProvider(Oe,Et(ie),he)},registerTypeDefinitionProvider(ie,he){return pt.registerTypeDefinitionProvider(Oe,Et(ie),he)},registerHoverProvider(ie,he){return pt.registerHoverProvider(Oe,Et(ie),he,Oe.identifier)},registerEvaluatableExpressionProvider(ie,he){return pt.registerEvaluatableExpressionProvider(Oe,Et(ie),he,Oe.identifier)},registerInlineValuesProvider(ie,he){return pt.registerInlineValuesProvider(Oe,Et(ie),he,Oe.identifier)},registerDocumentHighlightProvider(ie,he){return pt.registerDocumentHighlightProvider(Oe,Et(ie),he)},registerLinkedEditingRangeProvider(ie,he){return pt.registerLinkedEditingRangeProvider(Oe,Et(ie),he)},registerReferenceProvider(ie,he){return pt.registerReferenceProvider(Oe,Et(ie),he)},registerRenameProvider(ie,he){return pt.registerRenameProvider(Oe,Et(ie),he)},registerDocumentSymbolProvider(ie,he,Te){return pt.registerDocumentSymbolProvider(Oe,Et(ie),he,Te)},registerWorkspaceSymbolProvider(ie){return pt.registerWorkspaceSymbolProvider(Oe,ie)},registerDocumentFormattingEditProvider(ie,he){return pt.registerDocumentFormattingEditProvider(Oe,Et(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return pt.registerDocumentRangeFormattingEditProvider(Oe,Et(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Te,...dt){return pt.registerOnTypeFormattingEditProvider(Oe,Et(ie),he,[Te].concat(dt))},registerDocumentSemanticTokensProvider(ie,he,Te){return pt.registerDocumentSemanticTokensProvider(Oe,Et(ie),he,Te)},registerDocumentRangeSemanticTokensProvider(ie,he,Te){return pt.registerDocumentRangeSemanticTokensProvider(Oe,Et(ie),he,Te)},registerSignatureHelpProvider(ie,he,Te,...dt){return typeof Te=="object"?pt.registerSignatureHelpProvider(Oe,Et(ie),he,Te):pt.registerSignatureHelpProvider(Oe,Et(ie),he,typeof Te=="undefined"?[]:[Te,...dt])},registerCompletionItemProvider(ie,he,...Te){return pt.registerCompletionItemProvider(Oe,Et(ie),he,Te)},registerInlineCompletionItemProvider(ie,he){return(0,W.checkProposedApiEnabled)(Oe),pt.registerInlineCompletionsProvider(Oe,Et(ie),he)},registerDocumentLinkProvider(ie,he){return pt.registerDocumentLinkProvider(Oe,Et(ie),he)},registerColorProvider(ie,he){return pt.registerColorProvider(Oe,Et(ie),he)},registerFoldingRangeProvider(ie,he){return pt.registerFoldingRangeProvider(Oe,Et(ie),he)},registerSelectionRangeProvider(ie,he){return pt.registerSelectionRangeProvider(Oe,ie,he)},registerCallHierarchyProvider(ie,he){return pt.registerCallHierarchyProvider(Oe,ie,he)},setLanguageConfiguration:(ie,he)=>pt.setLanguageConfiguration(Oe,ie,he),getTokenInformationAtPosition(ie,he){return(0,W.checkProposedApiEnabled)(Oe),Qt.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,W.checkProposedApiEnabled)(Oe),pt.registerInlayHintsProvider(Oe,ie,he)},registerTypeHierarchyProvider(ie,he){return(0,W.checkProposedApiEnabled)(Oe),pt.registerTypeHierarchyProvider(Oe,ie,he)},createLanguageStatusItem(ie){return(0,W.checkProposedApiEnabled)(Oe),Qt.createLanguageStatusItem(ie)}},Rn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(ie,he,Te){const dt=await(A.URI.isUri(ie)?Promise.resolve(bn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(dt,he,Te)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Oe,ie)},onDidChangeActiveTextEditor(ie,he,Te){return Pt.onDidChangeActiveTextEditor(ie,he,Te)},onDidChangeVisibleTextEditors(ie,he,Te){return Pt.onDidChangeVisibleTextEditors(ie,he,Te)},onDidChangeTextEditorSelection(ie,he,Te){return Pt.onDidChangeTextEditorSelection(ie,he,Te)},onDidChangeTextEditorOptions(ie,he,Te){return Pt.onDidChangeTextEditorOptions(ie,he,Te)},onDidChangeTextEditorVisibleRanges(ie,he,Te){return Pt.onDidChangeTextEditorVisibleRanges(ie,he,Te)},onDidChangeTextEditorViewColumn(ie,he,Te){return Pt.onDidChangeTextEditorViewColumn(ie,he,Te)},onDidCloseTerminal(ie,he,Te){return mt.onDidCloseTerminal(ie,he,Te)},onDidOpenTerminal(ie,he,Te){return mt.onDidOpenTerminal(ie,he,Te)},onDidChangeActiveTerminal(ie,he,Te){return mt.onDidChangeActiveTerminal(ie,he,Te)},onDidChangeTerminalDimensions(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),mt.onDidChangeTerminalDimensions(ie,he,Te)},onDidChangeTerminalState(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),mt.onDidChangeTerminalState(ie,he,Te)},onDidWriteTerminalData(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),mt.onDidWriteTerminalData(ie,he,Te)},get state(){return Ye.state},onDidChangeWindowState(ie,he,Te){return Ye.onDidChangeWindowState(ie,he,Te)},showInformationMessage(ie,...he){return ln.showMessage(Oe,D.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return ln.showMessage(Oe,D.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return ln.showMessage(Oe,D.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Te){return Nt.showQuickPick(ie,!!Oe.enableProposedApi,he,Te)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Nt.showInput(ie,he)},showOpenDialog(ie){return $t.showOpenDialog(ie)},showSaveDialog(ie){return $t.showSaveDialog(ie)},createStatusBarItem(ie,he,Te){let dt,St,It;return typeof ie=="string"?(dt=ie,St=he,It=Te):(St=ie,It=he),Ft.createStatusBarEntry(Oe,dt,St,It)},setStatusBarMessage(ie,he){return Ft.setStatusBarMessage(ie,he)},withScmProgress(ie){return Ie.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),mn.withProgress(Oe,{location:F.ProgressLocation.SourceControl},(he,Te)=>ie({report(dt){}}))},withProgress(ie,he){return mn.withProgress(Oe,ie,he)},createOutputChannel(ie){return jt.createOutputChannel(ie,Oe)},createWebviewPanel(ie,he,Te,dt){return on.createWebviewPanel(Oe,ie,he,Te,dt)},createWebviewTextEditorInset(ie,he,Te,dt){return(0,W.checkProposedApiEnabled)(Oe),tn.createWebviewEditorInset(ie,he,Te,dt,Oe)},createTerminal(ie,he,Te){return typeof ie=="object"?"pty"in ie?mt.createExtensionTerminal(ie):mt.createTerminalFromOptions(ie):mt.createTerminal(ie,he,Te)},registerTerminalLinkProvider(ie){return mt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return mt.registerProfileProvider(Oe,ie,he)},registerTreeDataProvider(ie,he){return fn.registerTreeDataProvider(ie,he,Oe)},createTreeView(ie,he){return fn.createTreeView(ie,he,Oe)},registerWebviewPanelSerializer:(ie,he)=>on.registerWebviewPanelSerializer(Oe,ie,he),registerCustomEditorProvider:(ie,he,Te={})=>yn.registerCustomEditorProvider(Oe,ie,he,Te),registerFileDecorationProvider(ie){return _t.registerFileDecorationProvider(ie,Oe.identifier)},registerUriHandler(ie){return Lt.registerUriHandler(Oe.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Oe.identifier)},get activeColorTheme(){return gn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Te){return gn.onDidChangeActiveColorTheme(ie,he,Te)},registerWebviewViewProvider(ie,he,Te){return Dn.registerWebviewViewProvider(Oe,ie,he,Te?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Oe),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeActiveNotebookEditor(ie,he,Te)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Oe),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),Ht.onDidChangeNotebookEditorSelection(ie,he,Te)},onDidChangeNotebookEditorVisibleRanges(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),Ht.onDidChangeNotebookEditorVisibleRanges(ie,he,Te)},showNotebookDocument(ie,he){return(0,W.checkProposedApiEnabled)(Oe),bt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),Kt.registerExternalUriOpener(Oe.identifier,ie,he,Te)},get openEditors(){return(0,W.checkProposedApiEnabled)(Oe),ot.tabs},get onDidChangeOpenEditors(){return(0,W.checkProposedApiEnabled)(Oe),ot.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,W.checkProposedApiEnabled)(Oe),f.InlineCompletionController.get(ie)}},bn={get rootPath(){return Ie.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ve.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return Ve.getWorkspaceFolder(ie)},get workspaceFolders(){return Ve.getWorkspaceFolders()},get name(){return Ve.name},set name(ie){throw L.readonly()},get workspaceFile(){return Ve.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,he,...Te)=>Ve.updateWorkspaceFolders(Oe,ie,he||0,...Te),onDidChangeWorkspaceFolders:function(ie,he,Te){return Ve.onDidChangeWorkspace(ie,he,Te)},asRelativePath:(ie,he)=>Ve.getRelativePath(ie,he),findFiles:(ie,he,Te,dt)=>Ve.findFiles(x.GlobPattern.from(ie),x.GlobPattern.from(he),Te,Oe.identifier,dt),findTextInFiles:(ie,he,Te,dt)=>{let St,It;return typeof he=="object"?(St=he,It=Te):(St={},It=he,dt=Te),Ve.findTextInFiles(ie,St||{},It,Oe.identifier,dt)},saveAll:ie=>Ve.saveAll(ie),applyEdit(ie){return kn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Te,dt)=>Ot.createFileSystemWatcher(x.GlobPattern.from(ie),he,Te,dt),get textDocuments(){return Dt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let he;const Te=ie;if(typeof ie=="string")he=Promise.resolve(A.URI.file(ie));else if(A.URI.isUri(ie))he=Promise.resolve(ie);else if(!Te||typeof Te=="object")he=Dt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(dt=>Dt.ensureDocumentData(dt).then(St=>St.document))},onDidOpenTextDocument:(ie,he,Te)=>Dt.onDidAddDocument(ie,he,Te),onDidCloseTextDocument:(ie,he,Te)=>Dt.onDidRemoveDocument(ie,he,Te),onDidChangeTextDocument:(ie,he,Te)=>Dt.onDidChangeDocument(ie,he,Te),onDidSaveTextDocument:(ie,he,Te)=>Dt.onDidSaveDocument(ie,he,Te),onWillSaveTextDocument:(ie,he,Te)=>Yt.getOnWillSaveTextDocumentEvent(Oe)(ie,he,Te),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Te;if(A.URI.isUri(ie))Te=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Te=A.URI.revive(await bt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Te,dt){return bt.registerNotebookSerializer(Oe,ie,he,Te,Oe.enableProposedApi?dt:void 0)},registerNotebookContentProvider:(ie,he,Te,dt)=>((0,W.checkProposedApiEnabled)(Oe),bt.registerNotebookContentProvider(Oe,ie,he,Te,Oe.enableProposedApi?dt:void 0)),onDidChangeConfiguration:(ie,he,Te)=>pn.onDidChangeConfiguration(ie,he,Te),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,pn.getConfiguration(ie,he,Oe)},registerTextDocumentContentProvider(ie,he){return Jt.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Ie.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),At.registerTaskProvider(Oe,ie,he)),registerFileSystemProvider(ie,he,Te){return nn.registerFileSystemProvider(Oe.identifier,ie,he,Te,Oe.enableProposedApi)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),yt.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),yt.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),Me.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,W.checkProposedApiEnabled)(Oe),Sn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Te)=>Ot.onDidCreateFile(ie,he,Te),onDidDeleteFiles:(ie,he,Te)=>Ot.onDidDeleteFile(ie,he,Te),onDidRenameFiles:(ie,he,Te)=>Ot.onDidRenameFile(ie,he,Te),onWillCreateFiles:(ie,he,Te)=>Ot.getOnWillCreateFileEvent(Oe)(ie,he,Te),onWillDeleteFiles:(ie,he,Te)=>Ot.getOnWillDeleteFileEvent(Oe)(ie,he,Te),onWillRenameFiles:(ie,he,Te)=>Ot.getOnWillRenameFileEvent(Oe)(ie,he,Te),openTunnel:ie=>((0,W.checkProposedApiEnabled)(Oe),Ae.openTunnel(Oe,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,W.checkProposedApiEnabled)(Oe),Ae.getTunnels()},onDidChangeTunnels:(ie,he,Te)=>((0,W.checkProposedApiEnabled)(Oe),Ae.onDidChangeTunnels(ie,he,Te)),registerPortAttributesProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),Ae.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),sn.registerTimelineProvider(ie,he,Oe.identifier,gt.converter)),get isTrusted(){return Ve.trusted},requestWorkspaceTrust:ie=>((0,W.checkProposedApiEnabled)(Oe),Ve.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Te)=>Ve.onDidGrantWorkspaceTrust(ie,he,Te)},Ln={get inputBox(){return Ie.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Gt.getLastInputBox(Oe)},createSourceControl(ie,he,Te){return Gt.createSourceControl(Oe,ie,he,Te)}},Fn={createCommentController(ie,he){return _n.createCommentController(Oe,ie,he)}},Mn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(ie,he,Te){return ht.onDidStartDebugSession(ie,he,Te)},onDidTerminateDebugSession(ie,he,Te){return ht.onDidTerminateDebugSession(ie,he,Te)},onDidChangeActiveDebugSession(ie,he,Te){return ht.onDidChangeActiveDebugSession(ie,he,Te)},onDidReceiveDebugSessionCustomEvent(ie,he,Te){return ht.onDidReceiveDebugSessionCustomEvent(ie,he,Te)},onDidChangeBreakpoints(ie,he,Te){return ht.onDidChangeBreakpoints(ie,he,Te)},registerDebugConfigurationProvider(ie,he,Te){return ht.registerDebugConfigurationProvider(ie,he,Te||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return ht.registerDebugAdapterDescriptorFactory(Oe,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return ht.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ht.startDebugging(ie,he,{parentSession:Te}):ht.startDebugging(ie,he,Te||{})},stopDebugging(ie){return ht.stopDebugging(ie)},addBreakpoints(ie){return ht.addBreakpoints(ie)},removeBreakpoints(ie){return ht.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return ht.asDebugSourceUri(ie,he)}},On={registerTaskProvider:(ie,he)=>At.registerTaskProvider(Oe,ie,he),fetchTasks:ie=>At.fetchTasks(ie),executeTask:ie=>At.executeTask(Oe,ie),get taskExecutions(){return At.taskExecutions},onDidStartTask:(ie,he,Te)=>At.onDidStartTask(ie,he,Te),onDidEndTask:(ie,he,Te)=>At.onDidEndTask(ie,he,Te),onDidStartTaskProcess:(ie,he,Te)=>At.onDidStartTaskProcess(ie,he,Te),onDidEndTaskProcess:(ie,he,Te)=>At.onDidEndTaskProcess(ie,he,Te)},un={createNotebookController(ie,he,Te,dt,St){return Zt.createNotebookController(Oe,ie,he,Te,dt,Oe.enableProposedApi?St:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>bt.registerNotebookCellStatusBarItemProvider(Oe,ie,he),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Oe),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,W.checkProposedApiEnabled)(Oe),Ht.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return en.createRendererMessaging(Oe,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),qt.onDidChangeNotebookDocumentMetadata(ie,he,Te)},onDidChangeNotebookCells(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeNotebookCells(ie,he,Te)},onDidChangeNotebookCellExecutionState(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeNotebookCellExecutionState(ie,he,Te)},onDidChangeCellOutputs(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeCellOutputs(ie,he,Te)},onDidChangeCellMetadata(ie,he,Te){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeCellMetadata(ie,he,Te)},createConcatTextDocument(ie,he){return(0,W.checkProposedApiEnabled)(Oe),new Qe.ExtHostNotebookConcatDocument(bt,Dt,ie,he)}};return{version:de.version,authentication:In,commands:Pn,comments:Fn,debug:Mn,env:vn,extensions:cn,languages:Tn,notebooks:un,scm:Ln,tasks:On,tests:An,window:Rn,workspace:bn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:P.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:d.UIKind,Uri:A.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:Pe.TextSearchCompleteMessageType,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(me[275],ge([0,1,82,67,36,132,37,44,45,33,71,53,73,93,52,66,133,92,63,91,123,51]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,g.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,g.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,g.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(D.IExtHostDecorations,D.ExtHostDecorations),(0,g.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,g.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,g.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(me[94],ge([0,1,20,12,31,70]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function C(I,d,m,u){const p=(0,g.mapArrayOrNot)(m,y),_=new k.TextSearchMatch(d,p,u),T=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(p,P),uri:I,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(T,P)}}}e.createTextSearchResult=C;function y(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new D.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let n=class{constructor(d,m){this.prefix=d,this.logService=m}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};n=ze([Ue(1,L.ILogService)],n),e.OutputChannel=n}),define(me[276],ge([0,1,96,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const D=512,A=512,C=512*8,y=512*128;class P{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((c,f)=>{Y(["iconv-lite-umd"],c,f)})).getDecoder(m(r));else{const i=new TextDecoder;s={write(c){return i.decode(c,{stream:!0})},end(){return i.decode()}}}return new P(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function n(t,r){const s=r.minBytesRequiredForDetection??r.guessEncoding?C:A;return new Promise((i,c)=>{const f=(0,g.newWriteableStream)(w=>w.join("")),h=[];let b=0,S;const o=async()=>{try{const w=await v({buffer:L.VSBuffer.concat(h),bytesRead:b},r.guessEncoding);w.encoding=await r.overwriteEncoding(w.encoding),S=await P.create(w.encoding);const R=S.write(L.VSBuffer.concat(h).buffer);f.write(R),h.length=0,b=0,i({stream:f,detected:w})}catch(w){c(w)}};(0,g.listenStream)(t,{onData:async w=>{S?f.write(S.write(w.buffer)):(h.push(w),b+=w.byteLength,b>=s&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:w=>f.error(w),onEnd:async()=>{S||await o(),f.end(S?.end())}})})}e.toDecodeStream=n;async function I(t,r,s){const c=(await new Promise((b,S)=>{Y(["iconv-lite-umd"],b,S)})).getEncoder(m(r),s);let f=!1,h=!1;return{read(){if(h)return null;const b=t.read();if(typeof b!="string"){if(h=!0,!f&&s?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const S=c.end();return S&&S.length>0?(f=!0,L.VSBuffer.wrap(S)):null}return f=!0,L.VSBuffer.wrap(c.write(b))}}}e.toEncodeReadable=I;async function d(t){return(await new Promise((s,i)=>{Y(["iconv-lite-umd"],s,i)})).encodingExists(m(t))}e.encodingExists=d;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function u(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),i=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const c=t.readUInt8(2);return s===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=u;const p=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((h,b)=>{Y(["jschardet"],h,b)}),s=t.slice(0,y),i=a(s.buffer),c=r.detect(i);if(!c||!c.encoding)return null;const f=c.encoding.toLowerCase();return 0<=p.indexOf(f)?null:E(c.encoding)}const T={ibm866:"cp866",big5:"cp950"};function E(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return T[r]||r}function a(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=l;function v({buffer:t,bytesRead:r},s){let i=u(t,r),c=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let f=!0,h=!0,b=!1;for(let S=0;S<r&&S<D;S++){const o=S%2==1,w=t.readUInt8(S)===0;if(w&&(b=!0),f&&(o&&!w||!o&&w)&&(f=!1),h&&(o&&w||!o&&!w)&&(h=!1),w&&!f&&!h)break}b&&(f?i=e.UTF16le:h?i=e.UTF16be:c=!0)}return s&&!c&&!i&&t?_(t.slice(0,r)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:c,encoding:i}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[135],ge([0,1,276,28,134]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class D extends k.TextSearchManager{constructor(C,y,P=L){super(C,y,{readdir:n=>P.Promises.readdir(n.fsPath),toCanonicalName:n=>(0,g.toCanonicalName)(n)})}}e.NativeTextSearchManager=D}),define(me[277],ge([0,1,278,293,294,2,295]),function(Y,e,g,L,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,d,m,u,p,_){const T=_.environment.useHostProxy,E=typeof T=="boolean"?T:!_.remote.isRemote,a=(0,A.createProxyResolver)({resolveProxy:v=>I.resolveProxy(v),getHttpProxySetting:()=>d.getConfiguration("http").get("proxy"),log:(v,t,...r)=>{switch(v){case A.LogLevel.Trace:u.trace(t,...r);break;case A.LogLevel.Debug:u.debug(t,...r);break;case A.LogLevel.Info:u.info(t,...r);break;case A.LogLevel.Warning:u.warn(t,...r);break;case A.LogLevel.Error:u.error(t,...r);break;case A.LogLevel.Critical:u.critical(t,...r);break;case A.LogLevel.Off:break;default:s(v,t,r);break}function s(i,c,...f){u.error("Unknown log level",i),u.error(c,...f)}},getLogLevel:()=>u.getLevel(),proxyResolveTelemetry:v=>{p.$publicLog2("resolveProxy",v)},useHostProxy:E,env:process.env}),l=y(d,a);return n(m,l)}e.connectProxyResolver=C;function y(I,d){const m={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(p=>{m.config=I.getConfiguration("http").get("proxySupport")||"off"});const u={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(p=>{u.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,A.createHttpPatch)(g,d,{config:"off"},u,!0)),on:Object.assign({},g,(0,A.createHttpPatch)(g,d,{config:"on"},u,!0)),override:Object.assign({},g,(0,A.createHttpPatch)(g,d,{config:"override"},u,!0)),onRequest:Object.assign({},g,(0,A.createHttpPatch)(g,d,m,u,!0)),default:Object.assign(g,(0,A.createHttpPatch)(g,d,m,u,!1))},https:{off:Object.assign({},L,(0,A.createHttpPatch)(L,d,{config:"off"},u,!0)),on:Object.assign({},L,(0,A.createHttpPatch)(L,d,{config:"on"},u,!0)),override:Object.assign({},L,(0,A.createHttpPatch)(L,d,{config:"override"},u,!0)),onRequest:Object.assign({},L,(0,A.createHttpPatch)(L,d,m,u,!0)),default:Object.assign(L,(0,A.createHttpPatch)(L,d,m,u,!1))},tls:Object.assign(k,(0,A.createTlsPatch)(k))}}const P=new Map;function n(I,d){return I.getExtensionPathIndex().then(m=>{const u=Y.__$__nodeRequire("module"),p=u._load;u._load=function(T,E,a){if(T==="tls")return d.tls;if(T!=="http"&&T!=="https")return p.apply(this,arguments);const l=d[T],v=m.findSubstr(D.URI.file(E.filename).fsPath);let t=P.get(v);if(t||P.set(v,t={}),!t[T]){let r=l.default;v&&v.enableProposedApi&&(r=l[v.proxySupport]||l.onRequest),t[T]={...r}}return t[T]}})}}),define(me[279],ge([0,1,39,8,78,29,11,9,94,280]),function(Y,e,g,L,k,D,A,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(a,l,v,t){const r=d(a,l,v,t),s=l.folder.fsPath;return{cmd:g.spawn(n,r.args,{cwd:s}),rgDiskPath:n,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=I;function d(a,l,v,t){const r=["--files","--hidden","--case-sensitive"];u([l],v,!1).forEach(i=>{const c=(0,y.anchorGlob)(i);if(r.push("-g",c),A.isMacintosh){const f=(0,k.normalizeNFD)(c);f!==c&&r.push("-g",f)}});const s=m([l],t,void 0,!1);return s.globArgs.forEach(i=>{const c=`!${(0,y.anchorGlob)(i)}`;if(r.push("-g",c),A.isMacintosh){const f=(0,k.normalizeNFD)(c);f!==c&&r.push("-g",f)}}),l.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),l.ignoreSymlinks||r.push("--follow"),a.exists&&r.push("--quiet"),r.push("--no-config"),l.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function m(a,l,v,t=!0){const r=[];let s={};return a.forEach(i=>{const c=Object.assign({},i.excludePattern||{},l||{}),f=p(c,t?i.folder.fsPath:void 0,v);r.push(...f.globArgs),f.siblingClauses&&(s=Object.assign(s,f.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=m;function u(a,l,v=!0){const t=[];return a.forEach(r=>{const s=Object.assign({},l||{},r.includePattern||{}),i=p(s,v?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=u;function p(a,l,v){const t=[],r={};return Object.keys(a).forEach(s=>{if(v&&v.has(s)||!s)return;const i=a[s];s=T(l?_(l,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(E(s))):i&&i.when&&(r[s]=i)}),{globArgs:t,siblingClauses:r}}function _(a,l){return L.isAbsolute(l)?l:L.join(a,l)}e.getAbsoluteGlob=_;function T(a){return a=C.rtrim(a,"\\"),C.rtrim(a,"/")}function E(a){return D.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=E}),define(me[281],ge([0,1,39,49,8,104,20,60,30,78,29,11,46,9,14,28,31,279,101]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(s=>s())});class l{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(c=>{const f=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),h=c.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==h).forEach(b=>{(0,n.isEqualOrParent)(b,h)&&(f[k.relative(h,b)]=!0)}),this.folderExcludePatterns.set(h,new t(f,h))})}cancel(){this.isCanceled=!0}walk(i,c,f,h,b){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);c.forEach(S=>{const o=k.basename(S.fsPath);this.globalExcludePattern&&this.globalExcludePattern(S.fsPath,o)||this.matchFile(f,{relativePath:S.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(i,(S,o)=>{this.call(this.cmdTraversal,this,S,f,h,w=>{if(w){const R=(0,C.toErrorMessage)(w);console.error(R),this.errors.push(R),o(w,void 0)}else o(null,void 0)})},(S,o)=>{this.fileWalkSW.stop();const w=S?A.coalesce(S)[0]:null;b(w,this.isLimitHit)})}parallel(i,c,f){const h=new Array(i.length),b=new Array(i.length);let S=!1,o=0;if(i.length===0)return f(null,[]);i.forEach((w,R)=>{c(w,(O,$)=>{if(O?(S=!0,h[R]=null,b[R]=O):(h[R]=$,b[R]=null),++o===i.length)return f(S?b:null,h)})})}call(i,c,...f){try{i.apply(c,f)}catch(h){f[f.length-1](h)}}cmdTraversal(i,c,f,h){const b=i.folder.fsPath,S=I.isMacintosh;let o;const w=()=>o&&o.kill();a.add(w);let R=F=>{a.delete(w),R=()=>{},h(F)},O="";const $=this.initDirectoryTree();let K;const G=(0,T.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);o=G.cmd,K=!Object.keys(G.siblingClauses).length;const N=G.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${G.rgDiskPath} ${N}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),f({message:x}),this.cmdResultCount=0,this.collectStdout(o,"utf8",f,(F,V,M)=>{if(F){R(F);return}if(this.isLimitHit){R();return}const q=(O+(S?P.normalizeNFC(V||""):V)).split(`
`);if(M){const W=q.length;q[W-1]=q[W-1].trim(),q[W-1]||q.pop()}else O=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,K){for(const W of q)if(this.matchFile(c,{base:b,relativePath:W,searchPath:this.getSearchPath(i,W)}),this.isLimitHit){w();break}(M||this.isLimitHit)&&R();return}this.addDirectoryEntries(i,$,b,q,c),M&&(this.matchDirectoryTree($,b,c),R())})}spawnFindCmd(i){const c=this.folderExcludePatterns.get(i.folder.fsPath),f=c.getBasenameTerms(),h=c.getPathTerms(),b=["-L","."];if(f.length||h.length){b.push("-not","(","(");for(const S of f)b.push("-name",S),b.push("-o");for(const S of h)b.push("-path",S),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),g.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,c,f){let h="";this.collectStdout(i,c,()=>{},(b,S,o)=>{if(b){f(b);return}h+=S,o&&f(null,h)})}collectStdout(i,c,f,h){let b=(w,R,O)=>{(w||O)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),h(w,R,O)},S=!1;i.stdout?(this.forwardData(i.stdout,c,b),i.stdout.once("data",()=>S=!0)):f({message:"stdout is null"});let o;i.stderr?o=this.collectData(i.stderr):f({message:"stderr is null"}),i.on("error",w=>{b(w)}),i.on("close",w=>{let R;!S&&(R=this.decodeData(o,c))&&r(R)?b(new Error(`command failed with error code ${w}: ${this.decodeData(o,c)}`)):(this.exists&&w===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,c,f){const h=new D.StringDecoder(c);return i.on("data",b=>{f(null,h.write(b))}),h}collectData(i){const c=[];return i.on("data",f=>{c.push(f)}),c}decodeData(i,c){const f=new D.StringDecoder(c);return i.map(h=>f.write(h)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:c},f,h,b){h.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const S=o=>{const w=k.basename(o),R=k.dirname(o);let O=c[R];O||(O=c[R]=[],S(R)),O.push({base:f,relativePath:o,basename:w,searchPath:this.getSearchPath(i,o)})};h.forEach(S)}matchDirectoryTree({rootEntries:i,pathToEntries:c},f,h){const b=this,S=this.folderExcludePatterns.get(f),o=this.filePattern;function w(R){b.directoriesWalked++;const O=y.hasSiblingFn(()=>R.map($=>$.basename));for(let $=0,K=R.length;$<K;$++){const G=R[$],{relativePath:N,basename:x}=G;if(S.test(N,x,o!==x?O:void 0))continue;const F=c[N];if(F)w(F);else{if(b.filesWalked++,N===o)continue;b.matchFile(h,G)}if(b.isLimitHit)break}}w(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,c,f,h,b){const S=i.folder,o=y.hasSiblingFn(()=>f);this.parallel(f,(w,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const O=c?[c,w].join(k.sep):w;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,w,this.config.filePattern!==w?o:void 0))return R(null);const $=[S.fsPath,O].join(k.sep);L.lstat($,(K,G)=>{if(K||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded($,G,(N,x)=>N||this.isCanceled||this.isLimitHit?R(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded($,G,(F,V)=>F||this.isCanceled||this.isLimitHit||(V=V||"",this.walkedPaths[V])?R(null):(this.walkedPaths[V]=!0,p.Promises.readdir($).then(M=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(i,O,M,h,U=>R(U||null))},M=>{R(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&u.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(h,{base:S.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),R(null,void 0)))})},w=>{const R=w&&A.coalesce(w);return b(R&&R.length>0?R[0]:void 0)})}matchFile(i,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,k.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(c))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,c,f){return c.isSymbolicLink()?L.stat(i,f):f(null,c)}realPathIfNeeded(i,c,f){return c.isSymbolicLink()?L.realpath(i,(h,b)=>h?f(h):f(null,b)):f(null,i)}getSearchPath(i,c){return i.folderName?k.join(i.folderName,c):c}}e.FileWalker=l;class v{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new l(i)}search(i,c,f){this.walker.walk(this.folderQueries,this.extraFiles,i,c,(h,b)=>{f(h,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(i,c){this.expression=i,this.root=c,this.init(i)}init(i){let c,f;Object.keys(i).filter(h=>i[h]).forEach(h=>{k.isAbsolute(h)?(c=c||y.getEmptyExpression(),c[h]=i[h]):(f=f||y.getEmptyExpression(),f[h]=i[h])}),this.absoluteParsedExpr=c&&y.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=f&&y.parse(f,{trimForExclusions:!0})}test(i,c,f){return this.relativeParsedExpr&&this.relativeParsedExpr(i,c,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),c,f)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function r(s){const i=s.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}e.rgErrorMsgForDisplay=r}),define(me[136],ge([0,1,39,296,104,20,55,30,8,9,2,31,70,297,280,94]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=u.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class T{constructor(S){this.outputChannel=S}provideTextSearchResults(S,o,w,R){return this.outputChannel.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise((O,$)=>{R.onCancellationRequested(()=>U());const K=r(S,o),G=o.folder.fsPath,N=K.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${_} ${N}
 - cwd: ${G}`);let x=g.spawn(_,K,{cwd:G});x.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),$((0,I.serializeSearchError)(new I.SearchError(fe&&fe.message,I.SearchErrorCode.rgProcessError)))});let F=!1;const V=new l(o.maxResults,G,o.previewOptions);V.on("result",fe=>{F=!0,W="",w.report(fe)});let M=!1;const U=()=>{M=!0,x&&x.kill(),V&&V.cancel()};let q=!1;V.on("hitLimit",()=>{q=!0,U()});let W="";x.stdout.on("data",fe=>{V.handleData(fe),F||(W+=fe)});let X=!1;x.stdout.once("data",()=>X=!0);let Z="";x.stderr.on("data",fe=>{const _e=fe.toString();this.outputChannel.appendLine(_e),Z+=_e}),x.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),M)O({limitHit:q});else{V.flush(),x=null;let fe;Z&&!X&&(fe=E(Z))?$((0,I.serializeSearchError)(new I.SearchError(fe.message,fe.code))):O({limitHit:q})}})})}}e.RipgrepTextSearchEngine=T;function E(b){const S=b.split(`
`),o=S[0].trim();if(S.some(R=>R.startsWith("regex parse error")))return new I.SearchError(a(S),I.SearchErrorCode.regexParseError);const w=o.match(/grep config error: unknown encoding: (.*)/);if(w)return new I.SearchError(`Unknown encoding: ${w[1]}`,I.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(o,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function a(b){const S=["Regex parse error"],o=b.filter(w=>w.startsWith("PCRE2:"));if(o.length>=1){const w=o[0].replace("PCRE2:","");if(w.indexOf(":")!==-1&&w.split(":").length>=2){const R=w.split(":")[1];S.push(":"+R)}}return S.join("")}e.buildRegexParseError=a;class l extends L.EventEmitter{constructor(S,o,w){super();this.maxResults=S,this.rootFolder=o,this.previewOptions=w,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(S,o){return super.on(S,o),this}handleData(S){if(this.isDone)return;const o=typeof S=="string"?S:this.stringDecoder.write(S);this.handleDecodedData(o)}handleDecodedData(S){let o=S.indexOf(`
`);const w=this.remainder+S;if(o>=0)o+=this.remainder.length;else{this.remainder=w;return}let R=0;for(;o>=0;)this.handleLine(w.substring(R,o).trim()),R=o+1,o=w.indexOf(`
`,R);this.remainder=w.substring(R)}handleLine(S){if(this.isDone||!S)return;let o;try{o=JSON.parse(S)}catch(w){throw new Error(`malformed line from rg: ${S}`)}if(o.type==="match"){const w=v(o.data.path),R=n.URI.file(y.join(this.rootFolder,w)),O=this.createTextSearchMatch(o.data,R);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const w=v(o.data.path),R=n.URI.file(y.join(this.rootFolder,w));this.createTextSearchContext(o.data,R).forEach($=>this.onResult($))}}createTextSearchMatch(S,o){const w=S.line_number-1,R=v(S.lines),O=Buffer.from(R);let $=0,K=0,G=w;S.submatches.length===0&&S.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const N=(0,D.coalesce)(S.submatches.map((x,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const V=v(x.match),M=O.slice($,x.start).toString().length,U=K+M,q=t(V),W=G,X=q.numLines+W,Z=q.numLines>0?q.lastLineLength:q.lastLineLength+U;return $=x.end,K=Z,G=X,new d.Range(W,U,X,Z)}));return(0,p.createTextSearchResult)(o,R,N,this.previewOptions)}createTextSearchContext(S,o){const w=v(S.lines),R=S.line_number;return w.replace(/\r?\n$/,"").split(`
`).map((O,$)=>({text:O,uri:o,lineNumber:R+$}))}onResult(S){this.emit("result",S)}}e.RipgrepParser=l;function v(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const S=/\n/g;let o=0,w=-1,R;for(;R=S.exec(b);)o++,w=R.index;const O=w>=0?b.length-w-1:b.length;return{numLines:o,lastLineLength:O}}function r(b,S){const o=["--hidden"];o.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:w,otherIncludes:R}=(0,A.groupBy)(S.includes,$=>$.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const $=new Set;R.forEach(K=>{$.add(K)}),o.push("-g","!*"),$.forEach(K=>{s(K).map(p.anchorGlob).forEach(G=>{o.push("-g",G)})})}w&&w.length&&w.forEach($=>{o.push("-g",$)}),S.excludes.map(p.anchorGlob).forEach($=>o.push("-g",`!${$}`)),S.maxFileSize&&o.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),S.followSymlinks&&o.push("--follow"),S.encoding&&S.encoding!=="utf8"&&o.push("--encoding",S.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,P.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),S.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),o.push("--auto-hybrid-regex"));let O;if(b.isWordMatch){const K=(0,P.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",K)}else if(b.isRegExp){let $=f(b.pattern);$=h($),o.push("--regexp",$)}else O=b.pattern,o.push("--fixed-strings");return o.push("--no-config"),S.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),b.isMultiline&&o.push("--multiline"),S.beforeContext&&o.push("--before-context",S.beforeContext+""),S.afterContext&&o.push("--after-context",S.afterContext+""),o.push("--"),O&&o.push(O),o.push("."),o}function s(b){const S=(0,C.splitGlobAware)(b,"/");return S.map((o,w)=>S.slice(0,w+1).join("/"))}e.spreadGlobComponents=s;function i(b){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(S);)b=b.replace(S,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(o);)b=b.replace(o,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const c=b=>b.type==="Assertion"&&b.kind==="lookbehind";function f(b){let S;try{S=new m.RegExpParser().parsePattern(b)}catch{return b}let o="",w=0;const R=(K,G,N)=>{o+=b.slice(w,K)+N,w=G},O=[];return new m.RegExpVisitor({onCharacterEnter(K){if(K.raw!=="\\n")return;const G=O[0];if(!G)R(K.start,K.end,"\\r?\\n");else if(!O.some(c))if(G.type==="CharacterClass")if(G.negate){const N=b.slice(G.start+2,K.start)+b.slice(K.end,G.end-1);R(G.start,G.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=b.slice(G.start+1,K.start)+b.slice(K.end,G.end-1);R(G.start,G.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else G.type==="Quantifier"&&R(K.start,K.end,"(?:\\r?\\n)")},onQuantifierEnter(K){O.unshift(K)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(K){O.unshift(K)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(K){O.unshift(K)},onCharacterClassLeave(){O.shift()},onAssertionEnter(K){c(K)&&O.push(K)},onAssertionLeave(K){O[0]===K&&O.shift()}}).visit(S),o+=b.slice(w),o}e.fixRegexNewline=f;function h(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(me[282],ge([0,1,21,136,119,10]),function(Y,e,g,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,n,I,d){const m=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===D.Schemas.userData){const u={...n,folder:n.folder.with({scheme:D.Schemas.file})},p=new k.Progress(_=>I.report({..._,uri:_.uri.with({scheme:n.folder.scheme})}));return this.withToken(d,_=>m.provideTextSearchResults(P,u,p,_))}else return this.withToken(d,u=>m.provideTextSearchResults(P,n,I,u))}async withToken(P,n){const I=C(P);this.inProgress.add(I);const d=await n(I.token);return this.inProgress.delete(I),d}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function C(y){const P=new g.CancellationTokenSource;return y.onCancellationRequested(()=>P.cancel()),P}}),define(me[283],ge([0,1,28,136,135]),function(Y,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class D{constructor(y){this.query=y}search(y,P,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(m){n({message:m})}},d=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((m,u)=>d.search(p=>{P(p.map(A))},y).then(p=>m({limitHit:p.limitHit,type:"success"}),u))}}e.TextSearchEngineAdapter=D;function A(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((y,P)=>{if(P.ranges){const n=P;return y+(Array.isArray(n.ranges)?n.ranges.length:1)}else return y+1},0)}}}),define(me[284],ge([0,1,49,298,20,17,16,3,101,8,46,2,42,31,281,283]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const s=a(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,D.createCancelablePromise)(c=>this.doFileSearchWithEngine(u.Engine,s,f=>i.fire(f),c)),r.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}textSearch(t){let r;const s=a(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,D.createCancelablePromise)(c=>this.ripgrepTextSearch(s,f=>i.fire(f),c)),r.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=(0,d.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(u.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,i,c=_.BATCH_SIZE){let f=0;const h=S=>{Array.isArray(S)?(f+=S.length,s(S.map(o=>this.rawMatchToSearchItem(o)))):S.relativePath?(f++,s(this.rawMatchToSearchItem(S))):s(S)};if(r.sortByScore){let S=this.trySortedSearchFromCache(r,h,i);if(!S){const o=r.maxResults?Object.assign({},r,{maxResults:null}):r,w=new t(o);S=this.doSortedSearch(w,r,s,h,i)}return new Promise((o,w)=>{S.then(([R,O])=>{const $=O.map(K=>this.rawMatchToSearchItem(K));this.sendProgress($,s,c),o(R)},w)})}const b=new t(r);return this.doSearch(b,h,c,i).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:"searchProcess",fromCache:!1,resultCount:f,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,i,c){const f=new C.Emitter;let h=(0,D.createCancelablePromise)(S=>{let o=[];const w=R=>{Array.isArray(R)?o=R:(i(R),f.fire(R))};return this.doSearch(t,w,-1,S).then(R=>[R,o])}),b;if(r.cacheKey){b=this.getOrCreateCache(r.cacheKey);const S={promise:h,event:f.event,resolved:!1};b.resultsToSearchCache[r.filePattern||""]=S,h.then(()=>{S.resolved=!0},o=>{delete b.resultsToSearchCache[r.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([S,o])=>{const w=b?b.scorerCache:Object.create(null),R=(typeof r.maxResults!="number"||r.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(r,o,w,c).then(O=>{const $=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:$,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:O.length},messages:S.messages,limitHit:S.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults},O]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new T)}trySortedSearchFromCache(t,r,s){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const c=this.getResultsFromCache(i,t.filePattern||"",r,s);if(c)return c.then(([f,h,b])=>{const S=n.StopWatch.create(!1);return this.sortResults(t,h,i.scorerCache,s).then(o=>{const w=S.elapsed(),R={fromCache:!0,detailStats:b,type:"searchProcess",resultCount:h.length,sortingTime:w};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:R},o]})})}sortResults(t,r,s,i){const c=(0,y.prepareQuery)(t.filePattern||""),f=(b,S)=>(0,y.compareItemsByFuzzyScore)(b,S,c,!0,E,s),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(r,f,h,1e4,i)}sendProgress(t,r,s){if(s&&s>0)for(let i=0;i<t.length;i+=s)r(t.slice(i,i+s));else r(t)}getResultsFromCache(t,r,s,i){const c=n.StopWatch.create(!1),f=r.indexOf(P.sep)>=0;let h;for(const w in t.resultsToSearchCache)if(r.startsWith(w)){if(f&&w.indexOf(P.sep)<0&&w!=="")continue;const R=t.resultsToSearchCache[w];h={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!h)return null;const b=c.elapsed(),S=n.StopWatch.create(!1),o=h.event(s);return i&&i.onCancellationRequested(()=>{o.dispose()}),h.promise.then(([w,R])=>{if(i&&i.isCancellationRequested)throw(0,A.canceled)();const O=[],$=(0,y.prepareQuery)(r).normalizedLowercase;for(const K of R)!(0,m.isFilePatternMatch)(K,$)||O.push(K);return[w,O,{cacheWasResolved:h.resolved,cacheLookupTime:b,cacheFilterTime:S.elapsed(),cacheEntryCount:R.length}]})}doSearch(t,r,s,i){return new Promise((c,f)=>{let h=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(s?(h.push(b),s>0&&h.length>=s&&(r(h),h=[])):r(b))},b=>{r(b)},(b,S)=>{h.length&&r(h),b?f(b):c(S)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class T{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(v){return(0,P.basename)(v.relativePath)}getItemDescription(v){return(0,P.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function a(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(l),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>I.URI.revive(t))}}function l(v){return{...v,folder:I.URI.revive(v.folder)}}}),define(me[285],ge([0,1,6,2,28,12,31,284,282,94,13,64,27,73,10,135]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends m.ExtHostSearch{constructor(E,a,l,v){super(E,l,v);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(u.Schemas.userData,new y.RipgrepSearchProvider(t)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(u.Schemas.file,new y.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(u.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(E,a){const l=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,a,l,v){const t=(0,m.reviveQuery)(l);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,a,t,v):super.$provideFileSearchResults(E,a,l,v)}doInternalFileSearch(E,a,l,v){const t=r=>{if((0,A.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(E,a,r.map(s=>L.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,v)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,a){return new p.NativeTextSearchManager(E,a)}};_=ze([Ue(0,n.IExtHostRpcService),Ue(1,d.IExtHostInitDataService),Ue(2,I.IURITransformerService),Ue(3,D.ILogService)],_),e.NativeExtHostSearch=_}),define(me[137],ge([0,1,299,126,80,22,16,3,6,8,11,32,106,107,300]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(h){this.socket=h,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,A.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const b=S=>h(D.VSBuffer.wrap(S));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(h){const b=S=>{h({type:0,hadError:S,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,A.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,A.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((h,b)=>{if(this.socket.bufferSize===0){h();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),h()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=p;var _;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var T;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(T||(T={}));class E extends y.Disposable{constructor(h,b,S,o){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=o,b?(this._zlibInflate=u.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",w=>{console.error(w),(0,A.onUnexpectedError)(w),this._onClose.fire({type:0,hadError:!0,error:w})}),this._zlibInflate.on("data",w=>{this._pendingInflateData.push(w)}),S&&(this._zlibInflate.write(S.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",w=>{console.error(w),(0,A.onUnexpectedError)(w),this._onClose.fire({type:0,hadError:!0,error:w})}),this._zlibDeflate.on("data",w=>{this._pendingDeflateData.push(w)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(w=>this._acceptChunk(w))),this._register(this.socket.onClose(w=>this._onClose.fire(w)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):D.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(D.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,b){let S=2;h.byteLength<126?S+=0:h.byteLength<2**16?S+=2:S+=8;const o=D.VSBuffer.alloc(S);if(b?o.writeUInt8(194,0):o.writeUInt8(130,0),h.byteLength<126)o.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){o.writeUInt8(126,1);let w=1;o.writeUInt8(h.byteLength>>>8&255,++w),o.writeUInt8(h.byteLength>>>0&255,++w)}else{o.writeUInt8(127,1);let w=1;o.writeUInt8(0,++w),o.writeUInt8(0,++w),o.writeUInt8(0,++w),o.writeUInt8(0,++w),o.writeUInt8(h.byteLength>>>24&255,++w),o.writeUInt8(h.byteLength>>>16&255,++w),o.writeUInt8(h.byteLength>>>8&255,++w),o.writeUInt8(h.byteLength>>>0&255,++w)}this._totalOutgoingWireBytes+=o.byteLength+h.byteLength,this.socket.write(D.VSBuffer.concat([o,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),o=(b.readUInt8(0)&128)>>>7,w=b.readUInt8(1),R=(w&128)>>>7,O=w&127;this._state.state=2,this._state.readLen=2+(R?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),S=b.readUInt8(1),o=(S&128)>>>7;let w=S&127,R=1;w===126?w=b.readUInt8(++R)*2**8+b.readUInt8(++R):w===127&&(w=b.readUInt8(++R)*0+b.readUInt8(++R)*0+b.readUInt8(++R)*0+b.readUInt8(++R)*0+b.readUInt8(++R)*2**24+b.readUInt8(++R)*2**16+b.readUInt8(++R)*2**8+b.readUInt8(++R));let O=0;o&&(O=b.readUInt8(++R)*2**24+b.readUInt8(++R)*2**16+b.readUInt8(++R)*2**8+b.readUInt8(++R)),this._state.state=3,this._state.readLen=w,this._state.mask=O}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);a(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const S=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=S.length,this._onData.fire(D.VSBuffer.wrap(S))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function a(f,h){if(h===0)return;let b=f.byteLength>>>2;for(let $=0;$<b;$++){const K=f.readUInt32BE($*4);f.writeUInt32BE(K^h,$*4)}let S=b*4,o=f.byteLength-S;const w=h>>>24&255,R=h>>>16&255,O=h>>>8&255;o>=1&&f.writeUInt8(f.readUInt8(S)^w,S),o>=2&&f.writeUInt8(f.readUInt8(S+1)^R,S+1),o>=3&&f.writeUInt8(f.readUInt8(S+2)^O,S+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function v(){const f=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):h=(0,P.join)((0,k.tmpdir)(),`vscode-ipc-${f}.sock`),r(h),h}e.createRandomIPCHandle=v;function t(f,h,b){const S=(0,g.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${b}-${h}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${b}-${h}.sock`):o=(0,P.join)(f,`${b}-${h}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(f){const h=l[n.platform];typeof h=="number"&&f.length>=h&&console.warn(`WARNING: IPC handle "${f}" is longer than ${h} chars, try a shorter --user-data-dir`)}class s extends d.IPCServer{constructor(h){super(s.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const b=C.Event.fromNodeEventEmitter(h,"connection");return C.Event.map(b,S=>({protocol:new m.Protocol(new p(S)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(S,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(f){return new Promise((h,b)=>{const S=(0,L.createServer)();S.on("error",b),S.listen(f,()=>{S.removeListener("error",b),h(new s(S))})})}e.serve=i;function c(f,h){return new Promise((b,S)=>{const o=(0,L.createConnection)(f,()=>{o.removeListener("error",S),b(m.Client.fromSocket(new p(o),h))});o.once("error",S)})}e.connect=c}),define(me[286],ge([0,1,137,278,49,44,2,198,12]),function(Y,e,g,L,k,D,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(d,m,u){this._commands=d,this.logService=m,this._ipcHandlePath=u,this._server=L.createServer((p,_)=>this.onRequest(p,_)),this.setup().catch(p=>(m.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,m){const u=[];d.setEncoding("utf8"),d.on("data",p=>u.push(p)),d.on("end",()=>{const p=JSON.parse(u.join(""));switch(p.type){case"open":this.open(p,m);break;case"openExternal":this.openExternal(p,m);break;case"status":this.getStatus(p,m);break;case"extensionManagement":this.manageExtensions(p,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${p.type}`,_=>{_&&this.logService.error(_)}),m.end();break}})}open(d,m){let{fileURIs:u,folderURIs:p,forceNewWindow:_,diffMode:T,addMode:E,forceReuseWindow:a,gotoLineMode:l,waitMarkerFilePath:v}=d;const t=[];if(Array.isArray(p))for(const r of p)try{t.push({folderUri:A.URI.parse(r)})}catch(s){}if(Array.isArray(u))for(const r of u)try{(0,C.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:A.URI.parse(r)}):t.push({fileUri:A.URI.parse(r)})}catch(s){}if(t.length){const r=v?A.URI.file(v):void 0,i={forceNewWindow:_,diffMode:T,addMode:E,gotoLineMode:l,forceReuseWindow:a,preferNewWindow:!a&&!r&&!E,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(d,m){for(const u of d.uris){const p=A.URI.parse(u),_=p.scheme==="file"?p:u;await this._commands.executeCommand("_remoteCLI.openExternal",_)}m.writeHead(200),m.end()}async manageExtensions(d,m){try{const u=T=>T?.map(E=>/\.vsix$/i.test(E)?A.URI.parse(E):E),p={list:d.list,install:u(d.install),uninstall:u(d.uninstall),force:d.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);m.writeHead(200),m.write(_)}catch(u){m.writeHead(500),m.write(String(u),p=>{p&&this.logService.error(p)})}m.end()}async getStatus(d,m){try{const u=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(u),m.end()}catch(u){m.writeHead(500),m.write(String(u),p=>{p&&this.logService.error(p)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let n=class extends P{constructor(d,m){super(d,m,(0,g.createRandomIPCHandle)())}};n=ze([Ue(0,D.IExtHostCommands),Ue(1,y.ILogService)],n),e.CLIServer=n}),define(me[287],ge([0,1,72,274,269,5,277,40,259,2,10,7,286,105]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class u extends k.RequireInterceptor{_installInterceptor(){const T=this,E=Y.__$__nodeRequire("module"),a=E._load;E._load=function(v,t,r){for(let s of T._alternatives){let i=s(v);if(i){v=i;break}}return T._factories.has(v)?T._factories.get(v).load(v,P.URI.file((0,m.realpathSync)(t.filename)),s=>a.apply(this,[s,t,r])):a.apply(this,arguments)}}}class p extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const T=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(d.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(u,T,this._registry).install(),g.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const l=process.send,v=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(T){return T.main}_loadCommonJSModule(T,E,a){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let l=null;a.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{T&&g.mark(`code/extHost/willLoadExtensionCode/${T.value}`),l=Y.__$__nodeRequire(E.fsPath)}catch(v){return Promise.reject(v)}finally{T&&g.mark(`code/extHost/didLoadExtensionCode/${T.value}`),a.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(T){if(!!this._initData.remote.isRemote)for(const E in T){const a=T[E];a===null?delete process.env[E]:process.env[E]=a}}}e.ExtHostExtensionService=p}),define(me[288],ge([0,1,82,260,262,271,270,285,287,227,263,53,40,67,73,71,33,52,12,68,261]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_,T,E,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(d.IExtHostExtensionService,y.ExtHostExtensionService),(0,g.registerSingleton)(E.ILogService,P.ExtHostLogService),(0,g.registerSingleton)(a.IExtensionStoragePaths,l.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,A.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(u.IExtHostSearch,C.NativeExtHostSearch),(0,g.registerSingleton)(p.IExtHostTask,D.ExtHostTask),(0,g.registerSingleton)(_.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(T.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[289],ge([0,1,126,301,72,16,107,137,117,225,272,22,103,28,105,17,118,275,288]),function(Y,e,g,L,k,D,A,C,y,P,n,I,d,m,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const T=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=Y.__$__nodeRequire("module"),c=i._load;i._load=function(f){if(f==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return c.apply(this,arguments)}})();const E=process.exit.bind(process);function a(i){process.exit=function(c){if(i)E(c);else{const f=new Error("An extension called process.exit() and this was prevented.");console.warn(f.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)}}let l=function(i){E()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,c)=>{let f=null,h=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const b=108e5,S=3e5,o=new p.RunOnceScheduler(()=>l("renderer disconnected for too long (1)"),b),w=new p.RunOnceScheduler(()=>l("renderer disconnected for too long (2)"),S);process.on("message",(O,$)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const K=I.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let G;if(O.skipWebSocketFrames)G=new C.NodeSocket($);else{const N=I.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));G=new C.WebSocketNodeSocket(new C.NodeSocket($),O.permessageDeflate,N,!1)}f?(o.cancel(),w.cancel(),f.beginAcceptReconnection(G,K),f.endAcceptReconnection()):(clearTimeout(h),f=new A.PersistentProtocol(G,K),f.onDidDispose(()=>l("renderer disconnected")),i(f),f.onSocketClose(()=>{o.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;o.isScheduled()&&w.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((c,f)=>{const h=g.createConnection(i,()=>{h.removeListener("error",f),c(new A.PersistentProtocol(new C.NodeSocket(h)))});h.once("error",f),h.on("close",()=>{l("renderer closed the socket")})})}}async function t(){const i=await v();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(c=>{(0,P.isMessageOfType)(c,2)?(this._terminating=!0,l("received terminate message from renderer")):this._onMessage.fire(c)})}send(c){this._terminating||i.send(c)}drain(){return i.drain()}}}function r(i){return new Promise(c=>{const f=i.onMessage(h=>{f.dispose();const b=JSON.parse(h.toString()),S=b.commit,o=y.default.commit;S&&o&&S!==o&&E(55);const w=[];process.on("unhandledRejection",($,K)=>{w.push(K),setTimeout(()=>{const G=w.indexOf(K);G>=0&&K.catch(N=>{w.splice(G,1),(0,D.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,D.onUnexpectedError)($))})},1e3)}),process.on("rejectionHandled",$=>{const K=w.indexOf($);K>=0&&w.splice(K,1)}),process.on("uncaughtException",function($){(0,D.onUnexpectedError)($)});let R=0;setInterval(function(){try{process.kill(b.parentPid,0),R=0}catch($){$&&$.code==="EPERM"?(R++,R>=3&&l(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):l(`parent process ${b.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let O;try{O=Y.__$__nodeRequire("native-watchdog"),O.start(b.parentPid)}catch($){(0,D.onUnexpectedError)($)}i.send((0,P.createMessageOfType)(0)),c({protocol:i,initData:b})});i.send((0,P.createMessageOfType)(1))})}async function s(){k.mark("code/extHost/willConnectToRenderer");const i=await t();k.mark("code/extHost/didConnectToRenderer");const c=await r(i);k.mark("code/extHost/didWaitForInitData");const{initData:f}=c;a(!!f.environment.extensionTestsLocationURI),f.environment.useHostProxy=T.useHostProxy!==void 0?T.useHostProxy!=="false":void 0,f.environment.skipWorkspaceStorageLock=(0,_.boolean)(T.skipWorkspaceStorageLock,!1);const h=new class{exit(w){E(w)}exists(w){return m.Promises.exists(w)}realpath(w){return(0,u.realpath)(w)}};let b=null;if(f.remote.authority&&T.uriTransformerPath)try{const w=Y.__$__nodeRequire(T.uriTransformerPath)(f.remote.authority);b=new d.URITransformer(w)}catch(o){console.error(o)}const S=new n.ExtensionHostMain(c.protocol,f,h,b);l=o=>S.terminate(o)}e.startExtensionHostProcess=s}),define(me[302],ge([0,1,289]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c08913337cb8b95493be8e99d62e0b3241563f6b/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
